/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
import platform.*;
import csp.*;
import basic_ds.*;
import utils.*;
import mcs.utils.*;

import java.lang.*;
import java.net.*;
import java.io.*;


public class AgentLauncher extends GetOpt{
    static void argErr(){
// Usage: java AgentLauncher <agentNum> <nb_of_agents> <problem_name>
//                           <broker_host> <broker_port>
	MySystem.err.println("DisCSP algorithms\nby Silaghi, Marius-Calin --- (c) 1998,1999,2000,2001,2002,2004\nwith contributions from Michel Galley\n\njava AL -I <agentNum> -n  <nb-of-agents> -P <problem_name> -H <broker_host> -p <broker_port> -G {no_GUI_msg} -A {noACK}\n\tKnown Protocols:");
	for(int k=0; k<BrokerLauncher.sProtocols.length; k++){
	    MySystem.err.println("\t\t"+BrokerLauncher.sProtocols[k]);
	}
	return;
    }
    static public void main(String args[]){
	int ID=0,port=0,nbAgents=0;
	String problemName="problems/problemempty", host="";
	boolean verbose = false;
	char c;
	MySystem.out.println("got "+args.length+" arguments");
	Class[] protocols = new Class[18];
	try {
	    for(int k=0; k<BrokerLauncher.sProtocols.length; k++)
		protocols[k] = Class.forName(BrokerLauncher.sProtocols[k]);
	}
	catch(ClassNotFoundException e) { System.exit(-1); }
	while((c=getopt(args, "n:I:P:H:p:CAvh"))!=END){
 	    switch(c){
	    case 'I': ID=Integer.parseInt(optarg); break;
	    case 'n': nbAgents=Integer.parseInt(optarg); break;
	    case 'P': problemName = optarg; break;
	    case 'H': host = optarg; break;
	    case 'p': port = Integer.parseInt(optarg); break;
	    case 'G': Utils.sendingColors=false; Agent.notifying=false; break;
	    case 'A': Server.acknowledging=false; break;
	    case 'v': verbose=true; break;
	    default: argErr(); return;
	    }
	}	
	if(!verbose){
            MySystem.out.println("Disabling messages");
	    MyPrintStream.messages=false;
	}
	if(!Utils.sendingColors)
            MySystem.out.println("Disabling colors and notifications");
	if(!Server.acknowledging)
            MySystem.out.println("Disabling acks");
	try {
	    for(int i=0; i<nbAgents; i++) {
		Platform platform
		    = new Platform("Agent"+(ID+i),
				   protocols,
				   InetAddress.getByName(host),
				   port, false);
		File f=new File(problemName);
		if (!f.exists()){
		    MySystem.err.println("File does not exist:"+problemName);
		}
		platform.setProblem(f);
		platform.subscribe();
	    }
	}
	catch(Exception e) {
	    e.printStackTrace();
	}
    }
}
