/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
import platform.*;
import csp.*;
import basic_ds.*;
import dmhc.*;
import utils.*;
import tester.*;
import mcs.utils.*;

import java.lang.*;
import java.net.*;
import java.io.*;

public class BrokerLauncher extends GetOpt{
    public static String sProtocols[] = {
	"dmhc.MHC",
	"dhmc.MHC",
	"aas0.MHC",
	"smdc.SMDC",
	"Protocol_PlatformCheck",
	"basic_ds.Protocol_BasicDS",
	"mas.MHC",
	"mas.MAS",
	"mads.MHC",
	"mads.MAS",
	"dcsp.MHC",
	"dcsp.Cluster",
	"abt.ABT",
	"abtro.ABTRO",
	"abtro.ABTWC",
	"abt.ABTO",
	"abtrf.ABTRF",
	"abtrf.ABTRFH"
    };
    static void argErr(){
//      java BL nr-of-agents avg-nr-of-replicas Nr-of-Tests Domain-size tightness density nr-of-vars GUI ACK REPEAT
	MySystem.err.println("DisCSP algorithms\nby Silaghi, Marius-Calin --- (c) 1998,1999,2000,2001,2002,2004\nwith contributions from Michel Galley\n\njava BL -n nr-of-agents -p protocols_list -r avg-nr-of-replicas -t Nr-of-Tests -d Domain-size -T tightness -D density -m nr-of-vars -G {noGUI} -A {noACK} -R {REPEAT} -L {LOAD-noGenerate} -h {HELP} -v {VERBOSE} -Y {ABT}\n\tKnown Protocols:");
	for(int k=0; k<sProtocols.length; k++){
	    MySystem.err.println("\t"+k+"\t"+sProtocols[k]);
	}
	return;
    }
    static int[] getProtocols(String[] protocols, String sProtocolList){
	int[] testedProtocols=new int[1];
	testedProtocols[0]=11;
	if(sProtocolList!="") testedProtocols[0]=Integer.parseInt(sProtocolList);
	return testedProtocols;
    }
    static public void main(String args[]){
	int nrOfAgents=0;
	String sProtocolList="";
	int avgNrOfReplicas=0;
	boolean generate=true;
	boolean verbose=false;
	Platform platform = null;
	TestLeaderI tests = null;
	boolean GUI=true, ABT=false, repeat=false;
	int nrOfVars=0;
	float density=33;
	int domainSize=5;
	int tightness=55;
	int nrOfTests=50;
	char c;
	Class[] protocols = new Class[18];
	try {
	    for(int k=0; k<sProtocols.length; k++)
		protocols[k] = Class.forName(sProtocols[k]);
	}
	catch(Exception e) {
	    e.printStackTrace();
	    System.exit(-1);
	}
	while((c=getopt(args, "n:r:t:p:d:m:vhT:D:GARLY"))!=END){
 	    switch(c){
	    case 'n': nrOfAgents = Integer.parseInt(optarg); break;
	    case 'r': avgNrOfReplicas = Integer.parseInt(optarg); break;
	    case 't': nrOfTests = Integer.parseInt(optarg); break;
	    case 'd': domainSize = Integer.parseInt(optarg); break;
	    case 'm': nrOfVars = Integer.parseInt(optarg); break;
	    case 'v': verbose = true; break;
	    case 'p': sProtocolList = optarg; break;
	    case 'T': tightness = Integer.parseInt(optarg); break;
	    case 'D': density = Integer.parseInt(optarg); break;
	    case 'G': GUI=false; break;
	    case 'A': Server.acknowledging=false; break;
	    case 'R': repeat=true; break;
	    case 'L': generate=false; break;
	    case 'Y': ABT=true; break;
	    default: System.err.println("Not recognizing "+c); argErr(); return;
	    }
	}
	if(nrOfVars==0) nrOfVars=nrOfAgents;
	if(verbose){
	    MySystem.out.print(" Nr-of-agents:"+nrOfAgents);
	    MySystem.out.print(" Avg-nr-replicas:"+avgNrOfReplicas);
	    MySystem.out.print(" Nr-of-Tests:"+nrOfTests);
	    MySystem.out.print(" Domain-size:"+domainSize);
	    MySystem.out.print(" Tightness:"+tightness);
	    MySystem.out.print(" Density:"+density);
	    MySystem.out.print(" Variables:"+nrOfVars);
	    MySystem.out.println();
	}
	platform = new Platform(protocols, GUI);
	if(nrOfAgents<=0) return;
	if(ABT){
	    ABTTestLeader.repeat=repeat; 
	    tests=new ABTTestLeader(platform,generate);
	}else{
	    TestLeader.repeat=repeat;
	    tests=new TestLeader(platform,generate);
	}
	int[] testedProtocols = getProtocols(sProtocols, sProtocolList);
	tests.test(nrOfVars, nrOfTests,
		   domainSize, tightness, density,
		   nrOfAgents, avgNrOfReplicas, testedProtocols);
    }
}
