/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
import platform.*;
import java.awt.*;

public class Protocol_PlatformCheck extends Protocol
{
    Broker broker;
    Agent agent;

    Message_Command message;
    String command;

    boolean terminated = false;
    
    synchronized public void run() 
    {
	initProtocol();
	System.out.println("@Platform checking started.");

	int reply;

	if(genericAgent instanceof Broker) {

	    broker = (Broker)genericAgent;
	    int replies_test1 = 0, replies_test2 = 0;

	    for(int i=0; i<agentIDs.length; i++) {
		select.call(0, broker, broker._sendCommand);
		select.accept(1, _terminate);
		Synch_Wait();
		broker.sendCommand("check", null, agentIDs[i]);
	    }
	    for(int i=0; i<agentIDs.length; i++)
		for(int j=0; j<agentIDs.length; j++) {
		    
		    if(i==j) continue;
		    
		    select.call(0, broker, broker._sendCommand);
		    select.accept(1, _terminate);
		    Synch_Wait();
		    broker.sendCommand("sendMessageTo", 
					     agentIDs[j], agentIDs[i]);
		}
	    
	    while(!terminated) {
		
		select.accept(0, _terminate);
		select.accept(1, _getMessage);
		
		reply = Synch_Wait();
		
		switch(reply) {
		case 0:
		    terminated = true;
		    break;
		case 1:


		    if(command.compareTo("checkOk") == 0) {
			replies_test1++;
		    }
		    else if(command.compareTo("messageOk") == 0) {
			replies_test2++;
		    }
		}
	    }
	    
	    System.out.println("Test1");
	    System.out.println("Expected: "+agentIDs.length+" replies.");
	    System.out.println("Received: "+replies_test1+" replies.");
	    System.out.println("Test2");
	    System.out.println("Expected: "+agentIDs.length
			       *(agentIDs.length-1)+" replies.");
	    System.out.println("Received: "+replies_test2+" replies.");
	    
	    if(replies_test1 == agentIDs.length && 
	       replies_test2 == agentIDs.length*(agentIDs.length-1))
		System.out.println("@Check successful!");
	    else
		System.out.println("@Check unsuccessful!");

	} else {
	    
	    agent = (Agent)genericAgent;

	    while(!terminated) {
		
		select.accept(0, _terminate);
		select.accept(1, _getMessage);
		
		reply = Synch_Wait();
		
		switch(reply) {
		case 0:
		    terminated = true;
		    break;
		case 1:
		    if(command.compareTo("check") == 0) {
			select.call(0, agent, agent._sendCommand);
			select.accept(1, _terminate);
			Synch_Wait();
			agent.sendCommand("checkOk", null, 
					  agent.getBrokerID());
		    }	
		    else if(command.compareTo("sendMessageTo") == 0) {
			select.call(0, agent, agent._sendCommand);
			select.accept(1, _terminate);
			Synch_Wait();
			agent.sendCommand("message", null, 
					  (AgentID)message.getArguments());
		    }
		    else if(command.compareTo("message") == 0) {
			select.call(0, agent, agent._sendCommand);
			select.accept(1, _terminate);
			Synch_Wait();
			agent.sendCommand("messageOk", message.getSenderID(), 
					  agent.getBrokerID());
			select.call(0, agent, agent._createColorMatrix);
			select.accept(1, _terminate);
			Synch_Wait();
			agent.createColorMatrix("var1", "var2", 9, 7);
			select.call(0, agent, agent._createColorMatrix);
			select.accept(1, _terminate);
			Synch_Wait();
			agent.createColorMatrix("var3", "var4", 6, 8);
			for(int i=3; i<5; i++) {
				select.call(0, agent, agent._setColor);
				select.accept(1, _terminate);
				Synch_Wait();
				agent.setColor("var1", "var2", i, 2, 
					       Color.blue, Color.lightGray);
			}
			select.call(0, agent, agent._setColor);
				select.accept(1, _terminate);
				Synch_Wait();
				agent.setColor("var3", "var4", 5, 4, 
					       Color.blue, Color.lightGray);
		    }
		}
	    }
	}
	System.out.println("@Platform checking terminated.");	    
	cleanUpProtocol();
    }

    public int _getMessage = 1;
    synchronized public void getMessage(Message m) 
    {
	message = (Message_Command)m;
	command = (String)message.getCommand();       
	Synch_Reply();
    }

    public int _terminate = 2;
    synchronized public void terminate()
    {
	terminated = true;
	Synch_Reply();	
    }

    public String toString() { return "PlatformCheck"; } 
}    



