/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package aas0;
import java.util.*;
import csp.*;
import platform.*;
import parameters.*;
import utils.*;
import sjavap.*;

class MHCk implements MessageReceiver, Runnable{

 /**    active object support (needs implements Reply)   **/
 /*********************************************************/
 /**/ Synch_List select = new Synch_List(this);           //
 /**/ synchronized public void Synch_Reply()              //
 /**/   { notify();   }                                   //
 /**/ int now() {return Kernel.kern.currentTime;}         //
 /**/ int Synch_Wait() {                                  //
 /**/   Kernel.kern.Synch_Request(select);                //
 /**/   do{try {wait();} catch(InterruptedException e){}} //
 /**/   while(select.nbEntries!=0);                       //
 /**/   return select.Value; }                            //
 /*********************************************************/

    private MHCAgent MHCscheduler;
    private int variablesNr;
    private int level;
    private int myComputationNum;
    private MessageQueue queue;
    //Am I the level updating the instantiation?
    private boolean instantiation=false;
    private boolean fromLocal=false;//is the current message coming from local?
    //here we can be announced about modified histories
    //(String-var:int[]hist)
    private Hashtable outgoingPost=new Hashtable();
    private Hashtable post=new Hashtable();
    private Message_Command postPropagate=null;//propagate that can be sent to other level
    private Hashtable insts=new Hashtable();
    private Hashtable myInst=new Hashtable();
    private Object postMonitor=new Object();
    // changed histories for disabling level decisions
    private Hashtable changed=new Hashtable();
    private DCost localCost=new DCost();
    //active methods
    final public static int _terminate=2;
    final public static int _getLocalMessage=3;

    //states
    final static int Sreceiving=0;
    final static int SemptyReceiving=2;
    final static int Sstop=4;
    private int crtState;
    private Hashtable histories=new Hashtable();
    private MHCHistory[] levelState;
    private Message gotMessage=null;

    MHCk(MHCAgent scheduler, int level, int vars, int myComputationNum, MessageQueue queue){
	variablesNr=vars;
	this.level=level;
	this.queue=queue;
	this.myComputationNum=myComputationNum;
	levelState=new MHCHistory[variablesNr];
	MHCscheduler=scheduler;
    }

    MHCk(MHCAgent scheduler, int level, int vars, boolean instant, int myComputationNum, MessageQueue queue){
	instantiation=true;
	variablesNr=vars;
	this.level=level;
	this.queue=queue;
	this.myComputationNum=myComputationNum;
	levelState=new MHCHistory[variablesNr];
	MHCscheduler=scheduler;
    }

    private void checkPostPropagate(){
	if(postPropagate!=null){
	    int level=((Propagate)postPropagate.getArguments()).level;
	    if(level<=this.level) MySystem.exit(1);
	    MHCk nextC=MHCscheduler.getMHCk(level);
	    select.accept(0,_terminate);
	    select.call(1,nextC,nextC._getMessage);
	    if(Synch_Wait()==1){
		nextC.getMessage(postPropagate);
		postPropagate=null;
	    }
	}
    }

    boolean MHCmodif;
    synchronized public void run() {
	select.thread=Thread.currentThread();
	crtState=SemptyReceiving;
	for(;;){
	    //if(instantiation) MySystem.err.println("MHCK level "+level+" in state:"+crtState);
	    if(instantiation)printLevelState();
	    switch(crtState){
	    case Sstop:
		return;

	    case SemptyReceiving:
		MHCmodif=false;
                select.accept(0,_terminate);
		select.accept(1,_getMessage,1+level);
		select.accept(2,_getLocalMessage);
		int sWait = Synch_Wait();
		if(sWait==1){
		    getMessage(); //get external Message
		    checkPostPropagate();
		}
		if(instantiation)
		    MySystem.err.println("MHCK level "+level+" in state:"+crtState+" after choice:"+sWait);
		if(sWait==0){
                    crtState=Sstop;
                    break;
                  }
		if(level>=0) //no post for base
		    readPostToChanged();
		//Only if remote info has arrived
		if(MHCmodif&&(crtState!=Sstop)){//&&(sWait!=2)){
		    MySystem.err.println("MHCK level "+level+" goes to modified state:"+crtState);
		    crtState=Sreceiving;
// 		    MHCscheduler.interruptRequest();
		}
		break;
	    case Sreceiving:
                select.accept(0,_terminate);
		select.accept(1,_getMessage,1+level);
		select.call(2,MHCscheduler,MHCscheduler._MHCk,1+(1+level));
		select.accept(3,_getLocalMessage);
		int choice=Synch_Wait();
		if(choice==1){
		    getMessage(); //get external Message
		    checkPostPropagate();
		}
		//if(instantiation) MySystem.err.println("MHCK level "+level+" in state:"+crtState+" after choice:"+choice);
                if(choice==0){
                  crtState=Sstop; break;
                }
		if(level>=0) //no post for base
		    readPostToChanged();
		if(choice==2){
		    prepareLevels();
// 		    MHCscheduler.clearInterrupt();
		    ((DCost)Utils.agentCost).updateCost(localCost);
		    //if(instantiation) MHCscheduler.mHCk(levelState, outgoingPost,insts);else
		    MHCscheduler.mHCk(levelState,outgoingPost,insts,level);
		    outgoingPost.clear(); //already processed
// 		    if(okMessage!=null){
// 			MHCscheduler.getIncomingOK(okMessage);
// 			okMessage=null;
// 		    }
		    crtState=SemptyReceiving;
		    MySystem.err.println("MHCK level "+level+" goes to state:"+crtState);
		}
		break;
	    }
	}
    }

    public synchronized void terminate(){
	crtState=Sstop;
        Synch_Reply();
    }

    public synchronized void getLocalMessage(Propagate m){
	//MySystem.err.println("Agent enters getLocalMessage");
	if(level>=0) //no post for base
	    readPostToChanged();
	if(instantiation)
	    clearLevel();
	fromLocal=true;
	getMessage(m);
	fromLocal=false;
        Synch_Reply();
    }
    public synchronized void getMessage(Message message){
	gotMessage=message;
	if(message.getComputationNum()!=myComputationNum){
	    gotMessage=null;
	    MySystem.err.println("mHCk:"+level+":!!my myComputationNum="+myComputationNum);
	    MySystem.err.println("mHCk:"+level+":!!my getComputationNum()="+message.getComputationNum());
	    MySystem.exit(1);//why-debug
	}
        Synch_Reply();
    }
    private void getMessage(){
	Message message=gotMessage;
	if(message==null){
	    MySystem.exit(1);//why-debug
	    return;
	}
	if(level>=0) //no post for base
	    readPostToChanged();
	Object argument=((Message_Command)message).getArguments();
	MySystem.err.println("MHCk:"+level+":Got message:"+argument);
	if(instantiation&&(argument instanceof DNogood)){
	    getNogood((DNogood)argument);
	}else{
	    if(argument instanceof Propagate){
		Propagate mMHC=(Propagate)argument;
		postPropagate = mMHC.removeNext((Message_Command)message);
		localCost.incrementMessages(mMHC.cost);
		getMessage(mMHC);
	    }else{
		DView mMHC=(DView)argument;
		localCost.incrementMessages(mMHC.cost);
		getContext(mMHC.view,true);
		disableChanged();
	    }
	}
    }
    private void getNogood(DNogood dn){
	if(validNogood(dn.view)){
	    MHCmodif=true;
	    localCost.incrementMessages(dn.cost);
	    MySystem.err.println("MHCk:Valid nogood");
	    registerNogood(dn);
	}else
	    MySystem.err.println("MHCk:Invalid nogood");
    }
    private void getMessage(Propagate m){
	int i,j,k;
	if(m.addedLinks.size()>0)
	    getContext(m.addedLinks,true);

	mergeHistory(m.varHistories);
	disableChanged();
	for(k=0; k<m.varHistories.size(); k++){
	    Label prop=
		m.varHistories.getL(k);
	    updateKnowledge(new MHCHistory(prop));
	}
    }
    //if some element of the Context is old, the other new ones
    //are taken only if takeDisabled
    private boolean getContext(Context m, boolean takeDisabled){
	boolean disabled;
	disabled=false;
	String variable;
	int[] incomingHist;
	int[] localHist;
	Hashtable tmpHist=new Hashtable();
	Hashtable tmpPost=new Hashtable();
	Hashtable tmpInsts=new Hashtable();
	Iterator it=(Iterator)m.keys();
	while(it.hasNext()){
	    variable=(String)it.next();
	    Range incomingRange=m.getR(variable);
	    incomingHist=m.getH(variable).history;
	    //if(incomingHist==null)   MySystem.exit(1);
	    if((incomingHist==null)||(incomingHist.length==0))
		continue;
	    localHist=(int[])histories.get(variable);
	    if(localHist!=null) {
		if(History.firstDisablesSecond(incomingHist,localHist)){
		    changed.put(variable,incomingHist);
		    histories.put(variable,incomingHist);
		    if((!instantiation)||
		       (incomingHist[incomingHist.length-2]<level)){
			if(!fromLocal)
			    MHCmodif=true;
			if(incomingRange!=null)
			    insts.put(variable,incomingRange);
			else insts.remove(variable);
			outgoingPost.put(variable,incomingHist);
		    }else{
			if(incomingRange!=null)
			    myInst.put(variable,incomingRange);
			if(History.baseDisablesSecond(incomingHist,localHist))
			    insts.remove(variable);
		    }
		}else{
		    if(History.firstDisablesSecond(localHist,incomingHist)){
			disabled=true;
			//labeling.remove(k);break;//must continue
		    }else{//perhaps there was no instantiation
			//but myInst was surely there
			if(incomingRange!=null)
			    if((!instantiation)||
			       (incomingHist[incomingHist.length-2]<level))
				insts.put(variable,incomingRange);
		    }
		}
	    }else{
		tmpHist.put(variable,incomingHist);
		if((!instantiation)||
		   (incomingHist[incomingHist.length-2]<level)){
		    tmpPost.put(variable,incomingHist);
		    if(incomingRange!=null)
			tmpInsts.put(variable,incomingRange);
		}else
		    if(incomingRange!=null)
			myInst.put(variable,incomingRange);
	    }
	}
	if(takeDisabled||!disabled){
	    histories.putAll(tmpHist);
	    changed.putAll(tmpHist);
	    insts.putAll(tmpInsts);
	    if(tmpPost.size()>0)
		if(!fromLocal)
		    MHCmodif=true;
	    outgoingPost.putAll(tmpPost);
	}
	return disabled;
    }

    private void disableChanged(){
	if(changed.size()>0){
	    for(int k=0; k<levelState.length; k++){
		if((levelState[k]!=null)&&levelState[k].disabledBy(changed)){
		    if(!(instantiation&&levelState[k].disabledHistoryBy(changed)))
			MHCmodif=true;
		    if((instantiation)&&
		       (!levelState[k].disabledHistoryBy(changed))){
			levelState[k].proposal=
			    (Range)myInst.get(levelState[k].variable);
			levelState[k].dependencies=new ConflictSet();
		    }else{
			levelState[k]=null;
		    }
		}
	    }
	    changed.clear();
	}
    }

    //merge history, erase old proposals, return new history
    void mergeHistory(Labeling labeling){
	boolean disabled;
	Object removed;
	for(int k=labeling.size()-1; k>=0; k--){
	    Label prop = labeling.getL(k);
	    if(disabled=getContext(prop.context,false)){//do not take disabled
		removed=labeling.remove(k);
		MySystem.err.println("Removing incoming label:"+removed+":at level:"+level);
	    }
	}
    }
    //-- if new range for a variable, then
    //--reset all the dependent instantiations
    //-- if new history for a variable, then
    //--update all the dependent instantiations
    //if old history then discard proposal
    void updateKnowledge(MHCHistory prop){
	int idprop=MHCscheduler.getID(prop.variable);
        if(idprop<0){
	    MySystem.err.println("Error bad ID at:"+prop);
	    MySystem.exit(1); //old message?
	}
	if((levelState[idprop]==null)){
	    levelState[idprop]=(MHCHistory)prop.clone();
	    if(!fromLocal)
		MHCmodif=true;
	}else{
	    //if(!MHCHistory.disablingHistoryOf(prop, levelState[idprop]))
	    boolean differ=prop.proposal.different(levelState[idprop].proposal);
	    MHCHistory sol=MHCHistory.intersect(prop,
						levelState[idprop]);
	    if(sol!=null) {
		if(sol!=prop) //combination
		    MHCmodif=true;
		levelState[idprop]=sol;
		if(!fromLocal)
		    MHCmodif=true;
	    }else{ //unchanged
		if(fromLocal&&differ)
		    MHCmodif=true;
	    }
	}
    }
    void prepareLevels(){
	for(int k=0; k<levelState.length; k++){
	    if(levelState[k]==null){
		String var=MHCscheduler.variables[k];
		Range inst=(Range)insts.get(var);
		if(inst!=null)
		    levelState[k]=new MHCHistory(0,var,inst,null);
	    }
	}
    }

    private void printLevelState(){
	for(int i=0;i<levelState.length;i++)
	    if(levelState[i]==null)MySystem.err.println("null");
	    else MySystem.err.println(levelState[i]);
    }

    //tests if a nogood is denying my current instantiation
    private boolean validNogood(Context view){
	if(emptyLevel(levelState)){
	    MySystem.err.println("Nogood invalid since empty levelState");
	    printLevelState();
	    return false;
	}
	Iterator it= (Iterator)view.keys();
	while(it.hasNext()){
	    String var= (String)it.next();
	    int varID=MHCscheduler.getID(var);
	    DVarHistory valuation=view.getDV(var);
	    //It is sufficient that one view is outdated
	    //for invalidating the nogood
	    if(outdatedView(var,varID,valuation)){
		MySystem.err.println("Nogood invalid since outdated view");
		return false;
	    }
	}
	return true;
    }

    // test whether an element of a nogood is outdated
    private boolean outdatedView(String var, int varID, DVarHistory valuation){
	int[] old=(int[])histories.get(var);
	DVarHistory oldVH =new DVarHistory((Range)null,old);
	if((old!=null)&&valuation.olderThan(oldVH)){
	    MySystem.err.println("MHCk:old hist:Nogood outdated at var:"+var);
	    return true;
	}
// 	if(varID<0)
// 	    return false;
// 	MHCHistory ls=levelState[varID];
// 	if(ls==null){
// 	    MySystem.err.println("MHCk:ls=null:Nogood outdated at var:"+var);
// 	    return true;
// 	}
	return false;
    }

    //saves needed variables in linksToAdd respectively to conflictingVariables
    private void registerNogood(DNogood nogood){
	if(getContext(nogood.view,false))
	    MySystem.exit(1);//invalid nogood
	disableChanged();
	int vid=getLocalID(nogood.view);
	if(vid<0){
	    vid=0;
	    MySystem.err.println("MHCK inapropriate incoming nogood");
	    MySystem.exit(1);
	}
	if(levelState[vid]==null) {
	    String var=MHCscheduler.getVariable(vid);
	    MySystem.err.println("MHCK inst:"+vid+" was empty:will not register nogood at:"+var);
	    levelState[vid]=new MHCHistory(level, var,
					   new Range(2,1), null);
	    //MySystem.exit(1);//was valid
	    //return; //we have just disabled it somehow
	}
	levelState[vid].proposal.setU(levelState[vid].proposal.getL()-1);
	//ConflictSet cs=new ConflictSet(nogood.view.keySet());
	//levelState[vid].dependencies.addAll(cs);
	String var=levelState[vid].variable;
	Iterator it=(Iterator)nogood.view.keys();
	while(it.hasNext()) {
	    String dvar=(String)it.next();
	    if(dvar.equals(var)) continue;
	    int[] dhist=nogood.view.geth(dvar);
	    //if(dhist[dhist.length-2]<level)//always inst
	    levelState[vid].dependencies.add(dvar);
	}
    } 

    private void clearLevel(){
	for(int k=0;k<levelState.length;k++)
	    levelState[k]=null;
    }

    private int getLocalID(Context nogood){
	Iterator it=(Iterator)nogood.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    int[] vHist=nogood.geth(var);
	    if(vHist[vHist.length-2]==level)
		return MHCscheduler.getID(var);
	}
	return -1;
    }

    boolean emptyLevel(MHCHistory[] doms){
	for(int k=0;k<doms.length;k++){
	    if(doms[k]==null)// return true;
		continue;
	    if(doms[k].proposal.size()<=0)
		return true;
	}
	return false;
    }

    void setPost(Hashtable incomingPost){
	synchronized(postMonitor){
	    Iterator it=(Iterator)incomingPost.keys();
	    while(it.hasNext()){
		String var=(String)it.next();
		int[] postedHist=(int[])incomingPost.get(var);
		if((postedHist!=null)&&
		   (postedHist.length>1)&&
		   (postedHist[postedHist.length-2]<=level)){
		    int[] oldHistory=(int[])post.get(var);
		    if((oldHistory==null)||
		       MHCHistory.firstDisablesSecond(postedHist,oldHistory))
			post.put(var,postedHist);
		}else{
		    MySystem.err.println(History.toString(postedHist));
		    MySystem.exit(1);
		}
	    }
	}
    }

    //read and clear the post
    void readPostToChanged(){
	synchronized(postMonitor){
	    Iterator it=(Iterator)post.keys();
	    while(it.hasNext()){
		String var=(String)it.next();
		int[] incomingHist=(int[])post.get(var);
		int[] oldHistory=(int[])histories.get(var);
		//if i am dependent on older
		if((oldHistory!=null)&&
		   MHCHistory.firstDisablesSecond(incomingHist,
						  oldHistory)){
		    changed.put(var,incomingHist);
		    histories.put(var,incomingHist);
		    //avoid posting the old value....
		    if(outgoingPost.get(var)!=null)
			outgoingPost.remove(var);
		    insts.remove(var);
		}
		if(oldHistory==null){
		    // could used separate "unusedHistory"
		    histories.put(var,incomingHist);
		    changed.put(var,incomingHist);
		}
	    }
	    post.clear();
	    disableChanged();
	}
    }
}
