/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package abt;
import java.util.*;
import java.io.*;
import java.awt.Color;
import abt.msg.*;
import csp.*;
import platform.*;
import parameters.*;
import utils.*;
import hc.*;
import sjavap.*;

public class AABT extends ABT{
    static boolean GOB=true;

    private Agent agent;
    private int myID=0;
    private int myComputationNum=-2;
    private AgentID myself;
    private String myName;

    private DSearch dSearch;
    private int agentsNr, historyIDs[];
    private AgentID[] agents,defaultAgents;
    //private Orders orders;
    private DIncomingAgent dIncomingAgent;
    private DOutgoingAgent dOutgoingAgent;
    private POrder order;
    private AIHashtable cOrder=new AIHashtable();
    private MessagesPost msgPost=new MessagesPost();
    private AcceptedStructures accepts=new AcceptedStructures();
    private CompactorAccepted cAccepted;
   // states
    final static int Sprocessing=0;
    final static int Sstart=1;
    final static int Sannounced=2;
    final static int SwaitEnd=3;
    final static int Sstop=4;
    final static int Stimeout=5;
    boolean Snogood=false;
    boolean Ssolution=false;
    int crtState=Sstart;

    private boolean flowO=true;
    private boolean flowI=true;
    private boolean flow =true;//flowO&&flow

    final static int FlowOThreshold=100;
    final static int FlowIUThreshold=150;
    final static int FlowILThreshold=100;
    //active procedures
    final public static int _MHCk=3;
    final public static int _getStartParameters=4;
    final public static int _accepted=5;
    final public static int _addLink=6;
    final public static int _compactors=7;
    final public static int _reorder=8;
    final public static int _nogood=9;
    final public static int _ok=10;
    private Hashtable outGoing=new Hashtable();
    private Hashtable inComing=new Hashtable();

    //ABT
    String m_variables[];
    String m_variable;
    Range m_myRange;
    int m_value;
    int m_counter=0;
    private int m_variablesNr;
    private Message_Command m_mc;
    private ArrayList addedOutgoingLinks=new ArrayList();
    private ArrayList addedIncomingLinks=new ArrayList();
    private ArrayList outgoingLinks=new ArrayList();
    private Hashtable m_view=new Hashtable();
    private Hashtable m_varAgent=new Hashtable();
    private Hashtable m_agentVar=new Hashtable();
    private Assignments[] m_nogoods;
    private Constraint[] m_constraints;
    private int m_constraintsNr;
    private int m_initialIncomingNr=0;

    public AABT(){}
    public String toString(){
	if(ABT.ascendingOrder) return "AABT";
	else return "AABT-BAD-ORDER";
    }

    public synchronized void terminate(){
	crtState=Sstop;
	agent=null;
	genericAgent=null;
	myself=null;
	MySystem.out.println(" ABT receives Terminate");
        Synch_Reply();
	return;
    }

    //state machine
    synchronized public void run() {
	try{
	    rrun();
	}catch(Exception e){
	    e.printStackTrace();
	    MySystem.exit(1);
	}
    }
    private void rrun(){
	select.thread=Thread.currentThread();
	agent=(Agent)genericAgent;
	myself = genericAgent.getID();
	myName = myself.getName();
        Utils.aggregations=true;
	Utils.agentCost=new DCost();
	Utils.MAX_SECV_MSG=problem.workAmount;
	if(!initPhase()){
	    //MySystem.out.println("terminated before starting");
	    return;
	}
	//MySystem.out.println("after init phase");
	init(problem);
	//MySystem.out.println("after init");
	int sWait;
	for(;;){
	    if((((DCost)Utils.agentCost).getMessages()>Utils.MAX_SECV_MSG)&&(Utils.MAX_SECV_MSG>0))
		crtState=Stimeout;
	    //MySystem.out.println("State="+crtState);
	    int dim=0;
	    if(crtState!=Sstop)//if flow, do not force
		dim=agent.getOutputQueueSize(flow);
	    if(dim>FlowOThreshold){
		//MySystem.out.println("flowO:=false OQS="+dim);
		flowO=false;
	    }else flowO=true;
	    dim=getInputQueueSize();
	    if(dim<FlowILThreshold) flowI=true;
	    else if((dim=getInputQueueSize())>FlowIUThreshold){
		//MySystem.out.println("flowI:=false");
		flowI=false;
	    }
	    flow=flowO&&flowI;
	    if(!flow){
		//MySystem.out.println("not flowing");
		select.accept(6,_compactors);
	    }
	    switch(crtState){
	    case Sstart:
		crtState=instantiate();
		break;
	    case Sprocessing:
		select.accept(0,_terminate);
		select.accept(1,_accepted);
		select.accept(2,_ok);
		select.accept(3,_nogood);
		select.accept(4,_addLink);
		switch(Synch_Wait()){
		case 0:
		    crtState=Sstop;
		    break;
		case 1:
		    crtState=getAccepted();
		    break;
		case 2:
		    crtState=getOk();
		    break;
		case 3:
		    crtState=getNogood();
		    break;
		case 4:
		    crtState=getAddLink();
		    break;
		}
		break;
	    case Stimeout:
		AgentID target=((Agent)genericAgent).getBrokerID();
		DObject parameter=(DCost)(((DCost)Utils.agentCost).clone());
		if(!sndMsg(target,Commands.cFail,parameter))crtState=Sstop;
		else crtState=SwaitEnd;
                break;
	    case SwaitEnd:
		select.accept(0,_terminate);
		//may also wait and discard other messages
		select.accept(2,_accepted+MessageQueue.REFUSE);
		select.accept(3,_addLink+MessageQueue.REFUSE);
		//select.accept(4,_ok+MessageQueue.REFUSE);
		select.accept(5,_nogood+MessageQueue.REFUSE);
		//select.accept(6,_heuristic+MessageQueue.REFUSE);
		select.accept(7,_reorder+MessageQueue.REFUSE);
		if(Synch_Wait()==0) crtState=Sstop;
		break;
	    case Sstop:
		select.call(0,cAccepted,cAccepted._terminate);
		Synch_Wait();
		cAccepted.terminate();
		return;
	    }
	}
    }
    private int instantiate(){
	boolean found=false;//m_value=-1;
	for(int k=0;k<=m_myRange.getU();k++){
	    //MySystem.out.println("Instantiate:"+k);
	    if(m_nogoods[k]!=null){
		//MySystem.out.println("Existing Nogood:"+m_nogoods[k]);
		continue;
	    }
	    m_nogoods[k]=feasible(k);
	    if(m_nogoods[k]!=null){
		//MySystem.out.println("Nogood:"+m_nogoods[k]);
		continue;
	    }
	    found=true;
	    m_value=k;
	    break;
	}
	if(found){//m_value>=0){
	    m_counter++;
	    //MySystem.out.println("instantiates:"+m_value);
	    return announceSolution();
	}
	else return backtrack();
    }
    private int backtrack(){
	//MySystem.out.println("backtrack");
	Assignments nogood=new Assignments();
	Hashtable conflicts=new Hashtable();
	for(int k=0;k<m_nogoods.length;k++){
	    Iterator it=m_nogoods[k].set.iterator();
	    while(it.hasNext()){
		Assignment a=(Assignment)it.next();
		conflicts.put(a.variable,a);
	    }
	}
	Iterator it=conflicts.values().iterator();
	while(it.hasNext()){
	    nogood.add((Assignment)it.next());
	}
	AgentID target;
	if(nogood.set.size()==0){
	    target=((Agent)genericAgent).getBrokerID();
	    if(sndMsg(target,Commands.cEmptyNogood,(DCost)Utils.agentCost))
		return SwaitEnd;
	    else return Sstop;
	}
	target=getLast(nogood);
	DAssignments dn=new DAssignments(nogood,(DCost)Utils.agentCost);
	if(!sndMsg(target,Commands.cNogood,dn)) return Sstop;
	if(!GOB){//never
	    String var=getVariableAgent(target);
	    purgeNogoods(var);
	    m_view.remove(var);
	    return c_a_v();
	}else{
	    m_value=-1;
	    return Sprocessing;
	}
    }
    private int announcePartialSolution(){
// 	return Sprocessing;
//     }
//     private int announcePartialSolution1(){
	if(!ready()){
	    //MySystem.out.println("Not ready");
	    return Sprocessing;
	}
	AgentID agent; // targets of ACCEPTED
	DAccepted dAccepted=new DAccepted();
	dAccepted.agent=genericAgent.getID();
	dAccepted.senderName = genericAgent.getID().getName();
	dAccepted.history=IntersectionOfSolutions();

	accepts.acceptedCost.updateCost((DCost)((DCost)Utils.agentCost).clone());
	dAccepted.cost=(DCost)accepts.acceptedCost.clone();
	if(dAccepted.empty()) return Sprocessing;
	dAccepted.ID=accepts.AcceptedID;
	accepts.AcceptedID++;
	//MySystem.out.println("Sending:"+dAccepted.toShortString());
	if(accepts.endAgent)
	    if(!sndMsg(((Agent)genericAgent).getBrokerID(),
		       Commands.cAccepted,dAccepted))
		return Sstop;
	if(accepts.acceptedReceiver==null) return Sprocessing;
	if(!sndMsg(accepts.acceptedReceiver,Commands.cAccepted,dAccepted))
	    return Sstop;
	return Sprocessing;	
    }
    private Context IntersectionOfSolutions(){
	Context view=new Context();
	addInternalSolution(view);
	addAcceptedSolution(view);
	return view;
    }
    private void addInternalSolution(Context view){
	String var;
	DVarHistory dVarHistory;
	Iterator it=(Iterator) m_view.keys();
	while(it.hasNext()){
	    Assignment a=(Assignment)m_view.get(it.next());
	    dVarHistory=new DVarHistory(a.value);
	    view.put(a.variable,dVarHistory);
	}
	view.put(m_variable,new DVarHistory(new Range(m_value)));
    }
    private void addAcceptedSolution(Context view){
 	DVarHistory solHist, outHist;
	if(accepts.acceptedSendersNr==0)return;
 	Iterator it=(Iterator) accepts.acceptedIntersection.keys();
 	while(it.hasNext()){
 	    String var=(String)it.next();
 	    solHist=view.getDV(var);
 	    outHist=accepts.acceptedIntersection.getDV(var);
 	    if(solHist==null){
 		view.put(var,(DVarHistory)outHist.clone());
 	    }else{
 		solHist.restrict(outHist);
		view.put(var,solHist);
 	    }
 	}
    }
    private int getAddLink(){
	AgentID sender=m_mc.getSenderID();
	DAddVarLink dal=(DAddVarLink)m_mc.getArguments();
	((DCost)Utils.agentCost).incrementMessages(dal.cost);
	if(addedOutgoingLinks.contains(sender)) return Sprocessing;
	if(outgoingLinks.contains(sender)) return Sprocessing;
	addedOutgoingLinks.add(sender);
	Assignment assign=new Assignment();
	assign.variable=m_variable;
	assign.value=new Range(m_value);
	assign.counter=m_counter;
	DAssignment da=new DAssignment(assign,(DCost)Utils.agentCost);
	if(!sndMsg(sender,Commands.cOK,da))
	    return Sstop;
	return Sprocessing;
    }
    private int getAccepted(){
	DAccepted param=(DAccepted)m_mc.getArguments();
	accepts.acceptedIntersection=param.history;
	accepts.acceptedCost=((DAccepted)param).cost;
	return announcePartialSolution();
    }
    private int getOk(){
	Assignment olda,newa;
	DAssignment dass=(DAssignment)m_mc.getArguments();
	newa=dass.assign;
	((DCost)Utils.agentCost).incrementMessages(dass.cost);
	olda=(Assignment)m_view.get(newa.variable);
	if((olda!=null)&&(olda.counter>=newa.counter)) return Sprocessing;
	m_view.put(newa.variable,newa);
	if(olda!=null)purgeNogoods(newa.variable);
	int cav=c_a_v();
	if(cav!=Sprocessing) return cav;
 	if((accepts.acceptedIntersection!=null)||
 	   (accepts.acceptedSendersNr==0)){
	    //MySystem.out.println("going accepted");
 	    return announcePartialSolution();
	}
	return Sprocessing;
    }
    private int nogoodPos(Assignments as){
	int pos=-1;
	Iterator it=as.set.iterator();
	while(it.hasNext()){
	    Assignment a=(Assignment) it.next();
	    int npos=getPosition(a.variable);
	    if(npos>pos) pos=npos;
	}
	return pos;
    }
    private boolean nogoodEffic(Assignments as,int opos){
	if(opos==-1) return false;
	Iterator it=as.set.iterator();
	while(it.hasNext()){
	    Assignment a=(Assignment) it.next();
	    if(a.variable.equals(m_variable)) continue;
	    int npos=getPosition(a.variable);
	    if(npos>opos) return false;
	}
	return true;
    }
    private int getNogood(){
	DAssignments dass=(DAssignments)m_mc.getArguments();
	Assignments nogood=dass.nogood;
	((DCost)Utils.agentCost).incrementMessages(dass.cost);
	Assignments news= new Assignments();
	Assignments vnogood= new Assignments();
	Assignment myAssign=null;
	int removedValue=-1;
	Iterator it=nogood.set.iterator();
	while(it.hasNext()){
	    Assignment olda,a=(Assignment)it.next();
	    if(a.variable.equals(m_variable)){
		removedValue=a.value.getU();
		if(m_nogoods[removedValue]!=null){
		    int opos=nogoodPos(m_nogoods[removedValue]);
		    if(!nogoodEffic(nogood,opos))
			return Sprocessing;//resendToAgent(m_mc.getSenderID());
		}
		myAssign=a;
		continue;
	    }
	    olda=(Assignment)m_view.get(a.variable);
	    if(olda!=null){
		if(olda.counter>a.counter)
		    return resendToAgent(m_mc.getSenderID());
		if(olda.counter<a.counter) news.add(a);
	    }else news.add(a);
	    vnogood.add(a);
	}
	//if(removedValue<0) MySystem.exit("bad nogood:"+nogood);
	it=news.set.iterator();
	while(it.hasNext()){
	    Assignment a=(Assignment)it.next();
	    AgentID link=getAgent(a.variable);
	    m_view.put(a.variable,a);
	    if(!linked(link)){
		DAddVarLink dal=new DAddVarLink((DCost)Utils.agentCost);
		if(!sndMsg(link,Commands.cAddLink,dal))
		    return Sstop;
		addedIncomingLinks.add(link);
	    }else purgeNogoods(a.variable);
	}
	m_nogoods[removedValue]=vnogood;
 	int old_value=m_value;
	int cav=c_a_v();
	if(cav!=Sprocessing) return cav;
 	if(old_value==m_value)
	    return resendToAgent(m_mc.getSenderID());
	return Sprocessing;
    }
    private int resendToAgent(AgentID ag){
	if(m_value==-1) return Sprocessing;
	//if(getPosition(ag)<myID) return Sprocessing;
	Assignment assign=new Assignment();
	assign.counter=m_counter;
	assign.variable=m_variable;
	assign.value=new Range(m_value);
	DAssignment da=new DAssignment(assign,(DCost)Utils.agentCost);
	if(!sndMsg(ag,Commands.cOK,da)) return Sstop;
	return Sprocessing;
    }
    private int c_a_v(){
	//MySystem.out.println("c_a_v");//has a m_value
	if((m_value!=-1)&&(m_nogoods[m_value]==null)&&(feasible(m_value)==null))
	    return Sprocessing;
	return instantiate();
    }
    private boolean linked(AgentID ag){
	if(outgoingLinks.contains(ag)) return true;
	if(addedIncomingLinks.contains(ag)) return true;
	return false;
    }
    private void purgeNogoods(String var){
	for(int k=0;k<m_nogoods.length;k++){
	    if(m_nogoods[k]==null)continue;
	    if(m_nogoods[k].has(var)) m_nogoods[k]=null;
	}
    }
    private int announceSolution(){
	if(m_value==-1) return Sprocessing;
	Assignment assignment=new Assignment();
	assignment.variable=m_variable;
	assignment.counter=m_counter;
	assignment.value=new Range(m_value);
	DAssignment da=new DAssignment(assignment,(DCost)Utils.agentCost);
	//MySystem.out.println("announceSolution");
	Iterator it=addedOutgoingLinks.iterator();
	while(it.hasNext()){
	    AgentID ag=(AgentID)it.next();
	    //MySystem.out.println("outgoingLinks has "+ag);
	    if(getPosition(ag)<=myID) continue;
	    if(!sndMsg(ag,Commands.cOK,da)) return Sstop;
	}
	it=outgoingLinks.iterator();
	while(it.hasNext()){
	    AgentID ag=(AgentID)it.next();
	    //MySystem.out.println("outgoingLinks has "+ag);
	    if(getPosition(ag)<=myID) continue;
	    if(!sndMsg(ag,Commands.cOK,da)) return Sstop;
	}
	//MySystem.out.println("acc intersection:"+accepts.acceptedIntersection);
	//MySystem.out.println("accepts.acceptedSendersNr:"+accepts.acceptedSendersNr);
 	if((accepts.acceptedIntersection!=null)||
 	   (accepts.acceptedSendersNr==0)){
	    //MySystem.out.println("going accepted");
 	    return announcePartialSolution();
	}
	return Sprocessing;
    }
    private Assignments feasible(int val){
	Assignments assigns;

	for(int k=0;k<m_constraintsNr;k++){
	    assigns=new Assignments();
	    CRepresentation cr= m_constraints[k].getRepresentation();
	    int varNr=cr.getVariablesNr();
	    Range[] vals=new Range[varNr];
	    String[] vars=new String[varNr];
	    boolean checkable=true;
	    for(int v=0;v<varNr;v++){
		vars[v]=cr.getVariable(v);
		if(vars[v].equals(m_variable)){
		    vals[v]=new Range(val);
		    continue;
		}
		if(getPosition(vars[v])>myID){
		    checkable=false;break;
		}
		Assignment assign=(Assignment)m_view.get(vars[v]);
		if(assign!=null){
		    assigns.add(assign);
		    vals[v]=assign.value;
		}else vals[v]=problem.getSetOfVariables().getRange(vars[v]);
	    }
	    //MySystem.out.print("Space:");
	    //**for(int kk=0;kk<vals.length;kk++)
	      //**MySystem.out.print(cr.getVariable(kk)+vals[kk]);
	    //**MySystem.out.println("");
	    if(!checkable){
		//MySystem.out.println("Not checkable");
		continue;
	    }
	    cr.toString();
	    if(!cr.anyFeasible(vals)){
		return m_nogoods[val]=assigns;
	    }
	}
	return null;
    }
    private String getVariableAgent(AgentID agent){
	AgentData ad=(AgentData)dSearch.problemByAgent.get(agent);
	return ad.variable;
    }
    private AgentID getLast(Assignments nogood){
	int last=-1;
	Iterator it=nogood.set.iterator();
	while(it.hasNext()){
	    Assignment a=(Assignment)it.next();
	    int crt=getPosition(a.variable);
	    if(crt>last){
		last=crt;
	    }
	}
	return agents[last];
    }
    private int getPosition(String var){
	for(int k=0;k<agents.length;k++)
	    if(var.equals(getVariableAgent(agents[k]))) return k;
	MySystem.exit("no variable "+var);
	return -1;
    }
    private AgentID getAgent(String var){
	return agents[getPosition(var)];
    }
    private int getPosition(AgentID ag){
	for(int k=0;k<agents.length;k++)
	    if(ag.equals(agents[k])) return k;
	MySystem.exit("no agent "+ag);
	return -1;
    }
    boolean sndMsg(AgentID target, String command, Serializable message){
	select.accept(0,_terminate);
	select.call(1,genericAgent,genericAgent._sendCommand);
	if(Synch_Wait()==0){
	    //MySystem.out.println("A::got terminate");
	    return false;
	}
	//MySystem.out.println("sending:"+message+":to:"+target);
	genericAgent.sendCommand(command,message,target);
	return true;
    }   
    private boolean initPhase(){
	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverTypeAndProcedure);
	if(Synch_Wait()==0) return false;
	queue.setReceiverType(this,
			      new CommandSelector(Commands.cStartParameters),
			      _getStartParameters);
	
	//MySystem.out.println("Problem:"+problem);
	DSubscription myProblem=
	    new DSubscription(genericAgent.getID(),
			      problem.getVariables(),0,
			      problem.getComplexity(),
			      agent.getID().getName());
	myProblem.variable=problem.variable;
	if(!this.sndMsg(agent.getBrokerID(),Commands.cMyProblem,
			myProblem)) return false;
	select.accept(0,_terminate);
	select.accept(1,_getStartParameters);
	if(Synch_Wait()==0) return false;
	getStartParameters();

	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverTypeAndProcedure);
	if(Synch_Wait()==0) return false;
	queue.setReceiverType(this,
			      new CommandSelector(Commands.cOK),
			      _ok);

	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverTypeAndProcedure);
	if(Synch_Wait()==0) return false;
	queue.setReceiverType(this,
			      new CommandSelector(Commands.cNogood),
			      _nogood);

	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverTypeAndProcedure);
	if(Synch_Wait()==0){crtState=Sstop; return false;}
	queue.setReceiverType(this,
			      new CommandSelector(Commands.cAddLink),
			      _addLink);

	cAccepted=new CompactorAccepted(this, accepts.acceptedSendersNr, myComputationNum);
	new Thread(cAccepted).start();
	//MySystem.out.println("out of compactor accepted");

	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverType);
	if(Synch_Wait()==0){crtState=Sstop; return false;}
	queue.setReceiverType(cAccepted,
			      new CommandSelector(Commands.cAccepted));

	
	//MySystem.out.println("End of InitPhase");
	return true;
    }
    private void init(Problem problem){
	m_variablesNr=problem.getVariablesNr();
	Variable[] tmp=problem.getVariables();
	m_variables=new String[m_variablesNr];
	for(int k=0;k<m_variablesNr;k++)
	    m_variables[k]=tmp[k].getName();
	m_variable=problem.variable;

	m_myRange=problem.getSetOfVariables().getRange(m_variable);
	m_nogoods=new Assignments[m_myRange.getU()-m_myRange.getL()+1];
	m_constraints=problem.getSetOfConstraints().getConstraints();
	m_constraintsNr=m_constraints.length;
	Iterator it=(Iterator)dSearch.problemByAgent.keys();
	while(it.hasNext()){
	    MySystem.out.println("Here");
	    AgentID a=(AgentID)it.next();
	    AgentData ad=(AgentData)dSearch.getAgentData(a);
	    m_varAgent.put(a,ad.variable);
	    m_agentVar.put(ad.variable,a);
	}
	//MySystem.out.println("variablesNr="+m_variablesNr);
	for(int k=0;k<m_variablesNr;k++){
	    if(m_variable.equals(m_variables[k])) continue;
	    AgentID ag=getAgent(m_variables[k]);
	    if(!outgoingLinks.contains(ag))
	    outgoingLinks.add(ag);
	    //MySystem.out.println("variables="+m_variables[k]+ag);
	}
	computeIncomingNr();
    }
    private boolean ready(){
	if(m_value==-1)return false;
	int addedinc=getAddedIncoming();
	//MySystem.out.println("m_initialIncomingNr"+m_initialIncomingNr);
	//MySystem.out.println("addedinc"+addedinc);
	//MySystem.out.println("m_view.size()"+m_view.size());

	return m_initialIncomingNr+addedinc==m_view.size();
    }
    private int getAddedIncoming(){
	int ai=0;
	Iterator it=addedIncomingLinks.iterator();
	while(it.hasNext()){
	    if(getPosition((AgentID)it.next())<myID)
		ai++;
	}
	return ai;
    }
    private void computeIncomingNr(){
	m_initialIncomingNr=0;
	for(int k=0;k<m_variablesNr;k++){
	    if(m_variable.equals(m_variables[k])) continue;
	    if(getPosition(getAgent(m_variables[k]))<myID)
		m_initialIncomingNr++;
	}	
    }
    private void getStartParameters(){
	//Message_Command mc=msgPost.startParameters;
	StartLinks dsl=(StartLinks)m_mc.getArguments();
	//String command=(String)mc.getCommand();
	myComputationNum=m_mc.getComputationNum();
	//MySystem.out.println("MHC.myComputationNum="+myComputationNum);
	//StartLinks dsl=(StartLinks)param;
	//MySystem.out.println("got="+dsl);
	order=(POrder)dsl.order;
	dSearch=dsl.dSearch;
	setDefaultOrder();
	accepts.acceptedSendersNr=dSearch.acceptedSenders.size();
	accepts.acceptedReceiver=dSearch.acceptedReceiver;
	setAgentsPosition();
	if(dIncomingAgent.get().length==0)
	    accepts.endAgent=true;
    }
    private void setDefaultOrder(){
	agentsNr=dSearch.agentOrder.size();
	agents = new AgentID[agentsNr];
	defaultAgents=(AgentID[])((AgentID[])dSearch.sortedAgents).clone();
    }
    int getInputQueueSize(){
	return queue.size();
    }

    private void setAgentsPosition(){
	int i;
	cOrder.setCOrder(new Hashtable());
	for(i=0;i<order.sequence.length;i++){
	    agents[i]=order.sequence[i];
	    cOrder.put(agents[i],new IntObject(i));
	}
	for(int j=0;j<agents.length;j++){
	    if(cOrder.getIO(defaultAgents[j])!=null)continue;
	    agents[i]=defaultAgents[j];
	    cOrder.put(agents[i],new IntObject(i));
	    i++;
	}
	int newID=cOrder.getI(myself);
	//MySystem.out.println("my new ID:"+newID+" and old "+myID);
	if(newID!=myID){
	    myID=newID;
	    changeMyID();
	}
	getRelatedAgents();
	inComing.clear();outGoing.clear();
	registerInComing(dIncomingAgent.get());
	registerOutGoing(dOutgoingAgent.get());
	computeIncomingNr();
    }

    private boolean registerInComing(IncomingAgent agents[]){
        AgentID farAgent;
        for(int k=0;k<agents.length;k++){
	    farAgent=agents[k].getAgent();
	    if(!inComing.containsKey(farAgent))
		inComing.put(farAgent,farAgent);
	}
        return agents.length>0;
    }
    private boolean registerOutGoing(OutgoingAgent agents[]){
        AgentID farAgent;
        OutgoingAgent oa;
        for(int k=0;k<agents.length;k++){
	    farAgent=agents[k].getAgent();
	    oa=(OutgoingAgent)outGoing.get(farAgent);
	    if(oa==null) {
		outGoing.put(farAgent,agents[k]);
		//if(!outgoingLinks.contains(farAgent))
		//    outgoingLinks.add(farAgent);
		ArrayList vars;
		vars=agents[k].variables;
	    } else{
		ArrayList variables=agents[k].variables;
		for(int j=0;j<variables.size();j++){
		    String s=(String)variables.get(j);
		    if(!oa.variables.contains(s))
			oa.variables.add(s);
		}
	    }
	}
        return true;
    }

    //called from run when changeID is set
    private void changeMyID(){
// 	if(mHCks==null)return;//at initPhase
// 	if(mHCinst==mHCks[myID])return;
// 	MySystem.out.println("ChangeMyID set "+myID);
// 	select.call(1,mHCinst,mHCinst._setInstantiation);
// 	Synch_Wait();
// 	int k=mHCinst.getLevel();
// 	POrder pOrder=order.getOLevel(k);
// 	mHCinst.setInstantiation(pOrder,false);mHCinst.Synch_Reply();
// 	//myID=newID;
// 	mHCinst=mHCks[myID];
// 	select.call(1,mHCinst,mHCinst._setInstantiation);
// 	Synch_Wait();
// 	pOrder=(POrder)order.clone();
// 	mHCinst.setInstantiation(pOrder,true);mHCinst.Synch_Reply();
    }

    private void getRelatedAgents(){
	Hashtable outgoingsH=new Hashtable();
	Hashtable incomingsH=new Hashtable();
	Iterator keys = (Iterator) dSearch.problemByAgent.keys();
	while (keys.hasNext()){
	    AgentID agent = (AgentID) keys.next();
	    outgoingsH.put(agent,getOutGoing(agent));
	    incomingsH.put(agent,getInComing(agent));
	}
	IncomingAgent[] incomingAgent=(IncomingAgent[])incomingsH.get(myself);
	OutgoingAgent[] outgoingAgents=(OutgoingAgent[])outgoingsH.get(myself);
	dIncomingAgent=new DIncomingAgent(incomingAgent);
	dOutgoingAgent=new DOutgoingAgent(outgoingAgents);
    }

    // getAgents
    OutgoingAgent[] getOutGoing(AgentID agent){
	OutgoingAgent oAgent[]=new OutgoingAgent[0];
	Hashtable outgoing=new Hashtable();
	Variable svars[]=new Variable[0];
	int pos1,pos2;
	pos1=cOrder.getI(agent);
	AgentData ad=(AgentData) dSearch.problemByAgent.get(agent);
	if(ad!=null) svars=ad.getVariables();
	else return new OutgoingAgent[0];
	int svarsNr=svars.length;
	for(int k=0;k<svarsNr;k++){
	    String variableCrt=svars[k].getVariable();
	    ArrayList alist;
	    alist=(ArrayList)dSearch.problemByVariable.get(variableCrt);
	    int vAgentsNr=alist.size();
	    for(int a=0;a<vAgentsNr;a++){
		AgentID ag=(AgentID) alist.get(a);
		pos2=cOrder.getI(ag);
		if(pos1<pos2){
		    OutgoingAgent oa;
		    oa=(OutgoingAgent)outgoing.get(ag);
		    if(oa==null)oa=new OutgoingAgent(ag);
		    oa.insert(variableCrt);
		    outgoing.put(ag,oa);
		}
	    }
	}
	return (OutgoingAgent[]) outgoing.values().toArray(new OutgoingAgent[0]);
    }

    private IncomingAgent[] getInComing(AgentID agent){
	Hashtable incoming=new Hashtable();
	Variable svars[]=new Variable[0];
	int pos1,pos2;
	pos1=cOrder.getI(agent);
	AgentData ad=(AgentData) dSearch.problemByAgent.get(agent);
	if (ad!=null) svars=ad.getVariables();
	else return new IncomingAgent[0];
	int svarsNr=svars.length;
	for(int k=0;k<svarsNr;k++){
	    String variableCrt=svars[k].getVariable();
	    ArrayList alist;
	    alist=(ArrayList) dSearch.problemByVariable.get(variableCrt);
	    int vAgentsNr=alist.size();
	    for(int a=0;a<vAgentsNr;a++){
		AgentID ag=(AgentID) alist.get(a);
		pos2=cOrder.getI(ag);
		if(pos1>pos2){
		    IncomingAgent oa;
		    oa=(IncomingAgent)incoming.get(ag);
		    if(oa==null)
			oa=new IncomingAgent(ag);
		    incoming.put(ag,oa);
		}
	    }
	}
	return (IncomingAgent[]) incoming.values().toArray(new IncomingAgent[0]);
    }
    synchronized public void getMessage(Message message){
	m_mc=(Message_Command)message;
	//Object param=(Object)m_mc.getArguments();
	String command=(String)m_mc.getCommand();
	//MySystem.err.println("MHC.got:"+command+" "+m_mc);
	Synch_Reply();
    }
}
