/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package abt;

import java.util.*;
import sjavap.*;
import utils.*;
import platform.*;
import parameters.*;

class CompactorAccepted implements MessageReceiver, Runnable{

 /**    active object support (needs implements Reply)   **/
 /*********************************************************/
 /**/ Synch_List select = new Synch_List(this);           //
 /**/ synchronized public void Synch_Reply()              //
 /**/   { notify();   }                                   //
 /**/ int now() {return Kernel.kern.currentTime;}         //
 /**/ int Synch_Wait() {                                  //
 /**/   Kernel.kern.Synch_Request(select);                //
 /**/   do{try {wait();} catch(InterruptedException e){}} //
 /**/   while(select.nbEntries!=0);                       //
 /**/   return select.Value; }                            //
 /*********************************************************/

    private AABT MHCscheduler;
    private Message gotMessage=null;
    private int myComputationNum;
    private DCost localCost=new DCost();
    private int outGoingNr;
    private int crtState;
    private boolean activeOutput=false;
    //active methods
    final public static int _terminate=2;
    final public static int _setState=3;
    //states
    final static private int Sreceiving=0;
    final static private int SemptyReceiving=2;
    final static private int Sstop=4;

    //privates
    private boolean validAccepted = true;
    private int empties = 0;  //nr. of empty spaces
    //agentID:DAccepted
    Hashtable accepted = new Hashtable();
    //String v: Hashtable (agentID:DVarHist)
    Hashtable ranges = new Hashtable();
    //String v: DVarHist
    Context spaces = new Context();

    CompactorAccepted(AABT scheduler, int outGoingNr, int myComputationNum){
	this.outGoingNr = outGoingNr;
	this.myComputationNum=myComputationNum;
	MHCscheduler=scheduler;
    }

    synchronized public void run() {
	int sWait;
	select.thread=Thread.currentThread();
	crtState=SemptyReceiving;
	for(;;){
	    switch(crtState){
	    case Sstop:
		return;
	    case SemptyReceiving:
                select.accept(0,_terminate);
		select.accept(1,_getMessage);
		//select.accept(2,_setState);
		sWait = Synch_Wait();
		if(sWait==1){
		    getMessage();
		    if(validAccepted&&
		       (accepted.size()>=outGoingNr)){
			//set by getMessage()
			crtState = Sreceiving;
		    }
		}
		break;
	    case Sreceiving:
                select.accept(0,_terminate);
		select.accept(1,_getMessage);
		//select.accept(2,_setState);
		//if(activeOutput)
		select.call(3,MHCscheduler,MHCscheduler._accepted);
		sWait = Synch_Wait();
		if(sWait==1){
		    getMessage();
		    if(!validAccepted){ //set by getMessage()
			crtState = SemptyReceiving;
		    }
		}
		if(sWait==3){
		    DAccepted acc=new DAccepted();
		    acc.history=new Context(spaces.context);
		    acc.cost=(DCost)localCost.clone();
		    Message nm=
			new Message_Command(Commands.cAccepted, acc,null);
		    MHCscheduler.getMessage(nm);
		    crtState = SemptyReceiving;
		}
		break;
	    }
	}
    }

    public synchronized void terminate(){
	crtState=Sstop;
        Synch_Reply();
    }

    synchronized public void setActiveState(boolean activeOutput){
	this.activeOutput=activeOutput;
        Synch_Reply();
    }

    synchronized public void getMessage(Message message){
	gotMessage=message;
	if(message.getComputationNum()!=myComputationNum){
	    gotMessage=null;
	    MySystem.err.println("compactorAccepted:!!my myComputationNum="+myComputationNum);
	    MySystem.err.println("compactorAccepted:!!my getComputationNum()="+message.getComputationNum());
	    MySystem.exit(1);//why-debug
	}
        Synch_Reply();
    }
    private void getMessage(){
	Message message=gotMessage;
	DAccepted mAccepted=(DAccepted)((Message_Command)message).getArguments();
	//MySystem.err.println(mAccepted.toShortString());
	AgentID ag=mAccepted.agent;
	DAccepted lAcc = (DAccepted)accepted.get(ag);
	if((lAcc==null)||lAcc.olderThan(mAccepted)){
	    accepted.put(ag,mAccepted);
	    localCost.updateCost(mAccepted.cost);
	    //for each incoming variable
	    Iterator it=(Iterator)mAccepted.history.keys();
	    while(it.hasNext()){
		String var=(String)it.next();
		Hashtable rVar=(Hashtable)ranges.get(var);
		if(rVar==null) ranges.put(var,rVar=new Hashtable());
		DVarHistory inc =
		    mAccepted.history.getDV(var);
		DVarHistory prev =
		    (DVarHistory)rVar.get(ag);
		if((prev!=null)&&(!prev.range.different(inc.range))){
		    DVarHistory dv=spaces.getDV(var);
		    dv.updateHistory(inc);//take history if newest
		}else{
		    //if((prev==null)||(prev.range.different(inc.range))){
		    rVar.put(ag,inc);
		    Iterator ite=rVar.values().iterator();
		    DVarHistory nspc= //new space
			(DVarHistory)((DVarHistory)ite.next()).clone();
		    while(ite.hasNext()){
			DVarHistory dv = (DVarHistory)ite.next();
			nspc.restrict(dv);//nspc.updateHistory(dv);
		    }
		    if(validAccepted){
			if(nspc.range.size()<=0){
			    validAccepted=false;
			    empties++;
			}
			spaces.put(var,nspc);
		    }else{
			DVarHistory pspc= //previous space
			    spaces.getDV(var);
			spaces.put(var,nspc);
			if(nspc.range.size()<=0){
			    empties++;
			}
			if((pspc!=null)&&(pspc.range.size()<=0)){
			    empties--;
			    validAccepted= //)validSpace();
				(empties==0);
			}
		    }
		}
	    }
	    if(!validAccepted){
		//MySystem.err.println("Nr of accepted="+accepted.size()+":of:"+outGoingNr);
		if(accepted.size()>=outGoingNr){
		    //MySystem.err.println("Nr of accepted empties:"+empties);
		}
	    }
	}//else MySystem.err.println("Old Accepted");
    }

    private boolean validSpace(){
	Iterator it=(Iterator) spaces.values();
	while (it.hasNext())
	    if(((DVarHistory)it.next()).range.size()<=0)
		return false;
	return true;
    }
}
