/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package abtr;
import java.util.*;
import csp.*;
import parameters.*;

public class AssignmentRefs implements Cloneable {
    private ArrayList conflicts;
    private static final AssignmentRef[] sArray=new AssignmentRef[0];
    public String toString(){
	String s="{";
	for(int k=0;k<conflicts.size();k++)
	    s=s+((k>0)?",":"")+get(k);
	return s+"}";
    }
    public AssignmentRefs(){
	conflicts=new ArrayList();
    }
    public AssignmentRefs(AssignmentRefs cs){
	conflicts=(ArrayList)cs.conflicts.clone();
    }
    public AssignmentRefs(Set s){
	conflicts=new ArrayList(s);
    }
    public AssignmentRefs(Context c){
	conflicts=new ArrayList(c.keySet());
    }
    public int getLastLevel(){
	int result=-1;
	for(int k=conflicts.size()-1;k>=0;k--){
	    AssignmentRef ar=(AssignmentRef)conflicts.get(k);
	    if(result<ar.level) result=ar.level;
	}
	return result;
    }
    public void removeRefsOfLevel(int level){
	for(int k=conflicts.size()-1;k>=0;k--){
	    AssignmentRef ar=(AssignmentRef)conflicts.get(k);
	    if(ar.level==level) conflicts.remove(k);
	}
    }
    public boolean addMin(String var, int level) {
	return addMin(new AssignmentRef(var,level));
    }
    public boolean addMin(AssignmentRef ar) {
	for(int k=0;k<conflicts.size();k++) {
	    AssignmentRef o=(AssignmentRef)conflicts.get(k);
	    if(o.var.equals(ar.var)) {
		if(ar.higherParameter(o)) {
		    conflicts.remove(k);
		    return conflicts.add(ar);
		}
		return false;
	    }
	}
	return conflicts.add(ar);
    }
    public boolean add(String var, int level) {
	return add(new AssignmentRef(var,level));
    }
    public boolean add(AssignmentRef ar) {
	for(int k=0;k<conflicts.size();k++) {
	    AssignmentRef o=(AssignmentRef)conflicts.get(k);
	    if(o.var.equals(ar.var)) {
		if(o.higherParameter(ar)) {
		    conflicts.remove(k);
		    return conflicts.add(ar);
		}
		return false;
	    }
	}
	return conflicts.add(ar);
    }
    public AssignmentRef get(int k){
	return (AssignmentRef)conflicts.get(k);
    }
    public int size(){
	return conflicts.size();
    }
    public int sizeLevel(int level){
	int sizeL=0;
	for(int k=conflicts.size()-1;k>=0;k--) {
	    AssignmentRef o=(AssignmentRef)conflicts.get(k);
	    if(o.level==level) sizeL++;
	}
	return sizeL;
    }
    public Iterator iterator(){
	return conflicts.iterator();
    }
    //return !null if we have at least level
    public AssignmentRef contains(AssignmentRef o){
	return contains(o.var,o.level);
    }
    public boolean disabledBy(AssignmentRefs ars){
	for(int k=ars.size()-1;k>=0;k--){
	    AssignmentRef ar=ars.get(k);
	    if(contains(ar.var,ar.level)!=null)return true;
	}
	return false;
    }
    public AssignmentRef contains(String var,int level){
	for(int k=0;k<conflicts.size();k++) {
	    AssignmentRef o=(AssignmentRef)conflicts.get(k);
	    if(o.var.equals(var)) 
		if(o.level>=level) return o;
	}
	return null;
    }
    public AssignmentRef contains(int level){
	for(int k=0;k<conflicts.size();k++) {
	    AssignmentRef o=(AssignmentRef)conflicts.get(k);
	    if(o.level>=level) return o;
	}
	return null;
    }
    public void clear(){
	conflicts.clear();
    }
    public boolean addAll(AssignmentRefs cs){
	boolean modified=false;
	Iterator it=cs.iterator();
	while(it.hasNext()){
	    AssignmentRef ar=(AssignmentRef)it.next();
	    if(add(ar)) modified=true;
	}
	return modified;
    }
    public AssignmentRef[] toArray(){
	return (AssignmentRef[])conflicts.toArray(sArray);
    }
    public Object clone(){
	return new AssignmentRefs(this);
    }
}
