/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package abtro;
import platform.*;
import parameters.*;

public class POrder implements DObject,Cloneable{
    public AgentID[] sequence;
    public int[] history;
    public POrder(){
	sequence=new AgentID[0];
	history=new int[0];
    }
    public POrder(AgentID[] refAgents, int[] refHist){
	sequence=refAgents;
	history=refHist;
    }
    public boolean equals(POrder o){
	return History.isIdentical(history, o.history);
    }
    public boolean isIdentical(POrder o){
	if(o==null) return false;
	return History.isIdentical(history, o.history);
    }
    //get the level of the lowest MHCk interested in this Order
    public int getInterestLevel(){
	if(history.length<=0) return -1;
	return history[history.length-2]+1;
    }
    public int changeLevel(POrder o){
	return History.changeRLevel(history,o.history);
    }
    public boolean IDisableParam(POrder o){
	return History.firstDisablesSecond(history,o.history);
    }
    //the order of level deciding A^k
    public POrder getOLevel(int k){
	POrder result=new POrder();
	result.history=History.getHistory(history,k-1);
	int seqLen = sequence.length;
	if(seqLen>k+1) seqLen=k+1;
	result.sequence=new AgentID[seqLen];
	for(int i=0;i<seqLen;i++)
	    result.sequence[i]=sequence[i];
	return result;
    }
    public Object clone(){
	return new POrder((AgentID[])sequence.clone(),
			 (int[])history.clone());
    }
    public String toString(){
	String s="";
	for(int k=0;k<sequence.length;k++)
	    s=s+sequence[k].getName()+":";
	s=s+History.toString(history);
	return s;
    }
}
