/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package abtro.msg;
import platform.*;
import parameters.*;
import csp.*;
import utils.*;
import java.util.*;

public class DRAccepted implements DObject {
    public String senderName="Unknown";
    // variable mapped to DVarHistory
    public Context history;
    public HashSet constraintsIDs=new HashSet();
    public HashSet allConstraintsIDs=new HashSet();
    public AgentID agent;
    public DCost cost;
    public long ID=0;
    static public String toString(HashSet hSet){
	String s="";
	if(hSet==null) return s;
	Iterator it=hSet.iterator();
	while(it.hasNext()){
	    s=s+";"+it.next();
	}
	return s;
    }
    public boolean vide() {
	if(history==null) {
	    //MySystem.out.println("Empty history in accepted");
	    return true;
	}
	if(history.size()<=0) {
	    //MySystem.out.println("Empty history in accepted");
	    return true;
	}
	return false;
    }
    public boolean olderThan(DRAccepted oa) {

	//MySystem.err.println("Checking:"+this+"\nversus:"+oa);

	if(oa.history==null) {
	    //MySystem.out.println("olderThan:empty history in param");
	    return false;
	}
	if((ID>oa.ID)&&(ID-oa.ID>0)) {
	    //MySystem.out.println("olderThan: ID="+ID+">oa.ID="+oa.ID);
	    return false;
	}
	if((ID<oa.ID)&&(oa.ID-ID>0)) {
	    //MySystem.out.println("olderThan: ID="+ID+"<oa.ID="+oa.ID);
	    return true;
	}
	if(history==null) {
	    //MySystem.out.println("olderThan: history==null");
	    return true;
	}
	Iterator it=(Iterator)history.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    DVarHistory oah=oa.history.getDV(var);
	    if(oah==null)
		continue;
	    DVarHistory inh=history.getDV(var);
	    if(inh.olderThan(oah)) {
		//MySystem.out.println("olderThan:inh.olderThan(oah) at:"+var);
		return true;
	    }
	    if(oah.olderThan(inh)) {
		//MySystem.out.println("olderThan:oah.olderThan(inh) at:"+var);
		return false;
	    }
	}
	return false;
    }
    public boolean olderThan(OutgoingAgent oa) {
	if(oa.solution==null) {
	    MySystem.out.println("olderThan:empty solution in outgoing");
	    return false;
	}
	if((ID>oa.AcceptedID)&&(ID-oa.AcceptedID>0)){
	    MySystem.out.println("olderThan: ID>oa.AcceptedID");
	    return false;
	}
	if((ID<oa.AcceptedID)&&(oa.AcceptedID-ID>0)) {
	    MySystem.out.println("olderThan: ID<oa.AcceptedID");
	    return true;
	}
	if(history==null) {
	    MySystem.out.println("olderThan: history==null");
	    return true;
	}
	Iterator it=(Iterator)history.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    DVarHistory oah=(DVarHistory)oa.solution.get(var);
	    if(oah==null)
		continue;
	    DVarHistory inh=history.getDV(var);
	    if(inh.olderThan(oah)) {
		MySystem.out.println("olderThan:inh.olderThan(oah) at:"+var);
		return true;
	    }
	    if(oah.olderThan(inh)) {
		MySystem.out.println("olderThan:oah.olderThan(inh) at:"+var);
		return false;
	    }
	}
	return false;
    }
    public boolean empty(){
	boolean result=true;
	if(history==null){
	    //MySystem.out.println("Empty history in accepted");
	    return true;
	}
	Iterator it=(Iterator)history.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    Range range=history.getR(var);
	    int size=range.size();
	    if(size<=0){
		//MySystem.out.println("empty domain:"+var+"="+range+" size="+size);
		return true;
	    }
	    //MySystem.out.println("non empty domain found:"+var+"="+range);
	    result=false;
	}
	return result;
    }
    public String toString(){
	String s;
	s=senderName+":Accepted Solution:";
	s=s+" ID="+ID+"\n";
	if(history==null)
	    s=s+"null\n";
	else{
	    Iterator it=(Iterator)history.keys();
	    while(it.hasNext()){
		String var=(String)it.next();
		s=s+var+history.getR(var).toString()+"\n";
	    }
	}
	s=s+" Ckd:"+toString(constraintsIDs)+",All:"+toString(allConstraintsIDs);
	if(cost!=null)
	    s=s+cost.toString();
	return s+"\n";
    }
    public String toShortString(){
	String s;
	s=senderName+":Accepted:";
	s=s+" ID="+ID;
	if(history==null)
	    s=s+":null";
	else{
	    Iterator it=(Iterator)history.keys();
	    while(it.hasNext()){
		String var=(String)it.next();
		s=s+var+history.getR(var).toShortString()+":";
	    }
	}
	return s+"\n";
    }
    public String toVeryShortString(){
	String s;
	s=senderName+":Accepted:";
	s=s+" ID="+ID+"\n";
	return s;
    }
}
