/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package aggreg;
import csp.*;
import utils.*;
import parameters.*;

class Cover1 implements Cover {
    int tab[];
    int dim[]=new int[1];
    String vars[];
    int[] score; //direction scores, loaded by extend, expandable, expand
    Cover1(C1Representation mat){
        int[] _tab=mat.getMatrix();
        dim[0]=_tab.length;
        tab=new int[dim[0]];
   
        Refresh(mat);
    }
    public CRepresentation getCRepresentation() {
	C1Representation result=
	    new C1Representation((int[])tab.clone(),(int[])dim.clone(),
				 vars,null);
	return result;
    }
    public void init(CRepresentation mat){
        Refresh((C1Representation)mat);
    }
    boolean expandable(Range[] box, int direction, int value){
	return chk(value);
	/*
        Range tmp=box[0];
        box[0]=new Range(value);
        for(int k=box[0].getL();k<=box[0].getU();k++){
	    if(!chk(k)){ //edges first
		box[0]=tmp;
		return false;
	    }
	}
        box[0]=tmp;
        return true;
	*/
    }
    boolean excessive(Range[] box, Range[] domain, int direction, int value){
	return false;
	/*
        Range tmp=box[0];
        box[0]=new Range(value);
        int k,x;
        MySystem.out.println("Checking excessive");
        for(k=0;k<1;k++){
	    // if(k==direction)continue;
	    // do not matter if expandable
	    //  on bigger directions
	    if(score[k]>=score[0])
		continue;//direction ingrata
	    if((x=box[k].getL()-1)>=domain[k].getL())
		if(expandable(box,k,x)){
		    box[0]=tmp;
		    MySystem.out.println("Checking: excessive found");
		    return true;
		}
	    if(domain[k].getU()>=(x=box[k].getU()+1))
		if(expandable(box,k,x)){
		    box[0]=tmp;
		    MySystem.out.println("Checking: excessive found");
		    return true;
		}
	}
        box[0]=tmp;
        MySystem.out.println("Checking: excessive not found");
        return false;
	*/
    }
    public void setScore(int[] _score){
        score=_score;   
    }
    // ? excess tells if the excess is bothering (variab importance) true if this is not the first direction. 
    public void expand(Range[] box, Range[] domain, int direction, boolean excess){ //...;k<dim[direction];...
        for(int k=box[0].getU()+1;k<=domain[0].getU();k++){
	    /* always false
           if(excess && excessive(box,domain,0,k)){
               // excess exists & is bothering
               MySystem.out.println("Excess on direction "+direction);
               return;
           }
	    */
           if(!expandable(box,direction,k))
                    return;
           box[direction].setU(k);
           MySystem.out.println("Expanded direction: "+direction+" value: "+k);
        }
    }
    boolean chk(int a){
        MySystem.out.println("verify: ["+a+"]");
	((DCost)Utils.agentCost).incrementChecks();
	MySystem.out.println(((DCost)Utils.agentCost).toString());
        return tab[a]==1;
    }
    boolean good(int[] i){
        return chk(i[0]);
    }
    public boolean findIn(Range[] result, Range[] domain, Scanable region){
        final int dim=1;
        int dim1= dim-1;
        Range[] searchField=new Range[dim];

        boolean[] firstRun=new boolean[dim];
        firstRun[0]=true;

        MySystem.out.println("Domain:");
        Print(domain);
        MySystem.out.println("Region:");
        region.regionPrint();
        searchField[0]=region.restrict((Range)domain[0].clone(),0);
        MySystem.out.println("Search field:");
        Print(searchField);
        
        int[] i=new int[dim];
        i[0]=searchField[0].getL();
        int s0=region.getStartPoint(0);
        MySystem.out.println("Start Point s0="+s0);
        if(i[0]<s0){i[0]=s0;}
        int upper0=searchField[0].getU();
        for(;i[0]<=upper0;i[0]++){
            MySystem.out.println("i[0]=" + i[0]);
	    if(good(i)){
		result[0]=new Range(i[0]);
		//?region.setFirst(i0,i1);
		return true;
	    }
	}
        return false;
    }
    public void Print(){
        for(int k=0;k<tab.length;k++)
	    MySystem.out.print(tab[k]+" ");
        MySystem.out.println("");
    }
    private void Print(Range[] dom){
        for(int k=0;k<dom.length;k++){
           MySystem.out.println("["+dom[k].getL()+"\t,"+dom[k].getU()+"\t]");
        }
    }
    void Refresh(C1Representation mat){
        int[] _tab=mat.getMatrix();
	tab=(int[])_tab.clone();
    }
    void Refresh(C1Representation mat, Range[] range){
        int[] _tab=mat.getMatrix();
        for(int k=range[0].getL();k<=range[0].getU();k++)
	    tab[k]=_tab[k];
    }
    public void mark(Range[] range){
        int up0=range[0].getU();
        int k=range[0].getL();
        for(;k<=up0;k++){
                tab[k]=0;
        }
    }
}
