/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package aggreg;
import csp.*;
import utils.*;
import parameters.*;

class Cover2 implements Cover {
    int tab[][];
    int dim[]=new int[2];
    String vars[];
    int[] score; //direction scores, loaded by extend, expandable, expand
    Cover2(C2Representation mat){
        int[][] _tab=mat.getMatrix();
	if(_tab==null){
	    MySystem.err.println("Cover2:Null Matrix!!");
	    dim[0]=dim[1]=0;
	}else{
	    dim[0]=_tab.length;
	    if(dim[0]>0)
		dim[1]=_tab[0].length;
	    else dim[1]=0;
	}
        tab= new int[dim[0]][dim[1]];
   
        Refresh(mat);
    }
    public CRepresentation getCRepresentation() {
	C2Representation result=
	    new C2Representation((int[][])tab.clone(),(int[])dim.clone(),
				 vars,null);
	return result;
    }
    public void init(CRepresentation mat){
        Refresh((C2Representation)mat);
    }
    boolean expandable(Range[] box, int direction, int value) throws ArrayIndexOutOfBoundsException {
        //MySystem.out.println("expandable:Checking dir:"+direction+" value:"+value);
        Range tmp=box[direction];
	int kk=-100;
        box[direction]=new Range(value);
        for(int k=box[0].getL();k<=box[0].getU();k++){
	    int first=box[1].getL(),last=box[1].getU();
	    try{
		kk=-100; // for trace
		if(!chk(k,last)){ //edges first
		    box[direction]=tmp;
		    return false;
		}
		for(kk=first;kk<last;kk++)
		    if(!chk(k,kk)){
			box[direction]=tmp;
			return false;
		    }
	    }catch(ArrayIndexOutOfBoundsException e) {
		MySystem.err.println("Cover2:expandable:fatal error at direction="+direction+",value="+value);
		MySystem.err.println("Cover2:expandable:fatal error at kk="+kk+",k="+k+",first="+first+",last="+last);
		box[direction]=tmp;
		for(int ik=0;ik<box.length; ik++)
		    MySystem.println(box[ik]);
		e.printStackTrace();
		throw e;
		//MySystem.exit(1);
	    }
	}
        box[direction]=tmp;
        return true;
    }
    boolean excessive(Range[] box, Range[] domain, int direction, int value)throws ArrayIndexOutOfBoundsException{
        Range tmp=box[direction];
        box[direction]=new Range(value);
        int k,x;
	x=-2000; //for trace
        //MySystem.out.println("excessive:Checking direction:"+direction);
        for(k=0;k<2;k++) {
	    // if(k==direction)continue;
	    // do not matter if expandable
	    //  on bigger directions
	    if(score[k]>=score[direction]){
		//MySystem.out.println("excessive:Direction not interesting:"+k);
		continue;//direction ingrata
	    }
	    try{
		x=-2000;
		if((x=box[k].getL()-1)>=domain[k].getL())
		    if(expandable(box,k,x)){
			box[direction]=tmp;
			//MySystem.out.println("excessive: found");
			return true;
		    }
		if(domain[k].getU()>=(x=box[k].getU()+1))
		    if(expandable(box,k,x)){
			box[direction]=tmp;
			//MySystem.out.println("excessive: found");
			return true;
		    }
	    }catch(ArrayIndexOutOfBoundsException e){
		MySystem.println("Cover2:excessive:ArrayIndexOutOfBoundsException:x:k:dir:sc[0]:score[1]:"+x+":"+k+":"+direction+":"+score[0]+":"+score[1]);
		for(int lk=0;lk<domain.length;lk++) {
		    MySystem.println(domain[lk]);
		}
		MySystem.println(tmp);
		e.printStackTrace();
		throw e;
		//MySystem.exit(1);
	    }
	}
        box[direction]=tmp;
        //MySystem.out.println("excessive: not found");
        return false;
    }
    public void setScore(int[] _score){
        score=_score;   
    }
    // ? excess tells if the excess is bothering (variab importance) true if this is not the first direction. 
    public void expand(Range[] box, Range[] domain, int direction, boolean excess)throws ArrayIndexOutOfBoundsException{ 
	//...;k<dim[direction];...
	int k=box[direction].getU()+1;
	//MySystem.out.println("Expanding in direction "+direction+" between:"+k+" and "+domain[direction].getU());
        for(;k<=domain[direction].getU();k++){
	    try{
		//MySystem.out.println("Dealing with k="+k);
		if(excess && excessive(box,domain,direction,k)){
		    // excess exists & is bothering
		    //MySystem.out.println("Excess on direction "+direction);
		    return;
		}
		if(!expandable(box,direction,k))
		    return;
	    }catch(ArrayIndexOutOfBoundsException e) {
		MySystem.println("Cover2:expand: k,excess="+k+";"+(excess?"true":"false"));
		e.printStackTrace();
		throw e;
	    }
	    box[direction].setU(k);
	    //MySystem.out.println("Expanded direction: "+direction+" value: "+k);
        }
    }
    private boolean chk(int a, int b) throws ArrayIndexOutOfBoundsException {
        //MySystem.out.println("verify: ["+a+","+b+"]");
	((DCost)Utils.agentCost).incrementChecks();
	MySystem.out.println((DCost)Utils.agentCost);
	if((tab.length<a+1)||(tab[a].length<b+1)) {
	    MySystem.err.println("Cover2:chk:Error verifying: ["+a+","+b+"]-EXIT");
	    throw new ArrayIndexOutOfBoundsException("Cover2:chk");
	}
        return tab[a][b]==1;
    }
    public boolean good(int[] i, int[] reorder){
	try{
	    return chk(i[reorder[0]],i[reorder[1]]);
	}catch(ArrayIndexOutOfBoundsException e) {
	    MySystem.err.println("Cover2:good(i,reorder),i=["+i[0]+":"+i[1]+"];reorder=["+reorder[0]+":"+reorder[1]+"]");
	    e.printStackTrace();
	    MySystem.exit(1);
	}
	return false;
    }
    public boolean findIn(Range[] result, Range[] domain, Scanable region){
        final int dim=2;
        int dim1= dim-1;
        int dim2= dim-2;
        int[] order=region.getOrder();
        //MySystem.out.println("Setting first search order ["+order[0]+","+ order[1]+" ]");
        int[] reorder=region.getReorder();
        //MySystem.out.println("Setting first search reorder ["+reorder[0]+","+ reorder[1]+" ]");
        Range[] searchField=new Range[dim];

        boolean[] firstRun=new boolean[dim];
        firstRun[0]=firstRun[1]=true;

        //MySystem.out.println("Domain:");
        //Print(domain);
        //MySystem.out.println("Region:");
        //region.regionPrint();
        searchField[0]=region.restrict((Range)domain[0].clone(),0);
        searchField[1]=region.restrict((Range)domain[1].clone(),1);
        //MySystem.out.println("Search field:");
        //Print(searchField);
        
        int[] i=new int[dim];
        i[dim1]=searchField[order[dim1]].getL();
        int s0=region.getStartPoint(order[dim1]);
        //MySystem.out.println("Start Point s0="+s0);
        if(i[dim1]<=s0){
	    i[dim1]=s0;
	}else //we are jumping to a later value, all the
	    //other starting points should be disabled
	    firstRun[1]=false;
	//MySystem.out.println("Start Point s0<-"+i[dim1]);
        int upper0=searchField[order[dim1]].getU();
	// if we will however jump to the next
	if(i[dim1]>upper0)
	    firstRun[1]=false;
        for(;i[dim1]<=upper0;i[dim1]++){
            //MySystem.out.println("i["+dim1+"]=" + i[dim1]);
            int upper1=searchField[order[dim2]].getU();
            i[dim2]=searchField[order[dim2]].getL();
            if(firstRun[1]){
                firstRun[1]=false;
                int s1=region.getStartPoint(order[dim2]);
                //MySystem.out.println("Start Point s1="+s1);
                if(i[dim2]<s1)
                    i[dim2]=s1;
            }
            for(;i[dim2]<=upper1;i[dim2]++){
                //MySystem.out.println("i["+dim2+"]=" + i[dim2]);
                if(good(i,reorder)){
                    result[order[dim1]]=new Range(i[dim1]);
                    result[order[dim2]]=new Range(i[dim2]);
                    //?region.setFirst(i0,i1);
                    return true;
                }
            }
        }
	//MySystem.out.println("findIn:Search space exausted");
        return false;
    }
    int printTrials=0;
    public void Print(){
	if(printTrials>2){
	    MySystem.err.println("Cover2:Print:Too many IllegalMonitorStateException");
	    printTrials=0;
	    return;
	}
	if(tab==null){
	    MySystem.out.println("Cover2:empty");
	    return;
	}
	try {
	    for(int k=0;k<tab.length;k++){
		for(int kk=0;kk<tab[k].length;kk++)
		    MySystem.out.print(tab[k][kk]+" ");
		MySystem.out.println("");
	    }
	    MySystem.out.println("");
	} catch (IllegalMonitorStateException e){
	    // a bug of java
	    e.printStackTrace();
	    MySystem.err.println("Cover2:Print:IllegalMonitorStateException");
	    printTrials++;
	    Print();
	}
	printTrials=0;
    }
    private void Print(Range[] dom){
        for(int k=0;k<dom.length;k++){
           MySystem.out.println("["+dom[k].getL()+"\t,"+dom[k].getU()+"\t]");
        }
    }
    void Refresh(C2Representation mat){
        int[][] _tab=mat.getMatrix();
        for(int k=0;k<_tab.length;k++)
            tab[k]=(int[])_tab[k].clone();
    }
    void Refresh(C2Representation mat, Range[] range){
        int[][] _tab=mat.getMatrix();
        for(int k=range[0].getL();k<=range[0].getU();k++)
            for(int kk=range[1].getL();k<=range[1].getU();kk++)
                tab[k][kk]=_tab[k][kk];
    }
    public void mark(Range[] range){
	if(range.length<2)
	    MySystem.err.println("Bad range length:"+range.length);
        int up0=range[0].getU();
        int up1=range[1].getU();
        int k=range[0].getL();
        for(;k<=up0;k++){
            int kk=range[1].getL();
            for(;kk<=up1;kk++){
                tab[k][kk]=0;
            }
        }
    }
}
