/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package csp;
import java.io.*;
import utils.*;
import parameters.*;

public class C1Representation extends CRepresentation {
    int tab[];
    SetOfVariables vset;
    int dim[]=new int[1];
    String vars[]=new String[1];

    C1Representation(Constraint _owner){
	super(_owner);
	vset=getConstraint().getSetOfConstraints().getProblem().getSetOfVariables();
    }
    public C1Representation(int[]_tab, int[]_dim, 
			    String[]_vars, SetOfVariables _vset){
	super(null);
	tab=_tab;dim=_dim;vars=_vars;vset=_vset;
    }
    public int[] getDim(){
	return dim;
    }
    public int[] getMatrix(){
	return tab;
    }
    Constraint getConstraint(){
	return owner;
    }    
    public boolean anyFeasible(Range[] box){
	for(int k=box[0].getL(); k<=box[0].getU(); k++){
	    ((DCost)Utils.agentCost).incrementChecks();
	    if(tab[k]!=0) 
		return true;
	}
	return false;
    }
    public boolean isFeasible(Range[] box){
	for(int k=box[0].getL(); k<=box[0].getU(); k++){
	    ((DCost)Utils.agentCost).incrementChecks();
	    if(tab[k]==0) 
		return false;
	}
	return true;
    }
    public void coverSeeds(int seedsNr){
    }
    public boolean satisfiesConstraint(String var1, int val1)
	throws FalseConstraintException{
	if(var1.compareTo(vars[0]) != 0) 
	    throw new FalseConstraintException();
 
	Range range = vset.getRange(vars[0]);
	if(val1 < range.getL() || val1 > range.getU())
	    return false;
	((DCost)Utils.agentCost).incrementChecks();
	if(tab[val1-range.getL()] == 0)
	    return false;
   
	return true;    
    }
    public int getVariablesNr(){
	System.out.println("Constraint unidirectional");
	return 1;
    }
    public String getVariable(int index){
	return vars[index];
    }
    int getID(int index){
	return owner.getID(index);
    }   
    public boolean loadFile(RandomAccessFile fis, int fileType){
	vars[0]=vset.loader(fis, fileType);
	dim[0]=vset.getSize(vars[0]);
	tab=new int[dim[0]];
	int x,y;
	for(x=0;x<dim[0];x++){
	    tab[x]=Utils.getInt(fis);
	    //System.out.print(tab[x]+"\t");
	}
	//System.out.println("");
	return true;
    }
}
