/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package csp;
import java.io.*;
import utils.*;
import parameters.*;

public class C2Representation extends CRepresentation {
    int tab[][];
    SetOfVariables vset;
    int dim[]=new int[2];
    String vars[]=new String[2];

    public C2Representation(int[][]_tab, int[]_dim, 
		     String[]_vars, SetOfVariables _vset){
	super(null);
	tab=_tab;dim=_dim;vars=_vars;vset=_vset;
    }
    C2Representation(Constraint _owner){
	super(_owner);
	vset=getConstraint().getSetOfConstraints().getProblem().getSetOfVariables();
    }
    public int[] getDim(){
	return dim;
    }
    public int[][] getMatrix(){
	return tab;
    }
    Constraint getConstraint(){
	return owner;
    }
    public boolean anyFeasible(Range[] box){
	for(int i=box[0].getL(); i<=box[0].getU(); i++)
	    for(int j=box[1].getL(); j<=box[1].getU(); j++){
		((DCost)Utils.agentCost).incrementChecks();
		if(tab[i][j]!=0) 
		    return true;
	    }
	return false;
    }
    public boolean isFeasible(Range[] box){
	for(int i=box[0].getL(); i<=box[0].getU(); i++)
	    for(int j=box[1].getL(); j<=box[1].getU(); j++){
		((DCost)Utils.agentCost).incrementChecks();
		if(tab[i][j]==0) 
		    return false;
	    }
	return true;
    }
    private int getClosest(int x,int y,int[]posx,int[]posy,int seedsNr) {
	int min=-1;
	double minDist=-1.;
	for(int k=0;k<seedsNr;k++) {
	    if(posx[k]==-1) continue;
	    double dist=Math.sqrt((posx[k]-x)*(posx[k]-x)+
				 (posy[k]-y)*(posy[k]-y));
	    if((minDist==-1.)||(dist<minDist)){
		minDist=dist;
		min=k;
	    }
	}
	return min;
    }
    private void getSeedPosition(int k,int[]newSeed,int[][]classif){
	newSeed[0]=newSeed[1]=0;
	int kElem=0;
	int xSum=0,ySum=0;
	for(int x=0;x<dim[0];x++)
	    for(int y=0;y<dim[1];y++) {
		if(classif[x][y]==k){
		    xSum+=x; ySum+=y; kElem++;
		}
	    }
	if(kElem!=0){
	    newSeed[0]=xSum/kElem;
	    newSeed[1]=ySum/kElem;
	}else
	    newSeed[0]=-1;
	MySystem.out.println("got new seed:"+k+" "+kElem+" at "+
			     newSeed[0]+" "+newSeed[1]);
    }
    private void coverSeed(int k,int[][]classif) {
	int minX=-1,maxX=-1,minY=-1,maxY=-1;
	for(int x=0;x<dim[0];x++)
	    for(int y=0;y<dim[1];y++)
		if(classif[x][y]==k) {
		    if((minX==-1)||(x<minX)) minX=x;
		    if((maxX==-1)||(x>maxX)) maxX=x;
		    if((minY==-1)||(y<minY)) minY=y;
		    if((maxY==-1)||(y>maxY)) maxY=y;
		}
	MySystem.out.println("got seed:"+k+" at:"+minX+"-"+maxX+" "+
			     minY+"-"+maxY);
	if((minX<0)||(minY<0))
	    MySystem.err.println("Error at:"+k+" x:"+minX+
				 " y:"+minY+" \n"+toString(classif));
	for(int x=minX;x<=maxX;x++)
	    for(int y=minY;y<=maxY;y++) {
		tab[x][y]=1;
	    }
    }
    public void coverSeeds(int seedsNr) {
	int posx[]=new int[seedsNr];
	int posy[]=new int[seedsNr];
	int crtPos=0, crtSeed=0;
	int dist=(dim[0]*dim[1])/seedsNr;
	for(int x=0;x<dim[0];x++)
	    for(int y=0;y<dim[1];y++){
		crtPos++;
		if((crtPos%dist==dist/2)&&(crtSeed<seedsNr)) {
		    posx[crtSeed]=x; posy[crtSeed]=y;
		    crtSeed++;
		}
	    }
	int[][]classif=new int[dim[0]][dim[1]];
	for(int x=0;x<dim[0];x++)
	    for(int y=0;y<dim[1];y++) classif[x][y]=0;
	boolean change;
	int rounds=0;
	do{
	    change=false;
	    for(int x=0;x<dim[0];x++)
		for(int y=0;y<dim[1];y++) {
		    if(tab[x][y]==0) classif[x][y]=0;
		    else{
			int k=getClosest(x,y,posx,posy,seedsNr);
			if(k!=classif[x][y]-1) {
			    change=true;
			    classif[x][y]=k+1;
			}
		    }
		}
	    MySystem.out.println("Got classif:\n"+toString(classif));
	    if(change){
		change=false;
		for(int k=0;k<seedsNr;k++) {
		    int[]newSeed=new int[2];
		    getSeedPosition(k+1,newSeed,classif);
		    if((newSeed[0]!=posx[k])||
		       ((newSeed[0]!=-1)&&(newSeed[1]!=posy[k]))) {
			posx[k]=newSeed[0];
			posy[k]=newSeed[1];
			change=true;
		    }
		}
	    }
	    for(int ss=0;ss<seedsNr;ss++)
		MySystem.out.println("Seed:"+(ss+1)+" "+
				     posx[ss]+" "+posy[ss]);
	    //MySystem.out.println("Got classif:\n"+toString(classif));
	    if(rounds++>100)break;
	}while(change==true);
	for(int k=0;k<seedsNr;k++) {
	    if(posx[k]==-1)continue;
	    coverSeed(k+1,classif);
	}	
    }

    public boolean satisfiesConstraint(String var1, int val1,
				       String var2, int val2)
				       throws FalseConstraintException
    {
	if(var1.compareTo(vars[0]) != 0 ||
	   var2.compareTo(vars[1]) != 0)
	    throw new FalseConstraintException();
	
	Range r1 = vset.getRange(vars[0]),
	    r2 = vset.getRange(vars[1]);

	if(val1 < r1.getL() || val1 > r1.getU() ||
	   val2 < r2.getL() || val2 > r2.getU())
	    return false;	
	
	((DCost)Utils.agentCost).incrementChecks();
	if(tab[val1-r1.getL()][val2-r2.getL()] == 0)
	    return false;

	return true;    
    }
    public String toString(){
	String s="";
	for(int k=0;k<tab.length;k++){
	    for(int kk=0;kk<tab[k].length;kk++)
		s=s+tab[k][kk]+" ";
	    s=s+"\n";
	}
	s=s+"\n";
	return s;
    }
    public String toString(int[][]tab){
	String s="";
	for(int k=0;k<tab.length;k++){
	    for(int kk=0;kk<tab[k].length;kk++)
		s=s+tab[k][kk]+" ";
	    s=s+"\n";
	}
	s=s+"\n";
	return s;
    }
    public int getVariablesNr(){
	return 2;
    }
    public String getVariable(int index){
	return vars[index];
    }
    public int getID(int index){
	return owner.getID(index);
    }   
    public boolean loadFile(RandomAccessFile fis, int fileType){
	vars[0]=vset.loader(fis, fileType);
	vars[1]=vset.loader(fis, fileType);
	dim[0]=vset.getSize(vars[0]);
	dim[1]=vset.getSize(vars[1]);
	tab=new int[dim[0]][dim[1]];
	int x,y;
	for(x=0;x<dim[0];x++){
	    for(y=0;y<dim[1];y++){
		tab[x][y]=Utils.getInt(fis);
		//System.out.print(tab[x][y]+"\t");
	    }
	    //System.out.println("");
	}
	return true;
    }
}
