/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
//-----------------------------------------------------------------------------
// Intelligent Agents Collaborating in Distributed Problem Solving

// Supervisors:   Marius Silaghi, Djamila Sam-Haroud 
// Author:        Marius Silaghi

// File:          Constraint.java
// Version:       1.0
// Description:   
//----------------------------------------------------------
// Interface:
//----------------------------------------------------------

package csp;
import java.io.*;

public class Constraint implements Serializable{

    CRepresentation mat;
    SetOfConstraints owner;

    public int[] varIDs=new int[2];

    public Constraint(SetOfConstraints _owner) {
	owner=_owner;
    }
    Constraint(SetOfConstraints _owner, int varNr) {
	owner=_owner;
    }
    public void setCRepresentation(CRepresentation _mat){
	mat=_mat;
    }
    public int getVariablesNr() {
	return mat.getVariablesNr();
    }

    public String getVariable(int index) { 
	return mat.getVariable(index);
    }

    public void setID(int index,int id) {
	varIDs[index]=id;
    }

    public int getID(int index) {
	return varIDs[index];
    }   

    public CRepresentation getRepresentation() {
	return mat;
    }

    public SetOfConstraints getSetOfConstraints() { 
	return owner;
    }

    public boolean loadFile(RandomAccessFile fis, int varNr, int fileType) {
	switch(varNr) {
	case 1:
	    mat=new C1Representation(this);
	    mat.loadFile(fis,fileType);
	    break;
	case 2: 
	    mat=new C2Representation(this);
	    mat.loadFile(fis,fileType);
	    break;
	default:
	    return false;
	}
	return true;
    }
}
