/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package csp;
import java.io.Serializable;

public class Range implements Cloneable,Serializable{
    private int low,up;
    public Range(int _low, int _up){
	low=_low;up=_up;
    }
    public Range(Range range){
	if(range==null){
	    //System.err.println("Initializing range with null");
	    return;
	}
	low=range.low;up=range.up;
    }
    public Range(int val){
	low=up=val;
    }
    public void setL(int _low){
	low=_low;
    }
    public void setU(int _up){
	up=_up;
    }
    public boolean different(Range cmp){
	if ((up!=cmp.up)||(low!=cmp.low))
	    return true;
	return false;
    }
    // argument more restricting than this
    public boolean restricting(Range cmp){
	if ((up>cmp.up)||(low<cmp.low))
	    return true;
	return false;
    }
    // argument and this have common elements
    public boolean intersecting(Range cmp){
	if(cmp.size()<=0)return false;
	if ((up>=cmp.low)&&(low<=cmp.up))
	    return true;
	return false;
    }
    // argument contained in this
    public boolean contains(Range cmp){
	if ((up>=cmp.up)&&(low<=cmp.low))
	    return true;
	return false;
    }
    public void restrictL(int _low){
	if(_low>low)
	    low=_low;
    }
    public void restrictU(int _up){
	if(_up<up)
	    up=_up;
    }
    public static Range intersect(Range r1, Range r2){
	Range r=new Range(r1);
	r.restrictL(r2.low);
	r.restrictU(r2.up);
	return r;
    }
    public void restrict(Range range){
	restrictL(range.low);
	restrictU(range.up);
    }
    public void restrict(int _low, int _up){
	restrictL(_low);
	restrictU(_up);
    }
    public int getL(){
	return low;
    }
    public int size(){
	return up-low+1;
    }
    public int getU(){
	return up;
    }
    public Object clone(){
	try {
	    return super.clone();
	}
	catch (Exception e) {
	    System.err.println("Range:clone:!!");
	    System.err.println(e);
	    e.printStackTrace();
	    return null;
	}
    }
    public String toString(){
	return "["+low+"\t,"+up+"\t]";
    }
    public String toShortString(){
	return "["+low+","+up+"]";
    }
}
