/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
//-----------------------------------------------------------------------------
// Intelligent Agents Collaborating in Distributed Problem Solving

// Supervisors:   Marius Silaghi, Djamila Sam-Haroud 
// Author:        Michel Galley

// File:          SetOfDomains.java
// Version:       1.0
// Description:   
//-----------------------------------------------------------------------------
// Interface:
//-----------------------------------------------------------------------------


package csp;
import java.util.*;
import java.io.*;

public class SetOfDomains implements Serializable, Cloneable
{
    private String[] varNames;
    private Domain[] domains;

    //Hashtable domains = new Hashtable();
    //SetOfVariables vars;

    public SetOfDomains(SetOfVariables set) 
    {
	Variable[] vars = set.getVariables();
	varNames = new String[vars.length];
	domains = new Domain[vars.length];	
	String varName;

	// set domains from variables
	for(int i=0; i<vars.length; i++) {
	    varName = vars[i].getName();
	    varNames[i] = new String(varName);
	    domains[i] = new Domain(set.getRange(varName));
	    //domains.put(new String(varName), 
	    //		new Domain(set.getRange(varName)));
	}
    }

    public Object clone()
    {
	SetOfDomains clone = null;

	try { clone = (SetOfDomains)super.clone(); }
	catch(CloneNotSupportedException e) 
	{ e.printStackTrace(); System.exit(-1); }

	clone.domains = new Domain[domains.length];

	for(int i=0; i<domains.length; i++)
	    clone.domains[i] = (Domain)domains[i].clone();
   
	return clone;
    }

    public Domain getDomain(String var)
    {
	for(int i=0; i<varNames.length; i++)
	    if(varNames[i].compareTo(var) == 0)
		return domains[i];
	System.err.println("Domain not found");
	return null;
    }

    public Domain[] getDomains()
    {
	return domains;
    }

//     public void and(SetOfDomains otherDomains)
//     {
// 	for(int i=0; i<domains.length; i++)
// 	    domains[i].and(otherDomains.domains[i]);
//     }

    public String toString()
    {
	String str = "";

	for(int i=0; i<varNames.length; i++)
	    str += varNames[i]+"={"+domains[i]+"} ";
	return str;
    }
}

