/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
//-----------------------------------------------------------------------------
// Intelligent Agents Collaborating in Distributed Problem Solving

// Supervisors:   Marius Silaghi, Djamila Sam-Haroud 
// Author:        Marius Silaghi

// File:          SetOfVariables.java
// Version:       1.0
// Description:   
//-----------------------------------------------------------------------------
// Interface:
//-----------------------------------------------------------------------------


package csp;
import java.util.*;
import java.io.*;
import utils.*;

public class SetOfVariables implements Serializable {
    Hashtable vars = new Hashtable();
    Problem problem;

    SetOfVariables(Problem _problem) {
	problem=_problem;
    }

    public boolean contains(String s) {
	return vars.get(s)!=null;
    }

    public int getVariablesNr(){
	return vars.size();
    }

    public int getOwner(String variable){
	return ((ERange)vars.get(variable)).getOwner();
    }

    public Variable[] getVariables(){
	int varNr=getVariablesNr();
	String v;
	int owner;
	Iterator keys;
	Variable[] svars= new Variable[varNr];
	keys = (Iterator) vars.keys();
	for(int vcrt=0;vcrt<varNr;vcrt++){
	    v = (String) keys.next();
	    owner=((ERange)vars.get(v)).getOwner();
	    svars[vcrt]=new Variable(v,owner>0);
	    //System.out.println("var "+svars[vcrt].getVariable());
	}
	return svars;
    }

    public Range getRange(String v) {
	try {
	    Range d=(Range) vars.get(v);
	    return new Range(d.getL(),d.getU());
	} 
	catch (Exception e) {
		System.err.println("Variable not found:" + v);
	}
	return null;
    }

    public int getSize(String var) {
	try {
	    Range d=(Range) vars.get(var);
	    return d.getU()-d.getL()+1;
	}
	catch (Exception e) {
	    System.err.println("Variable not found:" + var);
	}
	return 0;
    }

    public String loader(RandomAccessFile fis, int fileType) {
	String v;
	int low,up;
	int owner=0;
      
	v=Utils.getString(fis);
	low=Utils.getInt(fis);
	up =Utils.getInt(fis);
	if(fileType!=0)
	    owner =Utils.getInt(fis);
	if(vars.containsKey(v)){
	    //System.out.println("OldVar: "+v+":["+low+","+up+"]");
	    return v;
	}
	vars.put(v,new ERange(low,up,owner));
	//System.out.println("NewVar: "+v+":["+low+","+up+"], owner: "+owner);
	return v;
    }
}
