/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dcsp;
import java.util.*;
import java.awt.Color;
import csp.*;
import utils.*;
import parameters.*;
import aggreg.*;
import hc.*;

class BinarySplitting implements Splitter{
    boolean LEFT_FIRST=true;
    int variablesNr;
    int constraintsNr,crtConstraint;
    int[] constraintsID;
    String[] variables;
    Constraint[] constraints;
    IYConstraint[] yconstraints;
    private IYConstraint clConstraint=null;
    Range currentDomains[], initialDomains[];
    PAgent agent;
    IOHashtable vIDs=new IOHashtable();
    ArrayList domains=new ArrayList();
    ArrayList futureDomains=new ArrayList();
    Range[] currentProposal=null;;
    boolean crtInstantiated=false;
    boolean noModif;

    Range[][] oldDomains,oldResults;
    Range[] clInstantiation;

    public IOHashtable getvIDs(){return vIDs;}
    public String[] getVariables(){return variables;}
    public Range[] getInitialDomains(){return initialDomains;}
    public Constraint[] getConstraints(){return constraints;}
    public int[] getConstraintsID(){return constraintsID;}
    public int   getConstraintsNr(){return constraintsNr;}
    public int   getVariablesNr(){return variablesNr;}


    BinarySplitting(Problem problem, PAgent agent) {
	this.agent=agent;
	initCSP(problem);
	currentDomains =new Range[variablesNr];
	initialDomains =new Range[variablesNr];
	for(int k=0;k<variablesNr;k++){
	    initialDomains[k]=
		problem.getSetOfVariables().getRange(variables[k]);
	}
        constraintsID=new int[constraintsNr];
	for(int i=0;i<constraintsNr;i++){
            constraintsID[i]=i;
	    int localVariablesNr=yconstraints[i].getVariablesNr();
	    int k1=yconstraints[i].getID(0);
	    String var0= yconstraints[i].getVariable(0);
	    int k2=k1;
	    String var1=var0;
	    if(localVariablesNr==2){
		k2=yconstraints[i].getID(1);
		var1=yconstraints[i].getVariable(1);
	    }
	    agent.createColorMatrix(i,
				    var0, var1,
				    initialDomains[k1].size(),
				    initialDomains[k2].size());

	    if(localVariablesNr==2)
		agent.setColor(var0, var1,
			       ((C2Representation)((YConstraint)yconstraints[i]).getRepresentation()).getMatrix(),
			       0,0,
			       initialDomains[k1].size()-1,
			       initialDomains[k2].size()-1,
			       0,0,
			       Color.white,Color.lightGray,
			       Color.gray,Color.lightGray);
	}
    }
    public void initSearch(){
	Range[] dom=(Range[])initialDomains.clone();
	for(int k=0;k<dom.length;k++){
	    dom[k]=(Range)initialDomains[k].clone();
            currentDomains[k]=(Range)dom[k].clone();
        }
	domains.add(dom);
	futureDomains.add(dom);
    }
    void initCSP(Problem problem){
	int k,i,j;
	variablesNr=problem.getVariablesNr();
	Variable[] tmp=problem.getVariables();
	variables=new String[variablesNr];
	for(k=0;k<variablesNr;k++){
	    variables[k]=tmp[k].getName();
	    vIDs.put(variables[k],new Integer(k));
	}
	constraints=problem.getSetOfConstraints().getConstraints();
	constraintsNr=constraints.length;

	oldResults=new Range[constraintsNr][];
	oldDomains=new Range[constraintsNr][];

	yconstraints=new YConstraint[constraintsNr];
	for(i=0;i<constraintsNr;i++){
	    yconstraints[i]=new YConstraint(constraints[i]);
	    int localConstraintsNr=yconstraints[i].getVariablesNr();
	    for(k=0;k<localConstraintsNr;k++){
              yconstraints[i].setID(k,getvID(yconstraints[i].getVariable(k)));
	      constraints[i].varIDs[k] =yconstraints[i].getID(k);
            }
	}
	if(false&&(constraintsNr>0)){
	    clConstraint=new YConstraint(constraints[0]);
	    int localConstraintsNr=yconstraints[0].getVariablesNr();
	    for(k=0;k<localConstraintsNr;k++){
		clConstraint.setID(k,getvID(clConstraint.getVariable(k)));
            }
	}
    }


    public int getvID(String variable){
	return vIDs.geti(variable);
    }
    public Range[] getSol(){ //getSolution
	return currentProposal;
    }
    private String getSDes(Range[]doms){
	String s="";
	for(int k=0;k<variablesNr;k++)
	    s=s+variables[k]+doms[k]+" ";
	return s;
    }

    public int search(){
	MySystem.out.println("Search");
	//if(currentProposal!=null) return 1;
	if(futureDomains.size()==0){
	    currentProposal=null;
	    MySystem.out.println("Search Failure");
	    return -1;
	}
	currentProposal=(Range[])((Range[])futureDomains.remove(0)).clone();
	for(int k=0;k<variablesNr;k++)
	    currentProposal[k]=(Range)currentProposal[k].clone();
	if(!mHC(currentProposal)){
	    currentProposal=null;
	    return search();
	}
	if(feasibleCurrentProposal())return 1;
	int splittedVar=getMaxDomainVarID(currentProposal);
	MySystem.out.println("splittedVar="+variables[splittedVar]);
	int dim=currentProposal[splittedVar].size();
	MySystem.out.println("splittedVar dim="+dim);
	if(dim==1) return 1;
	MySystem.out.println("in:"+getSDes(currentProposal));
	Range[] delayed=
	    extractSideDomains(LEFT_FIRST,splittedVar,dim/2,currentProposal);
	MySystem.out.println("out:"+getSDes(currentProposal));
	MySystem.out.println("outnext:"+getSDes(delayed));
	if(delayed[splittedVar].size()<=0)MySystem.exit("BS Empty"+dim);
	futureDomains.add(delayed);
	if(!mHC(currentProposal)){
	    currentProposal=null;
	    return search();
	}
	return 1;
    }
    private int getMaxDomainVarID(Range[]domain){
	int maxdID=0;
	int maxsize=domain[0].size();
	for(int k=1;k<domain.length;k++){
	    if(domain[k].size()>maxsize){
		maxsize=domain[k].size();
		maxdID=k;
	    }
	}
	return maxdID;
    }
    private Range[] extractSideDomains(boolean side, int v, int dim, Range[]domain){
	Range[] result=new Range[variablesNr];
	for(int i=0;i<variablesNr;i++) result[i]=domain[i];
	result[v]=new Range(domain[v]);
	domain[v]=new Range(domain[v]);
	if(side!=LEFT_FIRST){
	    result[v].setU(result[v].getL()+dim-1);
	    domain[v].setL(domain[v].getL()+dim);
	}else{
	    result[v].setL(result[v].getU()-dim+1);
	    domain[v].setU(domain[v].getU()-dim);
	}
	return result;
    }
    private boolean feasibleCurrentProposal(){
	for(int k=0;k<constraintsNr;k++){
	    IYConstraint iyc=yconstraints[k];
	    int size=iyc.getVariablesNr();
	    Range[] domain=new Range[size];
	    for(int l=0;l<size;l++) 
		domain[l]=currentProposal[iyc.getID(l)];
	    if(!constraints[k].getRepresentation().isFeasible(currentProposal))
		return false;
	}
	return true;
    }
    
    public void updateCLConstraint() {}
    boolean mHC(Range[] domain){return HC.HC(domain);}
    // this is called in order to initialize the domains, knowing the CSP, after the first HC
    public void resetSearch(){
	futureDomains.clear();
	futureDomains.add(currentDomains);
	currentProposal=null;
    }
    public ArrayList getNewConstraint() {
	ArrayList al=new ArrayList();
	if(clConstraint==null)return al;
	Constraint c=clConstraint.getCoverConstraint();
	if(c!=null){
	    MySystem.out.println("newConstraint:");
	    MySystem.out.println(c.getRepresentation());
	    al.add(c);
	}
	return al;
    }
    private Range[] getInstantiation(IYConstraint cons, Range[] instantiations){
        Range[] dom=new Range[cons.getVariablesNr()];
        for(int k=0; k<dom.length; k++){
            int id=cons.getID(k);
	    dom[k]=instantiations[id];//allowed domains
        }
        return dom;
    }

    public int setCurrentDomains(Range[]domains){
	boolean nomodif=true;
	for(int l=0; l<variablesNr;l++){
	    if(currentDomains[l].different(domains[l])){
		nomodif=false;break;
	    }
	}
	if(nomodif){
	    if(currentProposal!=null){
		MySystem.out.println("setCurrentDomains:SannouncedS");
		return agent.SannouncedS;
	    }
	    MySystem.out.println("setCurrentDomains:SprocM");
	    return agent.SprocessingM;
	}
	Range[]oldDomains=currentDomains;
	currentDomains=domains;
	futureDomains.clear();
	futureDomains.add(currentDomains);
	for(int l=0; l<variablesNr;l++)
	    MySystem.out.println("setCurrentDomains:"+variables[l]+
				 "="+currentDomains[l]);
	currentProposal=null;
	for(int l=0; l<variablesNr;l++)
	    if(currentDomains[l].restricting(oldDomains[l])){
		MySystem.out.println("setCurrentDomains:EngineNogoodExpansion");
		return agent.EngineNogoodExpansion;
	    }
	MySystem.out.println("setCurrentDomains:");
	return agent.SprocessingM;
    }
}
