/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dcsp;
import csp.*;
import java.util.*;
import parameters.*;

class CN implements DObject,Cloneable{
    String var;
    Range label;
    Context dep;
    int proposalID;

    public String toString(){
	return var+label+((dep==null)?"":("c{"+dep+"}"))+"pID="+proposalID;
    }
    CN(CN source){
	this.var=source.var;
	this.label=source.label;
	this.dep=source.dep;
	this.proposalID=source.proposalID;
    }
    CN(String var, Range label, Context dep, int proposalID){
	this.var=var;
	this.label=label;
	this.dep=dep;
	this.proposalID=proposalID;
    }
    public boolean sameAs(CN l){
	if(dep.size()!=l.dep.size())   return false;
	Iterator it=(Iterator)dep.keys();
	while(it.hasNext()){
	    String var=(String) it.next();
	    int[] h=dep.geth(var);
	    int[] lh=l.dep.geth(var);
	    if(lh==null) return false;
	    if(!History.isIdentical(h,lh)) return false;
	}
	return true;
    }
    public boolean hasLevel(int level){
	Iterator it=(Iterator)dep.keys();
	while(it.hasNext()){
	    String var=(String) it.next();
	    int[] h=dep.geth(var);
	    if(h[h.length-2]>=level)return true;
	}
	return false;
    }
    DVarHistory getDV(){
	return dep.getDV(var);
    }
    String getVariable(){return var;}
    boolean isNogood(){
	return label.size()<=0;
    }
    //true if old null
    public static boolean olderFirstThanSecond(LCN h,CN l){
	if(h==null)return true;
	return h.proposalID<l.proposalID;
    }
    public static boolean olderFirstThanSecond(LCN h,LCN l){
	if(h==null)return true;
	return h.proposalID<l.proposalID;
    }
    public Object clone(){
	return new CN(this);
    }
}
