/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dcsp;
import java.util.*;
import csp.*;
import parameters.*;

public class CNSet implements DObject,Cloneable{
    ArrayList labeling;
    public String toString(){
	String s="";
	for(int i=labeling.size()-1;i>=0;i--)
	    s=s+getCN(i)+(i>0?" ":"");
	return s;
    }
    public CNSet(){
	labeling=new ArrayList();
    }
    public CNSet(Collection c){
	labeling=new ArrayList();
	Iterator it=c.iterator();
	while(it.hasNext())
	    labeling.add((CN)((CN)it.next()).clone());
	//labeling=new ArrayList(c);//clone
    }
    public CNSet(int k){
	labeling=new ArrayList(k);
    }
    public boolean add(CN l){
	return labeling.add(l.clone());
    }
    public void addAll(CNSet lset){
	for(int k=0;k<lset.size();k++)
	    add((CN)lset.labeling.get(k));
    }
    public CN getCN(int k){
	return (CN)((CN)labeling.get(k)).clone();
    }
    public boolean isNogood(){
	if(labeling.size()!=1)
	    return false;
	CN lb=(CN)labeling.get(0);
	return lb.isNogood();
    }
    public boolean hasNogood(){
	for(int k=0;k<labeling.size();k++)
	    if(((CN)labeling.get(k)).isNogood())
		return true;
	return false;
    }
    public CNSet getNoEmpties(){
	CNSet result=(CNSet)clone();
	result.removeNogood();
	return result;
    }
    private CN removeNogood(){
	for(int k=labeling.size()-1;k>=0;k--)
	    if(((CN)labeling.get(k)).isNogood())
		return (CN)labeling.remove(k);
	return null;
    }
    public CN getNogood(){
	for(int k=labeling.size()-1;k>=0;k--)
	    if(((CN)labeling.get(k)).isNogood())
		return (CN)labeling.get(k);
	return null;
    }
    public int size(){
	return labeling.size();
    }
    public void clear(){
	labeling.clear();
    }
    public CN remove(int index){
	return (CN)labeling.remove(index);
    }
    public Iterator iterator(){
	return labeling.iterator();
    }
    public Object clone(){
	return new CNSet(labeling);
    }
}
