/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dcsp;
import java.util.*;
import csp.*;
import utils.*;
import parameters.*;
import platform.*;

class HeuristicContainer{
    int agentsNr;
    POrder order=null;
    AgentID[] defaultAgents;
    AgentID[] agents=null;
    Hashtable data=new Hashtable();
    Histories hist=new Histories();
    HeuristicContainer(int agentsNr, AgentID[] defaultAgents,POrder order){
	this.agentsNr=agentsNr;
	this.defaultAgents=defaultAgents;
	setOrder(order);
    }
    //what = String:int
    //return true if modifications appear for heur
    boolean updateHeurHistories(Histories history){
	Hashtable what=new Hashtable();
	boolean result=hist.updateWith(history, what);
	if(result)desactivate(what);
	return result;
    }
    //return true if modifications appear in parameter
    boolean updateParamHistories(Histories history, Hashtable what,
				 Hashtable changed){
	boolean result=history.updateWith(hist,what);
	return result;
    }
    //return true if modif appear in heur;
    boolean put(AgentID ag, CNSet ldata, int level){
	boolean result=false;
	if(ldata==null)return false;
	Iterator it=ldata.iterator();
	while(it.hasNext()){
	    if(put(ag,(CN)it.next(),level)) result=true;
	}
	return result;
    }
    //return true if modif appear in heur;
    boolean put(AgentID ag, CNSet ldata, int level, 
		AssignmentRefs nogood, BoolObject eNogood) {
	boolean result=false;
	if(ldata==null)return false;
	Iterator it=ldata.iterator();
	while(it.hasNext()){
	    if(put(ag,(CN)it.next(),level, nogood, eNogood)) result=true;
	}
	return result;
    }
    void setOrder(POrder o){
	//MySystem.out.println("heurs:gets:"+o);
	if(order==null){
	    //MySystem.out.println("heurs:prev null");
	    order=(POrder)o.clone();
	    placeAgents();
	    return;
	}
	if(History.firstDisablesSecond(order.history,o.history)){
	    //MySystem.out.println("heur incoming order old");
	    return;
	}
	if(History.firstDisablesSecond(o.history,order.history)){
	    //MySystem.out.println("heur disables order:"+order);
	    resetDisabledPOrder(o.changeLevel(order));
	    order=(POrder)o.clone();
	    placeAgents();
	}
    }
    void placeAgents(){
	agents=new AgentID[agentsNr];
	int j=0;
	Hashtable h=new Hashtable();
	for(j=0;j<order.sequence.length;j++){
	    agents[j]=order.sequence[j];
	    h.put(agents[j],agents[j]);
	}
	for(int k=0;k<agents.length;k++){
	    if(h.get(defaultAgents[k])!=null)continue;
	    agents[j++]=defaultAgents[k];
	}
    }
    void resetDisabledPOrder(int changeLevel){
	//MySystem.out.println("heurs:changePOrder:"+changeLevel);
	hist.trimm(changeLevel);
	Iterator it=(Iterator)data.keys();
	while(it.hasNext()){
	    Hashtable[] vls=(Hashtable[])data.get(it.next());
	    for(int k=changeLevel+2;k<=agentsNr;k++){
		vls[k]=null;
	    }
	}
    }
    private boolean invalidated(LCN label, HeuristicContainer levelHC){
	Iterator it=label.dep.iterator();
	while(it.hasNext()){
	    AssignmentRef ar=(AssignmentRef)it.next();
	    int[]ih=levelHC.hist.getHistory(ar.var,ar.level);
	    int[]lh=hist.getHistory(ar.var,ar.level);
	    if(History.firstDisablesSecond(lh,ih)) return true;
	}
	return false;
    }
    //here I take everything
    void merge(HeuristicContainer hc, int level){
	//print();
	//MySystem.out.print("inc:");hc.print();
	hc.setOrder(order.getOLevel(level));
	setOrder(hc.order);
	updateHeurHistories(hc.hist);//...merge
	Iterator it=(Iterator)hc.data.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    Hashtable[] vls=(Hashtable[])hc.data.get(var);
	    for(int k=0;k<=agentsNr;k++){
		if(vls[k]!=null){
		    Iterator itag=(Iterator)vls[k].keys();
		    while(itag.hasNext()){
			AgentID ag=(AgentID)itag.next();
			LCN mh=(LCN)vls[k].get(ag);
			if(invalidated(mh,hc))continue;
			LCN old=getMHCHist(var,k-1,ag);
			if(CN.olderFirstThanSecond(old,mh)){ //true if old null
			    set(mh,var,level,ag);
			}
		    }
		}
	    }
	}
	print();
    }
    void print(){
	MySystem.out.println("heur:order="+order);
	MySystem.out.println("heur:hist="+hist);
	Iterator it=(Iterator)data.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    MySystem.out.println("heur:var="+var+" "+History.toString(hist.geth(var)));
	    Hashtable[] vls=(Hashtable[])data.get(var);
	    for(int k=0;k<=agentsNr;k++){
		if(vls[k]!=null){
		    Iterator itag=(Iterator)vls[k].keys();
		    while(itag.hasNext()){
			AgentID ag=(AgentID)itag.next();
			LCN mh=(LCN)vls[k].get(ag);
			MySystem.out.println("L:"+(k-1)+":"+ag+"->"+mh);
		    }
		}
	    }
	}
    }
    private int[] geth(String var,int level) {
	int[]history=hist.geth(var);
	if(history==null) return null;
	return History.getHistory(history,level);
    }
    private Range getInstantiation(String var,int level){
	AgentID aID=agents[level];
	Hashtable[] vls=(Hashtable[])data.get(var);
	if(vls==null) return null;
	if(vls[level+1]==null) return null;
	LCN prop=(LCN)vls[level+1].get(aID);
	if(prop==null) return null;
	return prop.label;
    }
    private DVarHistory getDV(String var, int level){
	RuntimeException eh=new RuntimeException("no hist at level:"+level+
						 " for var:"+var);
	RuntimeException er=new RuntimeException("no range at level"+level+
						 " for var:"+var);
	int[] history=geth(var,level);
	if((history==null)||(history.length==0)){
	    if(history!=null)
		MySystem.err.println("hist="+History.toString(history));
	    printCrash();
	    throw eh;
	}
	if(history[history.length-2]!=level){
	    if(history!=null)
		MySystem.err.println("hist="+History.toString(history));
	    printCrash();
	    throw eh;
	}
	Range r=getInstantiation(var,level);
	if(r==null){
	    printCrash();
	    throw er;
	}
	return new DVarHistory(r,history);
    }
    Context getContext(AssignmentRefs nogood){
	Context result = new Context();
	for(int k=nogood.size()-1;k>=0;k--){
	    AssignmentRef ar=nogood.get(k);
	    result.put(ar.var,getDV(ar.var,ar.level));
	}
	return result;
    }
    AssignmentRefs getNogood(int level){
	int k=level+1;
	Iterator it=(Iterator)data.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    //if(vIDs.geti(var)>=0)continue; //Tested in MHCk
	    Hashtable[] vls=(Hashtable[])data.get(var);
	    ILCN inters=null;
	    for(int i=0;i<=k;i++){
		LCNHashtable lh=new LCNHashtable();
		if(vls[i]==null)continue;
		lh.context=vls[i];
		ILCN intersect=lh.intersection();
		if(intersect==null)continue;
		if(inters==null) inters=intersect;
		else inters.addILCN(intersect);
	    }
// 	    if(vls[k]==null)continue;
// 	    LCNHashtable lh=new LCNHashtable();
// 	    lh.context=vls[k];
// 	    ILCN inters=lh.intersection();
	    if(inters==null)continue;
	    if(inters.label.size()<=0)
		return inters.dep;
	}
	return null;
    }
    void printCrash(){
	System.err.println("heur:order="+order);
	System.err.println("heur:hist="+hist);
	Iterator it=(Iterator)data.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    System.err.println("heur:var="+var+" "+History.toString(hist.geth(var)));
	    Hashtable[] vls=(Hashtable[])data.get(var);
	    for(int k=0;k<=agentsNr;k++){
		if(vls[k]!=null){
		    Iterator itag=(Iterator)vls[k].keys();
		    while(itag.hasNext()){
			AgentID ag=(AgentID)itag.next();
			LCN mh=(LCN)vls[k].get(ag);
			System.err.println("L:"+k+":"+ag+"->"+mh);
		    }
		}
	    }
	}
    }
    Range getRange(String var, int id){
	Hashtable[] vls=(Hashtable[])data.get(var);
	if(vls==null) return null;
	Range result=null;
	for(int k=0;k<=id+1;k++){
	    if(vls[k]==null)continue;
	    Iterator it=vls[k].values().iterator();
	    while(it.hasNext()){
		LCN m=(LCN)it.next();
		if(result!=null)result.restrict(m.label);
		else result=(Range)m.label.clone();
	    }
	}
	return result;
    }
    void desactivate(Hashtable what){
	Iterator it=(Iterator)what.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    desactivate(var,((IntObject)what.get(var)).i);
	}
    }
    void desactivate(String var, int changeLevel){
	Iterator it=(Iterator)data.keys();
	while(it.hasNext()){
	    Hashtable[] vls=(Hashtable[])data.get(it.next());
	    for(int k=changeLevel+1;k<=agentsNr;k++){
		if(vls[k]==null) continue;
		ArrayList old=new ArrayList();
		Iterator itag=(Iterator)vls[k].keys();
		while(itag.hasNext()){
		    AgentID ag=(AgentID)itag.next();
		    LCN mh=(LCN)vls[k].get(ag);
		    if((mh!=null)&&(mh.disabledBy(var,changeLevel)))
			old.add(ag);
		}
		for(int j=old.size()-1;j>=0;j--){
		    vls[k].remove(old.get(j));
		}
	    }
	}
    }
    boolean getContext(Context c){
	if(c==null)return false;
	boolean result=false;
	IntObject old=new IntObject(0);
	IntObject taken=new IntObject(0);
	Iterator it=c.keysIterator();
	while(it.hasNext()){
	    String var=(String)it.next();
	    int[] h=c.geth(var);
	    if(h.length==0)continue;
	    //if old or inexistent return -1; if old, set old
	    old.i=0;
	    taken.i=0;
	    int changeLevel=hist.getNewAndReturnChangeLevel(var,h,old,taken);
	    if(changeLevel>=0){
		desactivate(var,changeLevel);
		result=true;
	    }
	    if(old.i==0){
		int level=h[h.length-2];
		DVarHistory dv=c.getDV(var);
		if(put(dv,var,level,getAgent(level))) result=true;
	    }
// 	    else
// 		if(taken.i==1){
// 		    int level=h[h.length-2];
// 		    DVarHistory dv=c.getDV(var);
// 		    if(put(dv,var,level,getAgent(level))) result=true;
// 		}
	}
	return result;
    }
    AgentID getAgent(int level){
	return agents[level];
    }
    //return true if after new taken in hist, (some labels are disabled)
    boolean takeAnyNew(Context c, IntObject old){
	if(c==null)return false;
	IntObject taken=new IntObject(0);
	IntObject depOld=new IntObject(0);
	boolean result=false;
	Iterator it=c.keysIterator();
	while(it.hasNext()){
	    String var=(String)it.next();
	    int[] h=c.geth(var);
	    if(h.length<=0) continue;
	    //if old or inexistent return -1; if old, set old
	    depOld.i=0;
	    int changeLevel=hist.getNewAndReturnChangeLevel(var,h,depOld,taken);
	    if(depOld.i==1)old.i=1;
	    if(changeLevel>=0){
		desactivate(var,changeLevel);
		result=true;
	    }
	    if(taken.i==1)
		result=true;
	    if(depOld.i==0){
		int level=h[h.length-2];
		DVarHistory dv=c.getDV(var);
		if(put(dv,var,level,getAgent(level))) result=true;
	    }
	}
	return result;
    }
    LCN getMHCHist(String var, int level, AgentID ag){
	Hashtable[] vls=(Hashtable[])data.get(var);
	if((vls==null)||(vls[level+1]==null))return null;
	return (LCN)vls[level+1].get(ag);
    }
    void set(LCN l, String var, int level, AgentID ag){
	Hashtable[] vls=(Hashtable[])data.get(var);
	if(vls==null) data.put(var,vls=new Hashtable[agentsNr+1]);
	if(vls[level+1]==null) vls[level+1]=new Hashtable();
	vls[level+1].put(ag,l);
    }
    boolean put(AgentID ag, CN l, int level, 
		AssignmentRefs nogood, BoolObject eNogood) {
	String var=l.getVariable();
	IntObject hasOld= new IntObject(0);
	boolean result=false;
	ILCN inters=null;
	try{
	    result=takeAnyNew(l.dep, hasOld);
	    if(hasOld.i==0){
		LCN old=getMHCHist(var,level,ag);
		if(CN.olderFirstThanSecond(old,l)){ //true if old null
		    set(new LCN(l),var,level,ag);
		    result=true;
		}
	    }
	    Hashtable[] vls=(Hashtable[])data.get(var);
	    int k=level+1;
	    //if(vls==null)throw new Exception("New Exception");//disabled hist
	    if((vls!=null)&&(vls[k]!=null)){
		LCNHashtable lh=new LCNHashtable();
		lh.context=vls[k];
		inters=lh.intersection();
		if((inters!=null)&&(inters.label.size()<=0)){
		    if(inters.dep.size()==0){nogood.clear();eNogood.b=true;}
		    else if((!eNogood.b)&&(nogood.size()==0))
			nogood.addAll(inters.dep);
		}
	    }
	}catch(Exception e){
	    e.printStackTrace();
	    System.err.println("put:"+ag+" label:"+l+" level:"+level+inters);
	    printCrash();
	    MySystem.exit(1);
	}
	return result;
    }
    boolean put(AgentID ag, CN l, int level){
	IntObject hasOld= new IntObject(0);
	boolean result=false;
	try{
	    result=takeAnyNew(l.dep, hasOld);
	    if(hasOld.i==0){
		String var=l.getVariable();
		LCN old=getMHCHist(var,level,ag);
		if(CN.olderFirstThanSecond(old,l)){ //true if old null
		    set(new LCN(l),var,level,ag);
		    result=true;
		}
	    }else{
		MySystem.out.println(l+" has old");
	    }
	}catch(Exception e){
	    e.printStackTrace();
	    System.err.println("put:"+ag+" label:"+l+" level:"+level);
	    printCrash();
	    MySystem.exit(1);
	}
	return result;
    }
    boolean put(DVarHistory dv, String var, int level, AgentID ag){
	boolean result=false;
	if((dv==null)||(dv.range==null)) return false;
	try{
	    LCN old=getMHCHist(var,level,ag);
	    if(old==null){ //true if old null
		set(new LCN(var,dv),var,level,ag);
		result=true;
	    }
	}catch(Exception e){
	    e.printStackTrace();
	    System.err.println("put:dv="+dv+" var:"+var+" level:"+level+" "+ag);
	    printCrash();
	    MySystem.exit(1);
	}
	return result;
    }
}
