/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dcsp;
import java.util.*;
import parameters.*;
import utils.*;
import csp.*;

class ILCN implements Cloneable{
    Range label;
    AssignmentRefs dep=new AssignmentRefs();
    public String toString(){
	return label+((dep==null)?"":("c"+dep));
    }
    ILCN(Range label, AssignmentRefs dep){
	this.label=label;
	if(dep!=null)
	    this.dep=dep;
    }
    ILCN(Range label){
	this.label=label;
    }
    ILCN(String var, Range label, int level){
	this.label=label;
	dep.add(new AssignmentRef(var,level));
    }
    ILCN(String var, DVarHistory dv){
	this.label=dv.range;
	if((dv.history==null)||(dv.history.length==0)){
	    MySystem.err.println("Got:"+dv);
	    MySystem.exit(1);
	}
	dep.add(new AssignmentRef(var,dv.history));
    }
    ILCN(ILCN lcn){
	label=lcn.label;
	dep=new AssignmentRefs();
	Iterator it=(Iterator)lcn.dep.iterator();
	while(it.hasNext()){
	    AssignmentRef var=(AssignmentRef)it.next();
	    dep.add((AssignmentRef)var.clone());
	}
    }
    ILCN(LCN lcn){
	label=lcn.label;
	dep=new AssignmentRefs();
	Iterator it=(Iterator)lcn.dep.iterator();
	while(it.hasNext()){
	    AssignmentRef var=(AssignmentRef)it.next();
	    dep.add((AssignmentRef)var.clone());
	}
    }
    ILCN(CN cn){
	label=cn.label;
	dep=new AssignmentRefs();
	Iterator it=(Iterator)cn.dep.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    DVarHistory dv=cn.dep.getDV(var);
	    dep.add(new AssignmentRef(var,dv.history));
	}
    }
    // if disabled by the list of changed histories
    public boolean disabledBy(String var, int level){
	if(dep.contains(var, level)!=null)
	    return true;
	return false;
    }
    // if disabled by the list of changed histories
    public boolean disabledBy(int level){
	if(dep.contains(level)!=null)
	    return true;
	return false;
    }
    public void addILCN(ILCN lcn){
	if(label.restricting(lcn.label)){
	    if(lcn.label.restricting(label)){
		label=Range.intersect(label,lcn.label);
		dep.addAll(lcn.dep);
		return;
	    }
	    label=lcn.label;
	    dep=(AssignmentRefs)lcn.dep.clone();
	    return;
	}
	if(!label.different(lcn.label)){
	    int myL=dep.getLastLevel();
	    int incL=lcn.dep.getLastLevel();
	    if((myL>incL)||((myL==incL)&&
			    (dep.size()>lcn.dep.size()))){
		label=lcn.label;
		dep=(AssignmentRefs)lcn.dep.clone();	    
	    }
	}
// 	if((!label.different(lcn.label))&&
// 	   (dep.size()>lcn.dep.size())){
// 	    label=lcn.label;
// 	    dep=(AssignmentRefs)lcn.dep.clone();	    
// 	}
    }
    public Object clone(){
	return new ILCN(this);
    }
}
