/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dcsp;
import java.util.*;
import parameters.*;
import utils.*;
import csp.*;

class LCN implements Cloneable{
    Range label;
    int proposalID;
    AssignmentRefs dep=new AssignmentRefs();
    public String toString(){
	return label+((dep==null)?"":("c"+dep))+" pID "+proposalID;
    }
    LCN(Range label, AssignmentRefs dep, int _proposalID){
	this.label=label;
	this.proposalID=_proposalID;
	if(dep!=null)
	    this.dep=dep;
    }
//     LCN(String var, int level, Range label, int proposalID){
// 	this.label=label;
// 	this.proposalID=proposalID;
// 	dep.add(new AssignmentRef(var,level));
//     }
    LCN(String var, Range label, int level, int _proposalID){
	this.label=label;
	this.proposalID=_proposalID;//=1//doesn't matter
	dep.add(new AssignmentRef(var,level));
    }
    LCN(String var, DVarHistory dv){
	this.label=dv.range;
	if((dv.history==null)||(dv.history.length==0)){
	    MySystem.err.println("Got:"+dv);
	    MySystem.exit(1);
	}
	this.proposalID=dv.history[dv.history.length-1];
	dep.add(new AssignmentRef(var,dv.history));
    }
    LCN(LCN lcn){
	label=lcn.label;
	proposalID=lcn.proposalID;
	if(lcn.dep==null)return;
	//dep=new AssignmentRefs();
	Iterator it=(Iterator)lcn.dep.iterator();
	while(it.hasNext()){
	    AssignmentRef var=(AssignmentRef)it.next();
	    dep.add((AssignmentRef)var.clone());
	}
    }
    LCN(ILCN lcn, int _proposalID){
	label=lcn.label;
	proposalID=_proposalID;
	if(lcn.dep==null)return;
	//dep=new AssignmentRefs();
	Iterator it=(Iterator)lcn.dep.iterator();
	while(it.hasNext()){
	    AssignmentRef var=(AssignmentRef)it.next();
	    dep.add((AssignmentRef)var.clone());
	}
    }
    LCN(CN cn){
	label=cn.label;
	proposalID=cn.proposalID;
	if(cn.dep==null)return;
	//dep=new AssignmentRefs();
	Iterator it=(Iterator)cn.dep.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    DVarHistory dv=cn.dep.getDV(var);
	    dep.add(new AssignmentRef(var,dv.history));
	}
    }
    public ILCN getILCN(){
	return new ILCN(this);
    }
    // if disabled by the list of changed histories
    public boolean disabledBy(String var, int level){
	if(dep.contains(var, level)!=null)
	    return true;
	return false;
    }
    // if disabled by the list of changed histories
    public boolean disabledBy(int level){
	if(dep.contains(level)!=null)
	    return true;
	return false;
    }
    public void addLCN(LCN lcn){
	if(label.restricting(lcn.label)){
	    if(lcn.label.restricting(label)){
		label.restrict(lcn.label);
		dep.addAll(lcn.dep);
		return;
	    }
	    label=lcn.label;
	    dep=(AssignmentRefs)lcn.dep.clone();
	}
	if((!label.different(lcn.label))&&
	   (dep.size()>lcn.dep.size())){
	    label=lcn.label;
	    dep=(AssignmentRefs)lcn.dep.clone();	    
	}
    }
    public Object clone(){
	return new LCN(this);
    }
}
