/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dcsp;
import java.util.*;
import csp.*;
import parameters.*;
import platform.*;

public class LCNHashtable implements DObject,Cloneable{
    public Hashtable context;
//     public String toString(){
// 	String s="";
// 	Iterator it=(Iterator)context.keys();
// 	while(it.hasNext()){
// 	    AgentID aid=(AgentID)it.next();
// 	    s=s+aid+context.get(aid)+" ";
// 	}
// 	return s;
//     }
    public LCNHashtable(){
	context=new Hashtable();
    }
    public LCNHashtable(Hashtable ht){
	context=new Hashtable();
	Iterator it=(Iterator)ht.keys();
	while(it.hasNext()){
	    AgentID ad=(AgentID)it.next();
	    context.put(ad,(LCN)((LCN)ht.get(ad)).clone());
	}
    }
    public boolean addAll(LCNHashtable lcnh){
	boolean result=false; Iterator it=(Iterator)lcnh.keys();
	while(it.hasNext()){
	    AgentID sender=(AgentID)it.next();
	    LCN ilcn=lcnh.getLCN(sender);
	    LCN lcn=(LCN)context.put(sender,ilcn);
	    if((lcn==null)||(lcn.proposalID!=ilcn.proposalID))
		result=true;
	}
	return result;
    }
    public ILCN intersection(){
	ILCN result=null;
	Iterator it=(Iterator)keys();
	while(it.hasNext()){
	    Object o=it.next();
	    LCN lcn=getLCN((AgentID)o);
	    if(result==null) result=new ILCN(lcn);
	    else result.addILCN(lcn.getILCN());
	}
	return result;
    }
    public Object clone(){
	return new LCNHashtable(context);
    }
    void clean(int changeLevel){
	Hashtable nc=new Hashtable();
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    AgentID ad=(AgentID)it.next();
	    LCN lcn=getLCN(ad);
	    if(!lcn.disabledBy(changeLevel))
		nc.put(ad,lcn);
	}
	context=nc;
    }
    Range getRange(){
	Range result=null;
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()) {
	    AgentID ad=(AgentID)it.next();
	    LCN lcn=getLCN(ad);
	    if(result==null)result=new Range(lcn.label);
	    else result.restrict(lcn.label);
	}
	return result;
    }
    boolean clean(String var, int changeLevel){
 	Hashtable nc=new Hashtable();
	boolean result=false;
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    AgentID ad=(AgentID)it.next();
	    LCN lcn=getLCN(ad);
	    if(!lcn.disabledBy(var,changeLevel)) nc.put(ad,lcn);
	    else result=true;
	}
	context=nc;
	return result;
   }
    boolean clean(AssignmentRefs ars){
	boolean result=false;
	for(int k=ars.size()-1;k>=0;k--){
	    AssignmentRef ar=(AssignmentRef)ars.get(k);
	    result=clean(ar.var,ar.level)||result;
	}
	return result;
    }
    public boolean sameAs(LCNHashtable c){
	if(c.size()!=size())
	    return false;
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    AgentID ad=(AgentID)it.next();
	    LCN cmp=c.getLCN(ad);
	    if((cmp==null)||(!cmp.equals(getLCN(ad))))
		return false;
	}
	return true;
    }
    LCN put(AgentID ad, LCN range){
	return (LCN)context.put(ad,range);
    }
    public LCN remove(AgentID ad){
	return (LCN)context.remove(ad);
    }
    public LCN getLCN(AgentID ad){
	return (LCN)context.get(ad);
    }
    public int size(){
	return context.size();
    }
    public void clear(){
	context.clear();
    }
    public Enumeration keys(){
	return context.keys();
    }
    public Iterator keysIterator(){
	return (Iterator)context.keys();
    }
    public Collection values(){
	return context.values();
    }
    public Set keySet(){
	return context.keySet();
    }
    public String toString(){
	String s="";
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    AgentID ad=(AgentID)it.next();
	    s=s+ad+getLCN(ad).toString()+"\n";
	}
	return s;
    }
}
