/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dcsp;
import java.util.*;
import csp.*;
import platform.*;
import parameters.*;
import utils.*;
import sjavap.*;

class MHCk implements MessageReceiver, Runnable{

 /**    active object support (needs implements Reply)   **/
 /*********************************************************/
 /**/ Synch_List select = new Synch_List(this);           //
 /**/ synchronized public void Synch_Reply()              //
 /**/   { notify();   }                                   //
 /**/ int now() {return Kernel.kern.currentTime;}         //
 /**/ int Synch_Wait() {                                  //
 /**/   Kernel.kern.Synch_Request(select);                //
 /**/   do{try {wait();} catch(InterruptedException e){}} //
 /**/   while(select.nbEntries!=0);                       //
 /**/   return select.Value; }                            //
 /*********************************************************/

    private PAgent MHCscheduler;
    private int variablesNr;
    private int agentsNr;
    private int level;
    private int myComputationNum;
    private MessageQueue queue;
    //Am I the level updating the instantiation?
    private boolean instantiation=false;
    private boolean fromLocal=false;//is the current message coming from local?
    private OPost opost=new OPost();
    private IPost ipost=new IPost();
    private HeuristicContainer heurs;
    private Message_Command gotMessage,postPropagate=null;//propagate that can be sent to other level
    //?private RHashtable myInst;
    private Histories histories=new Histories();
    private LCNHashtable[] levelState;
    private AssignmentRefs nogood;

    private Object postMonitor=new Object();
    // changed histories for disabling level decisions
    private AssignmentRefs changed=new AssignmentRefs();
    private DCost localCost=new DCost();

    private AgentID myself=null;
    private AgentID[] defaultAgents=null;
    private String gotMsgSource=null;
    private boolean mValidNogoodDiscarded=false;

    final public static int _terminate=2;
    final public static int _getLocalMessage=3;
    final public static int _setInstantiation=4;

    //states
    final static int Sreceiving=0;
    final static int SemptyReceiving=2;
    final static int Sstop=4;
    private int crtState;

    private boolean MHCmodif;
    private POrder order=new POrder();
    MHCk(PAgent scheduler, int level, int vars, int myComputationNum, MessageQueue queue, int agentsNr, AgentID myself, AgentID[] defaultAgents){
	variablesNr=vars;
	this.level=level;
	this.queue=queue;
	this.myComputationNum=myComputationNum;
	this.agentsNr=agentsNr;
	heurs=new HeuristicContainer(agentsNr,defaultAgents,order);
	levelState=new LCNHashtable[variablesNr];
	//?myInst=new RHashtable();
	opost.insts=new RHashtable[agentsNr];
	MHCscheduler=scheduler;
	set(myself,defaultAgents);
	instantiation=(level==getMyPosition(order));
    }
//     MHCk(PAgent scheduler, int level, int vars, boolean instant, int myComputationNum, MessageQueue queue, int agentsNr, AgentID myself, AgentID[] defaultAgents){
// 	instantiation=true;
// 	variablesNr=vars;
// 	this.level=level;
// 	this.queue=queue;
// 	this.agentsNr=agentsNr;
// 	this.myComputationNum=myComputationNum;
// 	heurs=new HeuristicContainer(agentsNr,defaultAgents,order);
// 	levelState=new LCNHashtable[variablesNr];
// 	//?myInst=new RHashtable();
// 	MHCscheduler=scheduler;
// 	set(myself,defaultAgents);
//     }
    private void set(AgentID myself, AgentID[] defaultAgents){
	this.myself=myself;
	this.defaultAgents=defaultAgents;
    }
    private int getMyPosition(POrder order){
	int k;
	if((order==null)||(order.sequence==null)){
	    MySystem.err.println("got:"+order);
	    MySystem.exit(1);
	}
	if((myself==null)){
	    MySystem.err.println("myself:"+myself);
	    MySystem.exit(1);
	}
	Hashtable h=new Hashtable();
	for(k=0;k<order.sequence.length;k++){
	    if(myself.equals(order.sequence[k])) return k;
	    h.put(order.sequence[k],myself);
	}
	if((defaultAgents==null)){
	    MySystem.err.println("defaultAgents:"+defaultAgents);
	    MySystem.exit(1);
	}
	//MySystem.err.println("defaultAgents:"+defaultAgents[0]);
	for(int j=0;j<defaultAgents.length;j++){
	    if(h.get(defaultAgents[j])==null){
		if(myself.equals(defaultAgents[j])) return k;
		else k++;
	    }
	}
	return -1;
    }
    public int getLevel(){
	return level;
    }
    private void checkPostPropagate(){
	if(postPropagate!=null){
	    int level=((Propagate)postPropagate.getArguments()).level;
	    if(level<=this.level) MySystem.exit(level+"<="+this.level);
	    MHCk nextC=MHCscheduler.getMHCk(level);
	    select.accept(0,_terminate);
	    select.call(1,nextC,nextC._getMessage);
	    if(Synch_Wait()==1){
		nextC.getMessage(postPropagate);
		postPropagate=null;
	    }
	}
    }
    synchronized public void run() {
	try{
	    rrun();
	}catch(Exception e){
	    e.printStackTrace();
	    MySystem.exit(1);
	}
    }

    synchronized public void rrun() {
	select.thread=Thread.currentThread();
	crtState=SemptyReceiving;
	for(;;){
	    //if(instantiation) MySystem.err.println("MHCK level "+level+" in state:"+crtState);
	    if(instantiation)printLevelState();
	    switch(crtState){
	    case Sstop:
		return;

	    case SemptyReceiving:
		MHCmodif=false;
                select.accept(0,_terminate);
		select.accept(1,_getMessage,1+level);
		select.accept(2,_getLocalMessage);
		select.accept(3,_setInstantiation);
		int sWait = Synch_Wait();
		if(sWait==2){getLM();}
		if(sWait==1){
                    MySystem.err.println("gotMessage="+gotMessage);
		    getMessage(); //get external Message
		    checkPostPropagate();
		}
		if(instantiation)
		    MySystem.err.println("MHCK level "+level+" in state:"+crtState+" after choice:"+sWait);
		if(sWait==0){
                    crtState=Sstop;
                    break;
                  }
		if(level>=0) //no post for base
		    readPostToChanged();
		//Only if remote info has arrived
		if(MHCmodif&&(crtState!=Sstop)){//&&(sWait!=2)){
		    MySystem.out.println("MHCK level "+level+" goes from:"+crtState+" to modified state");
		    crtState=Sreceiving;
// 		    MHCscheduler.interruptRequest();
		}
		break;
	    case Sreceiving:
                select.accept(0,_terminate);
		select.accept(1,_getMessage,1+level);
		select.call(2,MHCscheduler,MHCscheduler._MHCk,1+(1+level));
		select.accept(3,_getLocalMessage);
		select.accept(4,_setInstantiation);
		int choice=Synch_Wait();
		MySystem.out.println("level:"+level+":receiving selected="+choice);
		if(choice==3){getLM();}
		if(choice==1){
		    getMessage(); //get external Message
		    checkPostPropagate();
		}
		//if(instantiation) MySystem.err.println("MHCK level "+level+" in state:"+crtState+" after choice:"+choice);
                if(choice==0){
                  crtState=Sstop; break;
                }
		if(level>=0) //no post for base
		    readPostToChanged();
		if(choice==2){
		    prepareLevels();
// 		    MHCscheduler.clearInterrupt();
		    ((DCost)Utils.agentCost).updateCost(localCost);
		    MHCscheduler.heurs.merge(heurs,level);
		    //if(instantiation) MHCscheduler.mHCk(levelState, outgoingPost,insts);else
		    MHCscheduler.mHCk(levelState,opost.hist,opost.insts,level,order,nogood,mValidNogoodDiscarded);
		    mValidNogoodDiscarded=false;
		    opost.clear(); //already processed
// 		    if(okMessage!=null){
// 			MHCscheduler.getIncomingOK(okMessage);
// 			okMessage=null;
// 		    }
		    crtState=SemptyReceiving;
		    MySystem.out.println("MHCK level "+level+" goes to state:"+crtState);
		}
		break;
	    }
	}
    }
    synchronized public void getMessage(Message message){
	MySystem.out.println("mHCk:"+level+":got:"+message);
	gotMessage=(Message_Command)message;
	gotMsgSource=Utils.getStack();
	if(message.getComputationNum()!=myComputationNum){
	    gotMessage=null;
	    MySystem.err.println("mHCk:"+level+":!!my myComputationNum="+myComputationNum);
	    MySystem.exit("mHCk:"+level+":!!my getComputationNum()="+message.getComputationNum());//why-debug
	}
        Synch_Reply();
    }
    Propagate gotLMsg=null;
    AssignmentRefs gotLNMsg=null;
    Context gotCNogood=null;
    //from announceSolution
//     synchronized public void getLocalNogood(AssignmentRefs _nogood){
// 	//if(nogood==null)
// 	nogood=_nogood;
// 	gotLNMsg=null;
//     }
    synchronized public void getLocalMessage(Propagate m, AssignmentRefs _nogood, Context _cNogood){
	MySystem.out.println("Agent lets getLocalMessage:"+m+
			     " and nogood "+_nogood);
	if(nogood==null)nogood=_nogood;
 	gotLMsg=m;
	gotLNMsg=_nogood;
	gotCNogood=_cNogood;
        Synch_Reply();
    }
    synchronized public void getLocalMessage(Propagate m){
	MySystem.out.println("Agent lets getLocalMessage:"+m);
	gotLMsg=m;
 	gotLNMsg=null;
	gotCNogood=null;
        Synch_Reply();
    }
    private void getLM(){
	Propagate m=gotLMsg;
	MySystem.out.println("Agent enters getLocalMessage:"+m);
	fromLocal=true;
	if(level>=0) //no post for base
	    readPostToChanged();
	//if(instantiation) clearLevel();
	if(getOrder(m.order)){
	    getMessage(m,myself);
	    if((gotLNMsg!=null)&&(nogood==null)){
		if(getContext(gotCNogood,false)){
		    MySystem.out.println("Level take nogood:"+gotLNMsg);
		    nogood=gotLNMsg; MHCmodif=true;
		}
	    }
	}
	gotLNMsg=null;gotCNogood=null;
	fromLocal=false;
	MySystem.out.println("Agent exit getLocalMessage:");
    }
    synchronized public void terminate(){
	crtState=Sstop;
        Synch_Reply();
    }
    synchronized public void setInstantiation(POrder order, boolean b){
	fromLocal=true;
	if(getOrder(order))
	    if(instantiation!=b)
		MySystem.exit("incOrder="+order+b+instantiation);
	    fromLocal=false;
    }
    private void getMessage(){
	Message message=gotMessage;
	//if(level>=0) //no post for base
	readPostToChanged();
	Object argument=((Message_Command)message).getArguments();
	MySystem.out.println("MHCk:"+level+":Got message:"+argument);
	if(nogood!=null)
	    MySystem.out.println("MHCk:"+level+":had nogood:"+nogood);
	if(instantiation&&(argument instanceof DNogood)){
	    getNogood((DNogood)argument); //the order taken in scheduler and arrived by post
	    return;
	}
	if(argument instanceof Propagate){
	    Propagate mMHC=(Propagate)argument;
	    if(!getOrder(mMHC.order)) return;
	    postPropagate = mMHC.removeNext((Message_Command)message);
	    localCost.incrementMessages(mMHC.cost);
	    getMessage(mMHC,message.getSenderID());
	    return;
	}
	if(argument instanceof DPOrder){
	    DPOrder incOrder=(DPOrder)argument;
	    if(!message.getReceiverID().equals(message.getSenderID()))
		localCost.incrementMessages(incOrder.cost);
	    getOrder(incOrder.order);
	    return;
	}
// 	DView mMHC=(DView)argument;
// 	if(!getOrder(mMHC.order)) return;
// 	localCost.incrementMessages(mMHC.cost);
// 	getContext(mMHC.view,true);
// 	disableChanged();
    }
    private boolean getOrder(POrder incOrder){
	MySystem.out.println("incOrder="+incOrder);
	MySystem.out.println("oldOrder="+order);
	if(incOrder.getInterestLevel()>level){
	    System.err.println("inappropriate order");
	    System.err.println("incOrder="+incOrder);
	    System.err.println("oldOrder="+order);
	    System.err.println("message was="+gotMessage);
	    System.err.println("level was="+level);
	    MHCSelector sele=new MHCSelector(level);
	    System.err.println("selector returns:"+sele.accepts((Message_Command)gotMessage));
	    System.err.println("message source="+gotMsgSource);
	    MySystem.exit(1);
	}
	if(History.firstDisablesSecond(order.history,incOrder.history)){
	    MySystem.out.println("incoming order old");
	    return false;
	}
	if(History.firstDisablesSecond(incOrder.history,order.history)){
	    MySystem.out.println("incoming new:clean up");
	    heurs.setOrder(incOrder);
	    resetOrderDependentHistory(incOrder.changeLevel(order));
	    order=incOrder;
	    instantiation=(level==getMyPosition(order));
	    if(instantiation&&(nogood==null)) reestablishNogood();
	    if(!fromLocal){
		MHCmodif=true;
		MySystem.out.println("modif in getOrder. Level="+level);
	    }
	}
	return true;
    }

    private void clearInsts(Hashtable insts ,ArrayList vars){
	Iterator it=vars.iterator();
	while(it.hasNext())
	    insts.remove(it.next());
    }
    private void clearInsts(RHashtable[]instantiations, int cL) {
	for(int k=cL;k<=level;k++)
	    instantiations[k]=null;
    }
    private void cleanLevelState(int changeLevel){
	for(int k=0;k<variablesNr;k++)
            if(levelState[k]!=null)
	      levelState[k].clean(changeLevel);
    }
    private void resetOrderDependentHistory(int orderChangeLevel){
	ArrayList disabVar=histories.trimm(orderChangeLevel);
	if((nogood!=null)&&(nogood.contains(orderChangeLevel+1)!=null)){
	    MySystem.out.println(level+".disabling the nogood:"+nogood);
	    nogood=null;
	    //if(instantiation) reestablishNogood();
	}else{
	    if(nogood!=null)
		MySystem.err.println("Nogood "+nogood+" do not contain level "+(orderChangeLevel+1));
	}
	cleanLevelState(orderChangeLevel+1);
	//?if(orderChangeLevel<myID) myInst=null;
	clearInsts(opost.insts,orderChangeLevel+1);
	opost.hist.trimm(orderChangeLevel);
	//changed can remain unchanged since any disabled is disabled
    }
    private void getNogood(DNogood dn){
	if(validNogood(dn.view)){
	    localCost.incrementMessages(dn.cost);
	    registerNogood(dn);
	}else
	    MySystem.out.println("MHCk:Invalid nogood");
    }
    private void getMessage(Propagate m,AgentID sender){
	int i,j,k;
	if((m.addedLinks!=null)&&(m.addedLinks.size()>0))
	    getContext(m.addedLinks,true);

	mergeHistory(m.varHistories);
	heurs.updateHeurHistories(histories);
	if(instantiation){
	    AssignmentRefs heurNogood=new AssignmentRefs();
	    BoolObject eNogood=new BoolObject(false);
	    if(heurs.put(sender,m.heuristic,level,heurNogood,eNogood)&&
	       !fromLocal){
		MySystem.out.println("MHCmodif:heuristic:Level="+level);
		MHCmodif=true;
	    }
	    if((nogood==null)&&(heurNogood.size()>0)){
		nogood=heurNogood;
		Context nContext=heurs.getContext(nogood);
		if(getContext(nContext,true))MySystem.exit("heur nogood disabled");
	    }
	    if(eNogood.b)nogood=heurNogood;
	}else if(heurs.put(sender,m.heuristic,level)&&!fromLocal){
		MySystem.out.println("MHCmodif:heuristic:Level="+level);
		MHCmodif=true;
	    }
	if(heurs.put(sender,m.varHistories,level)&&!fromLocal){
	    MySystem.out.println("MHCmodif:varHistories:Level="+level);
	    MHCmodif=true;
	}
	//Hashtable what= new Hashtable();
	//heurs.updateParamHistories(histories,what,changed);
	disableChanged();
	for(k=0; k<m.varHistories.size(); k++){
	    CN prop=m.varHistories.getCN(k);
	    MySystem.out.println("add cn="+prop);
	    if(prop.label.size()>0)
		updateKnowledge(new LCN(prop),prop.var,sender);
	    else{
		MySystem.out.println("empty");
		makeNogood(prop.dep);
	    }
	}
    }
    //if some element of the Context is old, the other new ones
    //are taken only if takeDisabled
    private boolean getContext(Context m, boolean takeDisabled){
	if(m==null)return false;
	boolean disabled;
	disabled=false;
	String variable;
	int[] incomingHist;
	int[] localHist;
	if(heurs.getContext(m)&&!fromLocal){
	    MHCmodif=true;
	    MySystem.out.println("MHCmodif:getContext:Level="+level);
	}
	Hashtable tmpHist=new Hashtable();
	AssignmentRefs tmpChanged=new AssignmentRefs();
	Hashtable tmpPost=new Hashtable();
	RHashtable tmpInsts[]=new RHashtable[level+1];
	//for(int l=0;l<=level;l++) tmpInsts[l]=new RHashtable();
	Iterator it=(Iterator)m.keys();
	while(it.hasNext()){
	    variable=(String)it.next();
	    Range incomingRange=m.getR(variable);
	    incomingHist=m.geth(variable);
	    //if(incomingHist==null)   MySystem.exit(1);
	    if((incomingHist==null)||(incomingHist.length==0))
		MySystem.exit("empty history in a context in MHCk");
	    // continue;
	    localHist=histories.geth(variable);
	    MySystem.out.println("MHCk"+level+variable+incomingRange+
				 History.toString(incomingHist)+
				 " old"+History.toString(localHist));
	    if(localHist!=null) {
		if(History.firstDisablesSecond(incomingHist,localHist)){
		    int cL=History.changeRLevel(incomingHist,localHist);
		    changed.addMin(variable,cL);
		    histories.put(variable,incomingHist);
		    opost.hist.remove(variable);
		    //?myInst.remove(variable);
		    for(int l=cL;l<=level;l++)
			if(opost.insts[l]!=null)
			    opost.insts[l].remove(variable);
		    int instLevel=incomingHist[incomingHist.length-2];
		    if((!instantiation)||(instLevel<level)){
			if(!fromLocal) MHCmodif=true;
			if(incomingRange!=null){
			    if(opost.insts[instLevel]==null)
				opost.insts[instLevel]=new RHashtable();
			    opost.insts[instLevel].put(variable,incomingRange);
			}
			opost.hist.put(variable,incomingHist);
		    }//?else if(incomingRange!=null) myInst.put(variable,incomingRange);
		}else{
		    if(History.firstInvalidatesSecond(localHist,incomingHist)){
			MySystem.out.println(variable+" "+
					     History.toString(incomingHist)+
					     " disabled due to "+
					     History.toString(localHist));
			disabled=true;
			//labeling.remove(k);break;//must continue
		    }else{//perhaps there was no instantiation
			//but myInst was surely there
			int instLevel=incomingHist[incomingHist.length-2];
			if(incomingRange!=null)
			    if((!instantiation)||(instLevel<level)){
				if(opost.insts[instLevel]==null)
				    opost.insts[instLevel]=new RHashtable();
				opost.insts[instLevel].put(variable,incomingRange);
			    }
		    }
		}
	    }else{
		MySystem.out.println("Got new history:"+History.toString(incomingHist)+" for "+variable);
		tmpHist.put(variable,incomingHist);
		tmpChanged.addMin(variable,incomingHist[0]);
		int instLevel=incomingHist[incomingHist.length-2];
		if((!instantiation)||(instLevel<level)){
		    tmpPost.put(variable,incomingHist);
		    if(incomingRange!=null){
			if(tmpInsts[instLevel]==null)
			    tmpInsts[instLevel]=new RHashtable();
			tmpInsts[instLevel].put(variable,incomingRange);
		    }
		}//?else if(incomingRange!=null){
		//?if(myInst==null) myInst=new RHashtable();
		//?myInst.put(variable,incomingRange);
		//?}
	    }
	}
	if(takeDisabled||!disabled){
	    histories.putAll(tmpHist);
	    changed.addAll(tmpChanged);
	    for(int l=0;l<=level;l++){
		if(tmpInsts[l]!=null){
		    if(opost.insts[l]==null)
			opost.insts[l]=new RHashtable();
		    opost.insts[l].putAll(tmpInsts[l]);
		}
	    }
	    if(tmpPost.size()>0){
		if(!fromLocal){
		    MHCmodif=true;
		    MySystem.out.println("MHCmodif:getContext:take-dis:Level="+level);
		}
	        opost.hist.putAll(tmpPost);}
	}
	return disabled;
    }

    private void disableChanged(){
	if(changed.size()>0){
	    for(int k=0; k<levelState.length; k++) {
		if(levelState[k]!=null)
		    MHCmodif=(levelState[k].clean(changed)&&!fromLocal)||MHCmodif;
// 		if((levelState[k]!=null)&&levelState[k].disabledBy(changed)) {
// 		    if(!(instantiation&&levelState[k].disabledHistoryBy(changed))&&!fromLocal){
// 			MySystem.out.println("MHCmodif:disable:Level="+level);
// 			MHCmodif=true;
// 		    }
// 		    if((instantiation)&&
// 		       (!levelState[k].disabledHistoryBy(changed))){
// 			levelState[k].proposal=
// 			    (Range)myInst.get(levelState[k].variable);
// 			levelState[k].dependencies=new ConflictSet();
// 		    }else{
// 			levelState[k]=null;
// 		    }
// 		}
	    }
	    if(nogood!=null){
		if(nogood.disabledBy(changed)){
		    nogood=null;
		    if(instantiation) reestablishNogood();
		}else if(fromLocal) MHCmodif=true;
	    }
	    changed.clear();
	}
    }
    private void reestablishNogood(){
	for(int idprop=0;idprop<variablesNr;idprop++){
	    if(levelState[idprop]==null) continue;
	    ILCN inters=levelState[idprop].intersection();
	    if(inters==null)continue;
	    if(inters.label.size()<=0) {
		nogood=inters.dep;
		MySystem.out.println("MHCmodif:cNogood");
		MHCmodif=true;
		break;
	    }
	}
	if(nogood==null){
	    nogood=heurs.getNogood(level);
	    if(nogood!=null){
		Context nContext=heurs.getContext(nogood);
		if(getContext(nContext,true))
		    MySystem.exit("heur nogood disabled");
		MySystem.out.println("MHCmodif:heurs:cNogood");
		MHCmodif=true;
	    }
	}
	if(nogood!=null)
	    MySystem.out.println("MHCk:"+level+" got nogood:"+nogood);
    }
    //merge history, erase old proposals, return new history
    void mergeHistory(CNSet labeling){
	boolean disabled;
	Object removed;
	for(int k=labeling.size()-1; k>=0; k--){
	    CN prop = labeling.getCN(k);
	    MySystem.out.println("checking "+prop);
	    if(disabled=getContext(prop.dep,false)){//do not take disabled
		removed=labeling.remove(k);
		MySystem.out.println("Removing incoming label:"+removed+":at level:"+level);
	    }
	}
    }
    //-- if new range for a variable, then
    //--reset all the dependent instantiations
    //-- if new history for a variable, then
    //--update all the dependent instantiations
    //if old history then discard proposal
    void updateKnowledge(LCN prop,String var,AgentID sender){
	int idprop=MHCscheduler.getID(var);
	//MySystem.out.println("put="+var+" id="+idprop+" "+prop+" from "+sender);
	if(idprop<0){
	    MySystem.err.println("Error bad ID at:"+prop);
	    MySystem.exit(1); //old message?
	}
	if((levelState[idprop]==null)){
	    levelState[idprop]=new LCNHashtable();
	}
	LCN oldLCN=levelState[idprop].getLCN(sender);
	if((oldLCN==null)||(oldLCN.proposalID<prop.proposalID)){
	    levelState[idprop].put(sender,(LCN)prop.clone());
	    if(instantiation&&(nogood==null)){
		ILCN inters=levelState[idprop].intersection();
		if((inters!=null)&&(inters.label.size()<=0)) {
		    nogood=inters.dep;
		    MySystem.out.println("MHCmodif:computeNogood");
		    MHCmodif=true;
		}
	    }
	    if(!fromLocal){
		MySystem.out.println("MHCmodif:updateKnowledge");
		MHCmodif=true;
	    }
	}
    }
    void prepareLevels(){
	for(int k=0; k<levelState.length; k++){
	    if(levelState[k]==null){
		levelState[k]=new LCNHashtable();
// 		String var=MHCscheduler.variables[k];
// 		Range inst=(Range)insts.get(var);
// 		if(inst!=null)
// 		    levelState[k]=new MHCHistory(0,var,inst,null);
	    }
	}
    }

    private void printLevelState(){
	String[] variables=MHCscheduler.getVariables();
	MySystem.out.println("LevelState for level:"+level);
	for(int i=0;i<levelState.length;i++)
	    if(levelState[i]==null)MySystem.out.println(variables[i]+" "+"null");
	    else MySystem.out.println(variables[i]+" "+levelState[i]);
    }

    //tests if a nogood is denying my current instantiation
    private boolean validNogood(Context view){
	//if(nogood!=null) return false;
	//if(emptyLevel(levelState)){
	//    MySystem.out.println("Nogood invalid since empty levelState");
	//    printLevelState();
	//    return false;
	//}
	Iterator it= (Iterator)view.keys();
	while(it.hasNext()) {
	    String var= (String)it.next();
	    int varID=MHCscheduler.getID(var);
	    DVarHistory valuation=view.getDV(var);
	    //It is sufficient that one view is outdated
	    //for invalidating the nogood
	    if(outdatedView(var,varID,valuation)){
		MySystem.out.println("Nogood invalid since outdated view");
		return false;
	    }
	}
	return true;
    }

    // test whether an element of a nogood is outdated
    private boolean outdatedView(String var, int varID, DVarHistory valuation){
	int[] old=histories.geth(var);
	//DVarHistory oldVH =new DVarHistory((Range)null,old);
	if((old!=null)&&History.firstInvalidatesSecond(old,valuation.history)){
	    //olderThan(oldVH)){
	    MySystem.out.println("MHCk:old hist:Nogood outdated at var:"+var+" I had:"+History.toString(old));
	    return true;
	}
// 	if(varID<0)
// 	    return false;
// 	MHCHistory ls=levelState[varID];
// 	if(ls==null){
// 	    MySystem.err.println("MHCk:ls=null:Nogood outdated at var:"+var);
// 	    return true;
// 	}
	return false;
    }

    //saves needed variables in linksToAdd respectively to conflictingVariables
    private void registerNogood(DNogood nogood){
	if(getContext(nogood.view,false))
	    MySystem.exit("Nogood thought valid");//invalid nogood
	disableChanged();
	int vid=getLocalID(nogood.view);
	if(vid<0){
	    vid=0;
	    MySystem.exit("MHCK inapropriate incoming nogood");
	}
	makeNogood(nogood.view);
    }

    private void makeNogood(Context ncontext){
	if(nogood!=null){
	    mValidNogoodDiscarded=true;
	    return;
	}
	MySystem.out.println("MHCk:Valid made nogood:modif");
	MHCmodif=true;
	nogood=new AssignmentRefs();
	Iterator it=(Iterator)ncontext.keys();
	while(it.hasNext()) {
	    String dvar=(String)it.next();
	    int[] dhist=ncontext.geth(dvar);
	    nogood.add(new AssignmentRef(dvar,dhist[dhist.length-2]));
	}
    }

    private void clearLevel(){
	for(int k=0;k<levelState.length;k++)
	    levelState[k]=null;
    }

    private int getLocalID(Context nogood){
	Iterator it=(Iterator)nogood.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    int[] vHist=nogood.geth(var);
	    if(vHist[vHist.length-2]==level)
		return MHCscheduler.getID(var);
	}
	return -1;
    }

//     boolean emptyLevel(LCNHashtable[] doms){
// 	for(int k=0;k<doms.length;k++){
// 	    if(doms[k]==null)// return true;
// 		continue;
// 	    ILCN ilcn=doms[k].intersection();
// 	    if((ilcn!=null)&&(ilcn.label.size()<=0))
// 		return true;
// 	}
// 	return false;
//     }
    void setPost(Hashtable incomingPost, POrder order){
 	synchronized(postMonitor){
	    MySystem.err.println("set post:"+level);
	    ipost.order=order;
	    Iterator it=(Iterator)incomingPost.keys();
	    while(it.hasNext()){
		String var=(String)it.next();
		int[] postedHist=(int[])incomingPost.get(var);
		if((postedHist!=null)&&
		   (postedHist.length>1)&&
		   (postedHist[postedHist.length-2]<=level)){
		    int[] oldHistory=ipost.hist.geth(var);
		    if((oldHistory==null)||
		       History.firstDisablesSecond(postedHist,oldHistory))
			ipost.hist.put(var,postedHist);
		}else{
		    MySystem.err.println(History.toString(postedHist));
		    MySystem.exit(1);
		}
	    }
	}
    }
    void clearPostTellOrder(POrder o, int changeLevel){
	synchronized(postMonitor) {
	    MySystem.out.println("MHCk:"+level+" clear tell post:"+changeLevel+" "+o);
	    ipost.hist.trimm(changeLevel);
	    ipost.order=o;
	}
    }
    //read and clear the post
    void readPostToChanged(){
	synchronized(postMonitor){
	    if(ipost.order!=null){
		ipost.filterInfoOut(order,histories);
		getOrder(ipost.order);
	    }
	    MySystem.out.println("got ipost order");
	    heurs.updateHeurHistories(ipost.hist);
	    Iterator it=ipost.hist.keys();
	    while(it.hasNext()){
		String var=(String)it.next();
		int[] incomingHist=ipost.hist.geth(var);
		int[] oldHistory=histories.geth(var);
		MySystem.out.println("Read post:l:"+level+":v="+var+":"+History.toString(incomingHist)+":had:"+History.toString(oldHistory));
		//if i am dependent on older
		if((oldHistory!=null)&&
		   History.firstDisablesSecond(incomingHist,
					       oldHistory)){
		    int changedL=History.changeRLevel(oldHistory,
						      incomingHist);
		    changed.addMin(var,changedL);
		    histories.put(var,incomingHist);
		    //avoid posting the old value....
		    if(opost.hist.geth(var)!=null)
			opost.hist.remove(var);
		    for(int l=changedL;l<=level;l++){
			if(opost.insts[l]!=null)
			    opost.insts[l].remove(var);
			//?if(myInst!=null)myInst.remove(var);
		    }
		}
// 		else
// 		    if((oldHistory!=null)&&
// 		       History.firstDisablesSecond(oldHistory,
// 						   incomingHist)){
// 			int changedL=History.changeLevel(oldHistory,
// 							 incomingHist);
// 			changed.addMin(var,changedL);
// 			histories.put(var,incomingHist);
// 			//avoid posting the old value....
// 			if(opost.hist.geth(var)!=null)
// 			    opost.hist.remove(var);
// 			for(int l=changedL;l<=level;l++){
// 			    if(opost.insts[l]!=null)
// 				opost.insts[l].remove(var);
// 			    //?if(myInst!=null)myInst.remove(var);
// 			}
// 		    }
		if(oldHistory==null){
		    // could used separate "unusedHistory"
		    histories.put(var,incomingHist);
		    changed.add(var,incomingHist[0]);
		}
	    }
	    ipost.hist.clear();
            //MySystem.out.println("will DisableChanges");
	    disableChanged();
	}
    }
}
