/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dcsp;
import java.util.*;
import java.io.*;
import java.awt.Color;
import csp.*;
import platform.*;
import parameters.*;
import utils.*;
import hc.*;
import sjavap.*;

public class PAgent extends MHC {

    public boolean msSndHeuristics=true;
    public boolean msComputeGready=true;

    private Agent agent;
    private int myID=0;
    private int myComputationNum=-2;
    private AgentID myself;
    private String myName;
    private CN lastSentNogood=null;

    private IOHashtable vIDs;
    private Splitter engine;
    private HC hc=new HC();
    private AcceptedStructures accepts=new AcceptedStructures();
    private MessagesPost msgPost=new MessagesPost();
    private CompactorAccepted cAccepted;
    private int conflictingNogoods=0;
    private AssignmentRefs conflictingVariables
	= new AssignmentRefs();
    HeuristicContainer heurs;
    private LabelsManager labels;
    private Orders orders;
    private POrder order;
    private AIHashtable cOrder=new AIHashtable();

    private MHCk[] mHCks;
    private MHCk mHCk,mHCinst;

    private boolean flowO=true;
    private boolean flowI=true;
    private boolean flow =true;//flowO&&flow

    private DSearch dSearch;
    private int agentsNr, historyIDs[];
    private AgentID[] agents,defaultAgents;
    private CNTable lastSent = new CNTable();
    //world data
    private DIncomingAgent dIncomingAgent;
    private DOutgoingAgent dOutgoingAgent;
    private Hashtable outGoing=new Hashtable();
    private Hashtable inComing=new Hashtable();
    private Hashtable addedOutgoingLinks=new Hashtable();
    private boolean lastSolution=false;
    private boolean solutionHistoryChanges=false;
    private boolean validNogoodDiscarded=false;
    boolean mArtificial=false;
    private boolean mLastArtificial=false;

    final static int SprocessingM=0;
    final static int SannouncedN=1;
    final static int SannouncedS=2;
    final static int SannouncedEN=3;
    final static int SannouncedF=4;
    final static int SannouncedSresend=5;
    final static int SnoChange=6;
    final static int SstopM=7;
    final static int SwaitEndM=8;
    final static int SnoUse=9;
    final static int EngineNogoodExpansion=10;
   // states
    final static int Sprocessing=0;
    final static int Sstart=1;
    final static int Sannounced=2;
    final static int SwaitEnd=3;
    final static int Sstop=4;
    final static int Stimeout=5;
    boolean Snogood=false;
    boolean Ssolution=false;
    int crtState=Sstart;

    final static int FlowOThreshold=100;
    final static int FlowIUThreshold=150;
    final static int FlowILThreshold=100;
    //active procedures
    final public static int _MHCk=3;
    final public static int _getStartParameters=4;
    final public static int _accepted=5;
    final public static int _addLink=6;
    final public static int _compactors=7;
    final public static int _reorder=8;
    final public static int _nogood=9;

    public PAgent(){}
//                                               //
/* Here is the procedure for protocol identification*/
//                                               //
    public String toString(){
	if(MHC.ascendingOrder) return "DCSP";
	else return "DCSP-BAD-ORDER";
    }

    public synchronized void terminate(){
	crtState=Sstop;
	agent=null;
	genericAgent=null;
	myself=null;
	MySystem.out.println(" DCSP receives Terminate");
        Synch_Reply();
	return;
    }

    //state machine
    synchronized public void run() {
	try{
	    rrun();
	}catch(Exception e){
	    e.printStackTrace();
	    MySystem.exit(1);
	}
    }
    private void rrun(){
	select.thread=Thread.currentThread();
	agent=(Agent)genericAgent;
	myself = genericAgent.getID();
	myName = myself.getName();
        Utils.aggregations=true;
	Utils.agentCost=new DCost();
	Utils.MAX_SECV_MSG=problem.workAmount;
	if(!initPhase()){
	    MySystem.out.println("terminated before starting");
	    return;
	}
	init(problem);
	int sWait;
	for(;;){
	    MySystem.out.println("State="+crtState);
	    int dim=0;
	    if(crtState!=Sstop)//if flow, do not force
		dim=agent.getOutputQueueSize(flow);
	    if(dim>FlowOThreshold){
		MySystem.out.println("flowO:=false OQS="+dim);
		flowO=false;
	    }else flowO=true;
	    dim=getInputQueueSize();
	    if(dim<FlowILThreshold) flowI=true;
	    else if((dim=getInputQueueSize())>FlowIUThreshold){
		MySystem.out.println("flowI:=false");
		flowI=false;
	    }
	    flow=flowO&&flowI;
	    if(!flow){
		MySystem.out.println("not flowing");
		select.accept(6,_compactors);
	    }
	    switch(crtState){
	    case Sstart:
                engine.initSearch();
		CNSet propagate=new CNSet();
		if(mHC(propagate)){
		    if(announceMHC(-1,propagate)){
			MySystem.out.println("Will reorder 0?");
			if(!claim0Order()) crtState=Sstop;
			else crtState=Sprocessing;
			MySystem.out.println("Will reorder 0!");
		    }else crtState=Sstop;
		}else{
		    switch(announceEmptyNogoodToBroker()){
		    case 1:crtState=Sstop;break;
		    case 2:crtState=SwaitEnd;
		    }
		}
		break;
	    case Sprocessing:
		select.accept(0,_terminate);
		if(flow) select.accept(1,_MHCk);
		else
		    MySystem.out.println("Agent: Sprocessing is not flowing");
		if(msComputeGready||(labels.consistentLevel==myID-1))
		    select.waituntil(2,0);
		select.accept(3,_addLink);
		select.accept(4,_nogood);
		sWait = Synch_Wait();
        	MySystem.out.println("Choice="+sWait);
                if(sWait==0) crtState=Sstop;
                //if(sWait==9) crtState=Sstop;
		if(sWait==4) msgPost.nogoodBuf=null;
		if(sWait==2){
                    int result = engine.search();
		    if((result!=0)&&(crtState!=Sstop)) {
			crtState=Sannounced;
			if(result>0){
			    Ssolution=true;
			    Snogood=false;
			    Range[]sol=engine.getSol();
			    switch(announceSolution(sol)){
			    case 0: break;
			    case 1: crtState=Sstop;
			    }
			}else{
			    Snogood=true;
			    Ssolution=false;
                            switch(announceNogood()){
			    case 0: break;
			    case 1: crtState=Sstop;break;
			    case 2: crtState = SwaitEnd;
			    }
			}
		    }
		}
		if(sWait == 1){
		    switch(getMHCk()){
		    case SannouncedF:
			crtState=Stimeout;break;
		    case SnoChange: break;//no change
		    case SstopM: crtState=Sstop;break;
		    case SwaitEndM: crtState = SwaitEnd;break;
		    case SannouncedN:
			crtState=Sannounced;
			Snogood=true;
			Ssolution=false;
		    case SprocessingM: break;
		    default:
			MySystem.exit("Agent:->annouS from processing");
		    }
		    if((crtState!=Sstop)&&
		       (crtState!=SwaitEnd)&&(crtState!=Stimeout))
			if(!claimOrder()) crtState=Sstop;
		}
		if(sWait==3)
		    if(!answerToAddLinks())
			crtState=Sstop;
		break;
	    case Sannounced:
		MySystem.out.println("Snogood="+Snogood);
		select.accept(0,_terminate);
		if(flow){
		    select.accept(1,_MHCk);
		    select.accept(2,_accepted);
		}
		select.accept(3,_addLink);
		select.accept(5,_nogood);
		sWait = Synch_Wait();
        	MySystem.out.println("Choice="+sWait);
                if(sWait == 0) crtState=Sstop;
		if(sWait == 5){
		    //if(Snogood) msgPost.nogoodBuf=null;
		    if(msgPost.nogoodBuf!=null){
			DNogood param=(DNogood)msgPost.nogoodBuf.getArguments();
			IntObject io=new IntObject(0);
			BoolObject changeOrder=new BoolObject(false);
			if(getOrder((POrder)param.order,myID,io,changeOrder)){
			    select.call(0,mHCinst,mHCinst._getMessage);
			    Synch_Wait();
			    mHCinst.getMessage(msgPost.nogoodBuf);
			}
			switch(io.i){
			case SnoChange: break;
			case SprocessingM:
			case EngineNogoodExpansion:
			    crtState=Sprocessing;
			    Ssolution=Snogood=false;break;
			}
			if(changeOrder.b&&Ssolution){
			    crtState=Sannounced;
			    Snogood=false;
			    Ssolution=true;
			    switch(announceSolution(engine.getSol())){
			    case 0: break;
			    case 1: crtState=Sstop;break;
			    }
			}
		    }
		    msgPost.nogoodBuf=null;
		}
		if(sWait == 1){
		    int tres=getMHCk();
		    MySystem.out.println("getMHCk:"+tres);
		    switch(tres){
		    case SannouncedF:
			crtState=Stimeout;break;
		    case SnoChange: break;//no change
		    case SstopM: crtState=Sstop;break;
		    case SwaitEndM: crtState = SwaitEnd;break;
		    case SannouncedN:
			crtState=Sannounced;
			Snogood=true;
			Ssolution=false;
			break;
		    case SannouncedS:
			crtState=Sannounced;
			Snogood=false;
			Ssolution=true;
			break;
		    case SannouncedSresend:
			crtState=Sannounced;
			Snogood=false;
			Ssolution=true;
			switch(announceSolution(engine.getSol())){
			case 0: break;
			case 1: crtState=Sstop;break;
			}
			break;
		    case SprocessingM:
			crtState=Sprocessing;
			Snogood=false;
			Ssolution=false;
			break;
		    default:
			MySystem.exit("Agent:->annouS from processing");
		    }
		    if((crtState!=Sstop)&&
		       (crtState!=SwaitEnd)&&((crtState!=Stimeout)))
			if(!claimOrder()) crtState=Sstop;
		}
		if(sWait == 2){
		    if(msgPost.accepted!=null){
			DAccepted param=(DAccepted)msgPost.accepted.getArguments();
			accepts.acceptedIntersection=param.history;
			accepts.acceptedCost=((DAccepted)param).cost;
			if((outGoingAllFinished())&&
			   lastSolution&&Ssolution)
			    announcePartialSolution();
			else
			    MySystem.out.println("lastSolution"+lastSolution+" Ssolution"+Ssolution);
		    }else
			MySystem.exit("null accepted received");
		}
		if(sWait==3){
		    if(msgPost.addLink!=null){
			if(!answerToAddLinks())
			    crtState=Sstop;
		    }
		}
                break;
	    case Stimeout:
		AgentID target=((Agent)genericAgent).getBrokerID();
		DObject parameter=(DCost)(((DCost)Utils.agentCost).clone());
		if(!sndMsg(target,Commands.cFail,parameter))crtState=Sstop;
		else crtState=SwaitEnd;
                break;
	    case SwaitEnd:
		select.accept(0,_terminate);
		//may also wait and discard other messages
		select.accept(2,_accepted+MessageQueue.REFUSE);
		select.accept(3,_addLink+MessageQueue.REFUSE);
		//select.accept(4,_ok+MessageQueue.REFUSE);
		select.accept(5,_nogood+MessageQueue.REFUSE);
		//select.accept(6,_heuristic+MessageQueue.REFUSE);
		select.accept(7,_reorder+MessageQueue.REFUSE);
		if(Synch_Wait()==0) crtState=Sstop;
		break;
	    case Sstop:
		select.call(0,mHCk,mHCk._terminate);
		Synch_Wait();
		mHCk.terminate();
		select.call(0,cAccepted,cAccepted._terminate);
		Synch_Wait();
		cAccepted.terminate();
		for(int k=0;k<agentsNr;k++){
		    select.call(0,mHCks[k],mHCks[k]._terminate);
		    Synch_Wait();
		    mHCks[k].terminate();
		}
		return;
	    }
	}
    }
    boolean sndMsg(AgentID target, String command, Serializable message){
	select.accept(0,_terminate);
	select.call(1,genericAgent,genericAgent._sendCommand);
	if(Synch_Wait()==0){
	    MySystem.out.println("A::got terminate");
	    return false;
	}
	//MySystem.out.println("sending:"+message+":to:"+target);
	genericAgent.sendCommand(command,message,target);
	return true;
    }

//                                                 //
/* Here is the procedure for addlink answer        */
//                                                 //


    private void answerToAddLink(DAddLink dn,Hashtable lastEstablishedLinks){
	ArrayList vars=(ArrayList)addedOutgoingLinks.get(dn.source);
	ArrayList addedVars=(ArrayList)lastEstablishedLinks.get(dn.source);
	if(addedVars==null) addedVars=new ArrayList();
        int k;
	if(vars!=null){
	    for(k=0;k<dn.variables.length;k++)
		//one may receive all variables
		if((engine.getvID(dn.variables[k])>=0)&&
		   (!vars.contains(dn.variables[k]))){
		    vars.add(dn.variables[k]);
		    addedVars.add(dn.variables[k]);
		}
	}else
	    for(k=0;k<dn.variables.length;k++)
		//one may receive all variables
		if(engine.getvID(dn.variables[k])>=0)
		    addedVars.add(dn.variables[k]);
	lastEstablishedLinks.put(dn.source,addedVars);
	if(vars==null)
	    addedOutgoingLinks.put(dn.source,addedVars.clone());
    }
    //answer to add link: not sending fakes
    private boolean answerToAddLinks(){
	DAddLink dn=(DAddLink)msgPost.addLink.getArguments();
	((DCost)Utils.agentCost).incrementMessages(dn.cost);
	Hashtable lastEstablishedLinks=new Hashtable();
	answerToAddLink(dn,lastEstablishedLinks);
	Iterator it=(Iterator)lastEstablishedLinks.keys();
	while(it.hasNext()){//there should be only one
	    AgentID target=(AgentID)it.next();
	    if(cOrder.getI(target)<=myID) continue;
	    ArrayList al=(ArrayList)lastEstablishedLinks.get(target);
	    Propagate dView=new Propagate(myID);
	    for(int k=0;k<al.size();k++){
		String var=(String)al.get(k);
		CN mh=lastSent.getCN(var);
		if(mh==null) continue;
		dView.addedLinks.put(var,mh.getDV());
	    }
	    if(dView.addedLinks.size()==0) continue;
	    dView.order=(POrder)order.clone();
	    dView.cost=(DCost)((DCost)Utils.agentCost).clone();
	    dView.sender=myself;
	    if(!sndMsg(target,Commands.cMHC,dView)) return false;
	}
	return true;
    }

//                                                 //
/* Here are the procedures for color messages      */
//                                                 //

    synchronized void createColorMatrix(String var1, String var2, int sizeX, int sizeY) {
	if(!Utils.sendingColors) return;
        if(crtState==Sstop)  return;
	select.accept(0,_terminate);
	select.call(1,agent,agent._createColorMatrix);
	if(Synch_Wait()==0) return;
	agent.createColorMatrix(var1, var2, sizeX, sizeY);
    }

    synchronized void createColorMatrix(int id, String var1, String var2, int sizeX, int sizeY) {
	if(!Utils.sendingColors) return;
        if(crtState==Sstop) return;
	select.accept(0,_terminate);
	select.call(1,agent,agent._createColorMatrix);
	if(Synch_Wait()==0) return;
	agent.createColorMatrix(id, var1, var2, sizeX, sizeY);
    }

    synchronized void setColor(String var1, String var2,
			       int sizeX, int sizeY,
			       int sizeX2, int sizeY2,
			       Color c1, Color c2){
	if(!Utils.sendingColors) return;
        if(crtState==Sstop) return;
	select.accept(0,_terminate);
	select.call(1,agent,agent._setColor);
	if(Synch_Wait()==0) return;
	agent.setColor(var1, var2, sizeX, sizeY,
                        sizeX2, sizeY2, c1, c2);
    }

    synchronized void setColor(String var1, String var2,
			       int table[][],
			       int sizeX, int sizeY,
			       int sizeX2, int sizeY2,
			       int destX, int destY,
			       Color c1, Color c2,
			       Color color0, Color oldColor0){
	if(!Utils.sendingColors) return;
        if(crtState==Sstop) return;
	select.accept(0,_terminate);
	select.call(1,agent,agent._setColor);
	if(Synch_Wait()==0) return;
	agent.setColor(var1, var2, table, sizeX, sizeY,
                        sizeX2, sizeY2, destX, destY,
		       c1, c2, color0,oldColor0);
    }

    synchronized void setColor(String var1,
                                      String var2,
                                      Range[] size,
				      Range[] oldsize,
                                      Color c1,
				      Color color0){
	if(!Utils.sendingColors)
	    return;
        if(crtState==Sstop)
          return;
	select.accept(0,_terminate);
	select.call(1,agent,agent._setColor);
	if(Synch_Wait()==0){
	    return;
	}
	agent.setColor(var1, var2, size, oldsize, c1, color0);
    }

    //OTHERS//

    int getInputQueueSize(){
	return queue.size();
    }
    ArrayList getNewConstraint(int level) {
	int clLevel=conflictingVariables.getLastLevel();
	if((level==myID-1)||(level>=clLevel))
	    return engine.getNewConstraint();
	return null;
    }
    int getCLNogoodChangeLevel() {
	return conflictingVariables.getLastLevel();
    }
    private boolean initPhase(){
	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverTypeAndProcedure);
	if(Synch_Wait()==0) return false;
	queue.setReceiverType(this,
			      new CommandSelector(Commands.cStartParameters),
			      _getStartParameters);

	DSubscription myProblem=
	    new DSubscription(genericAgent.getID(),
			      problem.getVariables(),0,
			      problem.getComplexity(),
			      agent.getID().getName());
         if(!this.sndMsg(agent.getBrokerID(),Commands.cMyProblem,
                          myProblem)) return false;

	select.accept(0,_terminate);
	select.accept(1,_getStartParameters);
	if(Synch_Wait()==0) return false;
	getStartParameters();
	MySystem.out.println("End of InitPhase");
	return true;
    }
    private void getStartParameters(){
	Message_Command mc=msgPost.startParameters;
	StartLinks dsl=(StartLinks)mc.getArguments();
	//String command=(String)mc.getCommand();
	myComputationNum=mc.getComputationNum();
	MySystem.out.println("MHC.myComputationNum="+myComputationNum);
	//StartLinks dsl=(StartLinks)param;
	MySystem.out.println("got="+dsl);
	order=(POrder)dsl.order;
	dSearch=dsl.dSearch;
	setDefaultOrder();
	accepts.acceptedSendersNr=dSearch.acceptedSenders.size();
	accepts.acceptedReceiver=dSearch.acceptedReceiver;
	setAgentsPosition();
	if(dIncomingAgent.get().length==0)
	    accepts.endAgent=true;
    }
    private void setDefaultOrder(){
	agentsNr=dSearch.agentOrder.size();
	agents = new AgentID[agentsNr];
	defaultAgents=(AgentID[])((AgentID[])dSearch.sortedAgents).clone();
    }

    AgentID getAgent(int k){return agents[k];}
    private void init(Problem problem){
	if(problem.artificial) {
	    if(problem.mSplitter)
		engine=new BinarySplitting(problem, this);
	    else{
		MySystem.out.println("Nr of seeds:"+problem.mCoverSeedsNr);
		problem.coverSeeds(problem.mCoverSeedsNr);
		engine=new Splitting(problem, this);
	    }
	    mArtificial=true;
	    mLastArtificial=problem.mLastArtificial;
	}else engine=new Splitting(problem, this);
	MySystem.out.println("out of engine");
	vIDs = engine.getvIDs();
	MySystem.out.println("go labels");
	labels=new LabelsManager(agentsNr,engine.getVariables(),vIDs, this);
	MySystem.out.println("out of labels");
	//labels.setPosition(myID);
	labels.setInitialDomains(engine.getInitialDomains());

	orders=new Orders();//defaultAgents);
	order=(POrder)orders.sent0Order.clone();


	hc.setConstraints(engine.getConstraints());
	hc.order=engine.getConstraintsID();
        hc.constraintsNr=engine.getConstraintsNr();
	heurs=new HeuristicContainer(agentsNr,defaultAgents,order);
	//heurs.setOrder(order);

	cAccepted=new CompactorAccepted(this, accepts.acceptedSendersNr, myComputationNum);
	new Thread(cAccepted).start();
	MySystem.out.println("out of compactor accepted");
	initMHC();
	MySystem.out.println("out of queue");
	if(!initQueue())crtState=Sstop;
    }

    private void initMHC(){
	mHCk=new MHCk(this, -1, engine.getVariablesNr(), myComputationNum,queue,agentsNr,myself,defaultAgents);
        new Thread(mHCk).start();
	int k;

	mHCks=new MHCk[agentsNr];
	for (k=0;k<agentsNr;k++){
	    mHCks[k]=new MHCk(this, k, engine.getVariablesNr(), myComputationNum,queue,agentsNr,myself,defaultAgents);
	    if(k==myID){
		POrder pOrder=order.getOLevel(k);
		mHCks[k].setInstantiation(pOrder,true);
	    }
	    new Thread(mHCks[k]).start();
	}
	mHCinst=mHCks[myID];
    }

    private boolean initQueue(){
	select.call(1,queue,queue._setReceiverType);
	select.accept(0,_terminate);
        if(Synch_Wait()==0){ crtState=Sstop; return false;}
	queue.setReceiverType(mHCk, new MHCSelector(-1));

	for (int k=0;k<agentsNr;k++){
            select.accept(0,_terminate);
	    select.call(1,queue,queue._setReceiverType);
	    if(Synch_Wait()==0){crtState=Sstop; return false;}
	    queue.setReceiverType(mHCks[k],
				 new MHCSelector(k));
	}

	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverTypeAndProcedure);
	if(Synch_Wait()==0){crtState=Sstop; return false;}
	queue.setReceiverType(this,
			      new CommandSelector(Commands.cNogood),
			      _nogood);


	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverType);
	if(Synch_Wait()==0){crtState=Sstop; return false;}
	queue.setReceiverType(cAccepted,
			      new CommandSelector(Commands.cAccepted));


	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverTypeAndProcedure);
	if(Synch_Wait()==0){crtState=Sstop; return false;}
	queue.setReceiverType(this,
			      new CommandSelector(Commands.cAddLink),
			      _addLink);


	select.accept(0,_terminate);
	select.call(1,queue,queue._setActionTrigger);
	if(Synch_Wait()==0){crtState=Sstop; return false;}
	queue.setActionTrigger(new CompactorTriggerForInput(this,queue,FlowILThreshold,FlowIUThreshold));

	select.accept(0,_terminate);
	select.call(1,queue,queue._setActionTrigger);
	if(Synch_Wait()==0){crtState=Sstop; return false;}
	queue.setActionTrigger(new ServerTriggerForInput(agent.server,queue,FlowIUThreshold,agent.FlowConnectionThreshold));

	select.accept(0,_terminate);
	select.call(1,agent.outQueue,agent.outQueue._setActionTrigger);
	if(Synch_Wait()==0){crtState=Sstop; return false;}
	agent.outQueue.setActionTrigger(new CompactorTriggerForOutput(this,agent.outQueue,FlowOThreshold));
	return true;
    }

    private boolean claim0Order(){
	if(mArtificial)return true;
	if(myself.equals(defaultAgents[0])&&updateSent0Order()){
	    DPOrder msg=new DPOrder((POrder)orders.sent0Order.clone());
	    msg.cost=(DCost)((DCost)Utils.agentCost).clone();
	    for(int k=0;k<agentsNr;k++){
		if(myself.equals(agents[k])){
		    if(sendReorder0ToMyself(msg)) continue;
		    else break;
		}
		if(!sndMsg(agents[k],Commands.cREORDER,msg)) return false;
	    }
	    return true;
	}
	return true;
    }
    private boolean claimOrder(){
	if(mArtificial&&(!mLastArtificial))return true;
	if(!claim0Order()) return false;
	if(updateSentOrder()){
	    for(int k=myID+1;k<agentsNr;k++){
		DPOrder msg=new DPOrder((POrder)orders.sentOrder.clone());
		msg.cost=(DCost)((DCost)Utils.agentCost).clone();
		if(!sndMsg(agents[k],Commands.cREORDER,msg)) return false;
	    }
	}
	return true;
    }

    private boolean sendReorder0ToMyself(DPOrder msg){
	select.call(1,mHCks[0],mHCks[0]._getMessage);
	Synch_Wait();
	Message m=new Message_Command(Commands.cREORDER,msg,myself);
	m.setOtherData(myself,myComputationNum,0);
	mHCks[0].getMessage(m);
	return true;
    }

    private boolean updateSent0Order(){
 	AgentID winner,oldWinner=null;
 	if(0 >= (agentsNr-1)){
 	    //orders.sent0Order=new POrder();
 	    return false;
 	}
	if((orders.sent0Order!=null)&&(orders.sent0Order.sequence.length==1))
	    oldWinner=orders.sent0Order.sequence[0];
 	int bestVolumes=getVolume(agents[0],null,-1);
 	winner=agents[0];
 	for(int k=1;k<agentsNr;k++){
 	    int vol=getVolume(agents[k],null,-1);
 	    if(ascendingOrder){
		if(bestVolumes>vol){
		    bestVolumes=vol;
		    winner=agents[k];
		}else
		    if((bestVolumes==vol)&&(oldWinner!=null)&&
		       (agents[k].equals(oldWinner))) winner=oldWinner;
	    }else{
		if(bestVolumes<vol){
		    bestVolumes=vol;
		    winner=agents[k];
		}else
		    if((bestVolumes==vol)&&(oldWinner!=null)&&
		       (agents[k].equals(oldWinner))) winner=oldWinner;
	    }
 	}
	if(((orders.sent0Order==null)||
	    (orders.sent0Order.sequence.length==0))&&
	   (defaultAgents[0].equals(winner)))
	    return false;
	if((oldWinner!=null)&&(oldWinner.equals(winner))) return false;
	orders.order0IDs++;
 	orders.sent0Order=build0Order(winner);
 	return true;
     }
    //compute reorder
    private POrder build0Order(AgentID winner){
	int k;
	AgentID[] seq=new AgentID[1];
	seq[0]=winner;
	int[] hist=new int[2];
	hist[0]=-1;
	hist[1]=orders.order0IDs;
	return new POrder(seq,hist);
    }
    private POrder buildOrder(POrder order, AgentID winner, int pos){
	int k;
	AgentID[] seq=new AgentID[pos+1];
	for(k=0;k<pos;k++)
	    seq[k]=agents[k];
	seq[pos]=winner;
	int[] hist=new int[order.history.length+2];
	for(k=0;k<order.history.length;k++)
	    hist[k]=order.history[k];
	hist[k++]=myID;
	hist[k]=orders.orderIDs;
	return new POrder(seq,hist);
    }
    private boolean updateSentOrder(){
 	AgentID winner, oldWinner=null;
	//MySystem.out.println("sentorder at input:"+orders.sentOrder);
 	if(myID>=agentsNr-1){
 	    orders.sentOrder=(POrder)order.clone();
 	    return false;
 	}
	if((orders.sentOrder!=null)&&
	   (orders.sentOrder.sequence.length==myID+2))
	    oldWinner=orders.sentOrder.sequence[myID+1];
 	int bestVolumes=getVolume(agents[myID+1],null,myID);
 	winner=agents[myID+1];
	for(int k=myID+2;k<agentsNr;k++){
 	    int vol=getVolume(agents[k],null,myID);
	    if(ascendingOrder){
		if(bestVolumes>vol){
		    bestVolumes=vol;
		    winner=agents[k];
		}else
		    if((bestVolumes==vol)&&(oldWinner!=null)&&
		       (oldWinner.equals(agents[k]))) winner=oldWinner;
	    }else{
		if(bestVolumes<vol){
		    bestVolumes=vol;
		    winner=agents[k];
		}else
		    if((bestVolumes==vol)&&(oldWinner!=null)&&
		       (oldWinner.equals(agents[k]))) winner=oldWinner;
	    }
 	}
	if(orders.sentOrder==null) orders.sentOrder=(POrder)order.clone();
	if((oldWinner!=null)&&(oldWinner.equals(winner))) return false;
	if((orders.sentOrder.sequence.length<myID+2)&&winner.equals(agents[myID+1])) return false;
	orders.orderIDs++;
	orders.sentOrder=buildOrder(order,winner,myID+1);
 	return true;
     }

    //estimate the volume of that agent
    private int getVolume(AgentID ag, Range[] domains,int level){
	Variable[] svars=((AgentData)dSearch.problemByAgent.get(ag)).getVariables();
	int vol=getRangeEstimate(svars[0].getVariable(),level,domains);
	for(int k=1;k<svars.length;k++)
	    vol*=getRangeEstimate(svars[k].getVariable(),level,domains);
	return vol;
    }

    private int getRangeEstimate(String var, int level, Range[] domains){
	int vID=getID(var);
	if((vID>=0)&&(domains!=null)) return domains[vID].size();
	Range r=heurs.getRange(var,level);
	if(r!=null) return r.size();
	return (engine.getInitialDomains())[0].size();
    }

    synchronized public void mHCk(LCNHashtable[] levelState,
			   Histories post, RHashtable[] insts,
 			   int level, POrder lOrder,
			   AssignmentRefs nogood, boolean validNDiscarded){
	msgPost.levelState=null;
	if(levelState!=null) {
	    msgPost.levelState=(LCNHashtable[])levelState.clone();
	    for(int k=0;k<levelState.length;k++)
		if(levelState[k]!=null)
		    msgPost.levelState[k]=(LCNHashtable)levelState[k].clone();
	}
	msgPost.post=post;
	msgPost.insts=insts;
	msgPost.level=level;
	msgPost.lOrder=lOrder;
	msgPost.nogood=nogood;
	if(msgPost.nogood!=null)
	    msgPost.nogood=(AssignmentRefs)msgPost.nogood.clone();
	if(validNDiscarded)validNogoodDiscarded=true;
	MySystem.out.println("PAgent got mhck:"+post);
	Synch_Reply();
    }

    private boolean getOrder(POrder incOrder, int level, IntObject state, BoolObject change) {
	POrder trimorder=order.getOLevel(level);
	MySystem.out.println("inc order facing "+trimorder);
	state.i=SnoChange;
	if(History.firstDisablesSecond(trimorder.history,incOrder.history)){
	    MySystem.out.println("old inc order");
	    return false;
	}
	int vLevel=level+1;
	if(History.firstDisablesSecond(incOrder.history,trimorder.history)){
	    change.b=true;
	    MySystem.out.println("new inc order");
	    heurs.setOrder(incOrder);
	    int k=History.changeLevel(trimorder.history,incOrder.history);
	    order=incOrder;
	    orders.sentOrder=(POrder)order.clone();
	    state.i=resetOrderDependentHistory(k);
	}
	return true;
    }

    //called from run when changeID is set
    private void changeMyID(){
	if(mHCks==null)return;//at initPhase
	if(mHCinst==mHCks[myID])return;
	MySystem.out.println("ChangeMyID set "+myID);
	select.call(1,mHCinst,mHCinst._setInstantiation);
	Synch_Wait();
	int k=mHCinst.getLevel();
	POrder pOrder=order.getOLevel(k);
	mHCinst.setInstantiation(pOrder,false);mHCinst.Synch_Reply();
	//myID=newID;
	mHCinst=mHCks[myID];
	select.call(1,mHCinst,mHCinst._setInstantiation);
	Synch_Wait();
	pOrder=(POrder)order.clone();
	mHCinst.setInstantiation(pOrder,true);mHCinst.Synch_Reply();
    }

    private void setAgentsPosition(){
	int i;
	cOrder.setCOrder(new Hashtable());
	for(i=0;i<order.sequence.length;i++){
	    agents[i]=order.sequence[i];
	    cOrder.put(agents[i],new IntObject(i));
	}
	for(int j=0;j<agents.length;j++){
	    if(cOrder.getIO(defaultAgents[j])!=null)continue;
	    agents[i]=defaultAgents[j];
	    cOrder.put(agents[i],new IntObject(i));
	    i++;
	}
	int newID=cOrder.getI(myself);
	MySystem.out.println("my new ID:"+newID+" and old "+myID);
	if(newID!=myID){
	    myID=newID;
	    changeMyID();
	}
	getRelatedAgents();
	inComing.clear();outGoing.clear();
	registerInComing(dIncomingAgent.get());
	registerOutGoing(dOutgoingAgent.get());
    }

    private boolean registerInComing(IncomingAgent agents[]){
        AgentID farAgent;
        for(int k=0;k<agents.length;k++){
	    farAgent=agents[k].getAgent();
	    if(!inComing.containsKey(farAgent))
		inComing.put(farAgent,farAgent);
	}
        return agents.length>0;
    }
    private boolean registerOutGoing(OutgoingAgent agents[]){
        AgentID farAgent;
        OutgoingAgent oa;
        for(int k=0;k<agents.length;k++){
	    farAgent=agents[k].getAgent();
	    oa=(OutgoingAgent)outGoing.get(farAgent);
	    if(oa==null) {
		outGoing.put(farAgent,agents[k]);
		ArrayList vars;
		vars=agents[k].variables;
	    } else{
		ArrayList variables=agents[k].variables;
		for(int j=0;j<variables.size();j++){
		    String s=(String)variables.get(j);
		    if(!oa.variables.contains(s))
			oa.variables.add(s);
		}
	    }
	}
        return true;
    }

    // getAgents
    OutgoingAgent[] getOutGoing(AgentID agent){
	OutgoingAgent oAgent[]=new OutgoingAgent[0];
	Hashtable outgoing=new Hashtable();
	Variable svars[]=new Variable[0];
	int pos1,pos2;
	pos1=cOrder.getI(agent);
	AgentData ad=(AgentData) dSearch.problemByAgent.get(agent);
	if(ad!=null) svars=ad.getVariables();
	else return new OutgoingAgent[0];
	int svarsNr=svars.length;
	for(int k=0;k<svarsNr;k++){
	    String variableCrt=svars[k].getVariable();
	    ArrayList alist;
	    alist=(ArrayList)dSearch.problemByVariable.get(variableCrt);
	    int vAgentsNr=alist.size();
	    for(int a=0;a<vAgentsNr;a++){
		AgentID ag=(AgentID) alist.get(a);
		pos2=cOrder.getI(ag);
		if(pos1<pos2){
		    OutgoingAgent oa;
		    oa=(OutgoingAgent)outgoing.get(ag);
		    if(oa==null)oa=new OutgoingAgent(ag);
		    oa.insert(variableCrt);
		    outgoing.put(ag,oa);
		}
	    }
	}
	return (OutgoingAgent[]) outgoing.values().toArray(new OutgoingAgent[0]);
    }

    private IncomingAgent[] getInComing(AgentID agent){
	Hashtable incoming=new Hashtable();
	Variable svars[]=new Variable[0];
	int pos1,pos2;
	pos1=cOrder.getI(agent);
	AgentData ad=(AgentData) dSearch.problemByAgent.get(agent);
	if (ad!=null) svars=ad.getVariables();
	else return new IncomingAgent[0];
	int svarsNr=svars.length;
	for(int k=0;k<svarsNr;k++){
	    String variableCrt=svars[k].getVariable();
	    ArrayList alist;
	    alist=(ArrayList) dSearch.problemByVariable.get(variableCrt);
	    int vAgentsNr=alist.size();
	    for(int a=0;a<vAgentsNr;a++){
		AgentID ag=(AgentID) alist.get(a);
		pos2=cOrder.getI(ag);
		if(pos1>pos2){
		    IncomingAgent oa;
		    oa=(IncomingAgent)incoming.get(ag);
		    if(oa==null)
			oa=new IncomingAgent(ag);
		    incoming.put(ag,oa);
		}
	    }
	}
	return (IncomingAgent[]) incoming.values().toArray(new IncomingAgent[0]);
    }

    private void getRelatedAgents(){
	Hashtable outgoingsH=new Hashtable();
	Hashtable incomingsH=new Hashtable();
	Iterator keys = (Iterator) dSearch.problemByAgent.keys();
	while (keys.hasNext()){
	    AgentID agent = (AgentID) keys.next();
	    outgoingsH.put(agent,getOutGoing(agent));
	    incomingsH.put(agent,getInComing(agent));
	}
	IncomingAgent[] incomingAgent=(IncomingAgent[])incomingsH.get(myself);
	OutgoingAgent[] outgoingAgents=(OutgoingAgent[])outgoingsH.get(myself);
	dIncomingAgent=new DIncomingAgent(incomingAgent);
	dOutgoingAgent=new DOutgoingAgent(outgoingAgents);
    }
    String getVariable(int vID){
	return (engine.getVariables())[vID];
    }

    //clear posts and set orderScheduler
    private void resetPosts(int changeLevel){
	for(int k=changeLevel+1;k<agentsNr;k++) {
	    POrder pOrder=order.getOLevel(k);
	    mHCks[k].clearPostTellOrder(pOrder,changeLevel);
	}
    }
    //clear lastSent
    private void clearSolutions(){
	lastSent.clear();
	lastSolution=false;
	historyIDs=null;
	orders.orderIDs=0;
    }

    //reset on addVarHistory and on incomingOK
    void resetConflictingVariables(boolean _setDomains){
	conflictingNogoods=0;
	conflictingVariables.clear();
 	if(_setDomains){
	    engine.setCurrentDomains(labels.getCurrentDomains());
	}
	engine.resetSearch();
    }
    void resetConflictingVariables(){
	resetConflictingVariables(true);
    }

    private int resetOrderDependentHistory(int changeLevel){
	MySystem.out.println("will set agents position: cl="+changeLevel);
	setAgentsPosition();
	resetPosts(changeLevel);
	labels.cleanHistory(changeLevel);
	clearSolutions();
	int k=conflictingVariables.getLastLevel();
	if(k>changeLevel)resetConflictingVariables();
	labels.setOrderChange(changeLevel);
	if((lastSentNogood!=null)&&(lastSentNogood.hasLevel(changeLevel+1)))
	    lastSentNogood=null;
	return engine.setCurrentDomains(labels.getCurrentDomains());
    }
    AgentID getMyself(){
	return myself;
    }
    int getMyID(){
	return myID;
    }
    boolean clDisable(AssignmentRefs ars) {
	Iterator it=(Iterator)ars.iterator();
	while(it.hasNext()) {
	    AssignmentRef ar=(AssignmentRef)it.next();
	    if(conflictingVariables.contains(ar)!=null)
		return true;
	}
	return false;
    }

//     void getSearchCoveredConstraint(ArrayList constraints){
// 	engine.getSearchCoveredConstraint(constraints);
//     }
    private boolean performAddLinks(ConflictSet linksToAdd){
	AgentID guiltyA[], target;
	if(linksToAdd.size()>0){
	    String[] newVarsArray=(String[])linksToAdd.toArray();
	    guiltyA=getAgents(newVarsArray,agentsNr);
	    // interrupted waiting OutGoing
	    if(guiltyA==null) return true;
	    // for All agents
	    for(int k=0;k<guiltyA.length;k++){
		target=guiltyA[k];
		DAddLink params=new DAddLink();
		params.source=myself;
		params.senderName=myName;
		params.variables=newVarsArray;
		params.cost=(DCost)((DCost)Utils.agentCost).clone();
		//params.order=order.getOLevel(cOrder.getI(target));
		if(!sndMsg(target,Commands.cAddLink,params)) return false;
	    }
	}
	return true;
    }
    //returns the agents that can provide the parameters
    private AgentID[] getAgents(String[] variables, int firstUnChecked){
	ArrayList iagents=new ArrayList();
	for(int k=firstUnChecked-1;k>=0;k--)
	    if(hasAny(agents[k],variables))
		iagents.add(agents[k]);
	return (AgentID[])iagents.toArray(new AgentID[0]);
    }
    private boolean has(AgentID agent, String variable){
	Variable[] svars=((AgentData)dSearch.problemByAgent.get(agent)).getVariables();
	for(int k=0;k<svars.length;k++){
	  if(variable.equals(svars[k].getVariable()))
	    return true;
	}
	return false;
    }
    private boolean hasAny(AgentID agent, String[] variables){
	Variable[] svars=((AgentData)dSearch.problemByAgent.get(agent)).getVariables();
	for(int k=0;k<svars.length;k++){
	    for(int kk=0;kk<variables.length;kk++){
		if(variables[kk].equals(svars[k].getVariable()))
		    return true;
	    }
	}
	return false;
    }
    int decideState(int reorder,boolean disabledCL,int engineResult,
		    boolean solutionHistoryChanges,boolean changeOrder,int reorder_return){
	MySystem.out.println("CrtState="+crtState+",Snogood="+Snogood+
			     ",Ssolution="+Ssolution);
	MySystem.out.println("Result:reorder="+reorder+",disableCL="+
			     disabledCL+",engineResult="+engineResult+
			     ",solutionHistoryChanges="+solutionHistoryChanges+
			     ",changeOrder="+changeOrder+" "+conflictingVariables);
	if(reorder==SnoChange){
	    //if(Ssolution&&changeOrder)return SannouncedSresend;
	    return SnoChange;
	}
	if(Snogood&&disabledCL) return SprocessingM;
	if(Snogood&&(engineResult==EngineNogoodExpansion)) return SprocessingM;
	if(Snogood&&(reorder_return==EngineNogoodExpansion)) return SprocessingM;
	if(Snogood) return SannouncedN;
	//if(Ssolution&&(SolutionAnihilation==true)) return SprocessingM;
	if(Ssolution&&solutionHistoryChanges&&
	   (engineResult==SannouncedS))return SannouncedSresend;
	if(Ssolution&&(engineResult==SannouncedS)&&changeOrder)return SannouncedSresend;
	if(Ssolution&&(engineResult==SannouncedS))return SannouncedS;
	//if(Ssolution&&(reorder==SnoChange)&&changeOrder)return SannouncedSresend;
	//if(Ssolution&&(reorder==SnoChange))return SannouncedS;
	return SprocessingM;
    }
    MHCk getMHCk(int level){
	return mHCks[level];
    }
    boolean cleanCL(AssignmentRefs disabledAR){
	boolean disabledCL=false;
	MySystem.out.println("disabledAR="+disabledAR);
	if(clDisable(disabledAR)){
	    disabledCL=true;
	    resetConflictingVariables(false);
	}
	return disabledCL;
    }
    private void cleanNogoodFromMyselfHistories(AssignmentRefs nogood){
	nogood.removeRefsOfLevel(myID);
    }
    private int getMHCk(){
	LCNHashtable[] levelState=msgPost.levelState;
	Histories post=msgPost.post;
	RHashtable[] insts=msgPost.insts;
	int level=msgPost.level;
	POrder lOrder=msgPost.lOrder;
	AssignmentRefs nogood=msgPost.nogood;
	MySystem.out.println("mhck:"+level+" got:"+post+" order "+lOrder+" oldorder:"+order+" nogood:"+nogood+" myCL"+conflictingVariables);
	for(int idx=0;idx<levelState.length;idx++)
	    MySystem.out.println((engine.getVariables())[idx]+levelState[idx]);
	//set of posts to set;
	IntObject orderState=new IntObject(0);
	BoolObject orderChange=new BoolObject(false);
        if(!getOrder(lOrder,level,orderState,orderChange)) MySystem.exit("bad order");
	if(level>myID) return decideState(orderState.i,false,orderState.i,false,orderChange.b,SnoUse);
	if((((DCost)Utils.agentCost).getMessages()>Utils.MAX_SECV_MSG)&&(Utils.MAX_SECV_MSG>0))
	    return SannouncedF;
	if(nogood==null){
	    nogood=heurs.getNogood(myID-1);
	    if(nogood==null) nogood=heurs.getNogood(myID);
	    else nogood=null;
	    if(nogood!=null) {
		Context hists=heurs.getContext(nogood);
		//post.putAll(hists);
		Iterator it=hists.iterator();
		while(it.hasNext()){
		    String var=(String)it.next();
		    DVarHistory dv=hists.getDV(var);
		    int lev=dv.history[dv.history.length-2];
		    if(lev==myID) continue;
		    else if(lev>myID) MySystem.exit(var+" "+lev);
		    int[]ph=post.geth(var);
		    if((ph==null)||
		       History.firstDisablesSecond(dv.history,ph)){
			int[]lh=labels.geth(var);
			if((lh==null)||
			   History.firstDisablesSecond(dv.history,lh))
			    post.put(var,dv.history);
		    }
		    if(insts[lev]==null)insts[lev]=new RHashtable();
		    insts[lev].put(var,dv.range);
		}
	    }
	    //if((nogood!=null)&&(nogood.getLastLevel()!=myID)) nogood=null;
	}
	if((nogood!=null)&&(nogood.getLastLevel()==myID)){
	    if(Ssolution&&(nogood!=null)&&
	       //(level==myID)&&
	       (engine.getConstraintsNr()==1)){
		MySystem.out.println("Got nogood:"+nogood);
		engine.updateCLConstraint();
	    }
	}
	BoolObject disabledCLO=new BoolObject(false);
	Hashtable posts[]=new Hashtable[agentsNr];
	ConflictSet addedVars=new ConflictSet();
	AssignmentRefs disabledAR=new AssignmentRefs();
	CNSet[] newLabels=new CNSet[myID+1];
	BoolObject emptyNogood=new BoolObject(false);
	boolean solutionHistoryChanges=
	    labels.setLevel(posts, post, level, levelState,
			    addedVars, insts, disabledAR,
			    newLabels, emptyNogood, disabledCLO);
	if((nogood!=null)&&(nogood.getLastLevel()!=myID)){
	    int rn=announceNogood(nogood);
	    if(rn==1)return SstopM;
	    if(rn==2)return SwaitEndM;
	    nogood=null;
	}
	if(emptyNogood.b){
	    AgentID target=((Agent)genericAgent).getBrokerID();
	    DObject parameter=(DCost)(((DCost)Utils.agentCost).clone());
	    if(!sndMsg(target,Commands.cEmptyNogood,parameter))return SstopM;
	    return SwaitEndM;
	}
	boolean disabledCL=disabledCLO.b;
	MySystem.out.println("disabledAR="+disabledAR);
	if(disabledCL) resetConflictingVariables();
	if((nogood!=null)&&
	   //(level==myID)&&
	   Ssolution){
	    if((nogood.sizeLevel(myID)==engine.getVariablesNr())&&
	       ((conflictingNogoods==0)||
		((conflictingVariables.size()==0)&&
		 (nogood.size()==engine.getVariablesNr()))));
	    else validNogoodDiscarded=true;
	    conflictingNogoods++;
	    cleanNogoodFromMyselfHistories(nogood);
	    conflictingVariables.addAll(nogood);
	    MySystem.out.println("New CL="+conflictingVariables);
	}
	if(!performAddLinks(addedVars))return SstopM;
	if(!dispatchCNs(newLabels))return SstopM;
	int engineResult=engine.setCurrentDomains(labels.getCurrentDomains());
// 	SolutionAnihilation=false;
// 	if(level==myID)
// 	    if(!engine.setSolutionLevel(levelState,cs))
// 		SolutionAnihilation=true;
 	if(post.size()>0) {
            int k;
 	    for(k=0;k<myID;k++) {
		if(k==level)continue;
		POrder pOrder=order.getOLevel(k);
		mHCks[k].setPost(posts[k],pOrder);
 	    }
            for(;k<agentsNr;k++) {
		POrder pOrder=(POrder)order.clone();
                mHCks[k].setPost(posts[k],pOrder);
	    }
	}
	if(Ssolution&&(nogood!=null)
	   //&&(level==myID)
	   ){
	    return SprocessingM;
	}
	return decideState(SnoUse, disabledCL, engineResult,
		     solutionHistoryChanges,orderChange.b,orderState.i);
    }

    AssignmentRefs getConflictList(){return conflictingVariables;}

    private void sendToMySelf(CNSet[] newLabeling){
	for(int level=-1;level<myID;level++) {
	    if(newLabeling[level+1]==null) continue;
	    CNSet nl=newLabeling[level+1].getNoEmpties();
	    if(nl.size()<=0) continue;
	    heurs.put(myself,nl,level);
	    //if(nl.isNogood()) continue;
	    Propagate toSend=new Propagate(level);
	    toSend.cost=(DCost)((DCost)Utils.agentCost).clone();
	    toSend.order=order.getOLevel(level);
	    toSend.varHistories=nl;
	    if(level>=0)
		select.call(1,mHCks[level],mHCks[level]._getLocalMessage);
	    else  select.call(1,mHCk,mHCk._getLocalMessage);
	    int res=Synch_Wait();
	    if(level>=0) mHCks[level].getLocalMessage(toSend);
	    else mHCk.getLocalMessage(toSend);
	}
    }
    //ret false on terminate
    private boolean dispatchCNs(CNSet[] newLabels){
	sendToMySelf(newLabels);
 	for(int target=0;target<agents.length; target++) {
 	    if(agents[target].equals(myself))	continue;
	    Propagate toSend=buildToSendToTarget(newLabels,target);
 	    if((toSend==null)||
	       ((toSend.varHistories.size()==0)&&
		(toSend.heuristic.size()==0)))
		continue;
	    toSend.sender=myself;
	    if(!sndMsg(agents[target],Commands.cMHC,toSend))return false;
	}
 	return true;
    }
     private Propagate buildToSendToTarget(CNSet[] newLabeling, int target) {
 	Propagate toSend =null;
	for(int level=-1;(level<=target)&&(level<myID);level++){
	    if((level==-1)&&mArtificial) continue;
	    Propagate tosend=new Propagate(level);
	    tosend.order=order.getOLevel(level);
	    if(newLabeling[level+1]==null) continue;
	    Iterator it = newLabeling[level+1].iterator();
	    while(it.hasNext()){
		CN mh=(CN) it.next();
		if(mh.isNogood()) continue;
		String addedVar = mh.var;
		if(!has(agents[target], addedVar)){
		    tosend.heuristic.add((CN)mh.clone());
		    continue;
		}
		tosend.varHistories.add((CN)mh.clone());
	    }
	    if(!msSndHeuristics){
		if((level>=0)&&(target!=level))tosend.heuristic.clear();
		if((level==-1)&&(target!=0))tosend.heuristic.clear();
	    }
	    if((tosend.varHistories.size()<=0)&&
	       (tosend.heuristic.size()<=0)) continue;
	    if(toSend==null) toSend=tosend;
	    else toSend.addNext(tosend);
	}
	if((target<myID)&&(newLabeling[target+1]!=null)&&
	   (newLabeling[target+1].hasNogood())) {
	    CN mh=newLabeling[target+1].getNogood();
	    if((lastSentNogood==null)||(!lastSentNogood.sameAs(mh))){
		Propagate tosend=new Propagate(target);
		tosend.order=order.getOLevel(target);
		tosend.varHistories=new CNSet();
		String addedVar = mh.var;
		tosend.varHistories.add((CN)mh.clone());
		if(toSend==null) toSend=tosend;
		else toSend.addNext(tosend);
		lastSentNogood=mh;
	    }
	}
	if(toSend!=null)
	    toSend.cost=(DCost)((DCost)Utils.agentCost).clone();
 	return toSend;
     }
//                                                //
/* Here is the procedure for checking   mHC       */
//                                                //

    //called only at beginning
    private boolean mHC(CNSet reductions){
	Range[] blevel=labels.getRefBaseLevel();
	Hashtable dependency = new Hashtable();
	if(!hc.HC(blevel, dependency)) return false;
	labels.update0Level();
	engine.setCurrentDomains((Range[])blevel.clone());
	Iterator ita = (Iterator) dependency.keys();
        while(ita.hasNext()){
	    Integer code=(Integer)ita.next();
	    String variable = (engine.getVariables())[code.intValue()];
	    CN toSend;
	    int vID=code.intValue();
	    labels.basePID[vID]++;
	    toSend = new CN(variable,
			    blevel[vID],null,labels.basePID[vID]);
	    //heurs.put(myself,toSend,-1);
	    reductions.add(toSend);
	}
	return true;
    }

    //ret false on terminate
    private boolean announceMHC(int level, CNSet l){
	CNSet[] labels=new CNSet[agentsNr+1];
	labels[level+1]=l;
	return dispatchCNs(labels);
    }
    //ret 0-nothing
    // 1-terminated
    // 2-wait terminated
    private int announceNogood(AssignmentRefs nogood){
	int returnValue; String command; DObject parameter;
        AssignmentRef[] guiltyV=nogood.toArray();
	DNogood params=getNogood(guiltyV);
	AgentID target=getLastSender(params);
	if(target!=null){
	    params.cost=(DCost)(((DCost)Utils.agentCost).clone());
	    params.senderName=myName;
	    params.order=order.getOLevel(cOrder.getI(target));
	    parameter = params;
	    command=Commands.cNogood;
	    returnValue=0;
	}else {
	    target=((Agent)genericAgent).getBrokerID();
	    parameter=(DCost)(((DCost)Utils.agentCost).clone());
	    command=Commands.cEmptyNogood;
	    returnValue=2;
	}
	if(!sndMsg(target,command,parameter)) return 1;
	return returnValue; //0-nogood, 2-emptyNogood	
    }
    private int announceNogood(){
	int returnValue; String command; DObject parameter;
        AssignmentRef[] guiltyV=getConflictingVariables();
	DNogood params=getNogood(guiltyV);
	AgentID target=getLastSender(params);
	if(target!=null){
	    params.cost=(DCost)(((DCost)Utils.agentCost).clone());
	    params.senderName=myName;
	    params.order=order.getOLevel(cOrder.getI(target));
	    parameter = params;
	    command=Commands.cNogood;
	    returnValue=0;
	}else {
	    target=((Agent)genericAgent).getBrokerID();
	    parameter=(DCost)(((DCost)Utils.agentCost).clone());
	    command=Commands.cEmptyNogood;
	    returnValue=2;
	}
	if(!sndMsg(target,command,parameter)) return 1;
	return returnValue; //0-nogood, 2-emptyNogood
    }

    private AssignmentRef[] getConflictingVariables() {
	AssignmentRefs al=(AssignmentRefs)conflictingVariables.clone();
	labels.addInternalRestrictingVariables(al);
	return al.toArray();
    }

    private DVarHistory getInst(AssignmentRef ar){
	int id=getID(ar.var);
	if(id>=0) return labels.getLocalDV(ar);
	else return labels.getAddedDV(ar);
   }

    private DNogood getNogood(AssignmentRef[] guiltyV){
	MySystem.out.println("Nogood: ");
	for(int ar=0;ar<guiltyV.length;ar++)
	    MySystem.out.print(guiltyV[ar]);
	MySystem.out.println("");
	DVarHistory ev;
        DNogood nogood=new DNogood();
        Context view=new Context();
        for(int k=0;k<guiltyV.length;k++){
	    ev=getInst(guiltyV[k]);
	    if(ev!=null) view.put(guiltyV[k].var,ev);
	    else MySystem.exit("No inst found for:"+guiltyV[k]);
	}
        nogood.view=view;
        return nogood;
    }

    private AgentID getLastSender(DNogood nogood){
	if(nogood==null) return null;
	int crtLast=nogood.getLastSenderID();
	if(crtLast<0){
	    MySystem.out.println("last hist is:"+crtLast);
	    return null;
	}
	return agents[crtLast];
    }

    private void initLastSolution(Range[] domain,
				  boolean[] differences){
	lastSolution=true;
	historyIDs = new int[domain.length];
	for(int k=0;k<domain.length;k++){
	    historyIDs[k] = -1;
	    if(sameAsIncoming(domain[k],k)){
		MySystem.out.println("Same as incoming:first:k="+k);
		differences[k]=false;
	    }else differences[k]=true;
	    if(differences[k]) historyIDs[k]++;
	}
    }
    private void getSolutionDifferences(Range[] domain,
					boolean[] differences){
	for(int k=0; k<domain.length; k++){
	    differences[k]=true;
	    if(sameAsIncoming(domain[k],k)){
		MySystem.out.println("Same incoming:k="+k);
		if(olderHistLastSentThanIncoming(k)){
		    MySystem.out.println("Older Last sent than inc");
		    differences[k]=false;
		}
	    }
	    if(!validNogoodDiscarded){//difficult to count consistencies
		MySystem.out.println("not validDiscarded:k="+k);
		if(differences[k]){
		    //MySystem.out.println("differences[k]=true");
		    if(sameRHAsLastSent(domain[k],k)){
			MySystem.out.println("sameRHAsLastSent:k="+k);
			differences[k]=false;
		    }
		}
	    }
	    if(differences[k]) historyIDs[k]++;
	    MySystem.out.println("New history[k="+k+"]="+(engine.getVariables())[k]+" "+historyIDs[k]);
	}
   }
    //Are we sending the same domain and history(ev +1) as last time?
    boolean sameRHAsLastSent(Range domain, int varID){
	String var=(engine.getVariables())[varID];
        int[] incHistory=labels.getLocalh(var);
	CN l=lastSent.getCN(var);
	if(l==null)
	    return false;//never sent
	if(incHistory!=null){
	    int[] sndHistory=l.dep.geth(var);
	    if(!History.crtConsequence(sndHistory,incHistory,myID,historyIDs[varID]))
		return false;//not same history
	}
	if(domain.different(l.label))
	    return false;
	return true;
    }
    private boolean sameAsIncoming(Range domain, int varID){
	//if(myID==0) return false;
	Range prev=labels.getLastLocalInstantiation((engine.getVariables())[varID],myID-1);
	if(prev==null) return false;
	if(domain.different(prev)) return false;
	return true;
    }

    //was nothing sent since last receive?
    boolean olderHistLastSentThanIncoming(int varID){
	String var=(engine.getVariables())[varID];
	CN l=lastSent.getCN(var);
	if(l==null) return true;//never sent

        int[] incHistory=labels.getLocalh(var);
	if(incHistory==null)//never received
	    return false; //base was modified
	int[] sndHistory=l.getDV().history;
	if(History.crtConsequence(sndHistory,incHistory,myID,historyIDs[varID]))
	    return false;
	lastSent.remove(var);//old lastSent-can be removed
	return true; //sent was older than known
    }
    private void setLastSentHeuristic(){
	Iterator it=lastSent.values().iterator();
	while(it.hasNext())
	    heurs.put(myself,(CN)it.next(),myID);
    }
    // one build first the last sent structure

    private void buildLastSent(boolean diff[], Range domain[]){
	String varCrt;
	CN label; DVarHistory dv;Context ctx;
	for(int k=0; k<diff.length; k++){
	    if(!diff[k]) continue;
	    varCrt=(engine.getVariables())[k];
	    ctx=new Context();
	    dv=new DVarHistory(domain[k],
			       buildNewHistory(varCrt,k));
	    ctx.put(varCrt,dv);
	    label=new CN(varCrt,dv.range,ctx,historyIDs[k]);
	    lastSent.put(varCrt, label);
	}
    }
    private int[] buildNewHistory(String varCrt, int id){
        int[] newHistory, oldHistory;
        int k=0;
        oldHistory=labels.getLocalh(varCrt);
	if(oldHistory==null) newHistory=new int[2];
	else{
	    newHistory=new int[2+oldHistory.length];
	    for(k=0;k<oldHistory.length;k++)
		newHistory[k]=oldHistory[k];
	}
        newHistory[k]=myID;
	k++;
        newHistory[k]=historyIDs[id];
        return newHistory;
    }
    private Propagate different(ArrayList vars, ArrayList addedVars, boolean[] differences){
        Propagate view = new Propagate(myID);
	view.cost=(DCost)((DCost)Utils.agentCost).clone();
	view.order=(POrder)order.clone();
	Hashtable h=new Hashtable();
        CN mhcHistory;
	if(vars!=null)
	for(int k=0;k<vars.size();k++){
	    String varCrt=(String)vars.get(k);
	    int id=vIDs.geti(varCrt);
	    if(differences[id]){
		mhcHistory=lastSent.getCN(varCrt);
		h.put(varCrt,varCrt);
		view.varHistories.add((CN)mhcHistory.clone());
	    }
	}
	if(msSndHeuristics){
	    Iterator it=(Iterator)lastSent.keys();
	    while(it.hasNext()){
		String var=(String)it.next();
		int id=vIDs.geti(var);
		if(differences[id]&&(h.get(var)==null)){
		    mhcHistory=lastSent.getCN(var);
		    MySystem.out.println("att to heuristic:"+mhcHistory);
		    view.heuristic.add((CN)mhcHistory.clone());
		}
	    }
	}
	DVarHistory dVarHistory;
	if(addedVars!=null)
        for(int k=0;k<addedVars.size();k++){
            String varCrt=(String)addedVars.get(k);
            int id=vIDs.geti(varCrt);
            if(differences[id]){
		dVarHistory=lastSent.getInst(varCrt);
                view.addedLinks.put(varCrt,dVarHistory);
            }
        }
        if(!view.empty()) return view;
        return null;
    }
    private boolean outGoingAllFinished(){
	return (accepts.acceptedSendersNr==0)||
	    (accepts.acceptedIntersection!=null);
    }
    //ret 1 terminated
    private int announceSolution(Range[] domain){
	printSolution(domain);
        boolean differences[]=new boolean[domain.length];

        // first solution report
        if (!lastSolution)
	    initLastSolution(domain, differences);
	else getSolutionDifferences(domain, differences);
	validNogoodDiscarded=false;
	buildLastSent(differences, domain);
	solutionHistoryChanges=false;
        AgentID agent;
	//new instantiation
	setLastSentHeuristic();
	if(!claimOrder()) return 1;
	Propagate difVars=new Propagate(myID);
        difVars.order=(POrder)order.clone();
        //sending to my MHCk
        difVars.varHistories=new CNSet();//lastSent.values());
	for(int mv=0;mv<domain.length;mv++)
	    if(differences[mv])
		difVars.varHistories.add(lastSent.getCN((engine.getVariables())[mv]));
	if(difVars.varHistories.size()>0){
	    if(mHCinst!=mHCks[myID]){
		MySystem.out.println("myID="+myID+agents[0]+agents[1]+order);
	    }
	    select.call(1,mHCinst,mHCinst._getLocalMessage);
	    Synch_Wait();
	    AssignmentRefs nogood=null;
	    Context cNogood=null;
	    if(labels.consistentLevel==myID-1){
		nogood=heurs.getNogood(myID-1);
		if(nogood==null) nogood=heurs.getNogood(myID);
		else nogood=null;
	    }
 	    if(nogood!=null){
 		if(nogood.getLastLevel()!=myID){
		    heurs.print();
		    MySystem.exit("Nogood:"+nogood+" crash");
		    nogood=null;
		}
 		//else mHCinst.getLocalNogood(nogood);
	    }
	    if(nogood!=null){
		cNogood=heurs.getContext(nogood);
		mHCinst.getLocalMessage(difVars,nogood,cNogood);
	    }else mHCinst.getLocalMessage(difVars);
	}
	for(int k=myID+1;k<agentsNr;k++){
	    OutgoingAgent ooa=
		(OutgoingAgent)outGoing.get(agents[k]);
	    ArrayList aOL=
		(ArrayList)addedOutgoingLinks.get(agents[k]);
	    ArrayList vars=null;
	    if(ooa!=null)vars=ooa.variables;
	    // null if no difference
	    difVars=different(vars, aOL, differences);
	    if(difVars!=null){
		difVars.sender=genericAgent.getID();
		MySystem.out.println("Sending:"+agents[k]+difVars);
		if(!sndMsg(agents[k],Commands.cMHC,difVars))
		    return 1;
	    }
	}
	if(outGoingAllFinished()){
	    MySystem.out.println("Try to send ACCEPTED");
	    return (announcePartialSolution()?0:1);
	}
	return 0;
    }

//                                                 //
/* Here is the procedure for accepted announcement */
//       ret=false -> terminated                   //

    private boolean announcePartialSolution(){
	AgentID agent; // targets of ACCEPTED
	DAccepted dAccepted=new DAccepted();
	dAccepted.agent=genericAgent.getID();
	dAccepted.senderName = genericAgent.getID().getName();
	dAccepted.history=IntersectionOfSolutions();

	accepts.acceptedCost.updateCost((DCost)((DCost)Utils.agentCost).clone());
	dAccepted.cost=(DCost)accepts.acceptedCost.clone();
	if(dAccepted.empty()) return true;
	dAccepted.ID=accepts.AcceptedID;
	accepts.AcceptedID++;
	MySystem.out.println("Sending:"+dAccepted.toShortString());
	if(accepts.endAgent)
	    if(!sndMsg(((Agent)genericAgent).getBrokerID(),
		       Commands.cAccepted,dAccepted))
		return false;
	if(accepts.acceptedReceiver==null) return true;
	if(!sndMsg(accepts.acceptedReceiver,Commands.cAccepted,dAccepted))
	    return false;
	return true;
    }

    void printSolution(Range[] domain){
	MySystem.out.println("Announce Solution:");
	for(int k=0;k<engine.getVariablesNr();k++)
	    MySystem.err.print((engine.getVariables())[k]+"="+domain[k]+";");
	MySystem.out.println();
    }
//                                                //
/* Building the solution to announce              */
//                                                //

    private Context IntersectionOfSolutions(){
	Context view=new Context();
	addInternalSolution(view);
	addAcceptedSolution(view);
	return view;
    }
    private void addInternalSolution(Context view){
	String var;
	DVarHistory dVarHistory,oldHist;
	for(int k=0; k<engine.getVariablesNr(); k++){
	    var=(engine.getVariables())[k];
	    dVarHistory=lastSent.getInst(var);
	    if(dVarHistory==null)
		dVarHistory=labels.getNewestDVinView(var);
	    else
		dVarHistory=(DVarHistory)dVarHistory.clone();
	    view.put(var,dVarHistory);
	}
    }
    private void addAcceptedSolution(Context view){
 	DVarHistory solHist, outHist;
	if(accepts.acceptedSendersNr==0)return;
 	Iterator it=(Iterator) accepts.acceptedIntersection.keys();
 	while(it.hasNext()){
 	    String var=(String)it.next();
 	    solHist=view.getDV(var);
 	    outHist=accepts.acceptedIntersection.getDV(var);
 	    if(solHist==null){
 		view.put(var,(DVarHistory)outHist.clone());
 	    }else{
 		solHist.restrict(outHist);
		view.put(var,solHist);
 	    }
 	}
    }

    //ret 1 //received terminate
    //ret 2 //wait terminate, sent cEmptyNogood
    private int announceEmptyNogoodToBroker(){
	String command;
	AgentID target=((Agent)genericAgent).getBrokerID();
	DCost parameter=(DCost)(((DCost)Utils.agentCost).clone());
	command=Commands.cEmptyNogood;
	if(!sndMsg(target,command,parameter))
	    return 1; //terminated
	return 2; //(2-emptyNogood)
    }
    synchronized public void getMessage(Message message){
	Message_Command mc=(Message_Command)message;
	Object param=(Object)mc.getArguments();
	String command=(String)mc.getCommand();
	MySystem.err.println("MHC.got:"+command);
	if(command.equals(Commands.cStartParameters)){
	    msgPost.startParameters=mc;
// 	    myComputationNum=message.getComputationNum();
// 	    MySystem.err.println("MHC.myComputationNum="+myComputationNum);
// 	    DStartLinks dsl=(DStartLinks)param;
// 	    MySystem.err.println("got="+dsl);
// 	    order=dsl.order;
// 	    dSearch=dsl.dSearch;
// 	    setDefaultOrder();
// 	    acceptedSendersNr=dSearch.acceptedSenders.size();
// 	    acceptedReceiver=dSearch.acceptedReceiver;
// 	    setOrder(order);
// 	    if(dIncomingAgent.get().length==0)
// 		endAgent=true;
	}
	if(command.equals(Commands.cNogood)){
	    msgPost.nogoodBuf=mc;
// 	    if(getOrder((Order)((DNogood)param).order,myID))
// 		nogoodBuf=message;
	}
	if(command.equals(Commands.cAccepted)){
	    msgPost.accepted=mc;
//           MySystem.out.println(param);
// 	  acceptedIntersection=((DAccepted)param).history;
// 	  acceptedCost=((DAccepted)param).cost;
        }
	if(command.equals(Commands.cAddLink)){
	    msgPost.addLink=mc;
// 	    MySystem.out.println(param);
// 	    DAddLink dn=(DAddLink) param;
// 	    ((DCost)Utils.agentCost).incrementMessages(dn.cost);
// 	    answerToAddLink(dn);
        }
	Synch_Reply();
    }
    int getID(String var){
	return engine.getvID(var);
    }
    String[] getVariables(){
	return engine.getVariables();
    }
}
