/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dcsp;
import java.util.*;
import parameters.*;
import platform.*;
class Propagate implements DObject {
    int level;
    CNSet varHistories=new CNSet(), heuristic=new CNSet();
    Context addedLinks=new Context();
    DCost cost;
    POrder order;
    AgentID sender;
    Propagate next=null;
    public String toString(){
	return "P:"+level+varHistories+addedLinks+order+heuristic+cost+next+sender;
    }
    Propagate(int level){
	this.level=level;
    }
    boolean empty(){
	return ((varHistories.size()==0)&&
		(addedLinks.size()==0)&&
		(heuristic.size()==0));
    }
    void addNext(Propagate prop){
	if(prop.level==level)
	    throw new RuntimeException("Not implemented: lower added level");
	if(prop.level==level) {
	    varHistories.addAll(prop.varHistories);
	    heuristic.addAll(prop.heuristic);
	    return;
	}
	if(next!=null){
	    if(prop.level<next.level){
		prop.next=next;
		next=prop;
	    }else
		next.addNext(prop);
	}else
	    next=prop;
    }
    //removes this from Message_Command
    Message_Command removeNext(Message_Command message){
	if(next==null)
	    return null;
	next.cost=cost;
	next.sender=sender;
	//next.order=order;
	Propagate tmp=next;
	next=null;
	message.setArguments(tmp);
	return message;
    }
}
