/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dcsp;
import java.util.*;
import java.awt.Color;
import csp.*;
import utils.*;
import parameters.*;
import aggreg.*;
import hc.*;

class Splitting implements Splitter{
    int variablesNr;
    int constraintsNr,crtConstraint;
    int[] constraintsID;
    String[] variables;
    Constraint[] constraints;
    IYConstraint[] yconstraints;
    private IYConstraint clConstraint=null;
    Range currentDomains[], initialDomains[];
    PAgent agent;
    IOHashtable vIDs=new IOHashtable();
    ArrayList domains=new ArrayList();
    //we are in the solution
    private boolean crtSolution=false;
    //the current constraint has a cover and we have backtracked
    private boolean crtInstantiated=false;
    boolean noModif;

    Range[][] oldDomains,oldResults;
    Range[] clInstantiation;

    public IOHashtable getvIDs(){return vIDs;}
    public String[] getVariables(){return variables;}
    public Range[] getInitialDomains(){return initialDomains;}
    public Constraint[] getConstraints(){return constraints;}
    public int[] getConstraintsID(){return constraintsID;}
    public int   getConstraintsNr(){return constraintsNr;}
    public int   getVariablesNr(){return variablesNr;}


    Splitting(Problem problem, PAgent agent) {
	this.agent=agent;
	initCSP(problem);
	currentDomains =new Range[variablesNr];
	initialDomains =new Range[variablesNr];
	for(int k=0;k<variablesNr;k++){
	    initialDomains[k]=
		problem.getSetOfVariables().getRange(variables[k]);
	}
        constraintsID=new int[constraintsNr];
	for(int i=0;i<constraintsNr;i++){
            constraintsID[i]=i;
	    int localVariablesNr=yconstraints[i].getVariablesNr();
	    int k1=yconstraints[i].getID(0);
	    String var0= yconstraints[i].getVariable(0);
	    int k2=k1;
	    String var1=var0;
	    if(localVariablesNr==2){
		k2=yconstraints[i].getID(1);
		var1=yconstraints[i].getVariable(1);
	    }
	    agent.createColorMatrix(i,
				    var0, var1,
				    initialDomains[k1].size(),
				    initialDomains[k2].size());

	    if(localVariablesNr==2)
		agent.setColor(var0, var1,
			       ((C2Representation)((YConstraint)yconstraints[i]).getRepresentation()).getMatrix(),
			       0,0,
			       initialDomains[k1].size()-1,
			       initialDomains[k2].size()-1,
			       0,0,
			       Color.white,Color.lightGray,
			       Color.gray,Color.lightGray);
	}
    }
//     void getSearchCoveredConstraint(ArrayList al){
	//	computed after reset
	//	reset after computing
// 	if(crtConstraint>0){
// 	    Constraint c=new Constraint(constraints[constraintsID[0]]);
// 	    CReprezantation cr=yconstraints[constraintsID[0]].getCover();
// 	    c.setCReprezentation(cr);
// 	    al.add(c);
// 	}
//     }
    public void initSearch(){
	Range[] dom=(Range[])initialDomains.clone();
	for(int k=0;k<dom.length;k++){
	    dom[k]=(Range)initialDomains[k].clone();
            currentDomains[k]=(Range)dom[k].clone();
        }
	domains.add(dom);
    }
    void initCSP(Problem problem){
	int k,i,j;
	variablesNr=problem.getVariablesNr();
	Variable[] tmp=problem.getVariables();
	variables=new String[variablesNr];
	for(k=0;k<variablesNr;k++){
	    variables[k]=tmp[k].getName();
	    vIDs.put(variables[k],new Integer(k));
	}
	constraints=problem.getSetOfConstraints().getConstraints();
	constraintsNr=constraints.length;

	oldResults=new Range[constraintsNr][];
	oldDomains=new Range[constraintsNr][];

	yconstraints=new YConstraint[constraintsNr];
	for(i=0;i<constraintsNr;i++){
	    yconstraints[i]=new YConstraint(constraints[i]);
	    int localConstraintsNr=yconstraints[i].getVariablesNr();
	    for(k=0;k<localConstraintsNr;k++){
              yconstraints[i].setID(k,getvID(yconstraints[i].getVariable(k)));
	      constraints[i].varIDs[k] =yconstraints[i].getID(k);
            }
	}
	if(constraintsNr>0){
	    clConstraint=new YConstraint(constraints[0]);
	    int localConstraintsNr=yconstraints[0].getVariablesNr();
	    for(k=0;k<localConstraintsNr;k++){
		clConstraint.setID(k,getvID(clConstraint.getVariable(k)));
            }
	}
    }


    public int getvID(String variable){
	return vIDs.geti(variable);
    }
    public Range[] getSol(){ //getSolution
	return (Range[])domains.get(crtConstraint);
    }
    public int search(){
	boolean end=false;
	int result=0;
	noModif=false;
	while(!end){
	    end=true;
	    UpdateDomains(crtConstraint);
	    if(!nextInstantiation(crtConstraint)){
		crtSolution=false;
		if(crtConstraint==0){
		    crtInstantiated = false;
		    result=-1;
		    resetConstraint(0);
// 		    clConstraint.initCover();//??
// 		    printCLCoverRepresentation("Search end -> reset CL")
		    end=true;
		}else {// not removing the first domain
		    releaseConstraint(crtConstraint);
		    crtConstraint--;
		    crtInstantiated = true;
		    if(crtConstraint==0){
			MySystem.out.println("Backtracking return to 0");
			updateCLConstraint();
		    }
		}
		continue;
	    }
	    crtSolution=false;
	    crtInstantiated=true; //the current level is instantiated
	    if(noModif||(mHC(crtConstraint)&&
                         showDomains(crtConstraint))){
		crtConstraint++; crtInstantiated=false;
		if(checkFinished(crtConstraint)){
		    crtConstraint--;
		    crtInstantiated=true;
		    crtSolution=true;
		    result=1;
		    continue;
		}
		resetConstraint(crtConstraint);
		continue;
	    }else{
		crtSolution=false;
		crtInstantiated=true;
		if(crtConstraint==0){
		    MySystem.out.println("No HC 0");
		    updateCLConstraint();
		}
	    }
	}
	return result;
    }
    void printCLCoverRepresentation(String tag){
	if(clConstraint!=null){
	    Constraint c=clConstraint.getCoverConstraint();
	    MySystem.out.println(tag);
	    MySystem.out.println(c.getRepresentation());
	}
    }
    public void updateCLConstraint() {
	if(clConstraint!=null){
	    printCLCoverRepresentation("Initial CL mark");
	    clConstraint.setMark(clInstantiation);
	    printCLCoverRepresentation("Set CL mark");
	}
    }
    // true if the constraint is the last and no nogood is left
    boolean checkFinished(int constraint){
	if (constraint<constraintsNr) return false;
	return true;//testNogoods();
    }
    boolean showDomains(int crtConstraint){
      for(int i = crtConstraint+1; i<constraintsNr; i++){
        int hID = constraintsID[i];
        Range[] dom = new Range[2];
	int k1=yconstraints[hID].getID(0);
	String var0=yconstraints[hID].getVariable(0);
	int k2=k1;
	String var1=var0;
	if(yconstraints[hID].getVariablesNr()>1){
	    k2=yconstraints[hID].getID(1);
	    var1=yconstraints[hID].getVariable(1);
	}
        dom[0] = ((Range[])domains.get(crtConstraint))[k1];
        dom[1] = ((Range[])domains.get(crtConstraint))[k2];
        agent.setColor(var0,
		       var1,
		       dom, null,
		       Color.green,Color.lightGray);
      }
      return true;
    }
    boolean mHC(int constraint){
	return HC.mHC((Range[])domains.get(constraint),
		      constraint);
    }
    void UpdateDomains(int level){
	if(level==0) domains.set(0,currentDomains.clone());
	else domains.set(level,
			((Range[])domains.get(level-1)).clone());
    }
    // extracts a box out of the cover of the soft constraint
    boolean nextInstantiation(int constraint){
	int hardID=constraintsID[constraint];
	IYConstraint iyc=yconstraints[hardID];
	int k,size=iyc.getVariablesNr();
	Range[] crtDomains=(Range[])domains.get(constraint);
	Range[] result=new Range[size];
	Range[] domain=new Range[size];
	for(k=0;k<size;k++)
	    domain[k]=crtDomains[iyc.getID(k)];

	//setColor(domain);
        if(size==2)
	agent.setColor(iyc.getVariable(0),
		       iyc.getVariable(1),
		       domain,
		       oldDomains[hardID],
		       Color.green,Color.lightGray);
	oldDomains[hardID]=domain;
	if(!iyc.getNextBox(result, domain)) return false;
        noModif=true;
        for(k=0;k<size;k++)
          if(result[k].different(domain[k])){
            noModif=false;break;
          }
	if(constraint==0)
	    clInstantiation=(Range[])result.clone();
	//setColor(result);
        if(size==2){
	  agent.setColor(iyc.getVariable(0),
		       iyc.getVariable(1),
		       result,
		       oldResults[hardID],
		       Color.blue,Utils.transparent);

	  agent.setColor(iyc.getVariable(0),
		       iyc.getVariable(1),
		       result[0].getL(),
		       result[1].getL(),
		       result[0].getU(),
		       result[1].getU(),
		       Color.blue, Color.white);
        }
	oldResults[hardID]=result;
	for(k=0;k<size;k++)
	    crtDomains[iyc.getID(k)]=(Range)result[k].clone();
	return true;
    }
    void releaseConstraint(int constraint){
	int k;
	domains.remove(constraint);
	return;
    }
    void resetConstraint(int constraint){
        if(domains.size()<=constraint)
          domains.add(((Range[])domains.get(constraint-1)).clone());
	int hardID = constraintsID[constraint];
	int k1=yconstraints[hardID].getID(0);
	String var0=yconstraints[hardID].getVariable(0);
	int k2=k1;
	String var1=var0;
	if(yconstraints[hardID].getVariablesNr()>1){
	    k2=yconstraints[hardID].getID(1);
	    var1=yconstraints[hardID].getVariable(1);
	}
	yconstraints[hardID].initCover();
	if(yconstraints[hardID].getVariablesNr()>1)
	agent.setColor(var0,
		       var1,
		       ((C2Representation)((YConstraint)yconstraints[hardID]).getRepresentation()).getMatrix(),
		       0,0,
		       initialDomains[k1].size()-1,
		       initialDomains[k2].size()-1,
		       0,0,
		       Color.white,Color.lightGray,
		       Color.gray,Color.lightGray);
    }

    // this is called in order to initialize the domains, knowing the CSP, after the first HC
    public void resetSearch(){
	IYConstraint yc;
        Range[] instantiation; //crt instantiation

//	printCLCoverRepresentation("reset Search initial CL");
	if(clConstraint!=null)clConstraint.initCover();
	printCLCoverRepresentation("reset Search -> CL");
        for(int i=0;(i<crtConstraint)||
		((i==crtConstraint)&&crtInstantiated);i++) {
            yc=(IYConstraint)yconstraints[constraintsID[i]];
            //add regions for nogoods
            if(i>=constraintsNr) {
                Range[] dom=getInstantiation(yc,(Range[])domains.get(i-1));
                yc.initDomain(dom);
            }else
                yc.resetContinuationPoints();
	    //if((i==0)&&((crtConstraint>0)||(crtInstantiated))){
// 		instantiation=getInstantiation(yc,(Range[])domains.get(i));
// 		printCLCoverRepresentation("reset Search initial CL");
// 		clConstraint.initCover();//resetMark(instantiation);
// 		printCLCoverRepresentation("reset Search -> CL");
	    //}
	    if((crtConstraint!=i)||(crtInstantiated&&crtSolution&&
				    (i==constraintsNr-1))){
		instantiation=getInstantiation(yc,(Range[])domains.get(i));
		yc.resetMark(instantiation);
	    }else  if(i<constraintsNr) yc.initCover();
        }
    }
    public ArrayList getNewConstraint() {
	ArrayList al=new ArrayList();
	if(clConstraint==null)return al;
	Constraint c=clConstraint.getCoverConstraint();
	if(c!=null){
	    MySystem.out.println("newConstraint:");
	    MySystem.out.println(c.getRepresentation());
	    al.add(c);
	}
	return al;
    }
    private Range[] getInstantiation(IYConstraint cons, Range[] instantiations){
        Range[] dom=new Range[cons.getVariablesNr()];
        for(int k=0; k<dom.length; k++){
            int id=cons.getID(k);
	    dom[k]=instantiations[id];//allowed domains
        }
        return dom;
    }

    boolean emptyLevel(Range[] doms){
	for(int k=0;k<doms.length;k++)
	    if(doms[k].size()<=0) return true;
	return false;
    }
    private void setCrtConstraint(int level){
	crtInstantiated=false;//the current level is not instantiated
	crtSolution=false;
	for(int k=domains.size()-1;k>level;k--)
	    domains.remove(k);
	crtConstraint=level;
// 	if(crtConstraint==0){
// 	    clConstraint.initCover();//??
// 	    printCLCoverRepresentation("setCrtConstraint 0->CL")
// 	}
	yconstraints[constraintsID[crtConstraint]].initCover();
    }

    public int setCurrentDomains(Range[]domains){
	boolean nomodif=true;
	for(int l=0; l<variablesNr;l++){
	    if(currentDomains[l].different(domains[l])){
		nomodif=false;break;
	    }
	}
	if(nomodif){
	    if(crtInstantiated&&crtSolution&&(crtConstraint==constraintsNr-1)&&
	       (!emptyLevel((Range[])this.domains.get(crtConstraint))))
		return agent.SannouncedS;
	    return agent.SprocessingM;
	}
	Range[]oldDomains=currentDomains;
	currentDomains=domains;
	if((crtConstraint==0)&&(!crtInstantiated)){
	    this.domains.clear();
	    this.domains.add(domains);
	    for(int l=0; l<variablesNr;l++)
		if(currentDomains[l].restricting(oldDomains[l]))
		    return agent.EngineNogoodExpansion;
	    return agent.SprocessingM;
	}
 	for(int k=0;(k<crtConstraint) ||
 		((k==crtConstraint)&&crtInstantiated&&crtSolution&&
		 (crtConstraint==constraintsNr-1));k++){
 	    Range[]crtInst=(Range[])this.domains.get(k);
 	    //only modified by constraints
 	    if(emptyLevel(combineModifiedLevels(crtInst, currentDomains))){
 		setCrtConstraint(k);
 		break;
 	    }
 	}
	adaptEnlargedDomains();
	if(crtInstantiated&&crtSolution&&(crtConstraint==constraintsNr-1)&&
	   (!emptyLevel((Range[])this.domains.get(crtConstraint))))
	    return agent.SannouncedS;
	return agent.SprocessingM;
    }
    //comment outdated//modify the domain l1 if modifs
    Range[] combineModifiedLevels(Range[]l1, Range[]l2) {
	for(int k=0;k<variablesNr;k++){
	    l1[k]=(Range)l1[k].clone();
	    l1[k].restrict(l2[k]);
	}
	return l1;
    }

    void adaptEnlargedDomains(){
	int k,modifs=variablesNr;
	boolean[] modif = new boolean[variablesNr];
	for(k=0; k<variablesNr; k++){modif[k] = false;}
	for(k=0;(k<crtConstraint)&&(modifs>0);k++){
	    int hardLevel=constraintsID[k];
	    int localVarNr=constraints[hardLevel].getVariablesNr();
	    for(int l=0;l<localVarNr;l++){
		if(!modif[constraints[hardLevel].getID(l)])
		    modifs--;
		modif[constraints[hardLevel].getID(l)]=true;
	    }
	    Range[] cDoms=(Range[])domains.get(k);
	    for(int v=0; v<variablesNr; v++)
		if(!modif[v]) cDoms[v]=(Range)currentDomains[v].clone();
	}
	if((modifs>0)&&crtInstantiated&&crtSolution&&(crtConstraint==constraintsNr-1)){
	    //this is useless<=all modifs true
	    int hardLevel=constraintsID[crtConstraint];
	    int localVarNr=constraints[hardLevel].getVariablesNr();
	    for(int l=0;l<localVarNr;l++){
		if(!modif[constraints[hardLevel].getID(l)])
		    modifs--;
		modif[constraints[hardLevel].getID(l)]=true;
	    }
	    if(modifs==0) return;
	    MySystem.exit("at level:"+crtConstraint+" "+crtInstantiated+crtSolution);
	    //should never reach here(interested in all vars)
	    Range[] cDoms=(Range[])domains.get(crtConstraint);
	    for(int v=0; v<variablesNr; v++)
		if(!modif[v]) cDoms[v]=(Range)currentDomains[v].clone();
	}
    }
}
