/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dhmc;

import java.io.*;
import java.util.*;
import platform.*;
import utils.*;
import parameters.*;

class Propagate implements Serializable{
    int level;
//x_j[v_l, v_h]:hist {x^1:hist,...,x^n:hist}
    Labeling varHistories = new Labeling(); //MHCHistory
    Context addedLinks = new Context();
    Propagate next=null;
    DCost cost;
    AgentID sender;
    Propagate(int level){
	this.level=level;
	cost=(DCost)Utils.agentCost;
    }

    //removes this from Message_Command
    Message_Command removeNext(Message_Command message){
	if(next==null)
	    return null;
	next.cost=cost;
	next.sender=sender;
	Propagate tmp=next;
	next=null;
	message.setArguments(tmp);
	return message;
    }
    void addNext(Propagate prop){
	if(prop.level<=level)
	    throw new RuntimeException("Not implemented: lower added level");
	if(next!=null){
	    if(prop.level<next.level){
		prop.next=next;
		next=prop;
	    }else
		next.addNext(prop);
	}else
	    next=prop;
    }
    public String toString(){
      String s="Propagate:level="+level;
      if(varHistories!=null)
        for(int k=0;k<varHistories.size();k++){
	  Label ob=varHistories.getL(k);
	  if(ob!=null)
	      s=s+" "+ob;
        }
      if(addedLinks.size()>0)
	  s=s+" al:"+addedLinks;
      if(next!=null){
	  next.cost=cost;
	  return s+next.toString();
      }
      if(cost!=null)
	  s=s+" "+cost.toString();
      return s;
    }
}
