/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package dmhc;
import java.util.*;
import java.awt.Color;
import csp.*;
import utils.*;
import parameters.*;
import aggreg.*;
import hc.*;

class Splitting {
    MHCAgent agent;
    int myID;
    //the current soft constraint(index on the stack)
    public int crtConstraint=0;
    //the nr of initial constraints
    int constraintsNr=0;
    int variablesNr=0;
    String[] variables;
    Hashtable vIDs=new Hashtable();
    ArrayList domains=new ArrayList();

    Range[][] oldDomains,oldResults;

    //the initial domains of the search
    public Range[] initialDomains;
    //the currently initial domains of the search
    public Range[] currentDomains;
    //the order on constraints
    public int[] constraintsID;
    Constraint[] constraints;
    IYConstraint[] yconstraints;

    public MHCHistory[][] mHCks;
    public Range[] mHCk;

    //the list of nogoods to be tested
    ArrayList untestedNogoods=new ArrayList();
    //the list of tested nogoods
    ArrayList testedNogoods=new ArrayList();
    //the list of used nogoods
    ArrayList usedNogoods=new ArrayList();

    //used for requiering the interruption of the search
    public boolean end=false;

    /*
    //used for signaling the state 'Solution Processing'
    boolean solution=false; Object monitor_solution=new Object();
    //used for signaling the state 'Nogood Processing'
    boolean nogood=false; Object monitor_nogood=new Object();
    */

    //Has the current instantiation modified any domains?
    boolean noModif;

    //Does the domain of crtConstraint correspond to a box?
    boolean crtInstantiated=false;

    Splitting(int agentID, Problem problem, MHCAgent agent){
	this.agent=agent;
	myID=agentID;
	initCSP(problem); //initialize CSP
	//initialize ranges
	mHCks=new MHCHistory[agentID][variablesNr];
	mHCk =new Range[variablesNr];
	currentDomains =new Range[variablesNr];
	initialDomains =new Range[variablesNr];
	for(int k=0;k<variablesNr;k++){
	    initialDomains[k]=problem.getSetOfVariables().getRange(variables[k]);
	    mHCk[k]=(Range)initialDomains[k].clone();
	    for(int j=0;j<agentID;j++){
		mHCks[j][k]=new MHCHistory(j,variables[k],
					   (Range)mHCk[k].clone(),null);
	    }
	}
        constraintsID=new int[constraintsNr];
	for(int i=0;i<constraintsNr;i++){
            constraintsID[i]=i;
	    int localVariablesNr=yconstraints[i].getVariablesNr();
	    //if(localVariablesNr==2){
		int k1=yconstraints[i].getID(0);
		String var0= yconstraints[i].getVariable(0);
		//MySystem.err.println("Constraint:"+var0+" "+i+" "+localVariablesNr);
		int k2=k1;
		String var1=var0;
		if(localVariablesNr==2){
		    k2=yconstraints[i].getID(1);
		    //MySystem.err.println("Constraint::"+var0+" "+i+" "+localVariablesNr);
		    var1=yconstraints[i].getVariable(1);
		}
		//MySystem.err.println("Constraint");

		agent.createColorMatrix(i,
                        var0, var1,
                        initialDomains[k1].size(),
                        initialDomains[k2].size());

		//MySystem.err.println("ConstraintC");
 
		//agent.setColor(yconstraints[i].getVariable(0),
                //        yconstraints[i].getVariable(1),0,0,
                //        initialDomains[k1].size()-1,
                //        initialDomains[k2].size()-1,
                //        Color.gray,Color.lightGray);
		if(localVariablesNr==2)
		agent.setColor(var0, var1,
			       ((C2Representation)((YConstraint)yconstraints[i]).getRepresentation()).getMatrix(),
			       0,0,
                        initialDomains[k1].size()-1,
                        initialDomains[k2].size()-1,
			       0,0,
                        Color.white,Color.lightGray,
			Color.gray,Color.lightGray);
		//}
	}
    }

    void initCSP(Problem problem){
	int k,i,j;
	variablesNr=problem.getVariablesNr();
	Variable[] tmp=problem.getVariables();
	variables=new String[variablesNr];
	for(k=0;k<variablesNr;k++){
	    variables[k]=tmp[k].getName();
	    vIDs.put(variables[k],new Integer(k));
	}
	constraints=problem.getSetOfConstraints().getConstraints();
	constraintsNr=constraints.length;

	oldResults=new Range[constraintsNr][];
	oldDomains=new Range[constraintsNr][];

	yconstraints=new YConstraint[constraintsNr];
	for(i=0;i<constraintsNr;i++){
	    yconstraints[i]=new YConstraint(constraints[i]);
	    int localConstraintsNr=yconstraints[i].getVariablesNr();
	    for(k=0;k<localConstraintsNr;k++){
              yconstraints[i].setID(k,getvID(yconstraints[i].getVariable(k)));
	      constraints[i].varIDs[k] =yconstraints[i].getID(k);
            }
	}
    }

    int getvID(String variable){
	Integer i=(Integer)vIDs.get(variable);
	if(i==null) return -1;
	return i.intValue();
    }

    //adding nogoods done at solution by incrementing the crtConstraint,
    //        addind a domain and calling search
    //implies that the working domain is in place,
    //the eventual working nogood is at the end of the used list
    int search(){
	boolean end=false;
	int result=0;
	noModif=false;
	while(!end){
	    end=true;
	    //MySystem.out.println("engine:Search constraint:"+crtConstraint);
	    UpdateDomains(crtConstraint);
	    // look for an instantiation
	    if(!nextInstantiation(crtConstraint)){
		// the constraint is exausted
		if(crtConstraint==0){
		    crtInstantiated = false;
		    //setNogood(true);
		    result=-1;
		    resetConstraint(0);
		    end=true;
		}else {// not removing the first domain
		    //if nogood, then should remove it and its testedNoggods
		    releaseConstraint(crtConstraint);
		    crtConstraint--;
		}
		continue;
	    }
	    crtInstantiated=true; //the current level is instantiated
	    //MySystem.out.println("engine: Something found");
	    if(noModif||(mHC(crtConstraint)&&
                         showDomains(crtConstraint))){
		crtConstraint++; crtInstantiated=false;
		// if at solution
		if(checkFinished(crtConstraint)){
		    crtConstraint--;
		    crtInstantiated=true; //the current level is instantiated
		    //end=true;setSolution();
		    result=1;
		    publishSolution();
		    continue;
		}
		// reset the cover for the next constraint
		resetConstraint(crtConstraint);
		continue;
	    }else
		crtInstantiated=false;
	}
	return result;
    }
    boolean showDomains(int crtConstraint){
      for(int i = crtConstraint+1; i<constraintsNr; i++){
        int hID = constraintsID[i];
        Range[] dom = new Range[2];
	int k1=yconstraints[hID].getID(0);
	String var0=yconstraints[hID].getVariable(0);
	int k2=k1;
	String var1=var0;
	if(yconstraints[hID].getVariablesNr()>1){
	    k2=yconstraints[hID].getID(1);
	    var1=yconstraints[hID].getVariable(1);
	}
        dom[0] = ((Range[])domains.get(crtConstraint))[k1];
        dom[1] = ((Range[])domains.get(crtConstraint))[k2];
        agent.setColor(var0,
		       var1,
		       dom, null,
		       Color.green,Color.lightGray);
      }
      return true;
    }

    void publishSolution(){
	//setSolution(true);
	end=true;
    }

    private void registerConflicts(){
	for(int k=0;k<variablesNr;k++)
	    if(mHCk[k].restricting(currentDomains[k]))
		agent.updateConflictingList(mHCks[myID-1][k]);
    }

    //comment outdated//modify the domain l1 if modifs
    Range[] combineModifiedLevels(Range[]l1, Range[]l2) {
	for(int k=0;k<variablesNr;k++){
	    l1[k]=(Range)l1[k].clone();
	    l1[k].restrict(l2[k]);
	}
	return l1;
    }

    //testing if a nogood anulated the current range of varID
    //called only in the solution state
    boolean anulated(int varID, DVarHistory valuation){
	if(crtConstraint!=constraintsNr-1)
	    MySystem.exit(1);
	Range[] solution=(Range[])domains.get(crtConstraint);
	if(valuation.range.contains(solution[varID]))
	    return true;
	return false;
    }

    //combine accumulated history to new level, modify first
    //prefer first
    MHCHistory combineLevel(MHCHistory l1, MHCHistory l2) {
	    if((l2==null)||
	       (l2.proposal==null))
		return l1;
	    if(l1.proposal!=null){
		if(l1.proposal.restricting(l2.proposal)){
		    if(l2.proposal.restricting(l1.proposal)){
			l1=(MHCHistory)l1.clone();
			l1.proposal=(Range)l1.proposal.clone();
			l1.proposal.restrict(l2.proposal);
			//if(l1.dependencies==null) l1.dependencies=new Hashtable();
			l1.dependencies=(ConflictSet)l1.dependencies.clone();
			l1.dependencies.addAll(l2.dependencies);
		    }else{
			l1=(MHCHistory)l1.clone();
			l1.proposal=(Range)l2.proposal.clone();
			l1.dependencies=(ConflictSet)l2.dependencies.clone();
		    }
		}else
		    l1=(MHCHistory)l1.clone();
	    }else{
		l1.proposal=(Range)l2.proposal.clone();
		l1.dependencies=(ConflictSet)l2.dependencies.clone();
	    }
	return l1;
    }

    //combine accumulated history to new level, modify first
    //prefer first
    MHCHistory[] combineLevels(MHCHistory[]l1, MHCHistory[]l2){
	int k,sz=variablesNr;
	for(k=0;k<sz;k++){
	    if((l2[k]==null)||
	       (l2[k].proposal==null))
		continue;
	    if(l1[k].proposal!=null){
		if(l1[k].proposal.restricting(l2[k].proposal)){
		    if(l2[k].proposal.restricting(l1[k].proposal)){
			l1[k]=(MHCHistory)l1[k].clone();
			l1[k].proposal=(Range)l1[k].proposal.clone();
			l1[k].proposal.restrict(l2[k].proposal);
			//if(l1[k].dependencies==null) l1[k].dependencies=new Hashtable();
			l1[k].dependencies=(ConflictSet)l1[k].dependencies.clone();
			l1[k].dependencies.addAll(l2[k].dependencies);
		    }else{
			l1[k]=(MHCHistory)l1[k].clone();
			l1[k].proposal=(Range)l2[k].proposal.clone();
			l1[k].dependencies=(ConflictSet)l2[k].dependencies.clone();
		    }
		}else
		    l1[k]=(MHCHistory)l1[k].clone();
	    }else{
		l1[k].proposal=(Range)l2[k].proposal.clone();
		l1[k].dependencies=(ConflictSet)l2[k].dependencies.clone();
	    }
	}
	return l1;
    }

    //keeping instantiation of second, modify first
    //add second only if not erasing first
    MHCHistory[] combineRelaxedLevelsInFirst(MHCHistory[]l1, MHCHistory[]l2){
	for(int k=0;k<variablesNr;k++){
	  if(!l1[k].proposal.intersecting(l2[k].proposal))
	      continue;
	  if((l2[k].proposal.restricting(l1[k].proposal))){
	      if(l1[k].proposal.restricting(l2[k].proposal)){
		  l1[k]=(MHCHistory)l1[k].clone();
		  l1[k].proposal=(Range)l1[k].proposal.clone();
		  l1[k].proposal.restrict(l2[k].proposal);
		  l1[k].dependencies=(ConflictSet)l1[k].dependencies.clone();
		  l1[k].dependencies.addAll(l2[k].dependencies);
	      }else
		  l1[k]=(MHCHistory)l1[k].clone();
	  }else
	      l1[k]=(MHCHistory)l2[k].clone();
	}
	return l1;
    }

    //keeping instantiation of second, modify first
    //for prepareMHCk
    MHCHistory[] combineLevelsInFirst(MHCHistory[]l1, MHCHistory[]l2){
	for(int k=0;k<variablesNr;k++){
	    if((l2[k].proposal.restricting(l1[k].proposal))){
		if(l1[k].proposal.restricting(l2[k].proposal)){
		    l1[k]=(MHCHistory)l1[k].clone();
		    l1[k].proposal=(Range)l1[k].proposal.clone();
		    l1[k].proposal.restrict(l2[k].proposal);
		    l1[k].dependencies=(ConflictSet)l1[k].dependencies.clone();
		    l1[k].dependencies.addAll(l2[k].dependencies);
		}else
		    l1[k]=(MHCHistory)l1[k].clone();
	    }else
		l1[k]=(MHCHistory)l2[k].clone();
	}
	return l1;
    }

    ConflictSet getConflicts(MHCHistory h){
	ConflictSet result=new ConflictSet();
	result.addAll(h.dependencies);
	result.add(h.variable);
	return result;
    }

    // modify instantiation
    Range[] combineInstLevels(Range[]l1, MHCHistory[]l2, 
			      ConflictSet eCS, ConflictSet rCS) {
        boolean empty=false;
	int k,sz=l1.length;
	for(k=0;k<sz;k++){
	    if(l2[k]!=null){
		if(l1[k].size()<=0)continue;
		if(l1[k].restricting(l2[k].proposal)){
		    rCS.addAll(getConflicts(l2[k]));
		}
		l1[k]=(Range)l1[k].clone();
		l1[k].restrict(l2[k].proposal);
		if((!empty)&&(l1[k].size()<=0)){
		    empty=true;
		    eCS.addAll(getConflicts(l2[k]));}
	    }
	}
	return l1;
    }

    Range[] combineLevels(Range[]l1, MHCHistory[]l2){
	int k,sz=l1.length;
	for(k=0;k<sz;k++){
	    if(l2[k]!=null){
		l1[k]=(Range)l1[k].clone();
		l1[k].restrict(l2[k].proposal);
	    }
	}
	return l1;
    }

    //called in order to reduce the crtConstraint from something higher
    void setCrtConstraint(int level){
	//if(level==0) //usually the search is reset
	crtInstantiated=false;//the current level is not instantiated
	for(int k=domains.size()-1;k>level;k--)
	    domains.remove(k);
	crtConstraint=level;
	//next instruction informs the function InSolution (agent==1 constr)
	agent.Ssolution=false;
	//agent.Snogood=false;
	// reset the cover for the next constraint
	yconstraints[constraintsID[crtConstraint]].initCover();
	end=false; //allow restarting
    }

    //maintain the HC at level -1
    //return null if not emptied
    Range[] mHCk(Hashtable dependency){
	int k;
	Range[] crtInst;
	if(!HC.HC(mHCk, dependency)){ //empty nogood
	    setCrtConstraint(0);
	    return mHCk;
	}
	//prepare search
	updateCurrentDomains();
	for(k=0;(k<crtConstraint) ||
		((k==crtConstraint)&&crtInstantiated);k++){
	    crtInst=(Range[])domains.get(k);
	    //only modified by constraints
	    if(emptyLevel(combineModifiedLevels(crtInst,currentDomains))){
		setCrtConstraint(k);
		break;
	    }
	}
	//if(emptyLevel(currentDomains))return currentDomains;
	return null;
    }

    // prepares the new level in order to enable clear level
    // for levels following it
    void exchangeLevel(MHCHistory[] levelState,int level){
        if(level>=0){
          mHCks[level]=(MHCHistory[])levelState.clone();
	  for(int k=0;k<variablesNr;k++)
	      if(levelState[k]!=null) 
		  mHCks[level][k]=(MHCHistory)levelState[k].clone();
	}else
	    for(int k=0;k<variablesNr;k++)
		if(levelState[k]!=null) 
		    mHCk[k]=(Range)levelState[k].proposal.clone();
    }
    //maintain the HC at a given instantiation level
    //return null if not emptied
    Range[] mHCk(int level, Hashtable dependency) {
        if(level<0){return mHCk(dependency);}
	int k;
	Range[] mHL,crtInst=new Range[variablesNr];
	MHCHistory[] mHLC;
	//create structure mHL&mHLC to store intersection of levels
	mHLC=getLevelsCombinationRelaxedWithLast(-1,level);
	getRangesInFirst(mHCks[level],mHLC);
	mHL=getRangesFromHistories(mHLC);
        boolean emptied=false;
	if(emptyLevel(mHL)){emptied=true;}
	if(!emptied){
	    MySystem.err.println("run consistency at level "+level);
	    agent.printLabels(level);
	    if(!HC.HC(mHL, dependency)) emptied=true;
	    printH(dependency);
	    //announce mHL.clone(),
	    getConsistencyResult(mHCks[level],level,mHL,dependency);
	    agent.printLabels(level);
	}
	//prepare search
	mHLC=getLevelsCombinationRelaxedWithLast(level,myID-1);
	getRangesInFirst(mHCks[myID-1],mHLC);
	currentDomains=getRangesFromHistories(mHLC);
	//set conflicts for used nogoods
	registerConflicts();
	if(emptyLevel(currentDomains)) //because of last level
	    emptied=true;
        if(emptied){
	    setCrtConstraint(0);
	   return currentDomains;
	}

	mHL=getRangesFromHistories(mHLC);
	for(k=0;(k<crtConstraint) ||
		((k==crtConstraint)&&crtInstantiated);k++){
	    crtInst=(Range[])domains.get(k);
	    //only modified by constraints
	    if(emptyLevel(combineModifiedLevels(crtInst, currentDomains))){
		setCrtConstraint(k);
		break;
	    }
	}
	return null;
    }

    void adaptEnlargedDomains(){
	int k,modifs=variablesNr;
	boolean[] modif = new boolean[variablesNr];
	for(k=0; k<variablesNr; k++){modif[k] = false;}
	for(k=0;(k<crtConstraint)&&(modifs>0);k++){
	    int hardLevel=constraintsID[k];
	    int localVarNr=constraints[hardLevel].getVariablesNr();
	    for(int l=0;l<localVarNr;l++){
		if(!modif[constraints[hardLevel].getID(l)])
		    modifs--;
		modif[constraints[hardLevel].getID(l)]=true;
	    }
	    Range[] cDoms=(Range[])domains.get(k);
	    for(int v=0; v<variablesNr; v++)
		if(!modif[v]) cDoms[v]=(Range)currentDomains[v].clone();
	}
	if(crtInstantiated){//this is useless<=all modifs true
	    int hardLevel=constraintsID[crtConstraint];
	    int localVarNr=constraints[hardLevel].getVariablesNr();
	    for(int l=0;l<localVarNr;l++){
		if(!modif[constraints[hardLevel].getID(l)])
		    modifs--;
		modif[constraints[hardLevel].getID(l)]=true;
	    }
	    if(modifs==0) return;
	    if(crtConstraint!=constraints.length-1)
		MySystem.err.println("Not crtInstantiated but erroneously set");
	    MySystem.exit(1);//should never reach here(interested in all vars)
	    Range[] cDoms=(Range[])domains.get(crtConstraint);
	    for(int v=0; v<variablesNr; v++)
		if(!modif[v]) cDoms[v]=(Range)currentDomains[v].clone();
	}
    }

    void updateStructureLevel(int level){
	if(level<0) return;
	Range previous;
	for(int varID=0;varID<variablesNr;varID++){
	    if(mHCks[level][varID]==null){
		previous=getInstantiation(varID,level);
		mHCks[level][varID]=(previous!=null)?
		    new MHCHistory(variables[varID],previous):
		    new MHCHistory(variables[varID],null,
				   getProposal(-1,varID));
		//		   getProposal(level-1,varID));
	    }else if(mHCks[level][varID].instantiation==null){
		previous=getInstantiation(varID,level);
		mHCks[level][varID].instantiation=previous;
	    }
	}
    }

    //manage to have something correct in all proposals
    //the last level should contain the intersection
    //TODO erase whatever does not intersect intersection of predecesors(inst or range)
    void updateStructures(){
	Range previous=null;
	Int upperLevelOfCommonInstantiation=new Int();
	for(int varID=0;varID<variablesNr;varID++){
	    upperLevelOfCommonInstantiation.i=-1;
	    for(int level=0;level<myID;level++){
		if(mHCks[level][varID]==null){
		    previous=
			getInstantiation(varID,level,previous,
					 upperLevelOfCommonInstantiation);
		    if(previous!=null)
			mHCks[level][varID]=
			    new MHCHistory(variables[varID],previous);
		    else{
			mHCks[level][varID]=
			    new MHCHistory(variables[varID],null,
					   getProposal(level-1,varID));
			if(level>0)
			    mHCks[level][varID].dependencies=(ConflictSet)
				mHCks[level-1][varID].dependencies.clone();
		    }
		}else if(mHCks[level][varID].instantiation==null){
		    previous=
			getInstantiation(varID,level,previous,
					 upperLevelOfCommonInstantiation);
		    mHCks[level][varID].instantiation=previous;
		}else previous=mHCks[level][varID].instantiation;
	    }
	}
    }

    private Range getInstantiation(int varID, int level){
	//computation of up and low
	Range range;
	int up=-1, low=-1;
	String var=variables[varID];
	int[] hist=agent.varHistory.geth(var);
	if(hist==null) return mHCk[varID];
	int k=0;
	while(up<=level){
	    if(k>=hist.length){
		low=up;
		up=myID+1;
		break;
	    }
	    low=up;
	    up=hist[k];
	    k++;k++;
	}
	MySystem.err.println("getInst:for:"+var+":look from level:"+low+":,to:"+(up-1)+":at level:"+level);
	//look for an instantiation
	if(low==-1){
	    MySystem.err.println("getInst:for:"+var+":"+mHCk[varID]+":from mHCk["+varID+"]:at level:"+level);
	    return mHCk[varID];
	}
	for(k=low;k<up;k++){
	    range=(Range)agent.instantiations[k].get(var);
	    if(range!=null){
		MySystem.err.println("getInst:for:"+var+":"+range+":from level:"+k+":at level:"+level);
		return range;
	    }
	}
	MySystem.err.println("getInst:no inst for:"+var+":at level:"+level);
	return null;
    }

    //for external variables
    Range getInstantiation(String var, int level){
	//computation of up and low
	Range range;
	int up=-1, low=-1;
	int[] hist=agent.varHistory.geth(var);
	int k=0;
	while(up<=level){
	    if(k>=hist.length){
		low=up;
		up=myID+1;
		break;
	    }
	    low=up;
	    up=hist[k];
	    k++;k++;
	}
	MySystem.err.println("getEInst:for:"+var+":look from level:"+low+",to:"+(up-1)+":at level:"+level);
	//look for an instantiation
	if(low==-1) low++;
	for(k=low;k<up;k++){
	    range=(Range)agent.instantiations[k].get(var);
	    if(range!=null){
		MySystem.err.println("getEInst:for:"+var+":"+range+":from level:"+k+":at level:"+level);
		return range;
	    }
	}
	MySystem.err.println("getEInst:no inst for:"+var+":at level:"+level);
	return null;
    }

    private Range getInstantiation(int varID, int level, Range previousInst,
			     Int upperLevelOfCommonInstantiation){
	int i=upperLevelOfCommonInstantiation.i;
	if(level<=i){
	    MySystem.err.println("getInst:for:"+variables[varID]+":"+previousInst+":from previous-at level:"+level);
	    return previousInst;
	}
	//computation of upperLevelOfCommonInstantiation
	String var=variables[varID];
	int[] hist=agent.varHistory.geth(var);
	if(hist==null){
	    upperLevelOfCommonInstantiation.i=myID;
	    MySystem.err.println("getInst:for:"+var+":"+mHCk[varID]+":from level:-1:at level:"+level);
	    return mHCk[varID];
	}
	int low=-1;
	int k=0;
	i=-1;
	while(i<=level){
	    if(k>=hist.length){
		low=i;
		i=myID+1;
		break;
	    }
	    low=i;
	    i=hist[k];
	    k++;k++;
	}
	MySystem.err.println("getInst:for:"+var+":look from level:"+low+",to:"+(i-1)+":at level:"+level);
	if(low==-1){
	    MySystem.err.println("getInst::for:"+var+":"+mHCk[varID]+":from level:-1:at level:"+level);
	    return mHCk[varID];
	}
	upperLevelOfCommonInstantiation.i=i-1;
	//look for an instantiation
	for(k=low;k<i;k++){
	    previousInst=(Range)agent.instantiations[k].get(var);
	    if(previousInst!=null){
		MySystem.err.println("getInst:for:"+var+":"+previousInst+":from level:"+k+":at level:"+level);
		return previousInst;
	    }
	}
	MySystem.err.println("getInst:no inst for:"+var+":at level:"+level);
	return null;
    }

    private Range getProposal(int level, int varID){
	if(level>=0)
	    return mHCks[level][varID].proposal;
	return mHCk[varID];
    }

    private MHCHistory[] getHistoriesFromRanges(Range[] ranges){
	MHCHistory[] mHLC=new MHCHistory[variablesNr];
	//create structure to store intersection of levels
	for(int k=0; k<variablesNr; k++){
	    //getting the history as the last on the stack
	    mHLC[k]=new MHCHistory(variables[k],
				   (Range)ranges[k].clone());}
	return mHLC;
    }

    private Range[] getRangesFromHistories(MHCHistory[] levels){
	Range[] result=new Range[variablesNr];
	//create structure to store intersection of levels
	for(int k=0; k<variablesNr; k++){
	    //getting the history as the last on the stack
	    result[k]=(Range)levels[k].proposal.clone();}
	return result;
    }

    private MHCHistory[] cloneLevel(int level){
	if(level<0) return getHistoriesFromRanges(mHCk);
	MHCHistory[] result=(MHCHistory[])mHCks[level].clone();
	for(int k=0;k<variablesNr;k++){
	    result[k]=(MHCHistory)result[k].clone();}
	return result;
    }

    private MHCHistory[] getLevelsCombination(int startLevel,int endLevel){
	MHCHistory[] result=cloneLevel(startLevel);
	for(int level=startLevel+1;level<=endLevel;level++){
	    result=combineLevelsInFirst(result,mHCks[level]);}
	return result;
    }

    private MHCHistory[] getLevelsCombinationRelaxedWithLast(int startLevel,int endLevel){
	MHCHistory[] result=cloneLevel(startLevel);
	for(int level=startLevel+1;level<endLevel;level++){
	    result=combineRelaxedLevelsInFirst(result,mHCks[level]);}	    
	result=combineLevelsInFirst(result,mHCks[endLevel]);
	return result;
    }

    //update ranges and dependencies
    private void getRangesInFirst(MHCHistory[] dest, MHCHistory[] source){
	for(int k=0;k<variablesNr;k++){
	    dest[k].proposal=source[k].proposal;
	    dest[k].dependencies=source[k].dependencies;
	}
    }

    private ConflictSet[] getConflicts(MHCHistory[] levels){
	ConflictSet[] cs=new ConflictSet[variablesNr];
	for(int k=0;k<variablesNr;k++){
	    cs[k]=(ConflictSet)levels[k].dependencies.clone();}
	return cs;
    }

    private void getConsistencyResult(MHCHistory[] levels, int level,
				      Range[] ranges, Hashtable deps){
	ConflictSet[] cs=getConflicts(levels);
	for(int k=0;k<variablesNr;k++){
	    ArrayList vars=(ArrayList)deps.get(new Integer(k));
	    if(vars==null){
		if(levels[k].proposal.different(ranges[k])){
		    printRHLevel(levels);printRLevel(ranges);printH(deps);
		    MySystem.exit(1);
		}
		continue;}
	    levels[k].proposal=ranges[k];
	    Iterator it=vars.iterator();
	    while(it.hasNext()){
		int varID=((Integer)it.next()).intValue();
		if(varID==k) continue;
		int[] hist = agent.getHistory(variables[varID],level);
		if((hist!=null)&&(hist.length!=0))
		    levels[k].dependencies.add(variables[varID]);
		levels[k].dependencies.addAll(cs[varID]);
	    }
	    levels[k].dependencies.remove(variables[k]);
	}
    }

    private void printRHLevel(MHCHistory[] mhc){
	for(int k=0;k<variablesNr;k++)MySystem.err.println(mhc[k].variable+mhc[k].proposal);
    }
    private void printRLevel(Range[] mhc){
	MySystem.err.println("\n");
	for(int k=0;k<variablesNr;k++)MySystem.err.println("["+variables[k]+"]"+mhc[k]);
	MySystem.err.println("\n");
    }
    private void printH(Hashtable dep){
	Iterator it1=(Iterator)dep.keys();
	while(it1.hasNext()){
	    Integer i=(Integer)it1.next();
	    MySystem.err.print(i+":");
	    Iterator it2=((ArrayList)dep.get(i)).iterator();
	    while(it2.hasNext()){
		MySystem.err.println("\t"+it2.next());
	    }
	}
    }

    void updateCurrentDomains(){
	Range[] mHL;
	if(myID>0){ 
	    MHCHistory[] mHCL=getLevelsCombinationRelaxedWithLast(-1,myID-1);
	    getRangesInFirst(mHCks[myID-1],mHCL);
	    mHL=getRangesFromHistories(mHCks[myID-1]);
	}else mHL=(Range[])mHCk.clone();
	currentDomains = mHL;
    }

    //change the instantiations of this agent(level==myID)
    boolean mHCk(MHCHistory[] levelState,ConflictSet newCS){
	Range[] crtInst;
	for(int k=0;(k<crtConstraint) ||
		((k==crtConstraint)&&crtInstantiated);k++){
	    crtInst=(Range[])domains.get(k);
	    //only modified by constraints
	    if(emptyLevel(combineModifiedLevels(crtInst, currentDomains))){
		setCrtConstraint(k);
		return false;//emptied
	    }
	}
	//MySystem.out.println("Combine solution");
	crtInst=(Range[])domains.get(crtConstraint);
	ConflictSet eCS=new ConflictSet(), rCS=new ConflictSet();
	combineInstLevels(crtInst,levelState,eCS,rCS);
	if(emptyLevel(crtInst)){
	    crtInstantiated=false;
	    newCS.addAll(eCS);
	    return false;
	}
	newCS.addAll(rCS);
	return true;
    }

    //reset all covers excepting the current uppermost instantiation
    void resetSearch(){
	IYConstraint yc;
        Range[] instantiation; //crt instantiation

        for(int i=0;(i<crtConstraint)||
		((i==crtConstraint)&&crtInstantiated);i++) {
	    //MySystem.out.println("resetEverythingToCurrentInstantiation:Changing constraint: "+i);
	    if((i>=constraintsID.length)||
	       (i>=domains.size())||
	       ((crtConstraint==i)&&(crtConstraint<constraintsNr-1))){
		//MySystem.err.println("resetEverythingToCurrentInstantiation:Not so many YConstraints!!!:i="+i);
		MySystem.exit(1);//never here if no additional nogoods used
		continue;
	    }

            yc=(IYConstraint)yconstraints[constraintsID[i]];
            //add regions
            // for nogoods
            if(i>=constraintsNr) {
		//MySystem.out.println("resetEverythingToCurrentInstantiation:It is a nogood");
                // i== crtDomain-1 //for the crt constraint
                Range[] dom=getInstantiation(yc,(Range[])domains.get(i-1));
                yc.initDomain(dom);
            }else
                yc.resetContinuationPoints();
	    //MySystem.out.println("resetEverythingToCurrentInstantiation:Reset mark");
	    if((crtConstraint!=i)||crtInstantiated){
		instantiation=getInstantiation(yc,(Range[])domains.get(i));
		yc.resetMark(instantiation);
	    }
        }
	//MySystem.out.println("resetEverythingToCurrentInstantiation:End of remarking");
    }

    private Range[] getInstantiation(IYConstraint cons, Range[] instantiations){
        Range[] dom=new Range[cons.getVariablesNr()];
        for(int k=0; k<dom.length; k++){
            int id=cons.getID(k);
            //MySystem.out.println("build var "+id+" "+variables[id].name);
            if (id>=0)
                dom[k]=instantiations[id];//allowed domains
            else{
                // if ever using old nogoods
                // behaviour can be improved
		MySystem.err.println("Not implemented for nogoods!");
		MySystem.exit(1);
		//dom[k]=(Range)agent.varHistory.get(cons.getVariable(k));
	    }
        }
        return dom;
    }

    boolean mHC(int constraint){
	return HC.mHC((Range[])domains.get(constraint),
		      constraint);
    }
    // update domain
    void UpdateDomains(int level){
	if(level==0) domains.set(0,currentDomains.clone());
	else domains.set(level,
			((Range[])domains.get(level-1)).clone());
    }
    // extracts a box out of the cover of the soft constraint
    boolean nextInstantiation(int constraint){
	int hardID=constraintsID[constraint];
	IYConstraint iyc=yconstraints[hardID];
	int k,size=iyc.getVariablesNr();
	Range[] crtDomains=(Range[])domains.get(constraint);
	Range[] result=new Range[size];
	Range[] domain=new Range[size];
	for(k=0;k<size;k++)
	    domain[k]=crtDomains[iyc.getID(k)];

	//setColor(domain);
        if(size==2)
	agent.setColor(iyc.getVariable(0),
		       iyc.getVariable(1),
		       domain,
		       oldDomains[hardID],
		       Color.green,Color.lightGray);
	oldDomains[hardID]=domain;
	if(!iyc.getNextBox(result, domain)) return false;
        noModif=true;
        for(k=0;k<size;k++)
          if(result[k].different(domain[k])){
            noModif=false;break;
          }


	//setColor(result);
        if(size==2){
	  agent.setColor(iyc.getVariable(0),
		       iyc.getVariable(1),
		       result,
		       oldResults[hardID],
		       Color.blue,Utils.transparent);

	  agent.setColor(iyc.getVariable(0),
		       iyc.getVariable(1),
		       result[0].getL(),
		       result[1].getL(),
		       result[0].getU(),
		       result[1].getU(),
		       Color.blue, Color.white);
        }
	oldResults[hardID]=result;
	for(k=0;k<size;k++)
	    crtDomains[iyc.getID(k)]=(Range)result[k].clone();
	return true;
    }
    // this is called in order to initialize the domains, knowing the CSP, after the first HC
    void initSearch(){
	Range[] dom=(Range[])initialDomains.clone();
	for(int k=0;k<dom.length;k++){
	    dom[k]=(Range)mHCk[k].clone();
            currentDomains[k]=(Range)dom[k].clone();
        }
	domains.add(dom);
    }
    // resets the cover of the soft constraint
    // does nothing if no such constraint exists
    void resetConstraint(int constraint){
        if(domains.size()<=constraint)
          domains.add(((Range[])domains.get(constraint-1)).clone());
	int hardID = constraintsID[constraint];
	int k1=yconstraints[hardID].getID(0);
	String var0=yconstraints[hardID].getVariable(0);
	int k2=k1;
	String var1=var0;
	if(yconstraints[hardID].getVariablesNr()>1){
	    k2=yconstraints[hardID].getID(1);
	    var1=yconstraints[hardID].getVariable(1);
	}
	yconstraints[hardID].initCover();
	if(yconstraints[hardID].getVariablesNr()>1)
	agent.setColor(var0,
		       var1,
		       ((C2Representation)((YConstraint)yconstraints[hardID]).getRepresentation()).getMatrix(),
		       0,0,
		       initialDomains[k1].size()-1,
		       initialDomains[k2].size()-1,
		       0,0,
		       Color.white,Color.lightGray,
		       Color.gray,Color.lightGray);
    }

    void releaseConstraint(int constraint){
	int k;
	domains.remove(constraint);
	if (constraint<constraintsNr)
	    return;
	Object appliedN=usedNogoods.remove(constraint-constraintsNr);
	if((k=usedNogoods.size())==0){
	    if(appliedN==testedNogoods.get(k))
		untestedNogoods.add(0,testedNogoods.remove(0));
	    untestedNogoods.addAll(testedNogoods);
	    testedNogoods.clear();
	    return;
	}
	Object tmp,obj=usedNogoods.get(k-1);
	k=testedNogoods.size()-1;
	//the 0 at least should be same as obj
	for(;k>0;k--){
	    if(obj==testedNogoods.get(k))
		break;
	    tmp=testedNogoods.remove(k);
	    if(appliedN==tmp)
		untestedNogoods.add(0, tmp);
	    else
		untestedNogoods.add(tmp);
	}
    }
    // true if the constraint is the last and no nogood is left
    boolean checkFinished(int constraint){
	if (constraint<constraintsNr)
	    return false;
	// maintain that we have to add this in the ArrayList
	while (untestedNogoods.size()!=0){
	    Object obj=untestedNogoods.remove(0);
	    if(applicable(obj)){
		usedNogoods.add(obj);
		testedNogoods.add(obj);
		return false;
	    }else testedNogoods.add(obj);
	}
	return true;
    }

    //The levels to clear are cleared upward,
    //however, dependencies were always propagated

    //clearing the level for all previos or higher
    void clearLevel(int level, ArrayList hist){
	if(hist.size()>0){
	    for(int k=0; k<variablesNr; k++){
		if(mHCks[level][k]==null)
		    continue;
		if(mHCks[level][k].disabledBy(hist)){
		    if(mHCks[level][k].disabledHistoryBy(hist))
			for(int clevel=level;clevel<myID;clevel++){
			    mHCks[clevel][k]=null;
			}
		    else mHCks[level][k]=null;
		}
	    }
	}
    }

    boolean InSolution(){
	if((crtConstraint==constraintsNr-1)&&
	   (agent.Ssolution==true)&&crtInstantiated)
	    return true;
	return false;
    }

    //this function should annulate the current solution upon
    //the arrival of a valid nogood
    void nogoodEliminatesSolution(){
	Range[] sol=(Range[])domains.get(crtConstraint);
	sol[0]=new Range(2,1);
    }

    //get the index of the emptied instantiation
    int getEmptiedID(){
	Range[] crtInst=(Range[])domains.get(constraintsNr);
	for(int k=0;k<crtInst.length;k++){
	    if(crtInst[k].size()<0)
		return k;
	}
	MySystem.exit(1);
	return -1;
    }

    // copy the solution in a record
    boolean applicable(Object obj){
	return true;
    }

    boolean emptyLevel(Range[] doms){
	for(int k=0;k<doms.length;k++)
	    if(doms[k].size()<=0)
		return true;
	return false;
    }

    boolean emptyLevel(MHCHistory[] doms){
	for(int k=0;k<doms.length;k++){
	    if(doms[k]==null)
		continue;
	    if(doms[k].proposal.size()<=0)
		return true;
	}
	return false;
    }

    int getEmptyLevel(MHCHistory[] doms){
	for(int k=0;k<variablesNr;k++)
	    if(doms[k].proposal.size()<=0)
		return k;
	return -1;
    }
    /*
    void setSolution(boolean _solution){
	synchronized(monitor_solution){  solution=_solution; }
    }
    boolean getSolution(){
	synchronized(monitor_solution){  return solution;    }
    }

    void setNogood(boolean _nogood){
	synchronized(monitor_nogood){  nogood=_nogood; }
    }
    boolean getNogood(){
	synchronized(monitor_nogood){  return nogood;    }
    }
    */
    // called by solver to add in nogoods the variables
    // from original instance, modified by incoming
    void addInternalRestrictingVariables(ConflictSet _variables){
	String var;
        // for All original variables
        for(int k=0;k<variablesNr;k++){
	    var=variables[k];
	    if(myID>0){
		if((mHCks[myID-1][k].instantiation==null)||
		   (initialDomains[k].restricting(mHCks[myID-1][k].instantiation)))
		    if(!_variables.contains(var))
			_variables.add(var);		    
	    }
	}
    }
}
