/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package mads;
import sjavap.*;
import utils.*;
import platform.*;
import parameters.*;
class HeuristicCompactor implements MessageReceiver, Runnable{

 /**    active object support (needs implements Reply)   **/
 /*********************************************************/
 /**/ Synch_List select = new Synch_List(this);           //
 /**/ synchronized public void Synch_Reply()              //
 /**/   { notify();   }                                   //
 /**/ int now() {return Kernel.kern.currentTime;}         //
 /**/ int Synch_Wait() {                                  //
 /**/   Kernel.kern.Synch_Request(select);                //
 /**/   do{try {wait();} catch(InterruptedException e){}} //
 /**/   while(select.nbEntries!=0);                       //
 /**/   return select.Value; }                            //
 /*********************************************************/

    private MHCAgent MHCscheduler;
    private int myComputationNum;
    private Order sentOrder, sent0Order;
    private boolean resendOrder=false, resend0Order=false;
    private boolean agent0=false;
    private Message senderMsg, sender0Msg;
    //package accessible, only for priority
    int myID=0;
    //active methods
    final public static int _terminate=2;
    final public static int _getSents=3;
    HeuristicCompactor(MHCAgent scheduler, int myComputationNum, 
		       boolean agent0){
	this.agent0=agent0;
	this.myComputationNum=myComputationNum;
	MHCscheduler=scheduler;
    }
    synchronized public void run(){
	select.thread=Thread.currentThread();
	MySystem.err.println("HEURistic-COMPARATOR starts");
	for(;;){
	    select.accept(0,_terminate);
	    select.accept(1,_getMessage);
	    select.accept(2,_getSents);
	    if(resend0Order){
		select.call(3,MHCscheduler,MHCscheduler._heuristic,1);
		MySystem.err.println("HEURistic-COMPARATOR resend0Order");
	    }else if(resendOrder){
		select.call(3,MHCscheduler,MHCscheduler._heuristic,myID+2);
		MySystem.err.println("HEURistic-COMPARATOR resendOrder");
	    }
	    int sWait = Synch_Wait();
	    MySystem.err.println("HEURistic-COMPARATOR choice:"+sWait);
	    switch(sWait){
	    case 0:
		return;
	    case 1:
		break;
	    case 2:
		break;
	    case 3:
		if(resend0Order){
		    MHCscheduler.getMessage(sender0Msg);
		    resend0Order=false;
		    break;
		}
		if(resendOrder){
		    MHCscheduler.getMessage(senderMsg);
		    resendOrder=false;
		    break;
		}
	    }
	}
    }
    synchronized public void terminate(){
	Synch_Reply();
    }
    synchronized public void getSents(Order sentOrderMyLevel, 
				      Order sent0OrderMyLevel){
	MySystem.err.println("Heuristic Compactor gotSents:"+sentOrderMyLevel+" "+sent0OrderMyLevel);
	if((sentOrderMyLevel!=null)&&(sentOrderMyLevel.bestVolume>0)){
	    //if(sentOrderMyLevel.bestVolume<=0) MySystem.exit(1);
	    if((sentOrder==null)||(!sentOrder.equals(sentOrderMyLevel))){
		sentOrder=(Order)sentOrderMyLevel.clone();
		resendOrder=false;
	    }else{
		if(sentOrder.takeBV(sentOrderMyLevel)){
		    resendOrder=false;
		}
	    }
	}
	if((sent0OrderMyLevel!=null)&&(sent0OrderMyLevel.bestVolume>0)){
	    //if(sent0OrderMyLevel.bestVolume<=0) MySystem.exit(1);
	    if((sent0Order==null)||(!sent0Order.equals(sent0OrderMyLevel))){
		sent0Order=(Order)sent0OrderMyLevel.clone();
		resend0Order=false;
	    }else{
		if((sent0Order.bestVolume>sent0OrderMyLevel.bestVolume)&&
		   (sent0OrderMyLevel.bestVolume>0)){
		    sent0Order.bestVolume = sent0OrderMyLevel.bestVolume;
		    resend0Order=false;
		}
	    }
	}
	Synch_Reply();
    }
    private void getHeuristic(Order hOrder, Message message){
	if((sentOrder!=null)&&sentOrder.equals(hOrder)){
	    MySystem.err.println("got sentOrder heuristic. Old was:"+sentOrder);
	    if(sentOrder.takeBV(hOrder)){
		MySystem.err.println("got improved sentOrder heuristic");
		senderMsg=message;
		resendOrder=true;
	    }
	}
	if(agent0&&(sent0Order!=null)&&sent0Order.equals(hOrder)){
	    MySystem.err.println("got sent0Order heuristic. Old was:"+sent0Order);
	    if((sent0Order.bestVolume>hOrder.bestVolume)&&
	       (hOrder.bestVolume>0)){
		//bestVolumes[0]=hOrder.bestVolume;
		MySystem.err.println("got improved sentOrder heuristic");
		sent0Order.bestVolume = hOrder.bestVolume;
		sender0Msg=message;
		resend0Order=true;
	    }
	}
    }
    synchronized public void getMessage(Message message){
	Message_Command mc=(Message_Command)message;
	Object param=(Object)mc.getArguments();
	String command=(String)mc.getCommand();
	MySystem.err.println("HEURISTIC-COMPACTOR.got:"+command+":"+param);
	if(command.equals(Commands.cHeuristic)){
	   DOrder hOrder=(DOrder)param;
	    MySystem.err.println("got param="+hOrder+" from:"+mc.getSenderID());
	    getHeuristic(hOrder.order, message);
	}
	Synch_Reply();
    }
}
