/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package mads;
import java.util.*;
import csp.*;
import utils.*;
import parameters.*;
import platform.*;

class HeuristicContainer{
    int agentsNr=0;
    Order order=null;
    AgentID[] defaultAgents=null;
    AgentID[] agents=null;
    Hashtable data=new Hashtable();
    Histories hist=new Histories();
    HeuristicContainer(int agentsNr, AgentID[] defaultAgents){
	this.agentsNr=agentsNr;
	this.defaultAgents=defaultAgents;
	setOrder(new Order());
    }
    //what = String:int
    //return true if modifications appear for heur
    boolean updateHeurHistories(Histories history){
	Hashtable what=new Hashtable();
	boolean result=hist.updateWith(history, what);
	if(result)desactivate(what);
	return result;
    }
    //return true if modifications appear in parameter
    boolean updateParamHistories(Histories history, Hashtable what, 
				 Hashtable changed){
	boolean result=history.updateWith(hist,what);
	return result;
    }
    //return true if modif appear in heur;
    boolean put(AgentID ag, Labeling ldata, int level){
	boolean result=false;
	Iterator it=ldata.iterator();
	while(it.hasNext()){
	    if(put(ag,(Label)it.next(),level)) result=true;
	}
	return result;
    }
    void setOrder(Order o){
	MySystem.err.println("heurs:gets:"+o);
	if(order==null){
	    MySystem.err.println("heurs:prev null");
	    order=(Order)o.clone();
	    placeAgents();
	    return;
	}
	if(History.firstDisablesSecond(order.history,o.history)){
	    MySystem.err.println("heur incoming order old");
	    return;
	}
	if(History.firstDisablesSecond(o.history,order.history)){
	    MySystem.err.println("heur disables order:"+order);
	    resetDisabledOrder(o.changeLevel(order));
	    order=(Order)o.clone();
	    placeAgents();
	}
    }
    void placeAgents(){
	agents=new AgentID[agentsNr];
	int j=0;
	Hashtable h=new Hashtable();
	for(j=0;j<order.sequence.length;j++){
	    agents[j]=order.sequence[j];
	    h.put(agents[j],agents[j]);
	}
	for(int k=0;k<agents.length;k++){
	    if(h.get(defaultAgents[k])!=null)continue;
	    agents[j++]=defaultAgents[k];
	}
    }
    void resetDisabledOrder(int changeLevel){
	MySystem.err.println("heurs:changeOrder:"+changeLevel);
	hist.trimm(changeLevel);
	Iterator it=(Iterator)data.keys();
	while(it.hasNext()){
	    Hashtable[] vls=(Hashtable[])data.get(it.next());
	    for(int k=changeLevel+2;k<=agentsNr;k++){
		vls[k]=null;
	    }
	}
    }
    //here I take everything
    void merge(HeuristicContainer hc, int level){
	print();
	MySystem.err.print("inc:");hc.print();
	hc.setOrder(order.getOLevel(level));
	setOrder(hc.order);
	updateHeurHistories(hc.hist);//...merge
	Iterator it=(Iterator)hc.data.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    Hashtable[] vls=(Hashtable[])hc.data.get(var);
	    for(int k=0;k<=agentsNr;k++){
		if(vls[k]!=null){
		    Iterator itag=(Iterator)vls[k].keys();
		    while(itag.hasNext()){
			AgentID ag=(AgentID)itag.next();
			MHCHistory mh=(MHCHistory)vls[k].get(ag);
		    
			MHCHistory old=getMHCHist(var,k-1,ag);
			if(Label.olderFirstThanSecond(old,mh)){ //true if old null
			    set(mh,var,level,ag);
			}
		    }
		}
	    }
	}
	print();
    }
    void print(){
	MySystem.err.println("heur:order="+order);
	MySystem.err.println("heur:hist="+hist);
	Iterator it=(Iterator)data.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    MySystem.err.println("heur:var="+var+" "+History.toString(hist.geth(var)));
	    Hashtable[] vls=(Hashtable[])data.get(var);
	    for(int k=0;k<=agentsNr;k++){
		if(vls[k]!=null){
		    Iterator itag=(Iterator)vls[k].keys();
		    while(itag.hasNext()){
			AgentID ag=(AgentID)itag.next();
			MHCHistory mh=(MHCHistory)vls[k].get(ag);
			MySystem.err.println("L:"+k+":"+ag+"->"+mh);
		    }
		}
	    }
	}
    }
    void printCrash(){
	System.err.println("heur:order="+order);
	System.err.println("heur:hist="+hist);
	Iterator it=(Iterator)data.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    System.err.println("heur:var="+var+" "+History.toString(hist.geth(var)));
	    Hashtable[] vls=(Hashtable[])data.get(var);
	    for(int k=0;k<=agentsNr;k++){
		if(vls[k]!=null){
		    Iterator itag=(Iterator)vls[k].keys();
		    while(itag.hasNext()){
			AgentID ag=(AgentID)itag.next();
			MHCHistory mh=(MHCHistory)vls[k].get(ag);
			System.err.println("L:"+k+":"+ag+"->"+mh);
		    }
		}
	    }
	}
    }
    Range getRange(String var, int id){
	Hashtable[] vls=(Hashtable[])data.get(var);
	if(vls==null) return null;
	Range result=null;
	for(int k=0;k<=id+1;k++){
	    if(vls[k]==null)continue;
	    Iterator it=vls[k].values().iterator();
	    while(it.hasNext()){
		MHCHistory m=(MHCHistory)it.next();
		if(result!=null)result.restrict(m.proposal);
		else result=(Range)m.proposal.clone();
	    }
	}
	return result;
    }
    void desactivate(Hashtable what){
	Iterator it=(Iterator)what.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    desactivate(var,((IntObject)what.get(var)).i);
	}
    }
    void desactivate(String var, int changeLevel){
	Iterator it=(Iterator)data.keys();
	while(it.hasNext()){
	    Hashtable[] vls=(Hashtable[])data.get(it.next());
	    for(int k=changeLevel+1;k<=agentsNr;k++){
		if(vls[k]==null) continue;
		ArrayList old=new ArrayList();
		Iterator itag=(Iterator)vls[k].keys();
		while(itag.hasNext()){
		    AgentID ag=(AgentID)itag.next();
		    MHCHistory mh=(MHCHistory)vls[k].get(ag);
		    if((mh!=null)&&(mh.disabledBy(var)))
			old.add(ag);
		}
		for(int j=old.size()-1;j>=0;j--){
		    vls[k].remove(old.get(j));
		}
	    }
	}
    }
    boolean getContext(Context c){
	boolean result=false;
	IntObject old=new IntObject(0);
	IntObject taken=new IntObject(0);
	Iterator it=c.keysIterator();
	while(it.hasNext()){
	    String var=(String)it.next();
	    int[] h=c.geth(var);
	    if(h.length==0)continue;
	    //if old or inexistent return -1; if old, set old
	    int changeLevel=hist.getNewAndReturnChangeLevel(var,h,old,taken);
	    if(changeLevel>=0){
		desactivate(var,changeLevel);
		result=true;
	    }
	    if(old.i==0){
		int level=h[h.length-2];
		DVarHistory dv=c.getDV(var);
		if(put(dv,var,level,getAgent(level))) result=true;
	    }
	    //if(taken.i==1) result=true;
	}
	return result;
    }
    AgentID getAgent(int level){
	return agents[level];
    }
    //return true if after new taken in hist, (some labels are disabled)
    boolean takeAnyNew(Context c, IntObject old){
	IntObject taken=new IntObject(0);
	boolean result=false;
	Iterator it=c.keysIterator();
	while(it.hasNext()){
	    String var=(String)it.next();
	    int[] h=c.geth(var);
	    if(h.length<=0) continue;
	    //if old or inexistent return -1; if old, set old
	    int changeLevel=hist.getNewAndReturnChangeLevel(var,h,old,taken);
	    if(changeLevel>=0){
		desactivate(var,changeLevel);
		result=true;
	    }
	    if(taken.i==1)
		result=true;
	}
	return result;
    }
    MHCHistory getMHCHist(String var, int level, AgentID ag){
	Hashtable[] vls=(Hashtable[])data.get(var);
	if((vls==null)||(vls[level+1]==null))return null;
	return (MHCHistory)vls[level+1].get(ag);
    }
    void set(MHCHistory l, String var, int level, AgentID ag){
	Hashtable[] vls=(Hashtable[])data.get(var);
	if(vls==null) data.put(var,vls=new Hashtable[agentsNr+1]);
	if(vls[level+1]==null) vls[level+1]=new Hashtable();
	vls[level+1].put(ag,l);
    }
    boolean put(AgentID ag, Label l, int level){
	IntObject hasOld= new IntObject(0);
	boolean result=false;
	try{
	    result=takeAnyNew(l.context, hasOld);
	    if(hasOld.i==0){
		String var=l.getVariable();
		MHCHistory old=getMHCHist(var,level,ag);
		if(Label.olderFirstThanSecond(old,l)){ //true if old null
		    set(new MHCHistory(l),var,level,ag);
		    result=true;
		}
	    }
	}catch(Exception e){
	    System.err.println("put:"+ag+" label:"+l+" level:"+level);
	    printCrash();
	    MySystem.exit(1);
	}
	return result;
    }
    boolean put(DVarHistory dv, String var, int level, AgentID ag){
	boolean result=false;
	if((dv==null)||(dv.range==null)) return false;
	try{
	    MHCHistory old=getMHCHist(var,level,ag);
	    if(old==null){ //true if old null
		set(new MHCHistory(var,dv),var,level,ag);
		result=true;
	    }
	}catch(Exception e){
	    System.err.println("put:dv="+dv+" var:"+var+" level:"+level+" "+ag);
	    printCrash();
	    MySystem.exit(1);
	}
	return result;
    }
}
