/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package mads;
import java.util.*;
import java.rmi.*;
import csp.*;
import tester.*;
import platform.*;
import parameters.*;
import utils.*;
import hc.*;
import sjavap.*;

public class MHCBroker extends MHC{

    final public static int _getSubscriptionParameters=3;
    final static int FlowThreshold=150;

    int crtState;
    final static int Sstop=0;
    final static int Srunning=1;
    DAccepted foundSolution=null;
    boolean allSolutions=false;
    AgentID lastAgent=null;
    BrokerResult cleanUpCode = null;
    // cost buit to declare solution
    DCost acceptedCost=new DCost();
    int solutionsNr=0;
    int blocksNr=0;
    Context lastBlock=null;
    public MHCBroker(){
	allSolutions=Utils.allSolutions;
	//BrokerServer.protocol=this;
    }
    public String toString(){
	if(MHCAgent.ascendingOrder)
	    return "MADS";
	else return "MADS-BAD-ORDER";
    }
    synchronized public void terminate(){
	crtState=Sstop;
        Synch_Reply();
    }
    final DCost messageCost=(new DCost()).setMessages();
    // search hash mapping AgentID to AgentData
    Hashtable problemByAgent=new Hashtable();
    // search hash mapping String to ArrayList(AgentID)
    Hashtable problemByVariable=new Hashtable();
    // search hash mapping String names to AgentID
    Hashtable problemByAgentName=new Hashtable();
    //(AgentID, dAccepted)
    Hashtable accepted= new Hashtable();
    // endAgents (AgentID)
    ArrayList endAgents=new ArrayList();

    AgentID[] sortedAgents= new AgentID[0];
    // search hash mapping AgentID to position
    Hashtable agentOrder= new Hashtable();
    Object starting_links=new Object();
    boolean searchEnd=false;

    boolean subscriptionNew;
    void getSubscriptionParameters(Message m){
	DSubscription params= (DSubscription) ((Message_Command)m).getArguments();
	MySystem.out.println("agent "+params.name+ " importance " + params.importance+ " complexity "+params.complexity);
	subscriptionNew=subscribe(params.agent,
				  params.variables,
				  params.importance,
				  params.complexity);
    }

    private void printProblemByVariable(Hashtable problemByVariable) {
	MySystem.out.println("Problem by Variable:");
	if(problemByVariable==null){
	    MySystem.out.println("Null problemByVariable");
	    return;
	}
	Iterator keys = (Iterator)problemByVariable.keys();
	while(keys.hasNext()) {
	    String var=(String)keys.next();
	    //MySystem.out.print("Variable:"+var+" for the agents :");
	    ArrayList alist=(ArrayList)problemByVariable.get(var);
	    for(int k=0;k<alist.size();k++) {
		AgentID sa=(AgentID)alist.get(k);
		AgentData ad=(AgentData)problemByAgent.get(sa);
		//if((ad!=null)&&(ad.name!=null)) MySystem.out.print(ad.name+":");
	    }
	    //MySystem.out.println("");
	}
    }

    synchronized public void run() {
	select.thread=Thread.currentThread();
	int subscribed;
        crtState = Srunning;
	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverTypeAndProcedure);
	if(Synch_Wait()==0) return;
	queue.setReceiverType(this, new SubscriptionSelector(),_getSubscriptionParameters);
	MySystem.out.println("MHCBroker:run:_setReceiverTypeAndProcedure:_getSubscriptionParameters:"+agentIDs.length);

	for(subscribed=0; subscribed<agentIDs.length;){
	    select.accept(0,_terminate);
	    select.accept(1, _getSubscriptionParameters);
	    subscriptionNew=false;
	    if(Synch_Wait()==0) return;
	    if(subscriptionNew) {
		MySystem.out.println("MHCBroker:run:subscriptionNew:"+subscribed);
		subscribed++;
	    }else
		MySystem.out.println("MHCBroker:run:not subscriptionNew");
	}
	MySystem.out.println("MHCBroker:run:startSynchronized");
	try{
	    startSynchronized();
	}catch(AgentDeathException e){
	    MySystem.exit(1);
	}
	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiver);
	if(Synch_Wait()==0) return;
	queue.setReceiver(this);

	select.accept(0,_terminate);
	select.call(1,queue,queue._setActionTrigger);
	if(Synch_Wait()==0) return;
	queue.setActionTrigger(new ServerTriggerForInput(genericAgent.server,queue,
							 FlowThreshold,
							 genericAgent.FlowConnectionThreshold));
	while(!searchEnd&&(crtState!=Sstop)){
            select.accept(0,_terminate);
	    select.accept(1,_getMessage);
	    Synch_Wait();
	    if(allSolutions&&(foundSolution!=null)
	       //&&(solutionsNr<2)
	       ){
		askNextSolution();
		foundSolution=null;
		cleanUpCode=null;
	    }
            if(cleanUpCode!=null){
	      cleanUpProtocol(cleanUpCode);
              cleanUpCode=null;
            }
	}
        MySystem.println("End of search");
    }

    private void askNextSolution(){
	DNogood nogood=new DNogood();
	nogood.view=foundSolution.history;
	nogood.cost=(DCost)acceptedCost.clone();
	nogood.rang=0;
	nogood.senderName="Broker";
	int crtLast=nogood.getLastSenderID();
	lastAgent=sortedAgents[crtLast];
	oneWaySend(lastAgent,Commands.cNogood,nogood);
    }

    boolean oneWaySend(AgentID target, String command, DObject params){
        select.accept(0,_terminate);
	select.call(1, genericAgent, genericAgent._sendCommand);
	//MySystem.out.println("Synch_Wait:SendCommand");
	if(Synch_Wait()==0)
            return false;
	//MySystem.out.println("Synch_Wait:SendCommand:");
	genericAgent.sendCommand(command, params, target);
	return true;
    }

    synchronized private void startSynchronized() throws AgentDeathException{
	/*
	problemByAgent=buildProblemByAgent();
	problemByVariable=buildProblemByVariable();
	problemByAgentName=buildProblemByAgentName();
	*/
	printProblemByVariable(problemByVariable);

	reOrder();

	Hashtable outgoingsH=new Hashtable();
	Hashtable incomingsH=new Hashtable();

	AgentID agent;
	Iterator keys;
// 	outgoingsH=new Hashtable();
// 	incomingsH=new Hashtable();
	keys = (Iterator) problemByAgent.keys();
	while (keys.hasNext()){
	    agent = (AgentID) keys.next();
	    outgoingsH.put(agent,getOutGoing(agent));
	    incomingsH.put(agent,getInComing(agent));
	}
	keys = (Iterator) problemByAgent.keys();
	while (keys.hasNext()){
	    agent = (AgentID) keys.next();
	    //DStartSearch params=new DStartSearch("MHC");
	    //params.position=((IntObject)agentOrder.get(agent)).getInt();
	    //try {
	    //oneWaySend(agent, "STARTSEARCH", params);
	    //}catch (RemoteException e){MySystem.err.println("Agent "+((AgentData)problemByAgent.get(agent)).getName()+" not answering! Killing session...");throw new AgentDeathException(e.getMessage());}
	    IncomingAgent[] incomingAgent=(IncomingAgent[])incomingsH.get(agent);
	    DIncomingAgent incoming=new DIncomingAgent(incomingAgent);
	    if(incoming.get().length==0){
		endAgents.add(agent);
		MySystem.out.println("Agent "+((AgentData)problemByAgent.get(agent)).getName()+" is endAgent");
	    }
	    OutgoingAgent[] outgoingAgents=(OutgoingAgent[])outgoingsH.get(agent);
	    DOutgoingAgent outgoing=new DOutgoingAgent(outgoingAgents);
	    DSearch dSearch=new DSearch();
	    dSearch.acceptedReceiver=getAcceptedReceiver(incomingAgent);
	    dSearch.acceptedSenders=getAcceptedSenders(agent,outgoingAgents,incomingsH);
	    dSearch.agentOrder=agentOrder;
	    dSearch.sortedAgents=(Object)sortedAgents;
	    dSearch.problemByAgent=problemByAgent;
	    dSearch.problemByVariable=problemByVariable;
	    DStartLinks dStartLinks=new DStartLinks();
	    dStartLinks.dIncomingAgent=incoming;
	    dStartLinks.dOutgoingAgent=outgoing;
	    dStartLinks.dSearch=dSearch;
	    dStartLinks.position=((IntObject)agentOrder.get(agent)).getInt();
	    //try {
	    if(!oneWaySend(agent, Commands.cStartParameters,dStartLinks))
              break;
	    //}catch (Exception e) {e.printStackTrace();MySystem.err.println("Error register:");MySystem.err.println("    Agent \""+((AgentData)problemByAgent.get(agent)).getName()+"\" cannot get outgoing links");throw new AgentDeathException("Agent death at getting outgoing");}
	}
    }
    synchronized public void getMessage(Message messg){
	Message_Command message=(Message_Command)messg;
	String command=(String)message.getCommand();
	DObject parameters=(DObject)message.getArguments();
	MySystem.out.println("Got:"+command);

	// to ensure a full run at early
	// EMPTYNOGOOD detection
	if(command.equals(Commands.cEmptyNogood)||
	   command.equals(Commands.cFail)){
	    //!!broker.clearSession("Empty nogood");
	    MySystem.println(command+":\n"+parameters);
            searchEnd=true;
            //crtState = Sstop; //not needed since searchEnd is enough
	    if(command.equals(Commands.cFail))
		cleanUpCode = new BrokerResult(2,parameters+"\n Failure");
	    else
		cleanUpCode = new BrokerResult(0,parameters+"\n Empty Nogood");
	    //!!broker.endSolving("Empty nogood:\n"+parameters,0);
            Synch_Reply();
	    return;// null;
	}
	if(command.equals(Commands.cAccepted)) {
	    MySystem.out.println("The end occurs when all the incoming intersect nonempty.\n"+((DAccepted)parameters).toVeryShortString());
	    synchronized(starting_links) {
		if(!searchEnd)
		    searchEnd=receiveAccepted((DAccepted)parameters);
		if(allSolutions)
		    searchEnd=false;
	    }
            Synch_Reply();
	    return;// null;
	}
	if(command.equals("REMOVE_END_AGENT")) {
	    //synchronized(starting_links){removeEndAgent((AgentID)parameters);}
            Synch_Reply();
	    return;// null;
	}
	if(command.equals(Commands.cMyProblem)) {
	    if(subscriptionNew==true)
		MySystem.exit(1);
	    getSubscriptionParameters(messg);
            Synch_Reply();
	    return;
	}
	MySystem.err.println("Unknown command "+command);
        Synch_Reply();
	return;// null;
    }
    // true if end of search
    private boolean receiveAccepted(DAccepted daccepted){
	if(!endAgents.contains(daccepted.agent)) {
	    MySystem.err.println("Accepted do not come from an end Agent:"+daccepted);
	    return false;
	}
	DAccepted dold=(DAccepted)accepted.get(daccepted.agent);
	if((dold!=null)&&(daccepted.olderThan(dold))) {
	    MySystem.out.println("receiveAccepted: older Accepted than:"+dold);
	    return false;
	}
	accepted.put(daccepted.agent,daccepted);
	acceptedCost.updateCost(daccepted.cost);
	if(accepted.size()>=endAgents.size())
	    return testEndOfSearch();
	return false;
    }
    private boolean testEndOfSearch() {
	if(accepted.isEmpty()) {
	    MySystem.err.println("End of search, but empty!");
	    //!!broker.clearSession("No end Agents!!");
	    //!!broker.endSolving("No end Agents!!",0);
	    return true;
	}
	DAccepted dAccepted=new DAccepted();
	dAccepted.agent=genericAgent.getID();
	dAccepted.history=IntersectionOfSolutions();
	if(dAccepted.empty()&&
	   (!dAccepted.vide())) {
	    MySystem.err.println("Empty Accepted!!");
	    return false;
	}
	foundSolution=dAccepted;
        cleanUpCode = new BrokerResult(1,acceptedCost+"\n "+dAccepted);
	blocksNr++;
	MySystem.out.println("Blocks Nr="+blocksNr);
	if((lastBlock!=null)&&(lastBlock.sameAs(dAccepted.history)))
	    return true;
	lastBlock=(Context)dAccepted.history.clone();
	solutionsNr+=lastBlock.getSize();
	MySystem.out.println("Solutions Nr="+solutionsNr);
	MySystem.out.println(dAccepted.toString());
	MySystem.out.println(acceptedCost.toString());
	//!!broker.clearSession("Solved!");
	//!!broker.endSolving(dAccepted.toString()+"\n"+acceptedCost.toString()+"\n",1);
	return true;
    }
    private Context IntersectionOfSolutions() {
	Context view=new Context();
	Iterator it=(Iterator)accepted.keys();
	while(it.hasNext()){
	    MySystem.out.println("Adding solution from accepted");
	    addSolution(view,((DAccepted)accepted.get(it.next())).history);
	}
	return view;
    }
    // solution=(String,DVarHistory)
    private void addSolution(Context view, Context solution) {
	DVarHistory solHist, accHist;
	Iterator it=(Iterator) solution.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    solHist=view.getDV(var);
	    accHist=solution.getDV(var);
	    if(solHist==null)
		view.put(var,(DVarHistory)accHist.clone());
	    else{
		solHist.restrict(accHist);
		view.put(var,solHist);
	    }
	}
    }
    void removeEndAgent(AgentID agent){
	int pos=endAgents.indexOf(agent);
	if(pos<0)
	    MySystem.err.println("Agent not found for removing while pos<0");
	else try{
	    endAgents.remove(pos);
	    accepted.remove(agent);
	}catch(IndexOutOfBoundsException e){
	    MySystem.err.println("Agent not found for removing, Index out of bound exception");
	}
	if(accepted.size()==endAgents.size())
	    testEndOfSearch();
    }


    void sort(AgentData[] ad){
	// sort by importance
	//forall with same importance{
	//  sort by owner
	//     forall with same importance&&owner
	//        sort by complexity
	try {
	    Arrays.sort(ad,new AgentDataImportanceComparator());
	}catch (Exception e){
	    MySystem.err.println("Error while sorting agents by importance");
	}
	// for all subsets with equal cost
	int upperToConsider,lowerToConsider=0;
	while(lowerToConsider<ad.length){
	    int k=lowerToConsider;
	    //MySystem.out.println("sort:lowerToConsider="+k);
	    int crtImportance=ad[k].getImportance();
	    for(k++;;k++){
		if(k>=ad.length)
		    break;
		if(ad[k].getImportance()!=crtImportance)
		    break;
	    }
	    upperToConsider=k-1;
	    //MySystem.out.println("sort:=upperToConsider"+upperToConsider);
	    // building ArrayList parameter
	    ArrayList ordered=new ArrayList(upperToConsider-lowerToConsider+1);
	    for(k=lowerToConsider;k<=upperToConsider;k++)
		ordered.add(ad[k]);
	    AgentData add[];
	    add=sortWithCycles(ordered);
	    // got order
	    for(k=lowerToConsider;k<=upperToConsider;k++){
		ad[k]=add[k-lowerToConsider];
		if(ad[k]==null)
		    MySystem.err.println("sort:null");
	    }
	    lowerToConsider=upperToConsider+1;
	}
	//MySystem.out.println("sort:End");
    }
    private void resetMarks(AgentGraph[] ag, int kk){
	for(int k=0;k<=kk;k++){
	    if(ag[k]==null){
		MySystem.err.println("resetMarks:null:"+k);
	    }else
		ag[k].mark=false;
	}
    }
    AgentData[] sortWithCycles(ArrayList al){
	int k;
	AgentGraph ag[]=new AgentGraph[al.size()];
	//MySystem.out.println("sortWithCycles:size="+ag.length);
	for(k=0;k<ag.length;k++){
	    //MySystem.out.println("sortWithCycles:k="+k);
	    AgentData ad=(AgentData)al.get(k);
	    ag[k]=new AgentGraph(ad);
	    //MySystem.out.println("sortWithCycles:ad="+ad.name);
	    for(int kk=0;kk<k;kk++){
		//MySystem.out.println("sortWithCycles:deal with="+ag[kk].ad.name);
		//those we can inferr to be after
		// if cycles, then this brings suboptimalities
		if(ag[kk].mark){
		    //MySystem.out.println("sortWithCycles:marked="+ag[kk].ad.name);
		    continue;
		}
		if(AgentDataComparator.isBefore(ad,ag[kk].getAD())){
		    //MySystem.out.println("sortWithCycles:before:"+ag[k].ad.name+" to:"+ag[kk].ad.name);
		    ag[k].addLink(ag[kk]);
		    // by transitivity, all the followers follow
		    ag[kk].markFollowers();
		}
		if(AgentDataComparator.isBefore(ag[kk].getAD(),ad)){
		    //MySystem.out.println("sortWithCycles:before:"+ag[kk].ad.name+" to:"+ag[k].ad.name);
		    ag[kk].addLink(ag[k]);
		}
	    }
	    resetMarks(ag,k);
	}
	ArrayList competitors=new ArrayList();
	// get the candidates to first
	for(k=0;k<ag.length;k++){
	    // if no followers
	    if(ag[k].first()){
		//MySystem.out.println("sortWithCycles:among first competitors:"+ag[k].ad.name);
		competitors.add(ag[k]);
		ag[k].mark=true;
	    }
	}
	//MySystem.out.println("sortWithCycles:start sorting");
	// the sorting
	AgentData result[]=new AgentData[ag.length];
	for(k=0;k<ag.length;k++){
	    if(competitors.size()==0){
		//MySystem.out.println("Cycle !!");
		for(int kk=0;kk<ag.length;kk++){
		    if(ag[kk].mark) continue;
		    ag[kk].mark=true;
		    competitors.add(ag[kk]);
		    //MySystem.out.println("sortWithCycles:Cycle broken at:"+ag[kk].ad.name);
		    break;
		}
		if((competitors.size()==0)){
		    //MySystem.err.println("sortWithCycles:Cycle not broken!!");
		    break;
		}
	    }
	    AgentGraph[] tmp=(AgentGraph[])competitors.toArray(new AgentGraph[0]);
	    Arrays.sort(tmp,new AgentGraphComplexityComparator());
	    if(tmp==null){
		MySystem.err.println("sortWithCycles:null tmp!!");
		continue;
	    }
	    if(tmp.length==0){
		MySystem.err.print("sortWithCycles:empty tmp!!");
		continue;
	    }
	    //MySystem.out.print("sortWithCycles:Sorted: ");
	    for(int kk=0;kk<tmp.length;kk++){
		if(tmp[kk]==null){
		    MySystem.err.println("sortWithCycles:tmp["+kk+"]=null!!");
		    continue;
		}
		//MySystem.out.print(tmp[kk].ad.name+" ");
	    }
	    //MySystem.out.println("");
	    result[k]=tmp[0].getAD();
	    //erase links and adds to competitors those that are not marked
	    //MySystem.out.println("sortWithCycles:freeFollowers of:"+tmp[0].ad.name);
	    tmp[0].freeFollowers(competitors);
	    int pos=competitors.indexOf(tmp[0]);
	    if(pos<0){
		MySystem.err.println("Not found:"+tmp[0].ad.name+" "+pos);
	    }else{
		//MySystem.out.println("sortWithCycles:remove"+tmp[0].ad.name+" pos:"+pos);
		competitors.remove(pos);
	    }
	}
	MySystem.err.print("Obtained: ");
	for(int kk=0;kk<result.length;kk++){
	    MySystem.err.print(result[kk].name+" ");
	}
	MySystem.err.println("");
	return result;
    }
    void reOrder(){
	AgentData[] ad;
	int agentsNr;
	ad=(AgentData[]) problemByAgent.values().toArray(new AgentData[0]);
	if(false){ //!! !Utils.setYOrder) {
	    MySystem.err.print("Obtained: ");
	    for(int kk=0;kk<ad.length;kk++){
		MySystem.err.print(ad[kk].name+" ");
	    }
	    MySystem.err.println("");

	    agentsNr=ad.length;
	    MySystem.out.println("Subscribed "+agentsNr+" agent(s)!");
	    agentOrder=new Hashtable(agentsNr);
	    sortedAgents= new AgentID[agentsNr];
	    for(int i=0;i<agentsNr;i++) {
		sortedAgents[i]=ad[i].getAgent();
		IntObject io=new IntObject(i);
		agentOrder.put(sortedAgents[i],io);
		MySystem.out.println("Agent "+ad[i].getName()+" has position "+i);
	    }
	    return;
	}

	sort(ad);
	agentsNr=ad.length;
	/*
	//exchange first and last agent so that the debugged (always last) be first
	AgentData tmp=ad[ad.length-1];
	if(tmp.getName().equals("Agent0")){
	    ad[ad.length-1]=ad[0];
	    ad[0]=tmp;
	}

	tmp=ad[ad.length-2];
	if(tmp.getName().equals("Agent0")){
	    ad[ad.length-2]=ad[0];
	    ad[0]=tmp;
	}

	tmp=ad[ad.length-2];
	if(tmp.getName().equals("Agent2")){
	    ad[ad.length-2]=ad[2];
	    ad[2]=tmp;
	}
	*/
	//----
	AgentData tmp[]=new AgentData[agentsNr];
	if(agentsNr!=ad.length)
	    MySystem.exit(1);
	for(int kkk=0;kkk<agentsNr; kkk++) {
	    int ind=Integer.parseInt(ad[kkk].getName().substring(5));
	    if(ind>=agentsNr)
		MySystem.exit(1);
	    if(MHCAgent.ascendingOrder)
		tmp[ind]=ad[kkk];
	    else
		tmp[agentsNr-1-ind]=ad[kkk];
	}
	for(int kk=0;kk<agentsNr; kk++){
	    ad[kk]=tmp[kk];
	}

	MySystem.out.println("Subscribed "+agentsNr+" agent(s)!");
	agentOrder=new Hashtable(agentsNr);
	sortedAgents= new AgentID[agentsNr];
	for(int i=0;i<agentsNr;i++){
	    sortedAgents[i]=ad[i].getAgent();
	    IntObject io=new IntObject(i);
	    agentOrder.put(sortedAgents[i],io);
	    MySystem.out.println("Agent "+ad[i].getName()+" has position "+i);
	}
	lastAgent=sortedAgents[sortedAgents.length-1];
    }
    ArrayList getAcceptedSenders(AgentID agent,OutgoingAgent[] agents,Hashtable incomingsH){
	ArrayList result=new ArrayList();
	if((agents==null)||(agents.length==0)) return result;
	for(int i=0;i<agents.length;i++){
	    AgentID accRecv=getAcceptedReceiver((IncomingAgent[])incomingsH.get(agents[i].getAgent()));
	    if(agent.equals(accRecv))
		result.add(agents[i].getAgent());
	}
	return result;
    }

    OutgoingAgent[] getOutGoing(AgentID agent){
	OutgoingAgent oAgent[]=new OutgoingAgent[0];
	Hashtable outgoing=new Hashtable();
	Variable svars[]=new Variable[0];
	int pos1,pos2;
	IntObject i1,i2;
	i1=(IntObject)agentOrder.get(agent);
	pos1=i1.getInt();
	AgentData ad=(AgentData) problemByAgent.get(agent);
	if (ad!=null)
	    svars=ad.getVariables();
	else
	    return oAgent;
	int svarsNr=svars.length;
	for(int k=0;k<svarsNr;k++){
	    try {
		String variableCrt=svars[k].getVariable();
		ArrayList alist;
		alist=(ArrayList)problemByVariable.get(variableCrt);
		int vAgentsNr=alist.size();
		for(int a=0;a<vAgentsNr;a++){
		    AgentID sa=(AgentID) alist.get(a);
		    AgentID ag=sa;
		    i2=(IntObject)agentOrder.get(ag);
		    pos2=i2.getInt();
		    if(pos1<pos2){
			//MySystem.out.println("\tVariable "+variableCrt+" agent "+((AgentData)problemByAgent.get(agent)).getName()+" has position "+pos1+" while "+((AgentData)problemByAgent.get(ag)).getName()+" has position "+pos2);
			OutgoingAgent oa;
			oa=(OutgoingAgent)outgoing.get(ag);
			//MySystem.out.println("step1 ");
			if(oa==null){
			    oa=new OutgoingAgent(ag);
			    //MySystem.out.println("step2 ");
			}
			else{
			    //MySystem.out.println("\tAlready existing link from "+((AgentData)problemByAgent.get(agent)).getName()+" to "+((AgentData)problemByAgent.get(ag)).getName());
			}
			oa.insert(variableCrt);
			outgoing.put(ag,oa);
		    }
		}
	    }
	    catch (Exception e){
		MySystem.err.println("PYokooLeader:getOutgoing:Error getting agents list for variable "+svars[k].getVariable());
		MySystem.err.println(e);
		e.printStackTrace();
	    }
	}
	try {
	    oAgent= (OutgoingAgent[]) outgoing.values().toArray(new OutgoingAgent[0]);
	}
	catch (Exception e){
	    MySystem.err.println("PYokooLeader:Error getting list of outgoing");
	    MySystem.err.println(e);
	    e.printStackTrace();
	}
	return oAgent;
    }
    AgentID getAcceptedReceiver(IncomingAgent[] agents){
	if((agents==null)||(agents.length==0)) return null;
	int pos,bP=-1;
	AgentID chosenAgent=null;
	for(int i=0;i<agents.length;i++){
	    pos=((IntObject)agentOrder.get(agents[i].getAgent())).getInt();
	    if(pos>bP){
		bP=pos;
		chosenAgent=agents[i].getAgent();
	    }
	}
	return chosenAgent;
    }
    IncomingAgent[] getInComing(AgentID agent){
	IncomingAgent iAgent[]=new IncomingAgent[0];
	Hashtable incoming=new Hashtable();
	Variable svars[]=new Variable[0];
	int pos1,pos2;
	IntObject i1,i2;
	i1=(IntObject)agentOrder.get(agent);
	pos1=i1.getInt();
	AgentData ad=(AgentData) problemByAgent.get(agent);
	if (ad!=null)
	    svars=ad.getVariables();
	else
	    return iAgent;
	int svarsNr=svars.length;
	for(int k=0;k<svarsNr;k++){
	    try {
		String variableCrt=svars[k].getVariable();
		ArrayList alist;
		alist=(ArrayList)problemByVariable.get(variableCrt);
		int vAgentsNr=alist.size();
		for(int a=0;a<vAgentsNr;a++){
		    AgentID sa=(AgentID) alist.get(a);
		    AgentID ag=sa;
		    i2=(IntObject)agentOrder.get(ag);
		    pos2=i2.getInt();
		    if(pos1>pos2){
			IncomingAgent oa;
			oa=(IncomingAgent)incoming.get(ag);
			if(oa==null)
			    oa=new IncomingAgent(ag);
			incoming.put(ag,oa);
		    }
		}
	    } catch (Exception e){
		e.printStackTrace();
	    }
	}
	try {
	    iAgent= (IncomingAgent[]) incoming.values().toArray(new IncomingAgent[0]);
	}
	catch (Exception e){
	    MySystem.err.println("PYokooLeader"+e);
	    e.printStackTrace();
	}
	return iAgent;
    }

    public boolean subscribe(AgentID agent, Variable variables[], int importance, int complexity){
	int k;
	String agentName="";
	String varcrt;
	AgentData agentData=new AgentData();
	if (!agentData.set(agent,variables,importance,complexity)){
	    MySystem.out.println("Subscription error");
	    return false;
	}
	agentName=agentData.getName();

	boolean resubscrib=false;
	if(problemByAgent.put(agent, agentData)!=null){
	    MySystem.out.println("Resubscribing "+agentName);
	    resubscrib=true;
	}

	if(problemByAgentName.put(agentName, agent)!=null){
	    if(!resubscrib)
		MySystem.out.println("Name conflict on: \""+agentName+"\"");
	}else{
	    if(resubscrib)
		MySystem.out.println("\tThe resubscribtion was with new name: \""+agentName+"\"");
	}
	if(resubscrib){
	    try {
		eraseAgentFromVariables(agent);
	    }catch (Exception e){
		MySystem.err.println("Error erasing agent "+agent+" from variables");
		//clearSession("Broker internal error: Please announce application manager.");
		return false;
	    }
	}
	//MySystem.out.println("Subscribing :"+agentName+" vars:"+variables.length);
	for(k=0;k<variables.length;k++){
	    ArrayList alist;
	    varcrt=variables[k].getVariable();
	    //MySystem.out.println("Add: "+agentName+ " "+ variables[k].getVariable());
	    if(problemByVariable.containsKey(varcrt))
		alist=(ArrayList)problemByVariable.get(varcrt);
	    else
		alist= new ArrayList();
	    alist.add(agent);
	    problemByVariable.put(varcrt,alist);
	}
	return true;
    }

    void eraseAgentFromVariables(AgentID agent){
	int k,l,erasedNr;
	ArrayList[] alist;
	AgentID oldAgent;
	alist=(ArrayList[])(problemByVariable.values().toArray(new ArrayList[0]));
	erasedNr=l=0;
	for(k=0;k<alist.length;k++){
	    //MySystem.out.println(erasedNr+" erased,variable "+k+" restartfrom "+l);
	    int alength;
	    alength=(alist[k]).size();
	    //MySystem.out.println(erasedNr+" erased,variable "+k+" restartfrom "+restartFrom+" arraysize: "+alength);
	    for(l=0;l<alength;l++){
		//MySystem.out.println(erasedNr+" erased,variable "+k+" restartfrom "+restartFrom+" arraysize: "+alength+" agentcrt: "+l);
		oldAgent=(AgentID)alist[k].get(l);
		if(oldAgent.equals(agent)){
		    ((ArrayList)alist[k]).remove(l);
		    erasedNr++;
				//MySystem.out.println("removing agent");
		    alength=(alist[k]).size();
		    l--;
		}
	    }
	}
	MySystem.out.println(erasedNr+" already existing variables were erased");
    }
}
