/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package mads;

import java.io.*;
import java.util.*;
import platform.*;
import parameters.*;

class MHCSelector implements MessageSelector{
    //type of propagates
    Class typeP;
    //type of reorder
    Class typeR;
    //type of ok
    Class typeO;
    //type of winner
    Class typeW;
    int level=-1;
    MHCSelector(int level){
	this.level=level;
	try{
	    typeP=Class.forName("mads.Propagate");
	    typeR=Class.forName("parameters.DOrder");
	    typeO=Class.forName("parameters.DView");
	    typeW=Class.forName("parameters.DWinner");
	}catch(java.lang.ClassNotFoundException e){
	    e.printStackTrace();
	    System.exit(1);
	}
    }
    public boolean accepts(Message_Command message){
	Serializable arguments=message.getArguments();
	String command=(String)message.getCommand();
	if ((command.equals(Commands.cMHC))&&typeP.isInstance(arguments)){
	    if(((Propagate)arguments).level==level)
		return true;
	}
	if ((command.equals(Commands.cOK))&&typeO.isInstance(arguments)){
	    if(((DView)arguments).level==level)
		return true;
	}
	if ((command.equals(Commands.cREORDER))&&typeR.isInstance(arguments)){
	    if(((DOrder)arguments).order.getInterestLevel()==level)
		return true;
	}
	if ((command.equals(Commands.cWinner))&&typeW.isInstance(arguments)){
	    if(((DWinner)arguments).position-1==level)
		return true;
	}
	return false;
    }
}
