/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package mas;

import java.util.*;
import sjavap.*;
import platform.*;
import parameters.*;

class CompactorUpdate implements MessageReceiver, Runnable{

 /**    active object support (needs implements Reply)   **/
 /*********************************************************/
 /**/ Synch_List select = new Synch_List(this);           //
 /**/ synchronized public void Synch_Reply()              //
 /**/   { notify();   }                                   //
 /**/ int now() {return Kernel.kern.currentTime;}         //
 /**/ int Synch_Wait() {                                  //
 /**/   Kernel.kern.Synch_Request(select);                //
 /**/   do{try {wait();} catch(InterruptedException e){}} //
 /**/   while(select.nbEntries!=0);                       //
 /**/   return select.Value; }                            //
 /*********************************************************/

    private MHCAgent MHCscheduler;
    private int variablesNr;
    private DCost localCost=new DCost();
    private int crtState;
    private boolean activeOutput=false;
    //active methods
    final public static int _terminate=2;
    final public static int _setState=3;
    //states
    final static private int Sreceiving=0;
    final static private int SemptyReceiving=2;
    final static private int Sstop=4;

    //privates
    private boolean validUpdate;

    CompactorUpdate(int variablesNr){
	this.variablesNr = variablesNr;
    }

    synchronized public void run() {
	int sWait;
	select.thread=Thread.currentThread();
	crtState=SemptyReceiving;
	for(;;){
	    switch(crtState){
	    case Sstop:
		return;
	    case SemptyReceiving:
		validUpdate=false;
                select.accept(0,_terminate);
		select.accept(1,_getMessage);
		select.accept(2,_setState);
		sWait = Synch_Wait();
		if(sWait==1)
		    if(validUpdate){ //set by getMessage()
			crtState = Sreceiving;
		    }
		break;
	    case Sreceiving:
                select.accept(0,_terminate);
		select.accept(1,_getMessage);
		select.accept(2,_setState);
		if(activeOutput)
		    select.call(3,MHCscheduler,MHCscheduler._getMessage);
		sWait = Synch_Wait();
		if(sWait==3){
		    crtState = SemptyReceiving;
		}
		break;
	    }
	}
    }

    public synchronized void terminate(){
	crtState=Sstop;
        Synch_Reply();
    }

    public synchronized void getMessage(Message message){
	DView mUpdate=(DView)((Message_Command)message).getArguments();
	localCost.incrementMessages(mUpdate.cost);
        Synch_Reply();
    }
}
