/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package mas;
import java.util.*;
import java.awt.Color;
import csp.*;
import platform.*;
import parameters.*;
import utils.*;
import hc.*;
import sjavap.*;

public class MHCAgent extends MHC {
    Splitting engine;
    Agent agent;
    int myID=0;
    int myComputationNum=-2;
    //reorder
    private int[] bestVolumes;//the winner's volume at each level
    //history of current winner
    private int[] volumeHistory;
    //histories of the current winner
    private int sendOrderWH=0;
    //private int send0OrderWH=0;
    private boolean resendWH=false, resend0WH=false;
    Order order, sent0Order, lastHeuristic, sentOrder=new Order();
    //world data
    DIncomingAgent dIncomingAgent;
    DOutgoingAgent dOutgoingAgent;
    //computed by CompactorAccepted
    Context acceptedIntersection;
    private DSearch dSearch;
    AgentID acceptedReceiver;
    int acceptedSendersNr;
    //Number of agents
    int agentsNr=0;
    static float ReorderFactor=1.f;
    //the current positions
    AIHashtable cOrder=new AIHashtable();
    AgentID[] agents,defaultAgents;

    // states
    final static int Sprocessing=0;
    final static int Sstart=1;
    final static int Sannounced=2;
    final static int SwaitEnd=3;
    final static int Sstop=4;
    boolean Snogood=false;
    boolean Ssolution=false;
    int crtState=Sstart;
    String[] variables;
    MHCk[] mHCks;
    MHCk mHCk,mHCinst;
    CompactorAccepted cAccepted;
    HeuristicCompactor heuristicCompactor;
    boolean flowO=true;
    boolean flowI=true;
    boolean flow =true;//flowO&&flow
    //set each time the history of a local variable changes
    //reset each time a solution is sent to mHCinst
    boolean solutionHistoryChanges=false;
    boolean validDiscarded=false; //was a CL or a valid nogood discarded
    final static int FlowOThreshold=100;
    final static int FlowIUThreshold=150;
    final static int FlowILThreshold=100;
    HC hc=new HC();

    AgentID myself;
    String myName;
    boolean endAgent=false;
    boolean changeID=false;
    int AcceptedID=0;
    // a nogood that has to be dispached to mHCinst
    private Message nogoodBuf=null;
    //lastsentNogood
    private Label lastSentNogood=null;
    //Should I resend the  sendOrder
    boolean resendOrder=false;
    boolean resend0Order=false;
    DCost acceptedCost = new DCost();
    //    ArrayList waitedLinks=new ArrayList();
    Hashtable outGoing=new Hashtable();
    Hashtable inComing=new Hashtable();
    //incoming liks just required after addLink (AgentID target:ArrayList var)
    Hashtable lastEstablishedLinks=new Hashtable();
    //with the receipt of a nogood
    ArrayList linksToAdd=new ArrayList();
    Hashtable addedOutgoingLinks = new Hashtable();
    // ((String-var):DVarHistory)
    Histories varHistory=new Histories();
    // (String var)
    ConflictSet conflictingVariables = new ConflictSet();
    final private Range emptyRange = new Range(-2,-5);

    private int post_level;
    private Hashtable post_dependency;
    //set of posts to set;
    private Hashtable posts[];
    //set of variables to clear on level stacks
    private ArrayList toClear[];
    //tables of known instantiations
    Hashtable instantiations[];
    //labels to send
    Labeling newLabeling[];

    //post for setting next state after mHCk
    private int mHCkResult=-10;
    final static int SannouncedN=1;
    final static int SannouncedS=2;
    final static int SannouncedEN=3;
    final static int SannouncedF=4;

    //private data for solutions
    Range[] lastSolution;
    parameters.LabelTable lastSent = new parameters.LabelTable();
    int[] historyIDs;
    int orderIDs=0;
    int order0IDs=0;

    //active procedures
    final public static int _MHCk=3;
    final public static int _getStartParameters=4;
    final public static int _accepted=5;
    final public static int _nogood=6;
    final public static int _addLink=7;
    final public static int _ok=8;
    final public static int _compactors=9;
    final public static int _heuristic=10;
    final public static int _reorder=11;

    public MHCAgent(){}

//                                                            //
/* Here is the procedure for protocol identification          */
//                                                            //
    public String toString(){
	return "MAS";
    }



    //state machine
    synchronized public void run() {
	agent=(Agent)genericAgent;
	myself = genericAgent.getID();
	myName = myself.getName();
        Utils.aggregations=true;
	Utils.agentCost=new DCost();
	select.thread=Thread.currentThread();
	//Kernel.dp2=select;
	int sWait;
	if(!initPhase()){
	    MySystem.err.println("terminated before starting");
	    return; //nothing to Sstop
	}
	MySystem.err.println("got startParameter");
	//now MyID is set
	Utils.MAX_SECV_MSG=this.problem.workAmount;
	init(this.problem);
	MySystem.err.println("Out of init");
	if(crtState!=Sstop){
	    MySystem.err.println("ready to work");
	    crtState=Sstart;
	}else
	    MySystem.err.println("already terminated");
	for(;;){
	    System.err.print(".");
	    if(changeID){
		changeMyID();
		changeID=false;
	    }
	    MySystem.err.println("crtState="+crtState);
	    int dim=0;
	    if(crtState!=Sstop)
		dim=agent.getOutputQueueSize(flow);//if flow, do not force
	    MySystem.err.println("OQS="+dim);
	    if(dim>FlowOThreshold){
		MySystem.err.println("flowO:=false OQS="+dim);
		flowO=false;
	    }else flowO=true;
	    dim=getInputQueueSize();
	    MySystem.err.println("IQS="+dim);
	    if(dim<FlowILThreshold) flowI=true;
	    else if((dim=getInputQueueSize())>FlowIUThreshold){
		MySystem.err.println("flowI:=false");
		flowI=false;
	    }
            if(Snogood&&(crtState==Sannounced)){
                MySystem.err.println("crtstate is nogood");}
	    flow=flowO&&flowI;
	    if(!flow){
		MySystem.err.println("not flowing");
		select.accept(6,_compactors);
	    }
	    switch(crtState){
	    case Sstart:
                engine.initSearch();
		//MySystem.out.println("after init Search");
		Hashtable dependency = new Hashtable();
		if(mHC(dependency)){
		    //MySystem.out.println("after mHC level -1");
		    announceMHC(-1, dependency);
		    if(crtState==Sstop) break;
		    claimOrder();
		    //MySystem.out.println("after mHC level -1--go to processing");
		    crtState=Sprocessing;
		}else{
		    //MySystem.out.println("after mHC level -1's wipe-out");
		    switch(announceEmptyNogood()){
		    case 0://nothing
			//MySystem.out.println("announceEmptyNogood=0");
			//MySystem.exit(1); //debug
			break;
		    case 1://in Sstop
			//MySystem.out.println("announceEmptyNogood=1");
			if(crtState!=Sstop){
			    MySystem.err.println("term non stop");
			    MySystem.exit(2);//debug
			}
			break;
		    case 2://waiting terminated
			crtState=SwaitEnd;
			//MySystem.out.println("announceEmptyNogood=2");
		    }
		    //select.accept(0,_terminate);
		    //Synch_Wait();
		}
		break;
	    case Sprocessing:
		if(engine.emptyLevel(engine.currentDomains)){
		    MySystem.err.println("Empty Processing");
		    MySystem.exit(1);
		}
		select.accept(0,_terminate);
                //if((myID!=0)||tmp_solved)
		if(flow){
		  select.accept(1,_MHCk);
		  select.accept(5,_heuristic);
		  MySystem.err.println("Agent: Sprocessing is flowing");
		}else
		  MySystem.err.println("Agent: Sprocessing is not flowing");
		select.waituntil(2,0);
		select.accept(3,_addLink);
		select.accept(4,_nogood);
		select.accept(6,_reorder,-1);

		sWait = Synch_Wait();
        	MySystem.err.println("Choice="+sWait);
		if((sWait == 5)||(sWait == 6)){
		    do{
			select.accept(0,_reorder);
			select.accept(1,_heuristic);
			select.waituntil(2,0);
			sWait = Synch_Wait();
		    }while((sWait == 0)||(sWait == 1));
		    if(resend0WH)resend0WHistory();
		    if(resendWH) resendWH=false;
		    resendOrder=false;
		    if(resend0Order){
			MySystem.err.print("sent REORDER:"+sent0Order+" to:");
			DOrder msg=new DOrder((Order)sent0Order.clone());
			msg.cost=(DCost)((DCost)Utils.agentCost).clone();
			for(int k=0;k<agentsNr;k++){
			    if(myself.equals(agents[k])){
				if(sendReorder0ToMyself(msg))
				    continue;
				else break;
			    }
			    select.accept(0,_terminate);
			    select.call(1,genericAgent,genericAgent._sendCommand);
			    if(Synch_Wait()==0){
				break;
			    }
			    MySystem.err.print(agents[k]+":");
			    genericAgent.sendCommand(Commands.cREORDER,
						     msg,agents[k]);
			}
			MySystem.err.println("");
			resend0Order=false;
		    }
		    if(crtState==Sstop) continue;
		    claimOrder();
		}
		if(sWait==4) nogoodBuf=null;//discard
		if(sWait==2){
                    int result;
		    MySystem.err.println("Agent Start searching");
		    result = engine.search();
                    //tmp_solved=true;
		    MySystem.err.println("Agent end searching");
            	    //MySystem.out.println("search result="+result);
		    if((result!=0)&&(crtState!=Sstop)){
			crtState=Sannounced;
			if(result>0){
			    Ssolution=true;
			    Snogood=false;
                            MySystem.err.println("Agent announcing solution");
			    switch(announceSolution(// may set sStop
			      (Range[])engine.domains.get(engine.crtConstraint),
			      engine.vIDs)){
			    case 0://nothing
				MySystem.err.println("Agent sol announced done");
				break;
			    case 1://in Sstop
				if(crtState!=Sstop)
				    MySystem.exit(1);//debug
			    }
			}else{
			    Snogood=true;
			    Ssolution=false;
                            MySystem.err.println("Agent announcing nogood");
                            switch(announceNogood()){
			    case 0://nothing
				break;
			    case 1://in Sstop
				if(crtState!=Sstop)
				    MySystem.exit(1);//debug
				break;
			    case 2://waiting terminated
				crtState = SwaitEnd;
			    }
			}
		    }
		}
		if(sWait == 1){
		    if(!claimOrder()) continue;
		    MySystem.err.println("Agent:run will check addLinks");
		    if(performAddLinks()==1){//terminated
			MySystem.err.println("Agent:run check addLinks:terminated");
			if(crtState!=Sstop)
			    MySystem.exit(1);//debug
		    }else{
			MySystem.err.println("Agent:run will build MHCk");
			switch(buildAndSendMHCk()){
			case 0://nothing
			    MySystem.err.println("Agent:run bMHC ret 0");
			    switch(mHCkResult){
			    case Sprocessing:
				MySystem.err.println("Agent:run bMHC->proces");
				crtState=Sprocessing;
				Snogood=false;
				Ssolution=false;
				break;
			    case SannouncedS:
				MySystem.err.println("Agent:run bMHC->annouS in processing");
				MySystem.exit(1);
// 				crtState=Sannounced;
// 				Snogood=false;
// 				Ssolution=true;
 				break;
 			    case SannouncedN:
 				MySystem.err.println("Agent:run bMHC->annouN from processing");
				MySystem.exit(1);
//  				crtState=Sannounced;
//  				Snogood=true;
//  				Ssolution=false;
			    }
			    mHCkResult=-10;
			    break;
			case 1://in Sstop
			    MySystem.err.println("Agent:run bMHC ret stop");
			    if(crtState!=Sstop)
				MySystem.exit(1);//debug
			    break;
			case 2://waiting terminated
			    MySystem.err.println("Agent:run bMHC ret waitend");
			    crtState = SwaitEnd;
			}
		    }
		}
		if(sWait==3)
		    answerToAddLinks();
		//else the MHCk does its work
		break;
	    case Sannounced:
		select.accept(0,_terminate);
		if(flow){
		    select.accept(1,_MHCk);
		    select.accept(2,_accepted);
		    select.accept(4,_heuristic);
		    MySystem.err.println("Agent: Sannounced is flowing");
		}else
		    MySystem.err.println("Agent: Sannounced is not flowing");
		select.accept(3,_addLink);
		select.accept(5,_nogood);
		select.accept(6,_reorder);//May send me to Sprocessing
		sWait = Synch_Wait();
		MySystem.err.println("Announced choice:"+sWait);
		if((sWait == 4)||(sWait == 6)){
		    do{
			select.accept(0,_reorder);
			select.accept(1,_heuristic);
			select.waituntil(2,0);
			sWait = Synch_Wait();
		    }while((sWait == 0)||(sWait == 1));
;
		    if(resend0WH)resend0WHistory();
		    if(resendWH) resendWHistory();
		    if(resendOrder){
			MySystem.err.print("sent REORDER:"+sentOrder+" to:");
			for(int k=myID+1;k<agentsNr;k++){
			    select.accept(0,_terminate);
			    select.call(1,genericAgent,genericAgent._sendCommand);
			    if(Synch_Wait()==0){
				continue;
			    }
			    MySystem.err.print(agents[k]+":");
			    DOrder msg=new DOrder((Order)sentOrder.clone());
			    msg.cost=(DCost)((DCost)Utils.agentCost).clone();
			    genericAgent.sendCommand(Commands.cREORDER,
						     msg,agents[k]);
			}
			MySystem.err.println("");
			resendOrder=false;
		    }
		    if(resend0Order){
			MySystem.err.print("sent REORDER:"+sent0Order+" to:");
			DOrder msg=new DOrder((Order)sent0Order.clone());
			msg.cost=(DCost)((DCost)Utils.agentCost).clone();
			for(int k=0;k<agentsNr;k++){
			    if(myself.equals(agents[k])){
				if(sendReorder0ToMyself(msg))
				    continue;
				else break;
			    }
			    select.accept(0,_terminate);
			    select.call(1,genericAgent,genericAgent._sendCommand);
			    if(Synch_Wait()==0){
				break;
			    }
			    MySystem.err.print(agents[k]+":");
			    genericAgent.sendCommand(Commands.cREORDER,
						     msg,agents[k]);
			}
			MySystem.err.println("");
			resend0Order=false;
		    }
		    if(crtState==Sstop) continue;
		    claimOrder();
		}
		if(sWait == 5){
		    if(nogoodBuf!=null){
			select.call(0,mHCinst,mHCinst._getMessage);
			Synch_Wait();
			mHCinst.getMessage(nogoodBuf);
		    }
		    nogoodBuf=null;
		}
		if(sWait == 1){
		    if(!claimOrder()) continue;
		    MySystem.err.println("Agent.a:run will check addLinks");
		    if(performAddLinks()==1){//terminated
			MySystem.err.println("Agent.a:run check addLinks:terminated");
			if(crtState!=Sstop)
			    MySystem.exit(1);//debug
		    }else{
			MySystem.err.println("Agent.a:run will build MHCk");
			switch(buildAndSendMHCk()){
			case 0://nothing
			    MySystem.err.println("Agent.a:run bMHC ret 0");
			    MySystem.err.println("mHCK->:"+mHCkResult);
			    switch(mHCkResult){
			    case Sprocessing:
				crtState=Sprocessing;
				Snogood=false;
				Ssolution=false;
				break;
			    case SannouncedS:
				crtState=Sannounced;
				Snogood=false;
				Ssolution=true;
 				break;
 			    case SannouncedN:
 				crtState=Sannounced;
 				Snogood=true;
 				Ssolution=false;
			    }
			    mHCkResult=-10;
			    break;
			case 1://in Sstop
			    MySystem.err.println("Agent.a:run bMHC ret stop");
			    if(crtState!=Sstop)MySystem.exit(1);//debug
			    break;
			case 2://waiting terminated
			    MySystem.err.println("Agent.a:run bMHC ret waitend");
			    crtState=SwaitEnd;
			}
			if(Ssolution&&solutionHistoryChanges&&
			   (crtState==Sannounced))//may be Sstop
			    switch(announceSolution(// may set sStop
			      (Range[])engine.domains.get(engine.crtConstraint),
			      engine.vIDs)){
			    case 0://nothing
				MySystem.err.println("Agent sol announced done");
				break;
			    case 1://in Sstop
				if(crtState!=Sstop)
				    MySystem.exit(1);//debug
			    }
		    }
		}
		if((sWait == 2)&&
		   (outGoingAllFinished())&&
		   (lastSolution!=null)&&Ssolution) //checking if exists last solution
		    //if in nogood (!Ssolution)
		    announcePartialSolution();
		if(sWait == 3)
		    answerToAddLinks();
		break;
	    case SwaitEnd:
		select.accept(0,_terminate);
		//may also wait and discard other messages
                select.accept(2,_accepted+MessageQueue.REFUSE);
		select.accept(3,_addLink+MessageQueue.REFUSE);
		select.accept(4,_ok+MessageQueue.REFUSE);
		select.accept(5,_nogood+MessageQueue.REFUSE);
		select.accept(6,_heuristic+MessageQueue.REFUSE);
		select.accept(7,_reorder+MessageQueue.REFUSE);
		Synch_Wait();
		break;
	    case Sstop:
		select.call(0,mHCk,mHCk._terminate);
		Synch_Wait();
		mHCk.terminate();
		//Synch_Reply();

		select.call(0,cAccepted,cAccepted._terminate);
		Synch_Wait();
		cAccepted.terminate();

		select.call(0,heuristicCompactor,
			    heuristicCompactor._terminate);
		Synch_Wait();
		heuristicCompactor.terminate();
		//Synch_Reply();

		for(int k=0;k<agentsNr;k++){
		    select.call(0,mHCks[k],mHCks[k]._terminate);
		    Synch_Wait();
		    mHCks[k].terminate();
		    //Synch_Reply();
		}

		MySystem.err.println("Protocol Terminated");
		return;
	    }
	}
    }

//                                                     //
/* Here are the procedures for initialization          */
//                                                     //

    private boolean sendReorder0ToMyself(DOrder msg){
	select.accept(0,_terminate);
	select.call(1,mHCks[0],mHCks[0]._getMessage);
	if(Synch_Wait()==0) return false;
	Message m=new Message_Command(Commands.cREORDER,msg,myself);
	m.setOtherData(myself,myComputationNum,0);
	mHCks[0].getMessage(m);
	return true;
    }

    //if I should be earlier, I will announce it
    //return false on termination
    private boolean claimOrder(){	
	int k;
	MySystem.err.println("claim order:bestVolumes="+bestVolumesString());
	MySystem.err.println("claim order:Volumes="+toString(engine.volumes));
	MySystem.err.println("claim order:Last Heuristic="+lastHeuristic);
	for(k=-1;k<myID;k++){
	    if(bestVolumes[k+1]<=0) continue;
	    if(engine.volumes[k+1]<bestVolumes[k+1]*ReorderFactor){
		if(engine.volumes[k+1]<=0) continue;
		Order heur=order.getOLevel(k);
		heur.bestVolume=engine.volumes[k+1];
		heur.hW=volumeHistory[k+1];
		if(heur.isIdentical(lastHeuristic)) return true;
		lastHeuristic=heur;
		select.accept(0,_terminate);
		if((k<0)&&myself.equals(defaultAgents[0]))
		    select.call(1,heuristicCompactor,
				heuristicCompactor._getMessage);
		else
		    select.call(1,genericAgent,genericAgent._sendCommand);
		
		if(Synch_Wait()==0) return false;
		MySystem.err.println("claim order:claim="+lastHeuristic);
		DOrder msg=new DOrder(heur);
		msg.cost=(DCost)((DCost)Utils.agentCost).clone();
		if(k>=0){
		    MySystem.err.println("claim order:claim to="+agents[k]);
		    genericAgent.sendCommand(Commands.cHeuristic,msg,agents[k]);
		}else{
		    if(myself.equals(defaultAgents[0])){
			msg.cost=null;
			Message m=new Message_Command(Commands.cHeuristic,msg,myself);
			m.setOtherData(myself,myComputationNum,0);
			heuristicCompactor.getMessage(m);
		    }else
			genericAgent.sendCommand(Commands.cHeuristic,msg,
						 defaultAgents[0]);
		}
		return true;
	    }
	}
	return true;
    }

    private void setDefaultOrder(){
	agentsNr=dSearch.agentOrder.size();
	//defaultAgents = new AgentID[agentsNr];
	agents = new AgentID[agentsNr];
	//Iterator it = (Iterator)dSearch.agentOrder.keys();
	defaultAgents=(AgentID[])((AgentID[])dSearch.sortedAgents).clone();
// 	while(it.hasNext()){
// 	    AgentID agent = (AgentID)it.next();
// 	    IntObject pos=(IntObject)dSearch.agentOrder.get(agent);
// 	    defaultAgents[pos.i]=agent;
// 	}
    }

    OutgoingAgent[] getOutGoing(AgentID agent){
	OutgoingAgent oAgent[]=new OutgoingAgent[0];
	Hashtable outgoing=new Hashtable();
	Variable svars[]=new Variable[0];
	int pos1,pos2;
	pos1=cOrder.getI(agent);
	AgentData ad=(AgentData) dSearch.problemByAgent.get(agent);
	if (ad!=null)
	    svars=ad.getVariables();
	else
	    return oAgent;
	int svarsNr=svars.length;
	for(int k=0;k<svarsNr;k++){
	    try {
		String variableCrt=svars[k].getVariable();
		ArrayList alist;
		alist=(ArrayList)dSearch.problemByVariable.get(variableCrt);
		int vAgentsNr=alist.size();
		for(int a=0;a<vAgentsNr;a++){
		    AgentID ag=(AgentID) alist.get(a);
		    pos2=cOrder.getI(ag);
		    if(pos1<pos2){
			OutgoingAgent oa;
			oa=(OutgoingAgent)outgoing.get(ag);
			if(oa==null){
			    oa=new OutgoingAgent(ag);
			}
			oa.insert(variableCrt);
			outgoing.put(ag,oa);
		    }
		}
	    }
	    catch (Exception e){
		MySystem.err.println("PYokooLeader:getOutgoing:Error getting agents list for variable "+svars[k].getVariable());
		MySystem.err.println(e);
		e.printStackTrace();
	    }
	}
	try {
	    oAgent= (OutgoingAgent[]) outgoing.values().toArray(new OutgoingAgent[0]);
	}
	catch (Exception e){
	    MySystem.err.println("PYokooLeader:Error getting list of outgoing");
	    MySystem.err.println(e);
	    e.printStackTrace();
	}
	return oAgent;
    }

    private IncomingAgent[] getInComing(AgentID agent){
	IncomingAgent iAgent[]=new IncomingAgent[0];
	Hashtable incoming=new Hashtable();
	Variable svars[]=new Variable[0];
	int pos1,pos2;
	pos1=cOrder.getI(agent);
	AgentData ad=(AgentData) dSearch.problemByAgent.get(agent);
	if (ad!=null)
	    svars=ad.getVariables();
	else
	    return iAgent;
	int svarsNr=svars.length;
	for(int k=0;k<svarsNr;k++){
	    try {
		String variableCrt=svars[k].getVariable();
		ArrayList alist;
		alist=(ArrayList) dSearch.problemByVariable.get(variableCrt);
		int vAgentsNr=alist.size();
		for(int a=0;a<vAgentsNr;a++){
		    AgentID ag=(AgentID) alist.get(a);
		    pos2=cOrder.getI(ag);
		    if(pos1>pos2){
			IncomingAgent oa;
			oa=(IncomingAgent)incoming.get(ag);
			if(oa==null)
			    oa=new IncomingAgent(ag);
			incoming.put(ag,oa);
		    }
		}
	    } catch (Exception e){
		e.printStackTrace();
	    }
	}
	try {
	    iAgent= (IncomingAgent[]) incoming.values().toArray(new IncomingAgent[0]);
	}
	catch (Exception e){
	    MySystem.err.println("PYokooLeader"+e);
	    e.printStackTrace();
	}
	return iAgent;
    }

    private void getRelatedAgents(DSearch dSearch){
	Hashtable outgoingsH=new Hashtable();
	Hashtable incomingsH=new Hashtable();
	Iterator keys = (Iterator) dSearch.problemByAgent.keys();
	while (keys.hasNext()){
	    AgentID agent = (AgentID) keys.next();
	    outgoingsH.put(agent,getOutGoing(agent));
	    incomingsH.put(agent,getInComing(agent));
	}
	IncomingAgent[] incomingAgent=(IncomingAgent[])incomingsH.get(myself);
	OutgoingAgent[] outgoingAgents=(OutgoingAgent[])outgoingsH.get(myself);
	dIncomingAgent=new DIncomingAgent(incomingAgent);
	dOutgoingAgent=new DOutgoingAgent(outgoingAgents);
    }

    private int getMyPosition(Order order){
	int k;
	if((order==null)||(order.sequence==null)){
	    MySystem.err.println("got:"+order);
	    MySystem.exit(1);
	}
	if((myself==null)){
	    MySystem.err.println("myself:"+myself);
	    MySystem.exit(1);
	}
	Hashtable h=new Hashtable();
	for(k=0;k<order.sequence.length;k++){
	    if(myself.equals(order.sequence[k])) return k;
	    h.put(order.sequence[k],myself);
	}
	if((defaultAgents==null)){
	    MySystem.err.println("defaultAgents:"+defaultAgents);
	    MySystem.exit(1);
	}
	MySystem.err.println("defaultAgents:"+defaultAgents[0]);
	for(int j=0;j<defaultAgents.length;j++){
	    if(h.get(defaultAgents[j])==null){
		if(myself.equals(defaultAgents[j])) return k;
		else k++;
	    }
	}
	return -1;
    }

    private void setOrder(Order order){
	int i;
	MySystem.err.println("set order="+order);
	//dIncomingAgent=dsl.dIncomingAgent;dOutgoingAgent=dsl.dOutgoingAgent;
	//cOrder.setCOrder((Hashtable)dSearch.agentOrder.clone());
	cOrder.setCOrder(new Hashtable());
	for(i=0;i<order.sequence.length;i++){
	    agents[i]=order.sequence[i];
	    cOrder.put(agents[i],new IntObject(i));
	}
	for(int j=0;j<agents.length;j++){
	    if(cOrder.getIO(defaultAgents[j])!=null)continue;
	    agents[i]=defaultAgents[j];
	    cOrder.put(agents[i],new IntObject(i));
	    i++;
	}
	int newID=cOrder.getI(myself);
	if(newID!=myID) changeID=true;
	myID=newID;
	if(heuristicCompactor!=null)
	    heuristicCompactor.myID=myID;
	//changeMyID(cOrder.getI(myself)); //sets myID
	getRelatedAgents(dSearch);
	inComing.clear();outGoing.clear();
	registerInComing(dIncomingAgent.get());
	registerOutGoing(dOutgoingAgent.get());
    }

    private boolean initPhase(){
	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverTypeAndProcedure);
	if(Synch_Wait()==0) return false;
	queue.setReceiverType(this,
			      new CommandSelector(Commands.cStartParameters),
			      _getStartParameters);

	//MySystem.out.println("_setReceiverTypeAndProcedure:StartParameters");

	DSubscription myProblem=new DSubscription(genericAgent.getID(),
						  problem.getVariables(),0,
						  problem.getComplexity(),
						  agent.getID().getName());
	select.accept(0,_terminate);
	select.call(1,genericAgent,genericAgent._sendCommand);
	if(Synch_Wait()==0) return false;
	genericAgent.sendCommand(Commands.cMyProblem,
				 myProblem,
				 agent.getBrokerID());

	//MySystem.out.println("send "+Commands.cMyProblem+" parameters");

	select.accept(0,_terminate);
	select.accept(1,_getStartParameters);
	if(Synch_Wait()==0) return false;
	MySystem.out.println("End of InitPhase");
	return true;
    }

    //called from run when changeID is set
    private void changeMyID(){
	if(mHCinst==mHCks[myID])return;
	select.call(1,mHCinst,mHCinst._setInstantiation);
	Synch_Wait();
	int k=mHCinst.getLevel();
	Order pOrder=order.getOLevel(k);
	pOrder.hW=volumeHistory[k+1];
	pOrder.bestVolume=bestVolumes[k+1];
	mHCinst.setInstantiation(pOrder,false);mHCinst.Synch_Reply();
	//myID=newID;
	mHCinst=mHCks[myID];
	select.call(1,mHCinst,mHCinst._setInstantiation);
	Synch_Wait();
	pOrder=(Order)order.clone();
	pOrder.hW=volumeHistory[k+1];
	pOrder.bestVolume=bestVolumes[k+1];
	mHCinst.setInstantiation(pOrder,true);mHCinst.Synch_Reply();
    }

    private void init(Problem problem){
	engine=new Splitting(agentsNr,problem, this);
	engine.setPosition(myID);
	variables=engine.variables;

	sent0Order=new Order(new AgentID[1],new int[2],-1,0);
	sent0Order.sequence[0]=defaultAgents[0];
	sent0Order.history[0]=-1;
	sent0Order.history[1]=-1;
	order=(Order)sent0Order.clone();

	hc.setConstraints(engine.constraints);
	hc.order=engine.constraintsID;
        hc.constraintsNr=engine.constraintsNr;
	mHCk=new MHCk(this, -1, engine.variablesNr, myComputationNum,queue);
        new Thread(mHCk).start();
	int k;

	mHCks=new MHCk[agentsNr];
	for (k=0;k<agentsNr;k++){
	    mHCks[k]=new MHCk(this, k, engine.variablesNr, myComputationNum,queue);
	    mHCks[k].set(myself,defaultAgents);
	    if(k==myID){
		Order pOrder=order.getOLevel(k);
		pOrder.hW=0;
		pOrder.bestVolume=-1;
		mHCks[k].setInstantiation(pOrder,true);
	    }
	    new Thread(mHCks[k]).start();
	}
	mHCinst=mHCks[myID];
	//new MHCk(this, k, engine.variablesNr,true, myComputationNum,queue);
	//new CompactorAccepted(this, outGoing.size(), myComputationNum);
	cAccepted=new CompactorAccepted(this, acceptedSendersNr, myComputationNum);
	new Thread(cAccepted).start();

	heuristicCompactor=
	    new HeuristicCompactor(this, myComputationNum,
				   myself.equals(defaultAgents[0]));
	heuristicCompactor.myID=myID;
	new Thread(heuristicCompactor).start();

	bestVolumes=new int[agentsNr+1];
	volumeHistory=new int[agentsNr+1];
	posts=new Hashtable[agentsNr];
	instantiations=new Hashtable[agentsNr];
	toClear=new ArrayList[agentsNr];
	newLabeling=new Labeling[agentsNr];
	for(k=0;k<agentsNr;k++){
	    posts[k]=new Hashtable();
	    instantiations[k]=new Hashtable();
	    toClear[k]=new ArrayList();
	    newLabeling[k]=new Labeling();
	    bestVolumes[k]=-1;
	    volumeHistory[k]=0;
	}

	//-----From here on, one may receive _terminate----
	//System.out.println("Agent Sets Queues:");

	//select.call(0,platform,platform._setReceiver);
	//Synch_Wait();//platform.setReceiver(mHCk);
	select.call(1,queue,queue._setReceiverType);
	select.accept(0,_terminate);
        if(Synch_Wait()==0) return;
	queue.setReceiverType(mHCk, new MHCSelector(-1));

	for (k=0;k<agentsNr;k++){
            select.accept(0,_terminate);
	    select.call(1,queue,queue._setReceiverType);
	    if(Synch_Wait()==0) return;
	    queue.setReceiverType(mHCks[k],
				 new MHCSelector(k));
	}
	//System.out.println("Agent Sets Queues1:");

	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverTypeAndProcedure);
	if(Synch_Wait()==0) return;
	queue.setReceiverType(this,
			      new CommandSelector(Commands.cNogood),
			      _nogood);

	//System.out.println("Agent Sets Queues2:");

	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverType);
	if(Synch_Wait()==0) return;
	queue.setReceiverType(cAccepted,
			      new CommandSelector(Commands.cAccepted));

	//System.out.println("Agent Sets Queues3:");

	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverTypeAndProcedure);
	if(Synch_Wait()==0) return;
	queue.setReceiverType(this,
			      new CommandSelector(Commands.cAddLink),
			      _addLink);

	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverType);
	if(Synch_Wait()==0) return;
	queue.setReceiverType(heuristicCompactor,
			      new CommandSelector(Commands.cHeuristic));

//  	select.accept(0,_terminate);
//  	select.call(1,queue,queue._setReceiverTypeAndProcedure);
//  	if(Synch_Wait()==0) return;
//  	queue.setReceiverType(this,
//  			      new CommandSelector(Commands.cREORDER),
//  			      _reorder);

	select.accept(0,_terminate);
	select.call(1,queue,queue._setActionTrigger);
	if(Synch_Wait()==0) return;
	queue.setActionTrigger(new CompactorTriggerForInput(this,queue,
							    FlowILThreshold,
							    FlowIUThreshold));

	select.accept(0,_terminate);
	select.call(1,queue,queue._setActionTrigger);
	if(Synch_Wait()==0) return;
	queue.setActionTrigger(new ServerTriggerForInput(agent.server,queue,
							 FlowIUThreshold,
							 agent.FlowConnectionThreshold));

	select.accept(0,_terminate);
	select.call(1,agent.outQueue,agent.outQueue._setActionTrigger);
	if(Synch_Wait()==0) return;
	agent.outQueue.setActionTrigger(new CompactorTriggerForOutput(this,agent.outQueue,
							    FlowOThreshold));
	for(int a=0;a<agentsNr;a++){
	    Order pOrder=(Order)order.clone();
	    pOrder.hW=0;
	    pOrder.bestVolume=-1;
	    mHCks[a].setPost(new Hashtable(),pOrder);
	}
	Order pOrder=(Order)order.clone();
	pOrder.hW=0;
	pOrder.bestVolume=engine.volumes[0];
	mHCk.setPost(new Hashtable(),pOrder);
	if(myself.equals(defaultAgents[0])){
	    bestVolumes[0]=engine.volumes[0];
	    sent0Order.bestVolume=-1;
	    sent0Order.hW=0;//=send0OrderWH;

	    DWinner msgw=new DWinner(new Order());
	    msgw.cost=(DCost)((DCost)Utils.agentCost).clone();
	    msgw.position=0;
	    msgw.volume=bestVolumes[0]; msgw.history=0;

	    Order heur=new Order(new AgentID[0], new int[0], bestVolumes[0],
			    0);

	    select.call(0,heuristicCompactor,
			heuristicCompactor._getSents);
	    Synch_Wait();
	    //heuristicCompactor.getSents(null,sent0Order.getOHLevel(-1));
	    heuristicCompactor.getSents(null,heur);
	    MySystem.err.print("sent REORDER:"+sent0Order+" to:");
	    for(int j=1;j<agentsNr;j++){
// 		select.accept(0,_terminate);
// 		select.call(1,genericAgent,genericAgent._sendCommand);
// 		if(Synch_Wait()==0) return;
// 		MySystem.err.print(defaultAgents[j]+":");
// 		DOrder msg=new DOrder((Order)sent0Order.clone());
// 		msg.cost=(DCost)((DCost)Utils.agentCost).clone();
// 		genericAgent.sendCommand(Commands.cREORDER,
// 					 msg,
// 					 defaultAgents[j]);

		select.accept(0,_terminate);
		select.call(1,genericAgent,genericAgent._sendCommand);
		if(Synch_Wait()==0) return;
		MySystem.err.print(defaultAgents[j]+":");
		genericAgent.sendCommand(Commands.cWinner,
					 msgw,
					 defaultAgents[j]);
	    }
	    MySystem.err.println("");
	}

	MySystem.out.println("End of init");
    }

    MHCk getMHCk(int level){
	if(level<0) return mHCk;
	if(level==myID) return mHCinst;
	return mHCks[level];
    }

    int getInputQueueSize(){
	return queue.size();
    }

//                                                 //
/* Here are the procedures for color messages      */
//                                                 //


    synchronized void createColorMatrix(String var1, String var2, int sizeX, int sizeY) {
	if(!Utils.sendingColors)
	    return;
        if(crtState==Sstop)
          return;
	select.accept(0,_terminate);
	select.call(1,agent,agent._createColorMatrix);
	//MySystem.err.println("Agent send color Matrix1");
	if(Synch_Wait()==0){
	    //MySystem.err.println("Agent terminated sending color");
	    return;
	}
	//MySystem.err.println("Agent sent color");
	agent.createColorMatrix(var1, var2, sizeX, sizeY);
    }

    synchronized void createColorMatrix(int id, String var1, String var2, int sizeX, int sizeY) {
	if(!Utils.sendingColors)
	    return;
        if(crtState==Sstop)
          return;
	select.accept(0,_terminate);
	select.call(1,agent,agent._createColorMatrix);
	//MySystem.err.println("Agent send color Matrix2");
	if(Synch_Wait()==0){
	    //MySystem.err.println("Agent terminated sending color");
	    return;
	}
	//MySystem.err.println("Agent sent color");
	agent.createColorMatrix(id, var1, var2, sizeX, sizeY);
    }

    synchronized void setColor(String var1,
                                      String var2,
                                      int sizeX, int sizeY,
                                      int sizeX2, int sizeY2,
                                      Color c1, Color c2){
	if(!Utils.sendingColors)
	    return;
        if(crtState==Sstop)
          return;
	select.accept(0,_terminate);
	select.call(1,agent,agent._setColor);
	//MySystem.err.println("Agent send colorSet 1");
	if(Synch_Wait()==0){
	    //MySystem.err.println("Agent terminated sending color");
	    return;
	}
	//MySystem.err.println("Agent sent color");
	agent.setColor(var1, var2, sizeX, sizeY,
                        sizeX2, sizeY2, c1, c2);
    }

    synchronized void setColor(String var1,
                                      String var2,
				      int table[][],
                                      int sizeX, int sizeY,
                                      int sizeX2, int sizeY2,
				      int destX, int destY,
                                      Color c1, Color c2,
				      Color color0, Color oldColor0){
	if(!Utils.sendingColors)
	    return;
        if(crtState==Sstop)
          return;
	select.accept(0,_terminate);
	select.call(1,agent,agent._setColor);
	//MySystem.err.println("Agent send colorSet 2");
	if(Synch_Wait()==0){
	    //MySystem.err.println("Agent terminated sending color");
	    return;
	}
	//MySystem.err.println("Agent sent color");
	agent.setColor(var1, var2, table, sizeX, sizeY,
                        sizeX2, sizeY2, destX, destY,
		       c1, c2, color0,oldColor0);
    }

    synchronized void setColor(String var1,
                                      String var2,
                                      Range[] size,
				      Range[] oldsize,
                                      Color c1,
				      Color color0){
	if(!Utils.sendingColors)
	    return;
        if(crtState==Sstop)
          return;
	select.accept(0,_terminate);
	select.call(1,agent,agent._setColor);
	//MySystem.err.println("Agent send colorSet 3");
	if(Synch_Wait()==0){
	    //MySystem.err.println("Agent terminated sending color");
	    return;
	}
	//MySystem.err.println("Agent sent color");
	agent.setColor(var1, var2, size, oldsize, c1, color0);
    }
    //---------------GENERAL PROCEDURES---------------------


/*functions for asking if an agent wants a certain or any of a set of variables  */


    private boolean has(AgentID agent, String variable){
	Variable[] svars=((AgentData)dSearch.problemByAgent.get(agent)).getVariables();
	for(int k=0;k<svars.length;k++){
	  if(variable.equals(svars[k].getVariable()))
	    return true;
	}
	return false;
    }

    private boolean hasAny(AgentID agent, String[] variables){
	Variable[] svars=((AgentData)dSearch.problemByAgent.get(agent)).getVariables();
	for(int k=0;k<svars.length;k++){
	    for(int kk=0;kk<variables.length;kk++){
		if(variables[kk].equals(svars[k].getVariable()))
		    return true;
	    }
	}
	return false;
    }


//                                                          //
/* Here are the procedures for getting the history          */
//                                                          //

    int[] getHistory(String var){
	return varHistory.geth(var);
    }

    int[] getHistory(int varID, int level){
	int[] hist=getHistory(engine.variables[varID]);
	if(hist==null) return null;
	int k;
	for(k=0;k<hist.length;k++,k++)
	    if(hist[k]>level)
		break;
	int[] result=new int[k];
	for(k--;k>=0;k--)
	    result[k]=hist[k];
	return result;
    }

    int[] getHistory(String var, int level){
	int[] hist=getHistory(var);
	if(hist==null)
	    return null;
	int k;
	for(k=0;k<hist.length;k++,k++)
	    if(hist[k]>level)
		break;
	int[] result=new int[k];
	for(k--;k>=0;k--)
	    result[k]=hist[k];
	return result;
    }

//                                                //
/* The labels are always resent                   */
//                                                //
    //    private boolean sameAsIncoming(Range domain, String variable){return false;}

    private boolean sameAsIncoming(Range domain, int varID){
	if(myID==0)
	    return false;
	Range prev=getInstantiation(variables[varID],myID-1);
	    //engine.mHCks[myID-1][varID].instantiation;
	if(prev==null)
	    return false;
	if(domain.different(prev))
	    return false;
	return true;
    }

    private boolean outGoingAllFinished(){
	return (acceptedSendersNr==0)||
	    (acceptedIntersection!=null);
    }

//                                                //
/* Building the solution to announce              */
//                                                //

    private Context IntersectionOfSolutions(){
	Context view=new Context();
	addInternalSolution(view);
	addAcceptedSolution(view);
	return view;
    }

    private void addAcceptedSolution(Context view){
 	DVarHistory solHist, outHist;
	if(acceptedSendersNr==0)return;
	if(acceptedIntersection==null) MySystem.exit(1);
 	Iterator it=(Iterator) acceptedIntersection.keys();
 	while(it.hasNext()){
 	    String var=(String)it.next();
 	    solHist=view.getDV(var);
 	    outHist=acceptedIntersection.getDV(var);
 	    if(solHist==null){
		//MySystem.err.println("add inc acc:"+outHist);
 		view.put(var,(DVarHistory)outHist.clone());
 	    }else{
		//MySystem.err.println("add inc acc:"+outHist);
		//MySystem.err.println("to inc acc:"+solHist);
 		solHist.restrict(outHist);
		view.put(var,solHist);
		//MySystem.err.println("obtain acc:"+solHist);
 	    }
 	}
    }

    // add the personal solutions with the incoming history
    // the parameter is empty at input
    private void addInternalSolution(Context view){
	String var;
	DVarHistory dVarHistory,oldHist;
	if(lastSolution==null)
	    MySystem.exit(1);
	for(int k=0; k<lastSolution.length; k++){
	    var=engine.variables[k];
	    dVarHistory=lastSent.getInst(var);
	    if(dVarHistory==null){
		Range r=getInstantiation(var,myID-1);
		int[] hist=varHistory.geth(var);
		dVarHistory=new DVarHistory(r,hist);
	    }else
		dVarHistory=(DVarHistory)dVarHistory.clone();
	    ////dVarHistory=new DVarHistory(lastSolution[k]);
	    ////dVarHistory.history=buildNewHistory(var,k);
	    //MySystem.out.println("Adding "+var+"=["+dVarHistory+"] to internal solution");
	    if(dVarHistory==null){
		MySystem.err.println("DVarH not fond for Accepted");
		MySystem.exit(1);
	    }
	    view.put(var,dVarHistory);
	}
    }

    private boolean getOrder(Order incOrder){
	int level=incOrder.getInterestLevel();
	return getOrder(incOrder,level);
    }
    private boolean getOrder(Order incOrder, int level){
	MySystem.err.println("received order="+incOrder);
	MySystem.err.println("old order="+this.order);
	Order order=this.order.getOLevel(level);
	MySystem.err.println("old order level="+order+"  level="+level);
	if(History.firstDisablesSecond(order.history,incOrder.history))
	    return false;
	//the level whose heuristic is changed
	int vLevel=level+1;//incOrder.getInterestLevel()+1;
	if(History.firstDisablesSecond(incOrder.history,order.history)){
	    int k=History.changeLevel(order.history,incOrder.history);
	    this.order=incOrder;
	    sentOrder=(Order)this.order.clone();sentOrder.bestVolume=-1;
	    //if(vLevel>=0) //no need, -1 cannot arrive here disabling
	    bestVolumes[vLevel]=incOrder.bestVolume;
	    volumeHistory[vLevel]=incOrder.hW;
	    for(int j=vLevel+1;j<agentsNr;j++){
		bestVolumes[j]=-1;
		volumeHistory[j]=0;
	    }
	    sendOrderWH=0;
	    resetOrderDependentHistory(k);
	}else{
	    if((vLevel>=0)&&incOrder.giveBV(volumeHistory[vLevel],bestVolumes[vLevel])){
		//this.order.bestVolume=incOrder.bestVolume;
		volumeHistory[vLevel]=incOrder.hW;
		bestVolumes[vLevel]=incOrder.bestVolume;
	    }
	}
	MySystem.err.println("best volumes="+bestVolumesString());
	MySystem.err.println("obtained order="+this.order);
	return true;
    }

    private String toString(int[] bestVolumes){
	String s="";
	for(int j=0;j<bestVolumes.length;j++)
	    s=s+";"+bestVolumes[j]+":"+volumeHistory[j];
	return s;
    }
    private String bestVolumesString(){
	return toString(bestVolumes);
    }

    private void resetOrderDependentHistory(int changeLevel){
	MySystem.err.println("resetOrderDependentHistory="+changeLevel);
	//related agents;MHCinst;myID
	setOrder(order);
	//clear posts and set orderScheduler
	resetPosts(changeLevel);
	//trimm histories and clear instantiations
	cleanHistory(changeLevel);
	//clear lastSent
	clearSolutions();
	//prepare levels and currentDomains; clear search
	resetConflictingVariables();
	engine.setOrderChange(myID,changeLevel);
	crtState=Sprocessing;Ssolution=Snogood=false;
    }

    //clear lastSent
    private void clearSolutions(){
	lastSent.clear();
	lastSolution=null;
	historyIDs=null;
	orderIDs=0;
    }

    //trimm histories and clear instantiations
    private void cleanHistory(int changeLevel){
	ArrayList disabVar=varHistory.trimm(changeLevel);
	checkVarHistory();
	for(int k=changeLevel+1;k<agentsNr;k++)
	    clearInsts(k,disabVar);
    }

    //clear posts and set orderScheduler
    private void resetPosts(int changeLevel){
	for(int k=changeLevel+1;k<agentsNr;k++) {
	    Order pOrder=order.getOLevel(k);
	    pOrder.hW=volumeHistory[k+1];
	    pOrder.bestVolume=bestVolumes[k+1];
	    mHCks[k].clearPostTellOrder(pOrder,changeLevel);
	}
    }

    private void updateSentOrder(){
	AgentID winner;
	if(myID>=agentsNr-1){
	    sentOrder=(Order)order.clone();
	    return;
	}
	if(sentOrder.sequence.length<myID+2)winner=agents[myID+1];
	else winner=sentOrder.sequence[myID+1];
	MySystem.err.println("Reorder Got:"+order+"+"+winner+":pos:"+(myID+1));
	Order newOrder=buildOrder(order,winner,myID+1);
	sentOrder=newOrder;
	MySystem.err.println("Reorder Result:"+newOrder);
    }
    //compute reorder
//     private boolean updateSentOrder(Range[] domain){
// 	AgentID winner;
// 	if(myID>=agentsNr-1){
// 	    //bestVolumes[myID+1]=0;
// 	    sentOrder=(Order)order.clone();
// 	    return false;
// 	}
// 	bestVolumes[myID+1]=getVolume(agents[myID+1],domain);
// 	winner=agents[myID+1];
// 	for(int k=myID+2;k<agentsNr;k++){
// 	    int vol=getVolume(agents[k],domain);
// 	    if(bestVolumes[myID+1]>vol){
// 		bestVolumes[myID+1]=vol;
// 		winner=agents[k];
// 	    }
// 	}
// 	//no not change the winner
// 	if(sentOrder.sequence.length<myID+2)winner=agents[myID+1];
// 	else winner=sentOrder.sequence[myID+1];
// 	MySystem.err.println("Reorder Got:"+order+"+"+winner+":pos:"+(myID+1));
// 	Order newOrder=buildOrder(order,winner,myID+1);
// 	if(newOrder==null){
// 	    sentOrder=(Order)order.clone();
// 	    return false;
// 	}
// 	sentOrder=newOrder;
// 	MySystem.err.println("Reorder Result:"+newOrder);
// 	//return true;
// 	return false;
//     }

    //estimate the volume of that agent
    private int getVolume(AgentID ag, Range[] domains){
	Variable[] svars=((AgentData)dSearch.problemByAgent.get(ag)).getVariables();
	int vol=getRangeEstimate(svars[0].getVariable(),domains);
	for(int k=1;k<svars.length;k++)
	    vol*=getRangeEstimate(svars[k].getVariable(),domains);
	return vol;
    }

    private int getRangeEstimate(String var, Range[] domains){
	int vID=getID(var);
	if(vID>=0) return domains[vID].size();
	//Range r=getInstantiation(var,myID-1);
	//if(r!=null) return r.size();
	return engine.initialDomains[0].size();
    }

    //build
    private Order buildOrder(Order order, AgentID winner, int pos){
	Order result;
	int k;
// 	if(false&&(winner==agents[pos])){
// 	    if(sentOrder.bestVolume == bestVolumes[myID+1])
// 		return null;
// 	    result=(Order)order.clone();
// 	    return result;
// 	}
	//agents[pos]=winner;
	AgentID[] seq=new AgentID[pos+1];
	for(k=0;k<pos;k++)
	    seq[k]=agents[k];
	seq[pos]=winner;
	int[] hist=new int[order.history.length+2];
	for(k=0;k<order.history.length;k++)
	    hist[k]=order.history[k];
	hist[k++]=myID;
	hist[k]=orderIDs;
//	result=new Order(seq,hist,bestVolumes[myID+1],volumeHistory[myID+1]);
	result=new Order(seq,hist,-1,-1);
	return result;
    }

//                                                     //
/* Here is the procedure for solution announcement     */
//                                                     //

 

    //called only from run (Splitting,...)
    private int announceSolution(Range[] domain, Hashtable vIDs){
	if(engine.emptyLevel(domain)) MySystem.exit(2);
	MySystem.err.println("\n\n***************\n");
	printSolution(domain);
        boolean differences[]=new boolean[domain.length];

        // first solution report
        if (lastSolution==null)
	    initLastSolution(domain, differences);
	else getSolutionDifferences(domain, differences);

	buildLastSent(differences, domain);
        AgentID agent;
	//new instantiation
	updateSentOrder();
	volumeHistory[myID+1]=++sendOrderWH;
	if(sentOrder.sequence.length>=myID+2)
	    bestVolumes[myID+1]=
		getVolume(sentOrder.sequence[myID+1],domain);
	else if(agentsNr>myID+1)
	    bestVolumes[myID+1]=
		getVolume(agents[myID+1],domain);
//	if(updateSentOrder(domain)){
// 	    select.call(0,heuristicCompactor,
// 			heuristicCompactor._getSents);
// 	    Synch_Wait();
// 	    sentOrder.hW=sendOrderWH++;
// 	    heuristicCompactor.getSents(sentOrder.getOHLevel(myID),null);
	    
// 	    MySystem.err.print("sent REORDER:"+sentOrder+" to:");
// 	    for(int k=myID+1;k<agentsNr;k++){
// 		select.accept(0,_terminate);
// 		select.call(1,genericAgent,genericAgent._sendCommand);
// 		if(Synch_Wait()==0){
// 		    return 1;
// 		}
// 		MySystem.err.print(agents[k]+":");
// 		DOrder msg=new DOrder((Order)sentOrder.clone());
// 		msg.cost=(DCost)((DCost)Utils.agentCost).clone();
// 		genericAgent.sendCommand(Commands.cREORDER,
// 					 msg,agents[k]);
// 	    }
// 	    MySystem.err.println("");
//	}else{
//	resendWHistory();//broadcast order, history[myID+1],volume[myID+1]
//	}
	Propagate difVars=new Propagate(myID);
        difVars.order=(Order)order.clone();
        //sending to my MHCk
        difVars.varHistories=new Labeling(lastSent.values());
	select.accept(0,_terminate);
	select.call(1,mHCinst,mHCinst._getLocalMessage);
	MySystem.err.println("Agent announces local");
	if(Synch_Wait()==0){
	    MySystem.err.println("Agent receives terminate on local");
	    return 1;
	}
	solutionHistoryChanges=false; //solution sent to mHCinst
	MySystem.err.println("Agent receives access on local");
	mHCinst.getLocalMessage(difVars);
	MySystem.err.println("Agent leaves access on local");
        //maybe send ACCEPTED and return (no followers)
	if((outGoing.size()==0)&&(addedOutgoingLinks.size()==0)&&
	   outGoingAllFinished()){
	    resendWHistory();//broadcast order, history[myID+1],volume[myID+1]
	    MySystem.out.println("Try to send some ACCEPTED");
	    return (announcePartialSolution()?0:1);
	}

        int messagesSent=0;
        Iterator keys;
        keys = (Iterator) outGoing.keys();
	while (keys.hasNext()){
	    agent = (AgentID) keys.next();
	    // null if no difference
	    difVars=different(((OutgoingAgent)outGoing.get(agent)).variables,
			      (ArrayList)addedOutgoingLinks.get(agent),
			      lastSolution,vIDs,differences);
	    if(difVars!=null){
		//difVars.addedLinks.clear();///to comment after debugging
		//since the added may be the only changed
		if((difVars.varHistories.size()==0)&&
		   (difVars.addedLinks.size()==0)) continue;
		//((OutgoingAgent)outGoing.get(agent)).ready=false;
		//difVars.cost=(DCost)((DCost)Utils.agentCost).clone();
		difVars.sender=genericAgent.getID();
		//difVars.senderName=agent.getName();
		select.accept(0,_terminate);
		select.call(1,genericAgent,genericAgent._sendCommand);
        	//MySystem.out.println("Try to announce Solution");
		if(Synch_Wait()==0){
		    MySystem.err.println("Agent r. terminate on local");
		    return 1;
		}
		genericAgent.sendCommand(Commands.cMHC,difVars,agent);
		messagesSent++;
	    }
	}
	DView toSend;
	keys = (Iterator) addedOutgoingLinks.keys();
	while (keys.hasNext()){
	    agent = (AgentID) keys.next();
	    if(cOrder.getI(agent)<=myID) continue;
	    //already treated
	    if(outGoing.get(agent)!=null) continue;//to add after debugging
	    // null if no difference
	    difVars=different(null,
			      (ArrayList)addedOutgoingLinks.get(agent),
			      lastSolution,vIDs,differences);
	    if(difVars!=null){
		toSend=new DView(myID);
		toSend.order=(Order)order.clone();
		toSend.order.hW=volumeHistory[myID+1];
		toSend.order.bestVolume=bestVolumes[myID+1];
		toSend.view=difVars.addedLinks;
		toSend.agent=myself;
		toSend.cost=(DCost)((DCost)Utils.agentCost).clone();
		toSend.senderName=agent.getName();
		select.accept(0,_terminate);
		select.call(1,genericAgent,genericAgent._sendCommand);
        	//MySystem.out.println("Try to announce Solution");
		if(Synch_Wait()==0){
		    MySystem.err.println("Agent terminated on local");
		    return 1;
		}
		genericAgent.sendCommand(Commands.cOK,toSend,agent);
		messagesSent++;
	    }
	}
	resendWHistory();//broadcast order, history[myID+1],volume[myID+1]

	MySystem.err.println("Done announce Solution");
	//	if(messagesSent==0){
	if(outGoingAllFinished()){
	    MySystem.out.println("Try to send ACCEPTED");
	    return (announcePartialSolution()?0:1);
	}
	//	}
	return 0;
    }

    //lastSolution was null (yokoo-not send not owner)
    private void initLastSolution(Range[] domain,
				  //Hashtable vIDs,
				  boolean[] differences){
	lastSolution=(Range[])domain.clone();
	historyIDs = new int[domain.length];
	for(int k=0;k<domain.length;k++){
	    //init
	    historyIDs[k] = -1;
	    if(sameAsIncoming(domain[k],k)){
		MySystem.err.println("Same as incoming:first:k="+k);
		// SameAsIncoming-> differences[k]:=false
		differences[k]=false;
	    }else
		// !SameAsIncoming-> differences[k]:=true
		differences[k]=true;

	    // initially -1
	    if(differences[k])
		historyIDs[k]++;
	    //MySystem.out.println("New history[k="+k+"]="+historyIDs[k]);
	    lastSolution[k]=(Range)domain[k].clone();
	}
    }

    // compute differences
    private void getSolutionDifferences(Range[] domain,
				//Hashtable vIDs,
				boolean[] differences){
	for(int k=0; k<domain.length; k++){
	    //due to nogood removal
	    differences[k]=true;
	    // if not restriction brought
	    if(sameAsIncoming(domain[k],k)){
		MySystem.err.println("Same as incoming:k="+k);
		//this test will removes old hist lastSent
		if(olderHistLastSentThanIncoming(k)){
		    MySystem.err.println("Older Last sent than inc");
		    differences[k]=false;
		}
	    }
	    if(false){//!validDiscarded){//difficult to count consistencies
		MySystem.err.println("not validDiscarded:k="+k);
		if(differences[k]){
		    MySystem.err.println("differences[k]=true");
		    if(sameRHAsLastSent(domain[k],k)){
			MySystem.err.println("sameRHAsLastSent");
			differences[k]=false;
		    }
		}
	    }
	    if(differences[k])
		historyIDs[k]++;
	    MySystem.out.println("New history[k="+k+"]="+engine.variables[k]+" "+historyIDs[k]);
	    lastSolution[k]=(Range)domain[k].clone();
	    //}
	}
	validDiscarded=false;
    }
    //Are we sending the same domain and history(ev +1) as last time?
    boolean sameRHAsLastSent(Range domain, int varID){
	String var=engine.variables[varID];
        int[] incHistory=varHistory.geth(var);
	Label l=lastSent.getL(var);
	if(l==null)
	    return false;//never sent
	if(incHistory!=null){
	    int[] sndHistory=l.inst.history;
	    if(!History.crtConsequence(sndHistory,incHistory,myID,historyIDs[varID]))
		return false;//not same history
	}
	if(domain.different(l.inst.getRange()))
	    return false;
	return true;
    }

    //was nothing sent since last receive?
    boolean olderHistLastSentThanIncoming(int varID){
	String var=engine.variables[varID];
        int[] incHistory=varHistory.geth(var);
	Label l=lastSent.getL(var);
	if(l==null)
	    return true;//never sent
	if(incHistory==null){
	    //never received
	    return false; //base was modified
	}
	int[] sndHistory=l.inst.history;
	if(History.crtConsequence(sndHistory,incHistory,myID,historyIDs[varID]))
	    return false;
	lastSent.remove(var);//old lastSent-can be removed
	return true; //sent was older than known
    }

    public String getVariable(int vID){
	return engine.variables[vID];
    }

    // one build first the last sent structure

    private void buildLastSent(boolean differences[], Range domain[]){
	String varCrt;
	Label dVarHistory;
	for(int k=0; k<differences.length; k++){
	    if(!differences[k])
		continue;
	    varCrt=engine.variables[k];
	    //MySystem.out.println("Is worth updating k:"+varCrt);
	    // updates the Range&Hist(k==id)
	    dVarHistory=
		new Label(varCrt,
			  new DVarHistory(new Range(domain[k]),//safe
					  buildNewHistory(varCrt,k)),
			  null);
	    lastSent.put(varCrt, dVarHistory);
	}
    }

    // construieste istoria noului mesaj
    private int[] buildNewHistory(String varCrt, int id){
        int[] newHistory, oldHistory;
        int k=0;
        oldHistory=varHistory.geth(varCrt);
	if(oldHistory==null){
	    newHistory=new int[2];
	    //MySystem.out.println("null history pointer");
	}else{
	    newHistory=new int[2+oldHistory.length];
	    for(k=0;k<oldHistory.length;k++){
		// MySystem.out.println("Adding to "+varCrt+".history["+k+"]="+oldHistory[k]);
		newHistory[k]=oldHistory[k];
	    }
	}
        newHistory[k]=myID;
	k++;
        newHistory[k]=historyIDs[id];
	//MySystem.out.println("Adding to history: |"+crtMyselfPosition+":"+historyIDs[id]);
        return newHistory;
    }

    // returns map(var:Range)
    // being called, synchronized by (iAmReady)
    // should not be synchronized by anything else
    private Propagate different(ArrayList vars, ArrayList addedVars, Range[] domain, Hashtable vIDs, boolean[] differences){
        Propagate view = new Propagate(myID);
	view.cost=(DCost)((DCost)Utils.agentCost).clone();
	view.order=(Order)order.clone();
	view.order.hW=volumeHistory[myID+1];
	view.order.bestVolume=bestVolumes[myID+1];
        Label mhcHistory;
	if(vars!=null)
        for(int k=0;k<vars.size();k++){
            String varCrt=(String)vars.get(k);
            int id;
	    // find the internal id of the variable k
	    // to send to current agent
	    Integer io=(Integer)vIDs.get(varCrt);
            id=io.intValue();
	    //MySystem.out.println("Build dView for:"+varCrt+" id="+id);
            if(differences[id]){
		//MySystem.println("Is worth updating:"+varCrt);
		mhcHistory=lastSent.getL(varCrt);
		if(mhcHistory==null){
		    MySystem.exit(1);
		}
                view.varHistories.add((Label)mhcHistory.clone());
                //#MySystem.out.println(varCrt+"=["+domain[id].getL()+","+domain[id].getU()+"]");
            }
        }
	DVarHistory dVarHistory;
	if(addedVars!=null)
        for(int k=0;k<addedVars.size();k++){
            String varCrt=(String)addedVars.get(k);
            int id;
	    // find the internal id of the variable k
	    // to send to current agent
	    Integer io=(Integer)vIDs.get(varCrt);
            id=io.intValue();
	    //MySystem.out.println("Build dView for:"+varCrt+" id="+id);
            if(differences[id]){
		//MySystem.println("Is worth updating:"+varCrt);
		dVarHistory=new DVarHistory((Label)lastSent.getL(varCrt).clone());
                view.addedLinks.put(varCrt,dVarHistory);
                //#MySystem.out.println(varCrt+"=["+domain[id].getL()+","+domain[id].getU()+"]");
            }
        }
        if((view.varHistories.size()!=0)||(view.addedLinks.size()!=0))
            return view;
        return null;
    }

//                                                     //
/* Here is the procedure for accepted announcement     */
//                                                     //


    private boolean announcePartialSolution(){
	AgentID agent; // targets of ACCEPTED

	DAccepted dAccepted=new DAccepted();
	dAccepted.agent=genericAgent.getID();
	dAccepted.senderName = genericAgent.getID().getName();
	dAccepted.history=IntersectionOfSolutions();

	acceptedCost.updateCost((DCost)((DCost)Utils.agentCost).clone());
	dAccepted.cost=(DCost)acceptedCost.clone();
	if(dAccepted.empty())
	    return true;

	// updating AcceptedID
	dAccepted.ID=AcceptedID;
	AcceptedID++;
	MySystem.err.println("Sending:"+dAccepted.toShortString());
	if(endAgent){//||inComing.isEmpty()){
	    select.accept(0, _terminate);
	    select.call(1, genericAgent, genericAgent._sendCommand);
	    if(Synch_Wait()==0)
		return false;
	    genericAgent.sendCommand(Commands.cAccepted,dAccepted,((Agent)genericAgent).getBrokerID());
	    if(inComing.isEmpty())
		return true;
	}

	if(acceptedReceiver==null) return true;
	//agent=acceptedReceiver;
	// history contains all the history he accepts
	select.accept(0, _terminate);
	select.call(1, genericAgent, genericAgent._sendCommand);
	if(Synch_Wait()==0)
	    return false;
	genericAgent.sendCommand(Commands.cAccepted,dAccepted,acceptedReceiver);
	return true;
    }

//                                                 //
/* Here is the procedure for addlink answer        */
//                                                 //

    //answer to add link: not sending fakes
    private void answerToAddLinks(){
	Iterator it=(Iterator)lastEstablishedLinks.keys();
	while(it.hasNext()){//there should be only one
	    AgentID target=(AgentID)it.next();
	    if(cOrder.getI(target)<=myID) continue;
	    ArrayList al=(ArrayList)lastEstablishedLinks.get(target);
	    DView dView=new DView(myID);
	    for(int k=0;k<al.size();k++){
		String var=(String)al.get(k);
		Label mh=lastSent.getL(var);
		if(mh==null){//no local solution yet
		    //mh=getFakeLastSent(var);
		    //agent.Synch_Reply(); //deliver agent
		    continue; //not sending fake messages
		}
		DVarHistory dv=new DVarHistory((Range)mh.range.clone());
		dv.history=mh.inst.history;
		//if(dv.history!=null)
		dv.history=(int[])dv.history.clone();
		dView.view.put(var,dv);
	    }
	    if(dView.view.size()==0)
		continue;
	    select.accept(0,_terminate);
	    select.call(1,agent,agent._sendCommand);
	    MySystem.err.println("Agent requests to send ok");
	    if(Synch_Wait()==0){
		MySystem.err.println("Agent Terminated on sending ok");
		return;
	    }
	    MySystem.err.println("Agent allowed to send ok");
	    dView.order=(Order)order.clone();
	    dView.order.hW=volumeHistory[myID+1];
	    dView.order.bestVolume=bestVolumes[myID+1];
	    dView.cost=(DCost)((DCost)Utils.agentCost).clone();
	    dView.senderName=myName;
	    dView.agent=myself;
	    agent.sendCommand(Commands.cOK,dView,target);
	}
	lastEstablishedLinks.clear();
    }

//     //when link is requested before an instantiation
//     //no longer used
//     private Label getFakeLastSent(String var){
// 	Label mh=null;//new Label(myID,var,null,null);
// 	return mh;
//     }


//                                                //
/* Here is the procedure for sending addLinks     */
//                                                //

    //add the links in linksToAdd
    //return 1-terminated
    //       0-nothing
    private int performAddLinks(){
	AgentID guiltyA[], agent;
	linksToAdd.size();
	if(linksToAdd.size()>0){
	    String[] newVarsArray=(String[])linksToAdd.toArray(new String[0]);
	    guiltyA=getAgents(newVarsArray,agentsNr);
	    // interrupted waiting OutGoing
	    if(guiltyA==null)
		return 0;
	    // for All agents
	    for(int k=0;k<guiltyA.length;k++){
		agent=guiltyA[k];
		// add link
		select.accept(0,_terminate);
		select.call(1,genericAgent,genericAgent._sendCommand);
		MySystem.err.println("performAddLinks:Want to send command");
		if(Synch_Wait()==0){
		    MySystem.err.println("performAddLinks:Want to send addlink but terminated");
		    return 1;
		}
		    MySystem.err.println("performAddLinks:sending addlink");
		DAddLink params=new DAddLink();
		params.source=myself;
		params.senderName=myName;
		params.variables=newVarsArray;
		params.cost=(DCost)((DCost)Utils.agentCost).clone();
		params.order=order.getOLevel(cOrder.getI(agent));
		genericAgent.sendCommand(Commands.cAddLink,params,agent);
		// ok? that disable the dependency, should do it!
		//should erase the constraint
	    }
	}
	//no need of waitedLinks
	//waitedLinks.add(linksToAdd);
	linksToAdd.clear();
	return 0;
    }

    //returns the agents that can provide the parameters
    private AgentID[] getAgents(String[] variables, int firstUnChecked){
	ArrayList iagents=new ArrayList();
	int id=firstUnChecked;
	for(int k=id-1;k>=0;k--)
	    if(hasAny(agents[k],variables)){
		iagents.add(agents[k]);
		//MySystem.out.println("antecedent agent "+k);
	    }
	return (AgentID[])iagents.toArray(new AgentID[0]);
    }

//                                                //
/* Here is the procedure for adding histories     */
//                                                //

    //returns a list of variables to clear at each level
    //returns the posts for the mHCKs
    //removes olds from post
    //private boolean addVarHistory(Hashtable post, int level){
    //}
    private boolean addVarHistory(Hashtable post, int level){
	boolean disableCL=false;
	ArrayList toRemove=new ArrayList();
	Iterator it=(Iterator)post.keys();
	while(it.hasNext()) {
	    String var=(String) it.next();
            int[] incomingHist;
            incomingHist=(int[])post.get(var);
	    int incomingLen=incomingHist.length;
	    //filter detectable errors or not recordable histories(empty,myID)
	    if(incomingLen>0){
		if(incomingHist[incomingLen-2]>myID){
		    MySystem.err.println("addVarHistory:error 1-history from ahead");MySystem.exit(1);
		}else
		    if(incomingHist[incomingLen-2]==myID){
			toRemove.add(var);continue;
		    }
	    }else{
		toRemove.add(var);continue;
	    }
	    //going on with correct items
	    int[] oldHist=varHistory.geth(var);
	    if(oldHist==null){
		MySystem.err.println("addVH:add new:"+var+History.toString(incomingHist));
		varHistory.put(var, incomingHist);
		checkVarHistory();
		int changeLevel=incomingHist[0];
		MySystem.err.println("addVH:request clear for new:"+var+":because of:"+History.toString(incomingHist)+":between:"+changeLevel+":and:"+myID);
		for(int cl=changeLevel;cl<agentsNr;cl++) toClear[cl].add(var);
		addPosts(level,incomingHist,changeLevel,var);
		//links are added only if in valid nogoods
		int vID=engine.getvID(var);
		if(vID<0){
		    if(!linksToAdd.contains(var)){
			linksToAdd.add(var);
			MySystem.err.println("addVH:request link for:"+var);
		    }
		}else
		    solutionHistoryChanges=true;
	    }else{
		if(History.olderThan(oldHist,incomingHist)){
		    if(conflictingVariables.contains(var)){
			disableCL=true;
		    }
		    varHistory.put(var, incomingHist);
		    checkVarHistory();
		    int changeLevel=History.changeLevel(oldHist,incomingHist);
		    MySystem.err.println("addVH:request clear for:"+var+History.toString(oldHist)+":because of:"+History.toString(incomingHist)+":between:"+changeLevel+":and:"+myID);
		    for(int cl=changeLevel;cl<agentsNr;cl++)
			toClear[cl].add(var);
		    addPosts(level,incomingHist,changeLevel,var);
		    if(engine.getvID(var)>=0)
			solutionHistoryChanges=true;
		}else{
		    if(!History.consequence(oldHist,incomingHist,level)){
			//we have arrived once here
			toRemove.add(var);
			MySystem.err.println("addVH:error-should have been done in MHCk.readPostToChanged!!remove old incoming:"+var);
			MySystem.err.println("old hist:"+History.toString(oldHist));
			MySystem.exit(1);
		    }
		    toRemove.add(var);//redundant and was known
		}
	    }
	}
	//removing here in order not to disturb the iterator
	for(int k=toRemove.size()-1;k>=0;k--)
	    post.remove((String)toRemove.get(k));
	return disableCL;
    }

    //should add the needed part of the incomingHist to outPosts
    //starting upward from changeLevel and skipping level
    private void addPosts(int level,int[] incomingHist,int changeLevel, String var){
	int startingLen=0;
	for(int k=changeLevel;k<agentsNr;k++){
	    if(k==level) continue;
	    for(;startingLen<incomingHist.length;
		startingLen++,startingLen++){
		if(incomingHist[startingLen]>k)
		    break;
	    }
	    if(startingLen==0) continue;
	    int[] newHist=new int[startingLen];
	    for(int l=0;l<startingLen;l++)
		newHist[l]=incomingHist[l];
	    posts[k].put(var,newHist);
	    MySystem.err.println("addVH:add post incoming:"+var+":"+History.toString(newHist)+":at level:"+k);
	}
    }

    //reset on addVarHistory and on incomingOK
    void resetConflictingVariables(){
	conflictingVariables.clear();
	MySystem.err.println("Reset Search");
 	if(!Snogood)
	    engine.resetSearch();
    }

//                                                //
/* Here is the procedure for checking   mHC       */
//                                                //

    //called only at beginning
    private boolean mHC(Hashtable dependency){
	boolean result=hc.HC(engine.mHCk, dependency);
	engine.currentDomains=(Range[])engine.mHCk.clone();
	engine.updateMHCLevels();
	engine.updateVolumes();
	return result;
    }

//                                                //
/* Here are the procedures for sending mHCk      */
//                                                //

    //detect the empty domain
    //and the target of the nogood
    //as the agent with the initialization
    //level erased
    //0-not yet terminated
    //1-received terminate
    //2-waiting terminate after cEmptyNogood
    private int buildAndSendMHCk(){
	if((mHCkResult!=SannouncedEN)&&
	   (mHCkResult!=SannouncedF))
	    return buildAndSendMHCk(newLabeling);

	//emptynogood
	AgentID target;
	String command;
	DObject parameter;
	target=((Agent)genericAgent).getBrokerID();
	parameter=(DCost)(((DCost)Utils.agentCost).clone());
	if(mHCkResult==SannouncedF)
	    command=Commands.cFail;
	else
	    command=Commands.cEmptyNogood;

	select.accept(0,_terminate);
	select.call(1,agent,agent._sendCommand);
	//MySystem.err.println("buildAndSendMHCk:try to send enogood");
	int res=Synch_Wait();
	if(res==0){
	    //MySystem.err.println("Receive terminate before sending EmptyNogood after level "+post_level);
	    return 1; //terminated and in Sstop
	}
	//MySystem.err.println("Send EmptyNogood after level "+post_level);
	agent.sendCommand(command,parameter,target);
	return 2; //should wait _terminate
    }


//     //called only from buildAndSendMHCk()
//     //0-nothing
//     //1-terminated
//     //2-empty nogood
    private int buildAndSendMHCk(Labeling[] newLabeling){
	sendToMySelf(newLabeling);
 	for(int target=0;target<agents.length; target++){
 	    if(agents[target].equals(myself))
 		continue;
	    Propagate toSend=buildToSendToTarget(newLabeling,target);
 	    if((toSend==null)||
	       (toSend.varHistories.size()==0)) continue;
	    toSend.sender=myself;
	    select.accept(0,_terminate);
 	    select.call(1,agent,agent._sendCommand);
 	    MySystem.err.println("buildMHCK(...)Want send somewhere:"+toSend+":at to target:"+target);
 	    int res=Synch_Wait();
 	    //MySystem.err.println("buildMHCK(...)after nogood wait");
 	    if(res==0){//MySystem.err.println("buildMHCK(...)received terminate on sending nogood");
 		return 1;}
 	    agent.sendCommand(Commands.cMHC,toSend,agents[target]);}
 	//MySystem.err.println("I sent mHCks at level "+level);
 	return 0;
    }
//     //build the MHCHistory to be sent to the agent "target"
//     //given the modified variables in "dependency"
//     //at "level"
     private Propagate buildToSendToTarget(Labeling[] newLabeling, int target){
 	Propagate toSend =null;
	for(int level=-1;(level<target)&&(level<myID);level++){
	    //MySystem.err.println("IN bTSTT:"+level);
	    Propagate tosend=new Propagate(level);
	    tosend.order=order.getOLevel(level);
	    //MySystem.err.println("IN bTSTT::"+level);
	    //MySystem.err.println("IN bTSTT:::"+toSend);
	    //MySystem.err.println("IN bTSTT::::"+toSend.order);
	    //MySystem.err.println("IN bTSTT::::"+volumeHistory);
	    tosend.order.hW=volumeHistory[level+1];
	    tosend.order.bestVolume=bestVolumes[level+1];
	    tosend.varHistories=new Labeling();
	    Iterator it = newLabeling[level+1].iterator();
	    while(it.hasNext()){
		//MySystem.err.println("IN bTSTTn:"+level);
		Label mh=(Label) it.next();
		if(mh.isNogood())
		    continue;
		String addedVar = mh.variable;
		if(!has(agents[target], addedVar))
		    continue;
		tosend.varHistories.add((Label)mh.clone());
	    }
	    if(tosend.varHistories.size()<=0) continue;
	    if(toSend==null) toSend=tosend;
	    else toSend.addNext(tosend);
	}
	if((target<myID)&&(newLabeling[target+1].hasNogood())){
	    Label mh=newLabeling[target+1].getNogood();
	    if((lastSentNogood==null)||(!lastSentNogood.sameAs(mh))){
		Propagate tosend=new Propagate(target);
		tosend.order=order.getOLevel(target);
		tosend.varHistories=new Labeling();
		//Iterator it = newLabeling[target+1].iterator();
		//while(it.hasNext()){
		//MySystem.err.println("IN bTSTTt:"+target);
		//Label mh=(Label) it.next();
		String addedVar = mh.variable;
		if(!has(agents[target], addedVar)){
		    MySystem.exit(1);//was a nogood for target
		    //continue;
		}
		//if(mh.range.size()>0) continue;
		tosend.varHistories.add((Label)mh.clone());
		//}
		//if(tosend.varHistories.size()>0){
		if(toSend==null) toSend=tosend;
		else toSend.addNext(tosend);
		lastSentNogood=mh;
		//}
	    }else
		MySystem.err.println("Avoid sending the same nogood:"+mh+
				     " vs "+lastSentNogood);
	}
	if(toSend!=null)
	    toSend.cost=(DCost)((DCost)Utils.agentCost).clone();
	MySystem.err.println("Got:"+toSend);
 	return toSend;
     }

    private void checkVarHistory(){
	Iterator it=varHistory.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    int[] vh=varHistory.geth(var);
	    int source=vh[vh.length-2];
	    if(!has(agents[source],var))
		MySystem.exit(1);
	}
    }

    private void sendToMySelf(Labeling[] newLabeling){
	for(int level=-1;level<myID;level++){
	    Labeling nl=newLabeling[level+1].getNoEmpties();
	    if(nl.size()<=0) continue;
	    //if(nl.isNogood()) continue;
	    Propagate toSend=new Propagate(level);
	    toSend.cost=(DCost)((DCost)Utils.agentCost).clone();
	    toSend.order=order.getOLevel(level);
	    toSend.varHistories=nl;
	    if(level>=0)  select.call(1,mHCks[level],mHCks[level]._getLocalMessage);
	    else  select.call(1,mHCk,mHCk._getLocalMessage);
	    MySystem.err.println("buildMHCK(.)call local or remote");
	    int res=Synch_Wait();
	    //MySystem.err.println("buildMHCK(...)allowed on sending nogood");
	    if(level>=0) mHCks[level].getLocalMessage(toSend);
	    else mHCk.getLocalMessage(toSend);
	}
    }

    void putAllVarsInContext(Context context,ConflictSet vars,int level){
 	Iterator it=vars.iterator();
 	while(it.hasNext()){
 	    String var=(String)it.next();
 	    int[] hist=getHistory(var,level);
 	    context.put(var,
 			new DVarHistory(getInstantiation(var,level),
 					hist));
 	}
    }

    Range getInstantiation(String var, int level){
	int varID=engine.getvID(var);
 	return Context.getInstantiation(var,level,varHistory,instantiations,myID+1,varID,engine.mHCk);
    }



//                                                      //
/* Here are the procedures for announcing the first MHC */
//                                                      //

    //--announcings the first basic MHC
    private void announceMHC(int level, Hashtable dependency){
      if(level==-1)
	  announceBaseMHC(dependency);
    }
    private void announceBaseMHC(Hashtable dependency){
      for(int k=0; k<agentsNr; k++){
        //if(k==myID)continue;
        Propagate reductions = new Propagate(-1);
	reductions.order=new Order();
	reductions.order.bestVolume=bestVolumes[0];
	reductions.cost=(DCost)((DCost)Utils.agentCost).clone();
        if(dependency.size()==0)
	    return;
        reductions.varHistories = new Labeling();
        Iterator it = (Iterator) dependency.keys();
        while(it.hasNext()){
	  Integer code=(Integer)it.next();
	  String variable = engine.variables[code.intValue()];
          if(has(agents[k], variable)){
	      Label toSend;
	      toSend = new Label(variable,
		      new DVarHistory((Range)engine.mHCk[code.intValue()].clone(),
				      null),null);
	      reductions.varHistories.add(toSend);
          }
        }
        if(reductions.varHistories.size()==0)
         continue;
        if(k==myID){
          select.accept(0,_terminate);
          select.call(1,mHCk,mHCk._getLocalMessage);
          if(Synch_Wait()==0) return;
          mHCk.getLocalMessage(reductions);
          continue;
        }
        select.accept(0,_terminate);
        select.call(1,agent,agent._sendCommand);
        if(Synch_Wait()==0) return;
        agent.sendCommand(Commands.cMHC,reductions,
                          agents[k]);
      }
    }

//                                                //
/* Here are the procedures for announcing nogoods */
//                                                //


    //ret 0 //nothing
    //ret 1 //received terminate
    //ret 2 //wait terminate, sent cEmptyNogood
    private int announceEmptyNogood(){
	int returnValue;
        DNogood params;
        String[] guiltyV=null;
	String command;
	//if (Utils.hamadi)
	guiltyV=getConflictingVariables();
        params=getNogood(guiltyV);
	AgentID target;
	target=getLastSender(params);
	if(target==null){
	    //MySystem.out.println("Use getLast to find last agent using variables in nogood");
	    //target=getLast(guiltyV);
	}
	DObject parameter;
	if(target!=null){
	    //negateIncoming(target);
	    params.cost=(DCost)(((DCost)Utils.agentCost).clone());
	    params.senderName=myName;
	    params.order=order.getOLevel(cOrder.getI(target));
	    parameter = params;
	    command=Commands.cNogood;
	    returnValue=0;
	    //lastNogood=params;
	    //MySystem.err.println("sending NOGOOD: "+params);
	}else{
	    target=((Agent)genericAgent).getBrokerID();
	    parameter=(DCost)(((DCost)Utils.agentCost).clone());
	    command=Commands.cEmptyNogood;
	    returnValue=2;
	}
        if(crtState==Sstop)
	    return 1;//terminated
	select.accept(0,_terminate);
	select.call(1,agent,agent._sendCommand);
	int res=Synch_Wait();
	if(res==0){
	    //MySystem.err.println("reveived terminate");
	    return 1; //terminated
	}
	//MySystem.err.println("Sent "+command+" with parameter:"+parameter);
	agent.sendCommand(command,parameter,target);
	return returnValue; //(0-nogood or 2-emptyNogood)
    }

    //ret 0-nothing
    // 1-terminated
    // 2-wait terminated
    private int announceNogood(){
	int returnValue;
        DNogood params;
        String[] guiltyV=null;
	String command;
	//if (Utils.hamadi)
	guiltyV=getConflictingVariables();
        params=getNogood(guiltyV);
	AgentID target;
	target=getLastSender(params);
	if(target==null){
	    //MySystem.out.println("Use getLast to find last agent using variables in nogood");
	    //target=getLast(guiltyV);
	}
	DObject parameter;
	if(target!=null){
	    //negateIncoming(target);
	    params.cost=(DCost)(((DCost)Utils.agentCost).clone());
	    params.senderName=myName;
	    params.order=order.getOLevel(cOrder.getI(target));
	    parameter = params;
	    command=Commands.cNogood;
	    returnValue=0;
	    //lastNogood=params;
	    //MySystem.err.println("want sending NOGOOD: "+params);
	}else {
	    target=((Agent)genericAgent).getBrokerID();
	    parameter=(DCost)(((DCost)Utils.agentCost).clone());
	    command=Commands.cEmptyNogood;
	    //MySystem.err.println("want sending ENOGOOD: "+params);
	    returnValue=2;
	}
        if(crtState==Sstop){
          return 1;
	}
	select.accept(0,_terminate);
	select.call(1,agent,agent._sendCommand);
	MySystem.err.println("Try to send command");
	int res=Synch_Wait();
	if(res==0){
	    MySystem.err.println("Agent received terminate on send command");
	   return 1; //terminated
	}
	MySystem.err.println("Agent sending command");
	agent.sendCommand(command,parameter,target);
	return returnValue; //0-nogood, 2-emptyNogood
    }


    private String[] getConflictingVariables() {
	ConflictSet al=(ConflictSet)conflictingVariables.clone();
	engine.addInternalRestrictingVariables(al);
	return al.toArray();
    }


    private DNogood getNogood(String[] guiltyV){
	DVarHistory ev; //range of external variable
        DNogood nogood=new DNogood();
        Context view=new Context();
        // for All guilty variables
        for(int k=0;k<guiltyV.length;k++){
	    ev=varHistory.getDV(guiltyV[k]);
	    if(ev!=null) {
		//get instantiation
		int id=getID(guiltyV[k]);
		//if(id>=0)ev.range=engine.mHCks[myID-1][id].instantiation;else
		ev.range=getInstantiation(guiltyV[k],myID-1);
		//store it
		view.put(guiltyV[k],ev);
	    }
	}
        nogood.view=view;
        return nogood;
    }

    private AgentID getLastSender(DNogood nogood){
	AgentID result;
	int crtLast=-1;
	if(nogood==null)
	    return null;
	crtLast=nogood.getLastSenderID();
	if(crtLast>=myID){
	    MySystem.err.println("last hist is:"+crtLast);
	    MySystem.err.println(nogood);
	    MySystem.exit(1);
	}
	if(crtLast<0){
	    MySystem.err.println("last hist is:"+crtLast);
	    //MySystem.exit(1);//
	    return null;
	}
	if(crtLast>=myID)
	    MySystem.exit(1);//return null;
	if(agentsNr<=crtLast)
	    MySystem.exit(1);//return null;
	//MySystem.out.println("getLastSender:last position is="+crtLast);
	result=agents[crtLast];
	return result;
    }


//                                                //
/* Here is the procedure for termination          */
//                                                //

    synchronized public void terminate(){
	crtState=Sstop;
	agent=null;
	genericAgent=null;
	myself=null;
        Synch_Reply();
    }


//                                                //
/* Here are the procedures for incoming mHCk      */
//                                                //

    private void resendWHistory(){
	MySystem.err.print("sent WINNER:"+bestVolumes[myID+1]+" "+sendOrderWH+" to:");

	Order heur=(Order)order.clone();
	heur.hW=sendOrderWH;
	heur.bestVolume=bestVolumes[myID+1];

	//announce heuristic compactor
	select.call(0,heuristicCompactor,
		    heuristicCompactor._getSents);
	Synch_Wait();
	heuristicCompactor.getSents(heur,
				    null);

	DWinner msg=new DWinner((Order)order.clone());
	msg.history=sendOrderWH; msg.volume=bestVolumes[myID+1];
	msg.position=myID+1;
	msg.cost=(DCost)((DCost)Utils.agentCost).clone();

	for(int k=myID+1;k<agentsNr;k++){
	    select.accept(0,_terminate);
	    select.call(1,genericAgent,genericAgent._sendCommand);
	    if(Synch_Wait()==0){
		continue;
	    }
	    MySystem.err.print(agents[k]+":");
	    genericAgent.sendCommand(Commands.cWinner,
				     msg,agents[k]);
	}
	MySystem.err.println("");
	resendWH=false;
    }

    private void resend0WHistory(){
	MySystem.err.print("sent WINNER0:"+bestVolumes[0]+" to:");

	Order heur=new Order(new AgentID[0], new int[0], bestVolumes[0],0);

	//announce heuristic compactor
	select.call(0,heuristicCompactor,
		    heuristicCompactor._getSents);
	Synch_Wait();
	heuristicCompactor.getSents(null,heur);
	
	DWinner msg=new DWinner(new Order());
	msg.history=0; msg.volume=bestVolumes[0];
	msg.position=0;
	msg.cost=(DCost)((DCost)Utils.agentCost).clone();
	
	for(int k=0;k<agentsNr;k++){
	    if(myself.equals(agents[k])) continue;
	    select.accept(0,_terminate);
	    select.call(1,genericAgent,genericAgent._sendCommand);
	    if(Synch_Wait()==0){
		continue;
	    }
	    MySystem.err.print(agents[k]+":");
	    genericAgent.sendCommand(Commands.cWinner,
				     msg,agents[k]);
	}
	MySystem.err.println("");
	resend0WH=false;
    }

    private void setWH(int level, int wHist, int wVol){
	MySystem.err.println("Begin setWH level:"+level+":wVol="+wVol+":wHist"+wHist+"volumeHistory[level+1]="+volumeHistory[level+1]+"bestVolumes[level+1]"+bestVolumes[level+1]);
	if(volumeHistory[level+1]<wHist){
	    volumeHistory[level+1]=wHist;
	    bestVolumes[level+1]=wVol;
	}else if(volumeHistory[level+1]==wHist){
	    if((bestVolumes[level+1]>wVol)||(bestVolumes[level+1]<=0))
		bestVolumes[level+1]=wVol;
	}
    }

    synchronized public void mHCk(MHCHistory[] levelState,
				  Hashtable post, Hashtable insts,
 				  int level, Order lOrder, int wHist, int wVol){
 	MySystem.err.println("Begin MHCk of level "+level+":wVol="+wVol+":wHist"+wHist);
        if(getOrder(lOrder,level)){
	    setWH(level,wHist, wVol);
	}
	if(level>myID){
	    MySystem.err.println("old order high level "+level);
	    Synch_Reply();return;
	}
 	printInstantiations(insts);printPost(post);printLevel(levelState);
	if((((DCost)Utils.agentCost).getMessages()>Utils.MAX_SECV_MSG)&&(Utils.MAX_SECV_MSG>0)){
	    mHCkResult=SannouncedF;
	    Synch_Reply();return;
	}
	boolean reseted=false;
 	if(level>=0) instantiations[level]=(Hashtable)insts.clone();
// 	//extract info for MHCAgent
	ConflictSet cs=new ConflictSet();
	for(int cp=0;cp<agentsNr;cp++){
	    toClear[cp].clear();
	    posts[cp].clear();
	    newLabeling[cp].clear();
	}
 	if(post.size()>0){
 	    if(addVarHistory(post,level)){
		resetConflictingVariables();
		reseted=true;
	    }
	}

 	//update data in Splitting
	if(level<myID)engine.exchangeLevel(levelState, level);
 	if(post.size()>0){
 	    MySystem.err.println("MHCk post of level "+level);
            int k;
 	    for(k=0;k<agentsNr;k++){
		if(k==level)continue;
		clearInsts(k,toClear[k]);
		Order pOrder=order.getOLevel(k);
		pOrder.hW=volumeHistory[k+1];
		pOrder.bestVolume=bestVolumes[k+1];
		mHCks[k].setPost(posts[k],pOrder);
 	    }
            for(;k<agentsNr;k++){
		Order pOrder=(Order)order.clone();
		pOrder.hW=volumeHistory[k+1];
		pOrder.bestVolume=bestVolumes[k+1];
                mHCks[k].setPost(posts[k],pOrder);
	    }
	    mHCkResult=engine.mHCk(level,newLabeling,cs,toClear);
	}else
	    mHCkResult=engine.mHCk(level,newLabeling,cs,null);
	if((level==myID)&&(mHCkResult==SannouncedS))
	    if(!engine.setSolutionLevel(levelState,cs))
		mHCkResult=Sprocessing;
	if(Snogood&&!reseted)
	    mHCkResult=SannouncedN;
	//MySystem.err.println("IN mHCk 5");
	conflictingVariables.addAll(cs);
 	MySystem.err.println("End MHCk of level "+level+":state:"+mHCkResult);
	Synch_Reply();
    }

    // to check if an incoming level is empty
    private boolean empty(MHCHistory[] mhc){
	for(int k=0; k<mhc.length; k++){
	    if(mhc[k]==null)
		continue;
	    if(mhc[k].proposal.size()<=0)
		return true;
	}
	return false;
    }


    void printInstantiations(Hashtable insts){
	MySystem.out.println("Obtained instantiations:");
	Iterator it=(Iterator)insts.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    MySystem.out.print(var+"="+insts.get(var)+";");
	}
	MySystem.out.println("");
    }
   void printPost(Hashtable post){
	MySystem.out.println("Obtained post:");
	Iterator it=(Iterator)post.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    MySystem.out.print(var+"="+History.toString((int[])post.get(var))+";");
	}
	MySystem.out.println("");
    }

    void printSolution(Range[] domain){
	MySystem.out.println("Announce Solution:");
	for(int k=0;k<engine.variablesNr;k++)
	    MySystem.err.print(engine.variables[k]+"="+domain[k]+";");
	MySystem.out.println();
    }
    void printRanges(){
	MySystem.out.println("Obtained level -1:");
	for(int k=0;k<engine.variablesNr;k++)
	    MySystem.err.print(engine.variables[k]+"="+engine.mHCk[k]+";");
    }
    void printLevel(MHCHistory[] level){
	MySystem.out.println("Obtained MHCHist level");
	for(int k=0;k<engine.variablesNr;k++)
	    if(level[k]==null)
		MySystem.out.println(engine.variables[k]+"=null;");
	    else
		MySystem.out.println(engine.variables[k]+"="+level[k]+";");
    }
    void printLabels(int l){
	if(l<0){printRanges();return;}
	MySystem.out.println("Obtained level:"+l);
	for(int k=0;k<engine.variablesNr;k++)
	    if(engine.mHCks[l][k]==null)
		MySystem.err.println(engine.variables[k]+"=null;");
	    else
		MySystem.err.println(engine.variables[k]+"="+engine.mHCks[l][k]+";");
    }

//                                                //
/* Here are the procedures for incoming messages */
//                                                //

    synchronized public void getMessage(Message message){
	Message_Command mc=(Message_Command)message;
	Object param=(Object)mc.getArguments();
	String command=(String)mc.getCommand();
	MySystem.err.println("MHC.got:"+command);
	if(command.equals(Commands.cStartParameters)){
	    myComputationNum=message.getComputationNum();
	    MySystem.err.println("MHC.myComputationNum="+myComputationNum);
	    DStartLinks dsl=(DStartLinks)param;
	    MySystem.err.println("got="+dsl);
	    order=dsl.order;
	    //myID=dsl.position;
	    dSearch=dsl.dSearch;
	    setDefaultOrder();
	    acceptedSendersNr=dSearch.acceptedSenders.size();
	    acceptedReceiver=dSearch.acceptedReceiver;
	    setOrder(order);
	    if(dIncomingAgent.get().length==0)
		endAgent=true;
	}
// 	if(command.equals(Commands.cREORDER)){
// 	    Order incOrder=(Order)param;
// 	    if(getOrder(incOrder));
// 	    resendOrder=false; //remove when _heuristics
// 	}
	if(command.equals(Commands.cHeuristic)){
	    DOrder dOrder=(DOrder)param;
	    Order hOrder=dOrder.order;
	    if(dOrder.cost!=null)
		((DCost)Utils.agentCost).incrementMessages(dOrder.cost);
	    MySystem.err.println("got param="+dOrder);
	    if(order.equals(hOrder)){
		MySystem.err.println("got sentOrder heuristic");
		if((sendOrderWH==hOrder.hW)&&
		   (bestVolumes[myID+1]>hOrder.bestVolume)){
		    MySystem.err.println("got improved sentOrder heuristic A");
		    bestVolumes[myID+1]=hOrder.bestVolume;
		    //sentOrder.bestVolume = hOrder.bestVolume;
		    AgentID sender=message.getSenderID();
		    if(!sender.equals(sentOrder.sequence[myID+1])){
			sentOrder.sequence=new AgentID[myID+2];
			sentOrder.sequence[myID+1]=sender;
			for(int k=0;k<=myID;k++)
			    sentOrder.sequence[k]=agents[k];
			sentOrder.history=History.buildHistory(order.history,myID,orderIDs++);
			sentOrder.hW=0;
			sentOrder.bestVolume=-1;
			resendOrder=true;
		    }
		    resendWH=true;
		}
	    }
	    if((myself.equals(defaultAgents[0]))&&(hOrder.history.length==0)
	       //sent0Order.getOLevel(-1).equals(hOrder)
	       ){
		MySystem.err.println("got sent0Order heuristic");
		if(bestVolumes[0]>hOrder.bestVolume){
		    bestVolumes[0]=hOrder.bestVolume;
		    sent0Order.bestVolume = hOrder.bestVolume;
		    AgentID sender=message.getSenderID();
		    if(!sender.equals(sent0Order.sequence[0])){
			MySystem.err.println("got sent0Order heuristic from "+sender);
			sent0Order.sequence=new AgentID[1];
			sent0Order.sequence[0]=sender;
			sent0Order.history=History.buildHistory(new int[0],-1,order0IDs++);
			sent0Order.hW=0;
			sent0Order.bestVolume=-1;
			resend0Order=true;
		    }
		    resend0WH=true;
		}
	    }
	}
	if(command.equals(Commands.cNogood)){
	    if(getOrder((Order)((DNogood)param).order,myID))
		nogoodBuf=message;
	}
	if(command.equals(Commands.cAccepted)){
          MySystem.out.println(param);
	  acceptedIntersection=((DAccepted)param).history;
	  acceptedCost=((DAccepted)param).cost;
        }
	if(command.equals(Commands.cAddLink)){
	    MySystem.out.println(param);
	    DAddLink dn=(DAddLink) param; //DAddLink found in dcsp
	    //Set the link in outgoing (may be flagged for removal at first change)
	    ((DCost)Utils.agentCost).incrementMessages(dn.cost);
	    answerToAddLink(dn);
        }
        Synch_Reply();
    }
//                                                                //
/* Here are the procedures for incoming cStartParameters messages */
//                                                                //

    //return value used only at initialization to
    // detect endAgents
    private boolean registerInComing(IncomingAgent agents[]){
        AgentID farAgent;
        int oldAgents=0,newAgents=0;
        for(int k=0;k<agents.length;k++){
	    farAgent=agents[k].getAgent();
	    if(!inComing.containsKey(farAgent)){
		inComing.put(farAgent,farAgent);
		newAgents++;
	    }else
		oldAgents++;
	}
        //MySystem.out.println("There were "+newAgents+" new incoming agents and "+oldAgents+" old ones");
        return agents.length>0;
    }
    private boolean registerOutGoing(OutgoingAgent agents[]){
        AgentID farAgent;
        int oldAgents=0,newAgents=0;
        OutgoingAgent oa;
        for(int k=0;k<agents.length;k++){
	    farAgent=agents[k].getAgent();
	    oa=(OutgoingAgent)outGoing.get(farAgent);
	    if(oa==null) {
		outGoing.put(farAgent,agents[k]);
		ArrayList vars;
		vars=agents[k].variables;
		newAgents++;
	    } else{
		// Should be unique!
		ArrayList variables=agents[k].variables;
		for(int j=0;j<variables.size();j++){
		    String s=(String)variables.get(j);
		    if(!oa.variables.contains(s)){
			//MySystem.out.println(": new s="+s);
			oa.variables.add(s);
		    }//else MySystem.out.println(": old s="+s);
		}
		oldAgents++;
	    }
	}
	//MySystem.out.println("There were "+newAgents+" new outgoing agents and "+oldAgents+" old ones");
        return true;
    }


//                                                //
/* Here are the procedures for incoming cAddLink messages */
//                                                //

    private void answerToAddLink(DAddLink dn){
	ArrayList vars=(ArrayList)addedOutgoingLinks.get(dn.source);
	ArrayList addedVars=(ArrayList)lastEstablishedLinks.get(dn.source);
	if(addedVars==null)
	    addedVars=new ArrayList();
        int k;
	if(vars!=null){
	    for(k=0;k<dn.variables.length;k++)
		//one may receive all variables
		if((engine.getvID(dn.variables[k])>=0)&&
		   (!vars.contains(dn.variables[k]))){
		    vars.add(dn.variables[k]);
		    addedVars.add(dn.variables[k]);
		}
	}else
	    for(k=0;k<dn.variables.length;k++)
		//one may receive all variables
		if(engine.getvID(dn.variables[k])>=0)
		    addedVars.add(dn.variables[k]);
	lastEstablishedLinks.put(dn.source,addedVars);
	if(vars==null)
	    addedOutgoingLinks.put(dn.source,addedVars.clone());
    }

    void clearInsts(int k, ArrayList vars){
	Iterator it=vars.iterator();
	while(it.hasNext())
	    instantiations[k].remove(it.next());
    }

//                                                                   //
/* Here are the unsynchronized procedures called from other objects  */
//                                                                   //

    //only called from dhmc.Splitting
    //to add the conflict reducing k due to incoming level inLevel and of the
    //consistency added newDependency
    void updateConflictingList(MHCHistory hist){
	Iterator it=(Iterator)hist.dependencies.iterator();
	String var;
	while(it.hasNext()){
	    var=(String) it.next();
	    if(!conflictingVariables.contains(var)){
		conflictingVariables.add(var);}
	}
	var = hist.variable;
	if(varHistory.geth(var)==null) return;
	if(!conflictingVariables.contains(var))
	    conflictingVariables.add(var);
    }

    //to be called from dhmc.MHCk
    int getID(String var){
	return engine.getvID(var);
    }
}
