/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import java.util.*;
import csp.*;

public class ConflictSet implements Cloneable {
    private ArrayList conflicts;
    private static final String[] sArray=new String[0];
    public ConflictSet(){
	conflicts=new ArrayList();
    }
    public ConflictSet(ConflictSet cs){
	conflicts=(ArrayList)cs.conflicts.clone();
    }
    public ConflictSet(Set s){
	conflicts=new ArrayList(s);
    }
    public ConflictSet(Context c){
	conflicts=new ArrayList(c.keySet());
    }
    public boolean add(String var){
	boolean res=false;
	if(!conflicts.contains(var))
	    res=conflicts.add(var);
	return res;
    }
    public String get(int k){
	return (String)conflicts.get(k);
    }
    public int size(){
	return conflicts.size();
    }
    public Iterator iterator(){
	return conflicts.iterator();
    }
    public boolean contains(String var){
	return conflicts.contains(var);
    }
    public void clear(){
	conflicts.clear();
    }
    public String remove(String var){
	int index=conflicts.indexOf(var);
	if(index==-1)
	    return null;
	return (String)conflicts.remove(index);
    }
    public boolean addAll(ConflictSet cs){
	boolean modified=false;
	Iterator it=cs.iterator();
	while(it.hasNext()){
	    String var=(String)it.next();
	    if(conflicts.contains(var)) continue;
	    modified=true;
	    conflicts.add(var);
	}
	return modified;
    }
    public String[] toArray(){
	return (String[])conflicts.toArray(sArray);
    }
    public Object clone(){
	return new ConflictSet(this);
    }
}
