/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import java.util.*;
import csp.*;

public class Context implements DObject,Cloneable{
    public Hashtable context;
    public Context(){
	context=new Hashtable();
    }
    public Context(int level, ConflictSet dep, Histories histories, Hashtable[] instantiations, int instantiationsLength,Range[]mHCk,Hashtable varIDs){
	context=new Hashtable();
	Iterator it=dep.iterator();
	while(it.hasNext()){
	    String variable=(String)it.next();
	    context.put(variable,getDV(level,variable,histories,instantiations,instantiationsLength,mHCk,varIDs));
	}
    }
    public Context(Hashtable ht){
	context=new Hashtable();
	Iterator it=(Iterator)ht.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    context.put(var,(DVarHistory)((DVarHistory)ht.get(var)).clone());
	}
	//context=(Hashtable)ht.clone();
    }
    public Object clone(){
	return new Context(context);
    }
    public boolean sameAs(Context c){
	if(c.size()!=size())
	    return false;
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    Range cmp=c.getR(var);
	    if((cmp==null)||(cmp.different(getR(var))))
		return false;
	}
	return true;
    }
    public int getSize(){
	int vol=1;
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    DVarHistory dv=getDV(var);
	    vol*=dv.getRange().size();
	}
	return vol;
    }
    DVarHistory put(String var, Range range, History hist){
	return (DVarHistory)context.put(var,new DVarHistory(range,hist.history));
    }
    public DVarHistory put(String var, DVarHistory dvh){
	return (DVarHistory)context.put(var, dvh);
    }
    public DVarHistory remove(String var){
	return (DVarHistory)context.remove(var);
    }
    public History getH(String var){
	return new History((DVarHistory)context.get(var));
    }
    public int[] geth(String var){
	DVarHistory dv=(DVarHistory)context.get(var);
	if(dv==null)
	    return null;
	return dv.history;
    }
    public Range getR(String var){
	Range r=((DVarHistory)context.get(var)).getRange();
	if(r!=null)
	    return (Range)r.clone();
	return null;
    }
    public DVarHistory getDV(String var){
	return (DVarHistory)context.get(var);
	//DVarHistory dv=(DVarHistory)context.get(var);
	//if(dv!=null) return (DVarHistory)dv.clone();
	//return null;
    }
    public Iterator iterator(){
	return (Iterator)context.keys();
    }
    public int size(){
	return context.size();
    }
    public void clear(){
	context.clear();
    }
    public Enumeration keys(){
	return context.keys();
    }
    public Iterator keysIterator(){
	return (Iterator)context.keys();
    }
    public Collection values(){
	return context.values();
    }
    public Set keySet(){
	return context.keySet();
    }
    public static DVarHistory getDV(int level, String variable, Histories histories, Hashtable[] instantiations, int instantiationsLength, Range[]mHCk, Hashtable varIDs){
	int varID=getID(varIDs,variable);
	return new DVarHistory(getInstantiation(variable, level, histories, instantiations, instantiationsLength, varID, mHCk),
			       histories.getHistory(variable,level));
    }
    private static int getID(Hashtable vIDs, String variable){
	Integer i=(Integer)vIDs.get(variable);
	if(i==null) return -1;
	return i.intValue();
    }
    public static Range getInstantiation(String var, int level, Histories varHistory, Hashtable[] instantiations, int instantiationsLength, int varID, Range[] mHCk){
	//computation of up and low
	Range range;
	int up=-1, low=-1;
	int[] hist=varHistory.geth(var);
	if(hist==null) return mHCk[varID];
	int k=0;
	while(up<=level){
	    if(k>=hist.length){
		low=up;
		up=instantiationsLength;
		break;
	    }
	    low=up;
	    up=hist[k];
	    k++;k++;
	}
	//MySystem.err.println("getInst:for:"+var+":look from level:"+low+":,to:"+(up-1)+":at level:"+level);
	//look for an instantiation
	if(low==-1){
	    //MySystem.err.println("getInst:for:"+var+":"+mHCk[varID]+":from mHCk["+varID+"]:at level:"+level);
	    if(varID>=0)
		return mHCk[varID];
	    low++;
	}
	for(k=low;k<up;k++){
	    range=(Range)instantiations[k].get(var);
	    if(range!=null){
		//MySystem.err.println("getInst:for:"+var+":"+range+":from level:"+k+":at level:"+level);
		return range;
	    }
	}
	//MySystem.err.println("getInst:no inst for:"+var+":at level:"+level);
	return null;
    }
    public String toString(){
	String s="";
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    s=s+var+getDV(var).toString();
	}
	return s;
    }
}
