/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import utils.*;

public class DCost implements DObject, Cloneable{
    private static DCost messageCost=new DCost(true);
    public int crtCosts[]=new int[10];
    public synchronized Object clone(){
	Object o;
	try {
	    o=super.clone();
	}catch(CloneNotSupportedException e){
	    System.err.println("Error in DCost.clone()");
	    o=new DCost();
	}
	((DCost)o).crtCosts=(int[])crtCosts.clone();
	return o;
    }
    public DCost(){
	for(int k=0;k<crtCosts.length;k++)
	    crtCosts[k]=0;
    }

    //constructor for static messageCost
    private DCost(boolean messages){
	for(int k=0;k<crtCosts.length;k++)
	    crtCosts[k]=0;
	setMessages();
    }
    public int getMessages(){
	return crtCosts[0];
    }
    public synchronized void incrementChecks(){
	for(int k=1;k<crtCosts.length;k++)
	    crtCosts[k]++;
    }
    public DCost setMessages(){
	crtCosts[0]=1;//count messages
	crtCosts[1]=0;//count checks
	for(int k=2;k<crtCosts.length;k++)
	    crtCosts[k]=5*(k-1);
	return this;
    }
    public synchronized void incrementMessages(DCost messages){
	updateCost(((DCost)messages.clone()).incrementMessages_with(messageCost));
    }
    public synchronized DCost incrementMessages_with(DCost messages){
	if(crtCosts.length!=messages.crtCosts.length){
	    System.err.println("Message Cost Dimensions!!");
	    return this;
	}
	//System.out.println("Messages ");
	//System.out.println("Old "+toString());
	//System.out.println("New "+messages.toString());
	int[] oldCost=(int[])crtCosts.clone();
	crtCosts[0]+=messages.crtCosts[0];
	crtCosts[1]+=messages.crtCosts[1];
	for(int k=2;k<crtCosts.length;k++){
	    crtCosts[k]+=messages.crtCosts[k];
	    if(crtCosts[k]<crtCosts[k-1]){
		MySystem.err.println("Old "+toString(oldCost));
		MySystem.err.println("Incoming "+messages.toString());
		MySystem.err.println("Obtained "+toString());
		MySystem.exit(1);
	    }
	}
	//System.out.println("Got "+toString());
	return this;
    }
    public synchronized void updateCost(DCost inCost){
	if(crtCosts.length!=inCost.crtCosts.length){
	    System.err.println("Cost Dimensions differing!!");
	    return;
	}
	//System.out.println("Old "+toString());
	//System.out.println("New "+inCost.toString());
	// first only counts messages
	int[] oldCost=(int[])crtCosts.clone();
	if(inCost.crtCosts[0]>crtCosts[0])
	    crtCosts[0]=inCost.crtCosts[0];
	if(inCost.crtCosts[1]>crtCosts[1])
	    crtCosts[1]=inCost.crtCosts[1];
	for(int k=2;k<crtCosts.length;k++){
	    if(inCost.crtCosts[k]>crtCosts[k])
		crtCosts[k]=inCost.crtCosts[k];
	    if(crtCosts[k]<crtCosts[k-1]){
		MySystem.err.println("Old "+toString(oldCost));
		MySystem.err.println("Incoming "+inCost.toString());
		MySystem.err.println("Obtained "+toString());
		MySystem.exit(1);
	    }
	}
	//System.out.println("Result "+toString());
    }
    public String toString(){
	//String s=" cost ";
	//for(int k=0;k<crtCosts.length;k++)
	    //s=s+"\t:"+crtCosts[k];
	return toString(crtCosts);
    }
    String toString(int[] costs){
	String s=" cost ";
	for(int k=0;k<costs.length;k++)
	    s=s+"\t:"+costs[k];
	return s;
    }
}
