/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;

import csp.*;
import utils.*;

public class DVarHistory implements Cloneable,DObject{
    public Range range;
    public int[] history=new int[0];
    public DVarHistory(Range _range){
	if(_range!=null)
	    range=new Range(_range);
    }
    public DVarHistory(Range _range,int id,int order){
	if(_range!=null)
	    range=new Range(_range);
	history=new int[2];
	history[0]=id;
	history[1]=order;
    }
//     public DVarHistory(MHCHistory hist){
// 	if(hist.proposal!=null)
// 	    range=new Range(hist.proposal);
// 	history = hist.history;
//     }
    public DVarHistory(Label label){
	if(label.inst.range!=null)
	    range=new Range(label.inst.range);
	history = label.inst.history;
    }
//     public DVarHistory(Range _range,History hist){
// 	if(_range!=null)
// 	    range=new Range(_range);
// 	history = hist.history;
//     }
    public DVarHistory(Range _range,int[] hist){
	if(_range!=null)
	    range=new Range(_range);
	if(hist!=null)
	    history = hist;
    }
    public Range getRange(){
	if(range!=null)
	    return new Range(range);
	return null;
    }
    public Object clone(){
	return new DVarHistory(range, (int[])history.clone());
    }
    public boolean isEmptyAnswer() {
	if((history==null)||(history.length==0))
	    return true;
	if(history[history.length-1]<0)
	    return true;
	return false;
    }
    public void restrict(DVarHistory dVH){
	//MySystem.out.println("InitialDVH:"+toString());
	//MySystem.out.println("IncomingDVH:"+dVH.toString());
	if(olderThan(dVH)){
	    int[] oldH=history;
	    history=(int[])dVH.history.clone();	
	    //System.out.println("Changed To:"+toString());
	    if(!History.consequence(history,oldH))
		if(dVH.range.restricting(range))
		    history[history.length-1]--;
	}else{
	    if(!History.consequence(history,dVH.history)){
		history=(int[])history.clone();
		if(range.restricting(dVH.range))
		    history[history.length-1]--;
	    }
	}
	range=(Range)range.clone();
	range.restrict(dVH.range);
	//MySystem.out.println("FinalDVH:"+toString());
    }

    public void updateHistory(DVarHistory dVH){
	if(olderThan(dVH)){
	    history=(int[])dVH.history.clone();
	}	
    }

    public boolean newerThan(DVarHistory dVarHistory) {
	return dVarHistory.olderThan(this);
    }
    // true if this older than parameter
    public boolean olderOrEqualThan(DVarHistory dVarHistory){
	boolean result=false;
	int cmpsize; // the common length
	int hsize=dVarHistory.history.length>>1;
	int mysize=history.length>>1;
	cmpsize=(mysize<hsize)?mysize:hsize;
	int kk;
	for(int k=0;k<cmpsize;k++){
	    kk=k<<1;
	    if(dVarHistory.history[kk]!=history[kk]){
		// if incoming by earlier constraint
		if(dVarHistory.history[kk]<history[kk])
		    return true;
		else return false;
	    }else 
		if(dVarHistory.history[kk+1]!=history[kk+1]){
		    // if incoming by earlier announce
		    if(dVarHistory.history[kk+1]<history[kk+1])
			return false;
		    else return true;		
		}
	}
	// if the common part of the history is identical
	// then this is older only if its history is shorter or equal
	return mysize<=hsize;
    }
    public boolean printOlderOrEqualThan(DVarHistory dVarHistory){
	boolean result=false;
	int cmpsize; // the common length
	int hsize=dVarHistory.history.length>>1;
	int mysize=history.length>>1;
	cmpsize=(mysize<hsize)?mysize:hsize;
	int kk;
	for(int k=0;k<cmpsize;k++){
	    MySystem.out.println("printOlderOrEqualThan:At index k=:"+k);
	    kk=k<<1;
	    if(dVarHistory.history[kk]!=history[kk]){
		MySystem.out.println("printOlderOrEqualThan: kk="+kk+":"+dVarHistory.history[kk]+"?<"+history[kk]);
		// if incoming by earlier constraint
		if(dVarHistory.history[kk]<history[kk]){
		    MySystem.out.println("printOlderOrEqualThan:true at: kk="+kk);
		    return true;
		}else{
		    MySystem.out.println("printOlderOrEqualThan:false at: kk="+kk);
		    return false;
		}
	    }else 
		if(dVarHistory.history[kk+1]!=history[kk+1]){
		    // if incoming by earlier announce
		    MySystem.out.println("printOlderOrEqualThan: kk="+kk+":"+dVarHistory.history[kk]+"<"+history[kk]);
		    if(dVarHistory.history[kk+1]<history[kk+1]){
			MySystem.out.println("printOlderOrEqualThan:false at: kk+1="+(kk+1));
			return false;
		    }else{
			MySystem.out.println("printOlderOrEqualThan:true at: kk+1="+(kk+1));
			return true;
		    }
		}
	}
	// if the common part of the history is identical
	// then this is older only if its history is shorter or equal
	MySystem.out.println("printOlderOrEqualThan:at:(mysize?<=hsize)="+mysize+"<="+hsize);
	return mysize<=hsize;
    }
    // true if this older than parameter
    public boolean olderThan(DVarHistory dVarHistory){
	boolean result=false;
	int cmpsize; // the common length
	int hsize=dVarHistory.history.length>>1;
	int mysize=history.length>>1;
	cmpsize=(mysize<hsize)?mysize:hsize;
	int kk;
	for(int k=0;k<cmpsize;k++){
	    kk=k<<1;
	    if(dVarHistory.history[kk]!=history[kk]){
		// if incoming by earlier constraint
		if(dVarHistory.history[kk]<history[kk])
		    return true;
		else return false;
	    }else 
		if(dVarHistory.history[kk+1]!=history[kk+1]){
		    // if incoming by earlier announce
		    if(dVarHistory.history[kk+1]<history[kk+1])
			return false;
		    else return true;		
		}
	}
	// if the common part of the history is identical
	// then this is older only if its history is shorter
	return mysize<hsize;
    }
    public boolean cmpPrint(DVarHistory dVarHistory,int constraint, int order){
	MySystem.out.println("Checking crtConsequence");
	if(history==null){
	    MySystem.out.println("Null this(incom) history");
	    return false;
	}
	boolean result=false;
	int cmpsize; // the common length
	int k=0;
	int mysize=history.length>>1;
	if(dVarHistory==null){
	    if(mysize<1) {
		MySystem.out.println("mysize<1");
		return false;
	    }
	    if(history[0]!=constraint) {
		MySystem.out.println("history[0]!=constraint:"+history[0]+"!="+constraint);
		return false;
	    }
	    if(history[1]!=order) {
		MySystem.out.println("history[1]!=constraint:"+history[1]+"!="+constraint);
		return false;
	    }
	    MySystem.out.println("true: other(existing)==null");
	    return true;
	}
	int hsize=dVarHistory.history.length>>1;
	if(mysize<hsize+1){
	    MySystem.out.println("mysize<hsize+1:"+mysize+"<"+((int)(hsize+1)));
	    return false;
	}
	// k should increment with 2
	int kk;
	for(;k<hsize;k++){
	    kk= k<<1;
	    MySystem.out.println("Checking history:"+k);
	    if(dVarHistory.history[kk]!=history[kk]){
		MySystem.out.println("dVarHistory.history[kk]!=history[kk]:k="+k+" "+dVarHistory.history[kk]+"!="+history[kk]);
		return false;
	    }
	    if(dVarHistory.history[kk+1]!=history[kk+1]){
		MySystem.out.println("dVarHistory.history[kk+1]!=history[kk+1]:k="+k+" "+dVarHistory.history[kk+1]+"!="+history[kk+1]);
		return false;
	    }
	}
	kk=k<<1;
	// if the common part of the history is identical
	if(history[kk]!=constraint){
	    MySystem.out.println("history[kk]!=constraint:k="+k+" "+history[kk]+"!="+constraint);
	    return false;
	}
	if(history[kk+1]!=order){
	    MySystem.out.println("history[kk+1]!=order:k="+k+" "+history[kk+1]+"!="+order);
	    return false;
	}
	return true;	
    }


    //called when this older than parameter in order to
    //find the first different agent
    public int changeLevel(DVarHistory dVarHistory){
	int len=history.length;
	if(len>dVarHistory.history.length)
	    len=dVarHistory.history.length;
	for(int k=0;k<len;k++){
	    //if different agents here
	    if(history[k]!=dVarHistory.history[k])
		if(history[k]>dVarHistory.history[k])
		    return dVarHistory.history[k];
		else
		    return history[k];
	    k++;
	    //if different instantiation of the same agent
	    if(history[k]!=dVarHistory.history[k])
		return history[k-1];
	}
	if(history.length==dVarHistory.history.length)
	    MySystem.exit(1);
	if(history.length>dVarHistory.history.length)
	    return history[dVarHistory.history.length];
	else
	    return dVarHistory.history[history.length];
    }

    // true if this is consequence of parameter, following level
    // this should be identical with parameter for all agents<=level
    public boolean consequence(DVarHistory dVarHistory,int level){
	if(history==null){
	    MySystem.err.println("DVarHistory:consequence:MySystem.err-1");
	    MySystem.exit(1);
	    return dVarHistory.history==null;
	}
	int newthislength=history.length;
	for(int k=0;k<history.length;k++,k++){
	    if(history[k]<=level) continue;
	    newthislength=k; break;
	}
	int[] newthis=new int[newthislength];
	for(int kk=0;kk<newthislength;kk++)
	    newthis[kk]=history[kk];
	int[] tmp=history;
	history=newthis;
	boolean result=this.isIdentical(dVarHistory);
	history=tmp;
	return result;
    }

    //are the histories identical? this being not null
    public boolean isIdentical(DVarHistory dVarHistory){
	if(dVarHistory.history==null){
	    MySystem.err.println("DVarHistory:isIdentical:error 1 this null");
	    MySystem.exit(1);
	    return false; //this is not null
	}
	if(history.length!=dVarHistory.history.length)
	    return false;
	for(int k=0;k<history.length;k++)
	    if(history[k]!=dVarHistory.history[k])
		return false;
	return true;
    }

    // true if this is consequence of parameter
    // ended by the constraint and order
    public boolean crtConsequence(DVarHistory dVarHistory,int constraint, int order){
	MySystem.out.println("Checking crtConsequence");
	if(history==null){
	    MySystem.out.println("Null history");
	    return false;
	}
	boolean result=false;
	int cmpsize; // the common length
	int k=0;
	int mysize=history.length>>1;
	if((dVarHistory==null)||(dVarHistory.history==null)){
	    if(mysize<1)
		return false;
	    if(history[0]!=constraint)
		return false;
	    if(history[1]!=order)
		return false;
	    return true;
	}
// 	if(dVarHistory.history==null){
// 	    System.out.println("Null history");
// 	    return false;
// 	}   
	int hsize=dVarHistory.history.length>>1;
	if(mysize<hsize+1)
	    return false;
	int kk;
	for(;k<hsize;k++){
	    kk=k<<1;
	    MySystem.out.println("Checking history:"+k);
	    if(dVarHistory.history[kk]!=history[kk])
		return false;
	    if(dVarHistory.history[kk+1]!=history[kk+1])
		return false;
	}
	kk=k<<1;
	// if the common part of the history is identical
	if(history[kk]!=constraint)
	    return false;
	if(history[kk+1]!=order)
	    return false;
	
	return true;
    }
    public String toString(){
	String s;
	if(range!=null) s=range.toString();
	else s="[]";
	s=s+History.toString(history);
	return s;
    }
}
