/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import java.util.*;
import utils.*;
import csp.*;

public class Histories {
    Hashtable hist;
    public Histories(){
	hist=new Hashtable();
    }
    public Histories(Hashtable h){
	hist=h;
    }
    public Hashtable getHashtable(){
	return hist;
    }
    public void putAll(Hashtable o){
	hist.putAll(o);
    }
    public Iterator keys(){
	return (Iterator)hist.keys();
    }
    //return true if modifications appear in me
    public boolean updateWith(Histories H, Hashtable what){
	boolean result=false;
	Iterator it=H.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    int[] h=geth(var);
	    //if(h==null) continue;
	    int[] ih=H.geth(var);
	    if((h==null)||History.firstDisablesSecond(ih,h)){
		put(var,ih);
		MySystem.err.println("take:"+var);
		int cl=0;
		if(h!=null)cl=History.changeLevel(h,ih);
		what.put(var,new IntObject(cl));
		result=true;
	    }
	}
	return result;
    }
    //if old or inexistent return -1; if old, set old
    public int getNewAndReturnChangeLevel(String var, int[] h,
					  IntObject old, IntObject taken){
	int[] oh=geth(var);
	if(oh==null){
	    put(var,h);taken.i=1;return -1;
	}
	if(History.firstDisablesSecond(h,oh)){
	    put(var,h);taken.i=1;
	    return History.changeLevel(oh,h);
	}
	if(History.firstInvalidatesSecond(oh,h))
	    old.i=1;
	return -1;
    }

    public String toString(){
	String s="";
	Iterator it=(Iterator) hist.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    int[] oldH=geth(var);
	    s=s+":"+var+History.toString(oldH);
	}
	return s;
    }
    //trimm keeping inclusively changeLevel
    public ArrayList trimm(int changeLevel){
	ArrayList result=new ArrayList();
	Hashtable newHist=new Hashtable();
	Iterator it=(Iterator) hist.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    int[] oldH=geth(var);
	    int[] newH=History.getHistory(oldH,changeLevel);
	    if(oldH.length!=newH.length){
		MySystem.out.println("trimm:"+var+
				     History.toString(oldH)+" to "+
				     History.toString(newH));
		result.add(var);
	    }
	    if(newH.length>0){
		MySystem.out.println("trimm put "+History.toString(newH)+var);
		newHist.put(var,newH);
	    }
	}
	hist = newHist;
	return result;
    }
    public int[] put(String var, DVarHistory dvh){
	return (int[])hist.put(var, dvh.history);
    }
    public int[] put(String var, int[] dvh){
	if(dvh.length==0) MySystem.exit(1);
	return (int[])hist.put(var, dvh);
    }
    History getH(String var){
	return new History((int[])hist.get(var));
    }
    public DVarHistory getDV(String var){
	int[] h=(int[])hist.get(var);
	if(h!=null) return new DVarHistory(null,h);
	return null;
    }
    public int[] geth(String var){
	return (int[])hist.get(var);
    }
    public int[] getHistory(String var, int level){
	int[] hist=geth(var);
	if(hist==null)
	    return null;
	int k;
	for(k=0;k<hist.length;k++,k++)
	    if(hist[k]>level)
		break;
	int[] result=new int[k];
	for(k--;k>=0;k--)
	    result[k]=hist[k];
	return result;
    }
    public int size(){
	return hist.size();
    }
    public int[] remove(String var){
	return (int[])hist.remove(var);
    }
    public void clear(){
	hist.clear();
    }
}
