/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import java.util.*;
import csp.*;

public class Label implements DObject,Cloneable{
    public String variable;
    public Range range;
    public int proposalID=0;
    public Context context;
    public DVarHistory inst;
    public void setProposal(int p){
	proposalID=p;
    }
    public Label(String _variable,Range _range,DVarHistory _inst,Context _context){
	if(_context==null) context=new Context();
	else context=(Context)_context.clone();
        variable=_variable;
	put(_variable, _range, _inst);
    }
    public Label(int level, MHCHistory history,
		 Histories histories,
		 Hashtable[] instantiations,
		 int instantiationsLength,
		 Range[]mHCk, Hashtable vIDs){
	variable=history.variable;
	range=(Range)history.proposal.clone();
	context=new Context(level,history.dependencies,histories,instantiations,instantiationsLength, mHCk, vIDs);
	inst=Context.getDV(level,variable,histories,instantiations,instantiationsLength,mHCk,vIDs);
	context.put(variable,inst);
    }
    public Label(String _variable,DVarHistory _inst,Context _context){
	context=_context;
	if(context==null)
	    context=new Context();
	put(_variable, _inst);
        variable=_variable;
	range=(Range)_inst.getRange().clone();
	inst=_inst;
    }
    public String getVariable(){
	return variable;
    }
    //true if old null
    public static boolean olderFirstThanSecond(MHCHistory h,Label l){
	if(h==null)return true;
	return h.proposalID<l.proposalID;
    } 
    public static boolean olderFirstThanSecond(MHCHistory h,MHCHistory l){
	if(h==null)return true;
	return h.proposalID<l.proposalID;
    } 
    public boolean sameAs(Label l){
	if(context.size()!=l.context.size())
	    return false;
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    String var=(String) it.next();
	    int[] h=context.geth(var);
	    int[] lh=l.context.geth(var);
	    if(lh==null) return false;
	    if(!History.isIdentical(h,lh)) return false;
	}
	return true;
    }
    public boolean isNogood(){
	return (range.size()<=0);
    }
    public String getLatestVar(){
	String var,result=null;
	int pos=-1,crt;
	Iterator it=(Iterator)context.keys();
	while(it.hasNext()){
	    var=(String) it.next();
	    int[] h=context.geth(var);
	    if((h==null)||(h.length==0)||(pos>=(crt=h[h.length-2]))) continue;
	    pos=crt;result=var;
	}
	return result;
    }
    public int getNogoodInstantiator(){
	if(variable==null) return -1;
	int[]h=context.geth(variable);
	if((h==null)||(h.length==0)) return -1;
	return h[h.length-2];
    }
    public void setNogoodVariable(String eVar){
	if((variable!=null)&&((eVar==null)||(!variable.equals(eVar)))&&
	   (context.geth(variable).length==0))
	    context.remove(variable);
	variable=eVar;//if eVar null these become null
	if(eVar==null)return;
	inst=context.getDV(eVar);
    }
    public void put(String _variable, Range _range, DVarHistory _inst){
	variable=_variable;
	if(_range!=null)
	    range=(Range)_range.clone();
	if(_inst!=null){
	    inst=(DVarHistory)_inst.clone();
	    context.put(variable,inst);
	}
    }
    public void put(String variable, DVarHistory _inst){
	if(_inst!=null)
	    context.put(variable,(DVarHistory)_inst.clone());
    }
    public Object clone(){
	return new Label(variable,range,inst,context);
    }
    public String toString(){
	String s,var;
	s= "L:"+variable+""+
	    ((inst!=null)?inst.toString():"()")+
	    ((range!=null)?range.toString():"()");
	if(context!=null){
	    if(context.size()>0)
		s=s+"c:";
	    Iterator it=(Iterator)context.keys();
	    while(it.hasNext()){
		var=(String)it.next();
		s=s+var;
		s=s+context.getR(var);
		s=s+History.toString(context.getH(var).history);
	    }
	}
	return s;
    }
}
