/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import java.util.*;
import csp.*;

public class Labeling implements DObject,Cloneable{
    ArrayList labeling;
    public Labeling(){
	labeling=new ArrayList();
    }
    public Labeling(Collection c){
	labeling=new ArrayList();
	Iterator it=c.iterator();
	while(it.hasNext())
	    labeling.add((Label)((Label)it.next()).clone());
	//labeling=new ArrayList(c);//clone
    }
    public Labeling(int k){
	labeling=new ArrayList(k);
    }
    public boolean add(Label l){
	return labeling.add(l.clone());
    }
    public Label getL(int k){
	return (Label)((Label)labeling.get(k)).clone();
    }
    public boolean isNogood(){
	if(labeling.size()!=1)
	    return false;
	Label lb=(Label)labeling.get(0);
	return lb.isNogood();
    }
    public boolean hasNogood(){
	for(int k=0;k<labeling.size();k++)
	    if(((Label)labeling.get(k)).isNogood())
		return true;
	return false;
    }
    public Labeling getNoEmpties(){
	Labeling result=(Labeling)clone();
	result.removeNogood();
	return result;
    }
    private Label removeNogood(){
	for(int k=labeling.size()-1;k>=0;k--)
	    if(((Label)labeling.get(k)).isNogood())
		return (Label)labeling.remove(k);
	return null;
    }
    public Label getNogood(){
	for(int k=labeling.size()-1;k>=0;k--)
	    if(((Label)labeling.get(k)).isNogood())
		return (Label)labeling.get(k);
	return null;
    }
    public int size(){
	return labeling.size();
    }
    public void clear(){
	labeling.clear();
    }
    public Label remove(int index){
	return (Label)labeling.remove(index);
    }
    public Iterator iterator(){
	return labeling.iterator();
    }
    public Object clone(){
	return new Labeling(labeling);
    }
}
