/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import java.util.*;
import csp.*;
import aggreg.*;
import hc.*;
import utils.*;

public class MHCHistory implements DObject, Cloneable{
    //public int level;
    public String variable;
    public Range proposal;
    public int proposalID=0;
    public Range instantiation;
    //public int[] history;
    //(String-var:int[]-history)
    public ConflictSet dependencies=new ConflictSet();
    public MHCHistory(Label label){
	variable=label.variable;
	proposal=(Range)label.range.clone();
	instantiation=label.inst.range;
	//history=label.inst.history;
	proposalID=label.proposalID;
	dependencies=new ConflictSet(label.context);
	dependencies.remove(variable);
    }
    public MHCHistory(int level, String variable,
	       Range instantiation, int[] history){
	//this.level        =level;
	this.variable     =variable;
	if(instantiation!=null){
	    this.proposal     =(Range)instantiation.clone();
	    this.instantiation=(Range)instantiation.clone();
	}else{
	    this.proposal     =null;
	    this.instantiation=null;
	}
	//this.history      =history;
    }
    public MHCHistory(String variable, DVarHistory dv){
	this.variable=variable;
	proposal=(Range)dv.range.clone();
	instantiation=(Range)dv.range.clone();
    }
    public MHCHistory(String variable, Range instantiation){
	this.variable     =variable;
	if(instantiation!=null){
	    this.proposal     =(Range)instantiation.clone();
	    this.instantiation=(Range)instantiation.clone();
	}else{
	    this.proposal     =null;
	    this.instantiation=null;
	}
    }
    public MHCHistory(String variable, Range instantiation, Range proposal){
	this.variable     =variable;
	if(instantiation!=null)
	    this.instantiation=(Range)instantiation.clone();
	else    this.instantiation=null;
	if(proposal!=null)
	    this.proposal     =(Range)proposal.clone();
	else    this.proposal     =null;
    }
    public MHCHistory(int level, String variable,
	       Range instantiation, int[] history, Range proposal){
	//this.level        =level;
	this.variable     =variable;
	if(proposal!=null)
	    this.proposal=(Range)proposal.clone();
	this.instantiation=instantiation;
	//this.history      =history;
    }
    public String toString(){
	String s,var;
	s= "MHCHistory:"+variable+" "+
	    ((instantiation!=null)?instantiation.toString():"()")+
	    ((proposal!=null)?proposal.toString():"()");
	    //((history!=null)?DVarHistory.toString(history):"");
	if(dependencies!=null){
	    if(dependencies.size()>0)
		s=s+" dep:";
	    Iterator it=dependencies.iterator();
	    while(it.hasNext()){
		var=(String)it.next();
		s=s+" "+var;//+DVarHistory.toString((int[])dependencies.get(var));
	    }
	}
	return s;
    }
    public Object clone(){
	MHCHistory res=new MHCHistory(0,variable,
				      instantiation, null,proposal);
	res.dependencies=(ConflictSet)dependencies.clone();
	return res;
    }
//     //if result of newer instantiation of base agent
//     public static boolean disablingHistoryOf(MHCHistory old,MHCHistory nou){
// 	if(old==null) return false; //already null
// 	int[] oldHistory=getHistory(old,nou.variable);
// 	if((oldHistory==null)||
// 	   (nou.history==null)) return false; //only at base level
// 	if(firstDisablesSecond(nou.history,oldHistory))
// 	    return true;
// 	return false;
//     }

    //if obtained from
    public static MHCHistory intersect(MHCHistory modif,MHCHistory mH){
	if(((mH.proposal.size()<=0)&&(modif.proposal.size()<=0))||
	   (!mH.proposal.different(modif.proposal)))//optimal takes lowest level, but perhaps costly-use histories
	    if(modif.dependencies.size()<mH.dependencies.size())
		return modif;
	    else return null;
	if(mH.proposal.size()<=0) return null;
	if(modif.proposal.size()<=0) return modif;
	if(mH.proposal.restricting(modif.proposal)){
	    if(modif.proposal.restricting(mH.proposal))
		return combination(modif,mH);
	    else return modif;
	}
	return null;//no change==(mH)
    }

    private static MHCHistory combination(MHCHistory modif,MHCHistory mH){
	MHCHistory res=new MHCHistory(0, modif.variable,
				      modif.instantiation,null,modif.proposal);
	res.proposal.restrict(mH.proposal);
	res.dependencies=(ConflictSet)(modif.dependencies.clone());
	res.dependencies.addAll(mH.dependencies);
	return res;
    }
//     public static int[] getHistory(MHCHistory old, String variable){
// 	if(old==null) return null;
// 	if(variable.equals(old.variable)) return old.history;
// 	int[] mH=(int[])old.dependencies.get(variable);
// 	return mH;
//     }

    // if disabled by the list of changed histories
    public boolean disabledBy(ArrayList histories){
	if(histories.contains(variable))
	    return true;
	int sz=histories.size();
	for(int k=0;k<sz;k++)
	    if(dependencies.contains((String)histories.get(k)))
		return true;
	return false;
    }
    // if disabled by the list of changed histories
    public boolean disabledBy(String var){
	if(var.equals(variable))
	    return true;
	if(dependencies.contains(var))
	    return true;
	return false;
    }

    // if disabled by the list of changed histories
    public boolean disabledHistoryBy(ArrayList histories){
	if(histories.contains(variable))
	    return true;
	return false;
    }
    // if disabled by the list of changed histories
    public boolean disabledBy(Hashtable changed){
	if(changed.get(variable)!=null)
	    return true;
	Iterator it=dependencies.iterator();
	while(it.hasNext()){
	    if(changed.get(it.next())!=null)
		return true;
	}
	return false;
    }
    // if disabled by the list of changed histories
    public boolean disabledHistoryBy(Hashtable histories){
	if(histories.get(variable)!=null)
	    return true;
	return false;
    }

//     // if disabled by the list of changed histories
//     public boolean disabledBy(Hashtable histories){
// 	int[] incomingHist=(int[])histories.get(variable);
// 	if((history!=null)&&(incomingHist!=null)&&
// 	   (firstDisablesSecond(incomingHist,history)))
// 	    return true;
// 	Iterator it=dependencies.iterator();
// 	while(it.hasNext()){
// 	    String var=(String)it.next();
// 	    incomingHist=(int[])histories.get(var);
// 	    if((incomingHist!=null)&&
// 	       firstDisablesSecond(incomingHist,(int[])dependencies.get(var)))
// 		return true;
// 	}
// 	return false;
//     }

    public static boolean firstDisablesSecond(int[] first,int[] nou){
	return !olderOrEqualThan(first,nou);
    }
    public static boolean olderOrEqualThan(int[] first, int[] nou){
	int cmpsize; // the common length
	int hsize=nou.length>>1;
	int mysize=first.length>>1;
	cmpsize=(mysize<hsize)?mysize:hsize;
	int kk;
	for(int k=0;k<cmpsize;k++){
	    kk=k<<1;
	    if(nou[kk]!=first[kk]){
		// if incoming by earlier constraint
		return first[kk]>nou[kk];
	    }else
		if(nou[kk+1]!=first[kk+1]){
		    // if incoming by earlier announce
		    return first[kk+1]<nou[kk+1];
		}
	}
	// if the common part of the history is identical
	// then this is older only if its history is shorter or equal
	return mysize<=hsize;
    }
}
