/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package parameters;
import platform.*;

public class Order implements DObject,Cloneable{
    public AgentID[] sequence;
    public int[] history;
    public int bestVolume=-1;
    public int hW=0;
    public Order(){
	sequence=new AgentID[0];
	history=new int[0];
    }
    public Order(AgentID[] refAgents, int[] refHist){
	sequence=refAgents;
	history=refHist;
    }
    public Order(AgentID[] refAgents, int[] refHist, int bV,int hW){
	sequence=refAgents;
	history=refHist;
	bestVolume=bV;
	this.hW=hW;
    }
    public boolean takeBV(Order o){
	boolean result=takeBV(o.hW,o.bestVolume);
	if(result){
	    hW=o.hW;
	    bestVolume=o.bestVolume;
	}
	return result;
    }
    public boolean takeBV(int h, int v){
	if((h>hW)||
	   ((h==hW)&&(v>0)&&
	    ((v<bestVolume)||
	     (bestVolume<=0))))
	    return true;
	return false;
    }
    public boolean giveBV(int h, int v){
	if((h<hW)||
	   ((h==hW)&&(bestVolume>0)&&
	    ((v>bestVolume)||
	     (v<=0))))
	    return true;
	return false;
    }
    public boolean equals(Order o){
	return History.isIdentical(history, o.history);
    }
    public boolean isIdentical(Order o){
	if(o==null) return false;
	return (bestVolume==o.bestVolume)&&(hW==o.hW)&&
	    History.isIdentical(history, o.history);
    }
    //get the level of the lowest MHCk interested in this Order
    public int getInterestLevel(){
	if(history.length<=0) return -1;
	return history[history.length-2]+1;
    }
    public int changeLevel(Order o){
	return History.changeRLevel(history,o.history);
    }
    public boolean IDisableParam(Order o){
	return History.firstDisablesSecond(history,o.history);
    }
    //the order of level deciding A^k
    public Order getOLevel(int k){
	Order result=new Order();
	result.history=History.getHistory(history,k-1);
	int seqLen = sequence.length;
	if(seqLen>k+1) seqLen=k+1;
	result.sequence=new AgentID[seqLen];
	for(int i=0;i<seqLen;i++)
	    result.sequence[i]=sequence[i];
	return result;
    }
    public Order getOHLevel(int k){
	Order result=getOLevel(k);
	result.bestVolume=bestVolume;
	result.hW=hW;
	return result;
    }
    public Object clone(){
	return new Order((AgentID[])sequence.clone(),
			 (int[])history.clone(),bestVolume,hW);
    }
    public String toString(){
	String s="";
	for(int k=0;k<sequence.length;k++)
	    s=s+sequence[k].getName()+":";
	s=s+History.toString(history)+":bv:"+bestVolume+":h:"+hW;
	return s;
    }
}
