/*
The package platform is a semester project by Galley, Michel,
that Silaghi, Marius-Calin adviced in Spring 2000.
Several modifications were done subsequently by Silaghi, Marius-Calin.
Copyright (c) 2000, 2001, 2002, 2004
*/
/*
 * @(#)AgentList.java  1.0 00/02/04
 *
 * Intelligent Agents Collaborating in Distributed Problem Solving
 *
 * Supervisors:   Marius-Calin Silaghi, Djamila Sam-Haroud
 * Author:        Michel Galley
 */

package platform;

import java.util.*;

/**
 * This class maintains the list of all subscribed agents. It is
 * only accessbile by the broker.
 *
 * @author Michel Galley
 * @see Broker
 * @see AgentID
 * @version 1.0 00/02/04
 */

class AgentList {
    private Vector agentIDs;        // list of agents

    AgentList() { agentIDs = new Vector(0); }

    AgentID[] getAgentIDs()
    { return (AgentID[])agentIDs.toArray(new AgentID[0]); }

    AgentID getAgentID(int index)
    { return (AgentID)agentIDs.elementAt(index); }

    int nbOfAgents(){ return agentIDs.size(); }
    void addAgent(AgentID agentID) { agentIDs.add(agentID); }
    void removeAgent(AgentID agentID) {	agentIDs.remove(agentID); }
    void removeAll(){ agentIDs = new Vector(0); }
}
