/*
The package platform is a semester project by Galley, Michel,
that Silaghi, Marius-Calin adviced in Spring 2000.
Several modifications were done subsequently by Silaghi, Marius-Calin.
Copyright (c) 2000, 2001, 2002, 2004
*/
/*
 * @(#)ConstraintListModel.java  1.0 00/02/23
 *
 * Intelligent Agents Collaborating in Distributed Problem Solving
 *
 * Supervisors:   Marius-Calin Silaghi, Djamila Sam-Haroud
 * Author:        Michel Galley
 */
package platform;

import java.util.*;
import utils.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

class ConstraintListModel
    implements MutableComboBoxModel, Cloneable{
    ListDataListener listDataListener;

    Vector constraints;
    Object selectedItem = null;

    ConstraintListModel() {
      constraints = new Vector(0);
    }

    /**
     * MutableComboBox interface
     */

    public void addElement(Object obj){
	if(constraints.indexOf(obj) != -1)
	    return;

	constraints.add(obj);

	if(listDataListener != null) {
	    listDataListener.intervalAdded
		(new ListDataEvent(this, ListDataEvent.INTERVAL_ADDED,
				 constraints.size()-1, constraints.size()-1));
	}
    }

    public void insertElementAt(Object obj, int index) {}
    public void removeElement(Object obj) {}
    public void removeElementAt(int index) {}
    public Object getSelectedItem() {
      return selectedItem;
    }
    public void setSelectedItem(Object anItem){
      selectedItem = anItem;
    }

    public void addListDataListener(ListDataListener l){
      listDataListener = l;
    }
    public Object getElementAt(int index){
      return constraints.elementAt(index);
    }
    public int getSize() {
      return constraints.size();
    }
    public void removeListDataListener(ListDataListener l){
      listDataListener = null;
    }
    public Object clone(){
      try{
        return super.clone();
      }catch(CloneNotSupportedException e){
        MySystem.exit(1);
      }
      return null;
    }
}
