/*
The package platform is a semester project by Galley, Michel,
that Silaghi, Marius-Calin adviced in Spring 2000.
Several modifications were done subsequently by Silaghi, Marius-Calin.
Copyright (c) 2000, 2001, 2002, 2004
*/
/**
 * @(#)MessageReceiver.java  1.0 00/02/04
 *
 * Intelligent Agents Collaborating in Distributed Problem Solving
 *
 * Supervisors:   Marius-Calin Silaghi, Djamila Sam-Haroud
 * Author:        Michel Galley
 */

package platform;

import sjavap.*;

/**
 * All classes receiving messages from any MessageQueue object must
 * implement this interface. It defines only one method, getMessage.
 * A MessageQueue object can send messages to an
 * object implementing this interface.
 */

public interface MessageReceiver extends Reply
{
    /** sJava identification for the getMessage method. */
    final public static int _getMessage = 1;
    /** Give a message to this object. */
    public void getMessage(Message message);
}
