/*
The package platform is a semester project by Galley, Michel,
that Silaghi, Marius-Calin adviced in Spring 2000.
Several modifications were done subsequently by Silaghi, Marius-Calin.
Copyright (c) 2000, 2001, 2002, 2004
*/
/**
 * @(#)Message_StartProtocol.java  1.0 00/02/05
 *
 * Intelligent Agents Collaborating in Distributed Problem Solving
 *
 * Supervisors:   Marius-Calin Silaghi, Djamila Sam-Haroud 
 * Author:        Michel Galley
 */

package platform;

import java.io.*;
import utils.*;


/**
 * Platform-dependent message sent by the broker to agents asking them
 * to start a given protocol. If older protocols are still running,
 * the agents must kill them.
 *
 * @author Michel Galley
 * @see Message
 * @see Message_EndProtocol
 * @version 1.0 00/02/05 
 */

class Message_StartProtocol extends Message{
    Class protocol;
    Object parameters;

    Message_StartProtocol() { super(); }
    Message_StartProtocol(Class protocol, AgentID receiverID){
	super(receiverID);
	this.protocol = protocol;
    }    
    public Class getProtocol() { return protocol; }
    public String _toString()
    {
	try { return "Start protocol : "+protocol.newInstance().toString(); }
	catch(Exception e) { e.printStackTrace(); System.exit(-1); }
	return null;
    }

    public void _writeMessage(DataOutputStream out) throws IOException
    {
	String str = protocol.getName();
	out.writeShort(str.length());
	out.writeBytes(str);
    }
    public int _size() { return 2+protocol.getName().length(); }
    public void _readMessage(DataInputStream in) throws IOException
    {
	short size = in.readShort();
	byte[] str = new byte[size];
	in.readFully(str);
	try { protocol = Class.forName(new String(str)); 
	}catch(ClassNotFoundException e){
	    MySystem.err.println("Not found class:"+str);
	    e.printStackTrace(); MySystem.exit(-1); 
	}
    }
}    
