/*
The package platform is a semester project by Galley, Michel,
that Silaghi, Marius-Calin adviced in Spring 2000.
Several modifications were done subsequently by Silaghi, Marius-Calin.
Copyright (c) 2000, 2001, 2002, 2004
*/
//-----------------------------------------------------------------------------
// Intelligent Agents Collaborating in Distributed Problem Solving

// Supervisors:   Marius Silaghi, Djamila Sam-Haroud
// Author:        Michel Galley , Marius Silaghi

// File:          Server.java
// Version:       1.0
// Description:
//-----------------------------------------------------------------------------
// Interface:
//-----------------------------------------------------------------------------

package platform;

import sjavap.*;
import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;
import utils.*;

public class Server implements Runnable, Reply{
    public static boolean acknowledging = true;
    private GenericAgent genericAgent;
    private MessageSender messageSender;
    private MessageList messageList;
    private MessageQueue messageQueue, // queue for platform messages
	protocolMessageQueue; // queue for protocol messages
    private ServerSocket serverSocket;
    private int highestComputationNum = -1;      // highest computationNum
                                                // received by the server

    public static final int _compactors = 1;

 /**    active object support (needs implements Reply)               **/
 /*********************************************************************/
 /* Written by Claude Petitpierre,   LTI-DI-EPFL,           7 Apr 1999*/
 /*********************************************************************/
 /* Modif. by Marius-Calin Silaghi, LIA-DI-EPFL,silaghi@lia.di.epfl.ch*/
 /*  Bug that may lead to deadlock in Synch_Wait(),fixed,  30 Nov 1999*/
 /*********************************************************************/
 /**/ Synch_List select = new Synch_List(this) ;                      //
 /**/ synchronized public void Synch_Reply()                          //
 /**/   { notify(); }                                                 //
 /**/ int now() {return Kernel.kern.currentTime;}                     //
 /**/ int Synch_Wait() {                                              //
 /**/   Kernel.kern.Synch_Request(select);                            //
 /**/   do                                                            //
 /**/     {try {wait();} catch(InterruptedException e){}}             //
 /**/   while(select.nbEntries!=0);                                   //
 /**/   return select.Value; }                                        //
 /*********************** Need not be modified ************************/


    /**
     * Standard constructor
     */

    public Server(GenericAgent genericAgent,
		  MessageList messageList,
		  MessageQueue messageQueue,
		  MessageQueue protocolMessageQueue
		  //,
		  //int port
		  ){
	//try{
	//messageCommand =
	//Class.forName("platform.Message_Command");
	//}catch(Exception e){
	//e.printStackTrace();
	//MySystem.exit(1);
	//}
	boolean portFound = false;
	int localPort;// = port;

	if(genericAgent instanceof Broker)
	    localPort = 2000;
	else
	    localPort = 2001;

	this.genericAgent = genericAgent;
	this.messageList = messageList;
	this.messageQueue = messageQueue;
	this.protocolMessageQueue = protocolMessageQueue;

	while(!portFound) {
	    try {
		serverSocket = new ServerSocket(localPort);
		serverSocket.setSoTimeout(0);
		portFound = true;
	    }
	    catch(IOException e) {
		// Can't connect to port
		localPort++;
	    }
	}
    }

    /**
     * Run method
     */

    synchronized public void run(){
	select.thread=Thread.currentThread();
	int blockings=0;
	for(;;){
	    if(genericAgent.overflow()){
		blockings++;
		if(blockings==50) protocolMessageQueue.printMessages();
		if((blockings%10==0)&&(blockings<=50))
		    MySystem.err.println("****Server blockings="+blockings);
		if(blockings<=7)
		    MySystem.err.println("****Server Block waiting compactor");
		select.accept(0,_compactors);
		select.waituntil(1,0);
		Synch_Wait();
		if(blockings<=7)
		    MySystem.err.println("****Server UnBlock waiting compactor");
	    }else{
		blockings=0;
		readMessage();
	    }
	}
    }

    /**
     * Public methods
     */

    public InetAddress getHost(){
	InetAddress host = null;
	try { host = InetAddress.getLocalHost(); }
	catch(Exception e) {}
	return host;
    }

    public int getPort(){
	return serverSocket.getLocalPort(); 
    }

    /**
     * Private method
     */

    static private boolean starting=true;

    //static Class messageCommand=null;
    synchronized void readMessage(){
	Message receivedMessage = null;
	ObjectInputStream in;
	ObjectOutputStream out;
	Socket socket;

	// Wait for connection, then wait for a new message to arrive:
	try {
	    // Wait for connection
// 	    if(starting){
// 		select.waituntil(0,0);
// 		Synch_Wait();
// 		for(int i=0;i<100000;i++)
// 		    i=i*2-i;
// 		starting=false;
// 	    }
	    socket = serverSocket.accept();
	    socket.setTcpNoDelay(true);
	    in = new ObjectInputStream(socket.getInputStream());
	    //while(in.available() == 0)
	    //; // Wait for message
	    receivedMessage = (Message) in.readObject();
	    //MySystem.err.println("Message got.Try to send ack to "+receivedMessage.getSenderID().toString());
	    if(Server.acknowledging){
		out = new ObjectOutputStream(socket.getOutputStream());
		out.writeObject(new Integer(7));
	    }
	    in.close();
	    socket.close();
	    //MySystem.err.println("ack Sent");
	}
	catch(Exception e) {
	    e.printStackTrace();
	    //???return;
	    MySystem.exit(1);
	}

	// AFFICHE TOUS LES MESSAGES RECUS
	//if(!(receivedMessage instanceof Message_Command)) {
	//    System.err.println("Received"+receivedMessage);
	//}

	if(messageList != null){
	    messageList.addMessage(receivedMessage);
	}
// 	MySystem.err.println("Received "+receivedMessage);
// 	MySystem.err.println(receivedMessage.getMessageNum());
// 	MySystem.err.flush();

	// Maybe send a copy of the message to the broker if
	// the message comes from another agent
	if(Agent.notifying&&(genericAgent instanceof Agent)&&
           //(!((Agent)genericAgent).getBrokerID()
	   //.equals(receivedMessage.getSenderID()))&&
	   (receivedMessage instanceof Message_Command)){
	    //if(genericAgent instanceof Agent)
	    //if(!((Agent)genericAgent).getBrokerID()
	    //.equals(receivedMessage.getSenderID())) {
	    //if(receivedMessage instanceof Message_Command) {
	    //(messageCommand.isInstance(receivedMessage))){
	    Message_Command command = (Message_Command)receivedMessage;
	    Message_NotifyMessage notify = new Message_NotifyMessage
		(command.getCommandStr(),
		 command.getArgumentsStr(),
		 command.getReceiverID().toString(),
		 command.getSenderID().toString(),
		 (short)command.getComputationNum(),
		 command.getMessageNum(),
		 ((Agent)genericAgent).getBrokerID());
	    select.call(0, genericAgent,
			((Agent)genericAgent)._notifyMessage);
	    //MySystem.err.println("Notify message sent");
	    Synch_Wait();
	    //MySystem.err.println("Notify message-Done");
	    //MySystem.err.flush();
	    ((Agent)genericAgent).notifyMessage(notify);
	    //}
	}

	// Check the computationCounter of the message received by the agent:
	// - if the message is too old, it is dropped
	// - if it is the right computation, no special processing
	// - if it is a new computation, we prepare the new computation
	synchronized(queueClear) {
	    int currentCompNum = 
		genericAgent.getComputationNum();
	    int	messageCompNum = 
		receivedMessage.getComputationNum();
//  	    MySystem.err.println("Server:currentCompNum="+currentCompNum+
//  				 ";messageCompNum="+messageCompNum+
//  				 ";highCompNum="+highestComputationNum);
	    //for the start up--start with the first
	    if(highestComputationNum < currentCompNum){
		starting=true;
	        highestComputationNum = messageCompNum;
		//MySystem.err.println("Server:crtCN>highCompNum:="+highestComputationNum);
	    }
	    
	    if(messageCompNum < currentCompNum)
		if(!(receivedMessage instanceof Message_Load))
		//?!if(!(receivedMessage instanceof Message_Subscription))
		// ignore this message : too old
		return;
	    
	    if(messageCompNum < highestComputationNum &&
	       receivedMessage instanceof Message_Command)
		// ignore this message : a new protocol has started
		return;
	    //MySystem.err.println(receivedMessage);
	    //if(genericAgent instanceof Agent)
	    if(starting||(messageCompNum > highestComputationNum)) {
		// It's a "startComputation" message or
		// or a message coming from an agent who as received
		// a new "startComputation" message
		starting=false;
		// Prepare the protocolMessageQueue for the new protocol thread
		//if(genericAgent instanceof Agent){
		    select.call(0, protocolMessageQueue,
				protocolMessageQueue._setReceiver);
		    Synch_Wait();
		    protocolMessageQueue.setReceiver(null);
		    
		    select.call(0, protocolMessageQueue,
				protocolMessageQueue._clear);
		    Synch_Wait();
		    protocolMessageQueue.clear();
		    //}
		highestComputationNum = messageCompNum;
		//MySystem.err.println("Server:highestCompNum:="+highestComputationNum);
	    }
	    
	    // Put the new message on the queue:
	    if(receivedMessage instanceof Message_Command) {
		// Protocol-dependent message
		select.call(0, protocolMessageQueue,
			    protocolMessageQueue._addMessage);
		Synch_Wait();
		protocolMessageQueue.addMessage(receivedMessage);
	    } else {
		// Platform-dependent message
		select.call(0, messageQueue, messageQueue._addMessage);
		Synch_Wait();
		messageQueue.addMessage(receivedMessage);
	    }
	}
    }
    Object queueClear = new Object(); //monitor
    void clearIncomingQueue(GenericAgent ga, int cNum){
	synchronized(queueClear){
	    //If already storing new computation,return
	    if(highestComputationNum>=cNum){
		//MySystem.err.println("Server:ag:highestComputationNum="+highestComputationNum+";cNum="+cNum);
		return;
	    }
	    ga.select.call(0, protocolMessageQueue,
			   protocolMessageQueue._setReceiver);
	    ga.Synch_Wait();
	    protocolMessageQueue.setReceiver(null);
	    ga.select.call(0, protocolMessageQueue,
			protocolMessageQueue._clear);
	    ga.Synch_Wait();
	    protocolMessageQueue.clear();
	    //MySystem.err.println("Server:ag:pQclear;cNum="+cNum);
	}
    }
    void clearIncomingQueue(GenericAgent ga, int cNum, MessageQueue mQ){
	synchronized(queueClear){
	    //If already storing new computation,return
	    if(highestComputationNum>=cNum){
		//MySystem.err.println("Server:ag:highestComputationNum="+highestComputationNum+";cNum="+cNum);
		return;
	    }
	    if(mQ==protocolMessageQueue){
		ga.select.call(0, protocolMessageQueue,
			       protocolMessageQueue._setReceiver);
		ga.Synch_Wait();
		protocolMessageQueue.setReceiver(null);
	    }
	    ga.select.call(0, mQ,
			mQ._clear);
	    ga.Synch_Wait();
	    mQ.clear();
	    //MySystem.err.println("Server:ag:pQclear;cNum="+cNum);
	}
    }
}
