/*
The package platform is a semester project by Galley, Michel,
that Silaghi, Marius-Calin adviced in Spring 2000.
Several modifications were done subsequently by Silaghi, Marius-Calin.
Copyright (c) 2000, 2001, 2002, 2004
*/
//-----------------------------------------------------------------------------
// Intelligent Agents Collaborating in Distributed Problem Solving

// Supervisors:   Marius Silaghi, Djamila Sam-Haroud 
// Author:        Michel Galley

// File:          BrokerChildGUI.java
// Version:       1.0
// Description:   
//-----------------------------------------------------------------------------
// Interface:
//-----------------------------------------------------------------------------

package platform;

import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

class VariablesListModel
    implements MutableComboBoxModel
{
    ListDataListener listDataListener;

    Vector variables;
    Object selectedItem = null;

    VariablesListModel() { variables = new Vector(0); }

    /**
     * MutableComboBox interface
     */

    public void addElement(Object obj) 
    { 
	if(variables.indexOf(obj) != -1)
	    return;

	variables.add(obj); 
	
	if(listDataListener != null) {
	    //System.out.println("Notify list.");
	    listDataListener.intervalAdded
		(new ListDataEvent(this, ListDataEvent.INTERVAL_ADDED, 
				   variables.size()-1, variables.size()-1));
	}
    }

    public void insertElementAt(Object obj, int index) {}
    public void removeElement(Object obj) {}
    public void removeElementAt(int index) {}
    public Object getSelectedItem() { return selectedItem; } 
    public void setSelectedItem(Object anItem) 
    { selectedItem = anItem; } 

    public void addListDataListener(ListDataListener l)
    { listDataListener = l; }
    public Object getElementAt(int index) 
    { return variables.elementAt(index); }
    public int getSize() { return variables.size(); }
    public void removeListDataListener(ListDataListener l) 
    { listDataListener = null; }
}
