/*
The package sJavap is a modification of sJava written by Prof. Petitpierre.
The modifications were done by Silaghi, Marius-Calin.
Copyright (c) 2000, 2001, 2002, 2004
*/
package sjavap;

import utils.*;
import platform.Platform;
/************************************************************************/
/* Written by Claude Petitpierre        LTI-DI-EPFL          7 Apr 1999 */
/************************************************************************/
/* Modified by Marius-Calin Silaghi     LIA-DI-EPFL                     */
/*       Bug fix - one second of delay for waituntil(now()) 22 Nov 1999 */
/*       Priorities added                                   22 Nov 1999 */
/*       Multiple Kernels                                   15 Feb 2000 */
/************************************************************************/

public class Kernel implements Runnable {

  static public int ActiveObjectNb=0;
  static public int currentTime=0;
  static Timer timer=new Timer();
  static public Kernel kern;   // global pointer to the kernel
  static Object monitor=new Object();
  public Kernel() {
    synchronized(monitor){
      if (kern!=null) {
        return;		       // avoid losing kernels
      }
    }
    kern=this;                 // initialize the global pointer
    new Thread(this).start();
    new Thread(timer).start();
  }

    public static Synch_List plist;//,dp1,dp2;

  synchronized public void Synch_Request(Synch_List list) {
      if((!(list.object instanceof platform.Platform))&&
	 (list.thread!=Thread.currentThread()))
	  MySystem.exit(1);
      Synch_List tested=plist;
      while(tested!=null){
	  if(tested.object==list.object){
	      try{
		  DuplicateKernelSubscriptionException e=new DuplicateKernelSubscriptionException();
		  throw e;
	      }catch(DuplicateKernelSubscriptionException e){
		  System.err.println(list.object);
		  e.printStackTrace();
		  System.exit(1);
	      }
	  }
	  tested=tested.next;
      }
      list.next = plist;
      plist = list;
      notify();
  }
  synchronized public void Synch_Timer() {
    currentTime += 100;
    notify();
  }
  synchronized public void block(int val) {
      try{
	  Object bla=new Object();
	  if(val!=0){
	      synchronized(bla){bla.wait();}}
      }catch(Exception e){}
  }
  synchronized public void run () {
    Synch_List current, curr, cu, p1, p2;
    Reply p;
    int i, j, nSynch=0;
    boolean found;
    p1=null;
    p2=null;
    for (;;){
      try { wait(); }            // wait for the next command
      catch(InterruptedException e) {}
      /* /!!----
      current = plist;         // Debug : print the waiting object list
      System.out.println("Init-- ");
      while (current!=null){
	System.out.println(". "+current.object+" "+current.nbEntries);
	for (i=0;i<current.nbEntries;i++)
	  System.out.println(".."+current.entry[i]+" "+current.callee[i]);
	current=current.next;
      }
      */ //---
      found = false;
      p1=null;
      p2=null;
      int maxPriority = -1; //nothing found
      int maxFailures = -1; // ...( for round robin )...
      boolean matchFound;   //stop searching accepted since match found
      current = plist;
      while (current!=null) {   // look for a matching pair in two
	for (i=0;i<current.nbEntries;i++) { // different Synch_List objects
	  if (current.entry[i]>0){
	    curr = plist;
	    matchFound = false;
	    while ((curr!=null)&&(!matchFound)) {
	      if (current.callee[i]==curr.object) {
		for (j=0;(j<curr.nbEntries)&&!matchFound;j++) {
		  if (current.entry[i]==-curr.entry[j]){
		    // next is the function (+) for combining priorities;
		    int newPriority = current.priority[i]+curr.priority[j];
		    if (!found||
		        (maxPriority > newPriority)||
			((maxPriority == newPriority)&&
			 (maxFailures<current.failures[i]+curr.failures[j]))) {
		      if (found) {
		        p1.failures[p1.choice]++;
			p2.failures[p2.choice]++;
		      }
		      p1=current;
		      p2=curr;
		      p1.Value=current.selectCase[i];
		      p2.Value=curr.selectCase[j];
		      p1.choice =i;
		      p2.choice =j;
		      maxPriority = newPriority;
		      maxFailures = current.failures[i]+curr.failures[j];
		    } else {
		      current.failures[i]++;
		      curr.failures[j]++;
		    }
		    matchFound=found = true;
		  }
		}
                break; //no more than one select per Reply object
	      }
	      curr = curr.next;
	    }
	  }
	}
	current = current.next;
      }
      current = plist;
      while ((current!=null)&&(!found)) {
	for (i=0;i<current.nbEntries;i++) {
	  if (current.entry[i]==0){        // look for a timeout
	    if (current.timerValue[i]-currentTime<=0){
	      found = true;
	      p1=current;
	      p1.Value=current.selectCase[i];
	      p2=null;
	    }
	  }
	}
	current = current.next;
      }
      p=null;
      if (p1!=null) {     // if a ready object has been found,
	  p1.nbEntries=0;
	  //if((p1==dp1)||(p2==dp1)||(p1==dp2)||(p2==dp2))
	  //    MySystem.err.println("Kernel frees up caller:"+p1.object);
	  p=p1.object;
	  nSynch=p1.Value;  // store the case value of the switch and
	  if (plist==p1)    // extract its Synch_List block
	      plist=p1.next;
	  else {
	      cu=plist;
	      while (cu!=null) {
		  if (cu.next==p1)
		      cu.next = p1.next;
		  cu = cu.next;
	      }
	}
	  //p1=null;
      }
      if (p2!=null) {       // if a pair of objrcts have been found
	  //if((p1==dp1)||(p2==dp1)||(p1==dp2)||(p2==dp2))
	  //    MySystem.err.println("Kernel frees up:"+p2.object);
	  p2.nbEntries=0;
	  if (plist==p2)      // store the case value of the switch and
	      plist=p2.next;    // extract its Synch_List block
	  else {
	      cu=plist;
	      while (cu!=null) {
		  if (cu.next==p2)
		      cu.next = p2.next;
		  cu = cu.next;
	      }
	  }
	  //p2=null;
      }
      /* //  Debug : print the new list of waiting objects
	 current = plist;
	 System.out.println("Final--sJavap_:\n\n\n\n");
	 while (current!=null){
	System.out.println("_:"+current.object+" "+current.nbEntries);
	for (i=0;i<current.nbEntries;i++)
	  System.out.println("_:"+current.entry[i]+" "+current.callee[i]);
	current=current.next;
      }
      */
      if (p!=null) {
	  //System.out.println("start "+p+" "+nSynch);
	  p.Synch_Reply();
      }
    }
  }
}

