/*
The package sJavap is a modification of sJava written by Prof. Petitpierre.
The modifications were done by Silaghi, Marius-Calin.
Copyright (c) 2000, 2001, 2002, 2004
*/
package sjavap;
/************************************************************************/
/* Written by Claude Petitpierre        LTI-DI-EPFL          7 Apr 1999 */
/************************************************************************/
/* Modified by Marius-Calin Silaghi     LIA-DI-EPFL                     */
/*       Elimination of hard limit of 20 select entries     22 Nov 1999 */
/*       Priorities added                                   22 Nov 1999 */
/************************************************************************/

public class Synch_List {
    public Thread thread;
    Synch_List next;
    Reply object;
    public int Value;               // case number computed by the kernel
    public int nbEntries;           // size of the set (number of event expected)
    int size=20;                    // default lists length
    int choice;                     // chosen entry computed by the kernel
    int entry[] = new int[20];      // nb>0 : accept, nb<0 : call, 0 : time-out
    int selectCase[] = new int[20]; // number of the case of the switch
    int timerValue[] = new int[20]; // value of time
    int failures[] = new int[20];   // number of lost rounds
    int priority[];                 // priority
    Reply callee[] = new Reply[20]; // address of callee

  public Synch_List (Reply reply) {
    priority = timerValue;
    object = reply;
    nbEntries = 0;
  }
  public Synch_List (Reply reply, int _size) {
    entry = new int[_size];
    selectCase = new int[_size];
    timerValue = new int[_size];
    failures = new int[_size];
    callee = new Reply[_size];
    size = _size;
    priority = timerValue;
    object = reply;
    nbEntries = 0;
  }
  // should increment the actual size of all the lists by 20;
  private void resize() {
    int _entry[] = entry;
    int _selectCase[] = selectCase;
    int _timerValue[] = timerValue;
    int _failures[] = failures;
    Reply _callee[] = callee;
    int _size = size+20;

    entry = new int[_size];
    selectCase = new int[_size];
    timerValue = new int[_size];
    failures = new int[_size];
    callee = new Reply[_size];

    for(int k=0; k<nbEntries; k++) {
	entry[k] = _entry[k];
	selectCase[k] = _selectCase[k];
	timerValue[k] = _timerValue[k];
	failures[k] = _failures[k];
	callee[k] = _callee[k];
    }

    size = _size;
    priority = timerValue;      
  }
  public void call (int selectC, Reply pCallee, int nbMeth) {
    call(selectC, pCallee, nbMeth, 0);
  }
  public void accept (int selectC, int nbMeth) { 
    accept(selectC, nbMeth, 0);
  }
  public void call (int selectC, Reply pCallee, int nbMeth, int priorityC)
    throws InvalidMethodID {
    if (nbEntries>=size) resize();
    if (nbMeth<=0) throw new InvalidMethodID("method id number must be > 0");
    entry[nbEntries]=nbMeth;
    selectCase[nbEntries]=selectC;
    callee[nbEntries]=pCallee;
    priority[nbEntries]=priorityC;
    failures[nbEntries]=0;
    nbEntries++;
  }
  public void accept (int selectC, int nbMeth, int priorityA) 
    throws InvalidMethodID {
    if (nbEntries>=size) resize();
    if (nbMeth<=0) throw new InvalidMethodID("method id number must be > 0");
    entry[nbEntries]=-nbMeth;
    selectCase[nbEntries]=selectC;
    priority[nbEntries]=priorityA;
    callee[nbEntries]=null;//for debugging(never used)
    failures[nbEntries]=0;
    nbEntries++;
  }
  public void waituntil (int selectC, int timer) {
    if (nbEntries>=size) resize();
    entry[nbEntries]=0;   // 0 indicates timeout
    timerValue[nbEntries]=timer;
    selectCase[nbEntries]=selectC;
    nbEntries++;
  }
}
