/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package smdc;
import java.util.*;
import platform.*;
import utils.*;
import parameters.*;

class AgentGraph{
    AgentData ad;
    boolean mark=false;
    ArrayList followers=new ArrayList();
    ArrayList precedence=new ArrayList();
    AgentGraph(AgentData _ad){
	ad=_ad;
    }
    AgentData getAD(){
	return ad;
    }
    // assumes parameter not already in
    void addLink(AgentGraph ag){
	followers.add(ag);
	ag.precedence.add(this);
	//MySystem.out.println("addLink from:"+ad.name+" to:"+ag.ad.name);
    }
    void markFollowers(){
	if(mark) return;
	mark=true;
	for(int k=0;k<followers.size();k++){
	    ((AgentGraph)followers.get(k)).markFollowers();
	}
    }
    void freeFollowers(ArrayList adds){
	//MySystem.out.println("freeFollowers:size of:"+followers.size());
	for(int k=0;k<followers.size();k++){
	    // MySystem.out.println("freeFollowers:deal with k:"+k);
	    AgentGraph ag=(AgentGraph)followers.get(k);
	    //MySystem.out.println("freeFollowers:deal with:"+ag.ad.name);
	    if(ag.mark){
		//MySystem.err.println("freeFollowers:Already marked:"+ag.ad.name+" while freeing:"+ad.name);
		continue;
	    }
	    int pos=ag.precedence.indexOf(this);
	    if(pos<0){
		//MySystem.err.println("freeFollowers:not found in precedence of:"+ag.ad.name+" while freeing:"+ad.name);
	    }
	    ag.precedence.remove(pos);
	    if(ag.precedence.size()==0){
		ag.mark=true;
		adds.add(ag);
	    }
	}
    }
    boolean first(){
	return precedence.size()==0;
    }
}
