/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package smdc;
import java.io.*;

class Counters implements Serializable,Cloneable{
    int[] ins;
    int[] outs;
    int ID=0;
    Counters(int size){
	ins=new int[size];
	outs=new int[size];
    }
    void setAllOut(int b){
	for(int k=0;k<outs.length;k++) outs[k]=b;
    }
    void incOut(int ind, int b){
	outs[ind]+=b;
    }
    void setAllIn(int b){
	for(int k=0;k<ins.length;k++) ins[k]=b;
    }
    void incIn(int ind, int b){
	ins[ind]+=b;
    }
    void add(Counters c){
	for(int k=0;k<outs.length;k++){
	    ins[k]+=c.ins[k];
	    outs[k]+=c.outs[k];
	}
    }
    boolean ready(){
	for(int k=0;k<outs.length;k++)
	    if(ins[k]!=outs[k])
		return false;
	return true;
    }
    boolean olderThan(Counters c){
	return ID<c.ID;
    }
    void reset(){
	setAllIn(0);//all counters init to 0
	setAllOut(0);//all counters init to 0
    }
    public Object clone(){
	Counters c=new Counters(ins.length);
	c.ID=ID;
	c.ins =(int[])ins.clone();
	c.outs=(int[])outs.clone();
	return c;
    }
    public String toString(){
	String s="CountersID:"+ID+":ins\n";
	for(int k=0;k<ins.length;k++)
	    s=s+":"+ins[k];
	s=s+"\n:outs\n";
	for(int k=0;k<outs.length;k++)
	    s=s+":"+outs[k];
	return s;
    }
}
