/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/
package smdc;
import java.util.*;
import java.awt.Color;
import csp.*;
import platform.*;
import parameters.*;
import utils.*;
import hc.*;
import sjavap.*;

public class SMDCAgent extends SMDC{
    Splitting engine;
    HC hc;
    Agent agent;
    AgentID myself;
    String myName;
    int myID;
    int myComputationNum=-2;

    final static int FlowOThreshold=100;
    final static int FlowIUThreshold=150;
    final static int FlowILThreshold=100;
    private final int SInit=0;
    private final int SConsistency=1;
    private final int SSearch=2;
    private final int SAnnounced=3;
    private final int SInit0=4;
    private final int SWaitingEnd=5;
    private final int Sstop=6;
    // local constants for consistency
    private final int sEmptyReceiving=0;
    private final int sReceiving=1;

    //active procedures
    final public static int _MHCk=3;
    final public static int _getStartParameters=4;
    final public static int _accepted=5;
    final public static int _nogood=6;
    final public static int _addLink=7;
    final public static int _ok=8;
    final public static int _compactors=9;
    final public static int _propagation=10;

    private DSearch dSearch;
    private AgentID[] agents;
    private int initiatorHID;
    private int crtState=0;
    private int localState=0;
    private String[] variables;
    private String[] allVariables;
    private Hashtable allVars;

    //globalRanges
    private Range[] rangesIAmAllowed;
    private Range[] rangesIAllow;
    int agentsOrder[];
    //flag for triggering change of consistency round
    int crtConsistency=0;
    //counters of messages in a consistency
    Counters counters;
    //counters received at coordinator (Agent:counters)
    Hashtable receivedCounters=new Hashtable();
    //counters to send to coordinator (Agent:counters)
    //Hashtable countersOnStack=new Hashtable();
    //domains received in consistency
    boolean[] modifiedDomains;
    //domains to send in consistency
    boolean[] modifiedDomainsToSend;
    //yes-have to send. no have to compute HC
    //boolean consistentLocalDomains=false;
    //when computed, send consistencyNogood to everybody
    //when received, send consistencyNogood and counters to initiator
    boolean nogood=false;
    //failure
    boolean failure=false;
    //post
    Propagation message=null;

    final boolean colorSnd=false;

    public SMDCAgent(){}
//                                                            //
/* Here is the procedure for protocol identification          */
//                                                            //
    public String toString(){
	return "SMDC";
    }

    //state machine
    synchronized public void run() {
	Utils.agentCost=new DCost();
	select.thread=Thread.currentThread();
	Utils.sendingColors=false;

	if(!initPhase()) return;
	MySystem.err.println("got startParameter");
	//now MyID is set
	Utils.MAX_SECV_MSG=this.problem.workAmount;
	initQueue();
	int sWait;

	if(myID==0){
	    if(!initAgent0())//compute consistency and order
		return;
	}else{
	    if(!initAgent())//compute consistency--wait order
		return;
	}
	if(crtState!=SWaitingEnd){
	    //wait order
	    crtState=SConsistency;
	    //if here afret newConsistency, then Receiving
	    localState=sReceiving;
	    if(myID==initiatorHID)
		crtState=SSearch;
	    engine.initSearch();
	}
	for(;;){
	    if(failure){
		select.accept(0,_terminate);
		select.call(1,agent,agent._sendCommand);
		int res=Synch_Wait();
		if(res==0){
		    crtState=Sstop;
		}else{
		    DObject parameter;
		    AgentID target=((Agent)genericAgent).getBrokerID();
		    parameter=(DCost)(((DCost)Utils.agentCost).clone());
		    agent.sendCommand(Commands.cEmptyNogood,parameter,
				      target);
		    crtState=SWaitingEnd;
		}
	    }
	    switch(crtState){
	    case Sstop:
		return;
	    case SConsistency:
		select.accept(0,_terminate);
		select.accept(1,_propagation);
		select.accept(2,_ok);
		if(localState==sReceiving)
		    select.waituntil(3,0);
		int result=Synch_Wait();
		if(result==0) return;
		if(result==2){
		    crtState=SSearch;
		}
		if(result==1){
		    if(message.crtConsistency!=crtConsistency){
			//change of consistency
			integrateNewPropagate();
		    }else
			integratePropagate();
		    localState=sReceiving;
		}
		if(result==3){
		    localState=sEmptyReceiving;
		    HC();
		    //send modifiedDomainsToSend,counters and sets counters
		    sendResultsAndCounters(rangesIAmAllowed);//can terminate
		}
		break;
	    case SSearch:
		result = engine.search();
		if(result<0){//search exausted
                  select.accept(0,_terminate);
                  select.call(1,genericAgent,genericAgent._sendCommand);
                  if(Synch_Wait()==0) break;
		  if(myID==0){
		      agent.sendCommand(Commands.cEmptyNogood,
				       (DCost)((DCost)Utils.agentCost).clone(),
					agent.getBrokerID());
		      crtState=this.SWaitingEnd;
		      break;
		  }
		  Nogood msg=new Nogood(myID,crtConsistency);
		  msg.cost=(DCost)((DCost)Utils.agentCost).clone();
		  agent.sendCommand(Commands.cNogood,msg,
				    agents[agentsOrder[myID-1]]);
		  crtState=SConsistency;
		  localState=sEmptyReceiving;
		  counters.reset();
		  receivedCounters=new Hashtable();
		}else{//solution found
		    boolean cResult=launchConsistency();//can terminate
		    if(crtState==Sstop) return;
		    if(cResult){
			getNewOrder(0);
			if(!sendAcknowledgedOrder(myID+1))
			    break;
			crtState=SAnnounced;
		    }else{//solution inconsistent or _terminate
			continue;
		    }
		}
		break;
	    case SAnnounced:
		select.accept(0,_terminate);
		select.accept(1,_nogood);
		if(Synch_Wait()==0)
		    return;
		crtState=SSearch;
		break;
            case SWaitingEnd:
		select.accept(0,_terminate);
		if(Synch_Wait()==0)
		    return;
	    }
	}
    }


//                                                //
/* Here is the procedure for termination          */
//                                                //

    synchronized public void terminate(){
	crtState=Sstop;
	agent=null;
	genericAgent=null;
	myself=null;
        Synch_Reply();
    }

//                                                 //
/* Here are the procedures for color messages      */
//                                                 //

    synchronized void createColorMatrix(String var1, String var2, int sizeX, int sizeY) {
	if(!Utils.sendingColors)
	    return;
        if(crtState==Sstop)
          return;
	select.accept(0,_terminate);
	select.call(1,agent,agent._createColorMatrix);
	//MySystem.err.println("Agent send color Matrix1");
	if(Synch_Wait()==0){
	    //MySystem.err.println("Agent terminated sending color");
	    return;
	}
	//MySystem.err.println("Agent sent color");
	agent.createColorMatrix(var1, var2, sizeX, sizeY);
    }

    synchronized void createColorMatrix(int id, String var1, String var2, int sizeX, int sizeY) {
	if(!Utils.sendingColors)
	    return;
        if(crtState==Sstop)
          return;
	select.accept(0,_terminate);
	select.call(1,agent,agent._createColorMatrix);
	//MySystem.err.println("Agent send color Matrix2");
	if(Synch_Wait()==0){
	    //MySystem.err.println("Agent terminated sending color");
	    return;
	}
	//MySystem.err.println("Agent sent color");
	agent.createColorMatrix(id, var1, var2, sizeX, sizeY);
    }

    synchronized void setColor(String var1,
                                      String var2,
                                      int sizeX, int sizeY,
                                      int sizeX2, int sizeY2,
                                      Color c1, Color c2){
	if(!Utils.sendingColors)
	    return;
        if(crtState==Sstop)
	    return;
	select.accept(0,_terminate);
	select.call(1,agent,agent._setColor);
	//MySystem.err.println("Agent send colorSet 1");
	if(Synch_Wait()==0){
	    //MySystem.err.println("Agent terminated sending color");
	    return;
	}
	//MySystem.err.println("Agent sent color");
	agent.setColor(var1, var2, sizeX, sizeY,
                        sizeX2, sizeY2, c1, c2);
    }

    synchronized void setColor(String var1,
                                      String var2,
				      int table[][],
                                      int sizeX, int sizeY,
                                      int sizeX2, int sizeY2,
				      int destX, int destY,
                                      Color c1, Color c2,
				      Color color0, Color oldColor0){
	if(!Utils.sendingColors)
	    return;
        if(crtState==Sstop)
	    return;
	select.accept(0,_terminate);
	select.call(1,agent,agent._setColor);
	//MySystem.err.println("Agent send colorSet 2");
	if(Synch_Wait()==0){
	    //MySystem.err.println("Agent terminated sending color");
	    return;
	}
	//MySystem.err.println("Agent sent color");
	agent.setColor(var1, var2, table, sizeX, sizeY,
                        sizeX2, sizeY2, destX, destY,
		       c1, c2, color0,oldColor0);
    }

    synchronized void setColor(String var1,
                                      String var2,
                                      Range[] size,
				      Range[] oldsize,
                                      Color c1,
				      Color color0){
	if(!Utils.sendingColors)
	    return;
        if(crtState==Sstop)
	    return;
	select.accept(0,_terminate);
	select.call(1,agent,agent._setColor);
	//MySystem.err.println("Agent send colorSet 3");
	if(Synch_Wait()==0){
	    //MySystem.err.println("Agent terminated sending color");
	    return;
	}
	//MySystem.err.println("Agent sent color");
	agent.setColor(var1, var2, size, oldsize, c1, color0);
    }


    private boolean initPhase(){
	agent=(Agent)genericAgent;

	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverTypeAndProcedure);
	if(Synch_Wait()==0) return false;
	queue.setReceiverType(this,
			      new CommandSelector(Commands.cStartParameters),
			      _getStartParameters);

	//MySystem.out.println("_setReceiverTypeAndProcedure:StartParameters");

	DSubscription myProblem=new DSubscription(genericAgent.getID(),
						  problem.getVariables(),0,
						  problem.getComplexity(),
						  agent.getID().getName());
	select.accept(0,_terminate);
	select.call(1,genericAgent,genericAgent._sendCommand);
	if(Synch_Wait()==0)
	    return false;
	genericAgent.sendCommand(Commands.cMyProblem,
				 myProblem,
				 agent.getBrokerID());

	//MySystem.out.println("send "+Commands.cMyProblem+" parameters");

	select.accept(0,_terminate);
	select.accept(1,_getStartParameters);
	if(Synch_Wait()==0)
	    return false;
	MySystem.out.println("End of InitPhase");
	return true;
    }

    private void initQueue(){
	myself = genericAgent.getID();
	myName = myself.getName();
	//mHCParameters=(MHCParameters)message.parameters;
	//myID=mHCParameters.agentID;
        Utils.aggregations=true;
	engine=new Splitting(myID, problem, this);
	variables=engine.variables;
	allVariables=dSearch.allVariables;
	initAllVars();
	rangesIAmAllowed=new Range[allVariables.length];
        updateAllowedFromDomains();
	rangesIAllow=new Range[allVariables.length];

	hc.setConstraints(engine.constraints);
	hc.order=engine.constraintsID;
        hc.constraintsNr=engine.constraintsNr;

	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverTypeAndProcedure);
	if(Synch_Wait()==0)
	    return;
	queue.setReceiverType(this,
			      new CommandSelector(Commands.cPropagation),
			      _propagation);

	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverTypeAndProcedure);
	if(Synch_Wait()==0)
	    return;
	queue.setReceiverType(this,
			      new CommandSelector(Commands.cOK),
			      _ok);
	select.accept(0,_terminate);
	select.call(1,queue,queue._setReceiverTypeAndProcedure);
	if(Synch_Wait()==0)
	    return;
	queue.setReceiverType(this,
			      new CommandSelector(Commands.cNogood),
			      _nogood);
	select.accept(0,_terminate);
	select.call(1,queue,queue._setActionTrigger);
	if(Synch_Wait()==0) return;
	queue.setActionTrigger(new ServerTriggerForInput(agent.server,queue,
							 FlowIUThreshold,
							 agent.FlowConnectionThreshold));

	modifiedDomainsToSend=new boolean[allVariables.length];
	modifiedDomains=new boolean[allVariables.length];
	agentsOrder=new int[agents.length];
	for(int k=0;k<agents.length;k++) agentsOrder[k]=k;
	counters=new Counters(agents.length);
	MySystem.out.println("End of init");
    }
    private void initAllVars(){
	allVars=new Hashtable();
	for(int k=0;k<allVariables.length;k++)
	    allVars.put(allVariables[k], new Integer(k));
    }
    private void initModifiedDomainsToSend(){
	for(int k=0;k<modifiedDomainsToSend.length;k++)
	    modifiedDomainsToSend[k]=false;
    }
    private void initModifiedDomains(boolean b){
	for(int k=0;k<modifiedDomains.length;k++)
	    modifiedDomains[k]=b;
    }
    private boolean countersReady(){
	int[][] channels=new int[agents.length][agents.length];
	for(int a1=0;a1<agents.length;a1++)
	    for(int a2=0;a2<agents.length;a2++)
		channels[a1][a2]=0;
	receivedCounters.put(myself,counters.clone());
	Iterator it=(Iterator)receivedCounters.keys();
	MySystem.err.println("Checking ready");
	while(it.hasNext()){
	    AgentID agent=(AgentID)it.next();
	    MySystem.err.print("Agent:"+agent+" ");
	    addToChannels(channels,getAID(agent),
			  (Counters)receivedCounters.get(agent));
	}
	for(int a1=0;a1<agents.length;a1++)
	    for(int a2=0;a2<agents.length;a2++)
		if((channels[a1][a2])!=0)
		    return false;
	MySystem.err.println("C Ready");
	return true;
    }
    private void addToChannels(int[][] channels, int aID, Counters c){
	for(int k=0;k<agents.length;k++)
	    channels[k][aID]-=c.ins[k]; //arrived
	for(int k=0;k<agents.length;k++)
	    channels[aID][k]+=c.outs[k];//sent
	MySystem.err.println(" aID:"+aID);
	MySystem.err.println(c);
    }
    private void getNewOrder(int nextIndex){
	//reorder agents starting with index in param
    }
    //take modifiedDomains into consistency-queue
    private ArrayList buildQueue(){
	ArrayList queue=new ArrayList();
	for(int c=0; c<engine.constraintsNr; c++){
	    for(int lv=0; lv<engine.constraints[c].varIDs.length; lv++){
		int vID=engine.constraints[c].varIDs[lv];
		//String s=variables[vID];
		int globalVar=getGvID(vID);
		if(modifiedDomains[globalVar]){
		    queue.add(new Integer(c));
		    break;
		}
	    }
	}
	return queue;
    }
    private void HC(){
	if(nogood){
	    initModifiedDomains(false);
	    return;
	}
	ArrayList queue=buildQueue();
	initModifiedDomains(false);
	mHC(queue);
    }
    //set domains and mark modified in modifiedDomainsToSend
    private void mHC(ArrayList queue){
	Hashtable dependency=new Hashtable();
	Range[] domains=engine.currentDomains;
	boolean result=hc.HC(domains, dependency, queue);
	engine.currentDomains=(Range[])domains.clone();
	for(int k=0;k<domains.length;k++){
	    rangesIAmAllowed[getGvID(k)]=(Range)domains[k].clone();
	}
	if (!result) nogood=true;
	Iterator it=(Iterator)dependency.keys();
	while(it.hasNext()){
	    Integer modif=(Integer)it.next();
	    int i=modif.intValue();
	    String s=variables[i];
	    modifiedDomainsToSend[((Integer)allVars.get(s)).intValue()]=true;
	}
    }
    private void integrateCounters(){
	if(message.counters==null)
	    return;
	Iterator it=(Iterator)message.counters.keys();
	while(it.hasNext()){
	    AgentID aID=(AgentID)it.next();
	    if(aID.equals(myself)) continue;
	    Counters c=(Counters)message.counters.get(aID);
	    MySystem.err.println("Received from:"+aID+":"+c);
	    if(knowNewerEqThan(aID,c)) continue; //know older counters
	    MySystem.err.println("Received counter integrated");
	    receivedCounters.put(aID,c);
	}
    }
    private boolean knowNewerEqThan(AgentID aID, Counters c){
	Counters mc=(Counters)receivedCounters.get(aID);
	if(mc==null)return false;
	if(mc.olderThan(c)) return false;
	return true;
    }
    private void intersectRangesFromPropagate(){
	for(int k=0; k<allVariables.length; k++){
	    if(message.domains[k]==null)
		continue;
	    if(rangesIAmAllowed[k]==null){
		modifiedDomains[k]=true;
		rangesIAmAllowed[k]=message.domains[k];
		continue;
	    }
	    if(rangesIAmAllowed[k].restricting(message.domains[k])){
		modifiedDomains[k]=true;
		rangesIAmAllowed[k]=(Range)rangesIAmAllowed[k].clone();
		rangesIAmAllowed[k].restrict(message.domains[k]);
	    }
	}
      updateDomainsFromAllowed();
    }
    private void intersectRangesFromPropagate(Range[] ranges){
	for(int k=0; k<allVariables.length; k++){
	    if(message.domains[k]==null)
		continue;
	    if(ranges[k]==null){
		ranges[k]=message.domains[k];
		continue;
	    }
	    if(ranges[k].restricting(message.domains[k])){
		ranges[k]=(Range)ranges[k].clone();
		ranges[k].restrict(message.domains[k]);
	    }
	}
    }
    private void updateDomainsFromAllowed(){
        for(int k=0;k<engine.variablesNr;k++)
	    engine.currentDomains[k]=(Range)rangesIAmAllowed[getGvID(k)].clone();
    }
    private void updateAllowedFromDomains(){
        for(int k=0;k<engine.variablesNr;k++)
	    rangesIAmAllowed[getGvID(k)]=(Range)engine.currentDomains[k].clone();
    }
    private void updateAllowedAndDomainsFromInit(){
        for(int k=0;k<engine.variablesNr;k++){
	    rangesIAmAllowed[getGvID(k)]=(Range)engine.initialDomains[k].clone();
	    engine.currentDomains[k]=(Range)engine.initialDomains[k].clone();
	}
    }
   private void integratePropagate(Range[] ranges){
	integrateCounters();//integrate incoming counters in receivedCounters
	intersectRangesFromPropagate(ranges);
	nogood|=message.consistencyNogood;
	counters.incIn(message.senderID,1);
    }
   private void integratePropagate(){
	integrateCounters();//integrate incoming counters in receivedCounters
	intersectRangesFromPropagate();
	nogood|=message.consistencyNogood;
	counters.incIn(message.senderID,1);
    }
    private void integrateNewPropagate(){
	counters.reset();//=new Counters(agents.length);
	    //counters.setAllIn(0);//all counters init to 0
	    //counters.setAllOut(0);//all counters init to 0
	if(receivedCounters.size()>0)
	    MySystem.exit(1);
	receivedCounters=new Hashtable();
	initModifiedDomainsToSend(); //set all to false
	initModifiedDomains(true); //set all to true
	resetDomains();
	nogood=false;
	integratePropagate();
	crtConsistency=message.crtConsistency;
	initiatorHID=message.initiator;
	agentsOrder=(int[])message.order.clone();
    }
    private boolean initAgent0(){
	counters.setAllIn(0);//all counters init to 0
	counters.incIn(0,1);
	initModifiedDomainsToSend(); //set all to false
	initModifiedDomains(true); //set all to true

	counters.setAllOut(1);//all counters init to 1
	boolean modif=true; //not consistent at start
	for(;;){
	    int sWait;
	    select.accept(0,_terminate);
	    select.accept(1,_propagation);
	    if(modif) select.waituntil(2,0);
	    if((sWait=Synch_Wait())==0)
		return false;
	    //add counters,ranges
	    if(sWait==1){
		integratePropagate();
		modif=true;
	    }else{
		modif=false;
		//uses modifiedDomains and sets modifiedDomainsToSend
		if(!nogood)
		    HC();
		if(!nogood){
		    //send modifiedDomainsToSend and sets counters
		    if(!sendResultsSetCounters(rangesIAmAllowed))
			return false;
		}else{
		    if(!sendEmptyNogood()) return false;
		    crtState=SWaitingEnd;
		}
		if(countersReady())
		    break;
	    }
	}
	//reorder agents starting with index in param
	getNewOrder(0);
	//new agent 0 is the only informed of crt order&ranges by ok
	if(!sendAcknowledgedOrder(0))
	    return false;
	return true;
    }
    private boolean sendEmptyNogood(){
	select.accept(0,_terminate);
	select.call(1,genericAgent,genericAgent._sendCommand);
	if(Synch_Wait()==0) return false;
	agent.sendCommand(Commands.cEmptyNogood,(DCost)Utils.agentCost,
			  agent.getBrokerID());
	return true;
    }
    private boolean initAgent(){
	counters.setAllIn(0);
	counters.incIn(0,1);
	initModifiedDomainsToSend();//set all to false
	initModifiedDomains(true); //set all to true

	counters.setAllOut(0);
	boolean modif=true;//initially not consistent
	for(;;){
	    select.accept(0,_terminate);
	    select.accept(1,_propagation);
	    select.accept(2,_ok);
	    if(modif)
		select.waituntil(3,0);
	    int result=Synch_Wait();
	    if(result==0)
		return false;
	    if(result==2){
		return true;//and of consistency
	    }
	    if(result==1){
		if(message.crtConsistency!=0){//change of consistency
		    integrateNewPropagate();
		    return true;
		}
		integratePropagate();
		modif=true;
	    }
	    if(result==3){
		modif=false;
		HC();
		//send modifiedDomainsToSend,counters and sets counters
		if(!sendResultsAndCounters(rangesIAmAllowed))
		    return false;
	    }
	}
    }
    //new agent 0 is the only informed of crt order&ranges by ok
    private boolean sendAcknowledgedOrder(int received){
        if(received==myID)
	    return true;
        Range[] sol;
        if(received>0)
	    sol=(Range[])rangesIAllow.clone();//engine.getSolution().clone();+consistency
        else
	    sol=(Range[])rangesIAmAllowed.clone();//engine.currentDomains.clone();

	select.accept(0,_terminate);
	select.call(1,genericAgent,genericAgent._sendCommand);
	if(Synch_Wait()==0) return false;
	if(received>=agents.length){
            DAccepted da=new DAccepted();
            da.agent=myself;
            da.cost=(DCost)((DCost)Utils.agentCost).clone();
            da.history=new Context();
            for(int k=0; k<this.allVariables.length; k++){
              da.history.put(allVariables[k],new DVarHistory(sol[k]));
            }
	    agent.sendCommand(Commands.cAccepted,da,agent.getBrokerID());
	}else{
	    OrderMessage msg=
		new OrderMessage(myID, (int[])agentsOrder.clone(),
				 crtConsistency,
				 sol);
	    msg.allVariables=allVariables;
            msg.cost=(DCost)((DCost)Utils.agentCost).clone();
	    agent.sendCommand(Commands.cOK,msg,agents[agentsOrder[received]]);
	}
	return true;
    }
    private int getGvID(int lID){
      return this.getGvID(variables[lID]);
    }
    private int getGvID(String v){
      return ((Integer)allVars.get(v)).intValue();
    }
    private void setModifiedDomainsToSend(){//from solution
      Range[] sol= engine.getSolution();
      rangesIAllow=(Range[])rangesIAmAllowed.clone();
      for(int k=0;k<engine.variablesNr;k++){
	  rangesIAllow[getGvID(k)]=(Range)sol[k].clone();
	  if(sol[k].different(engine.currentDomains[k]))
	      modifiedDomainsToSend[getGvID(k)]=true;
      }
    }
    private boolean interestedAgent(AgentID agent){
        AgentData ad=(AgentData)dSearch.problemByAgent.get(agent);
        boolean interestedAgent=false;
        for(int k=0;k<ad.svars.length;k++){
          int gID=getGvID(ad.svars[k].getVariable());
          if(modifiedDomainsToSend[gID])
            interestedAgent=true;
        }
        return interestedAgent;
    }
    private Propagation getMsg(Range[] ranges){
	Propagation msg=
	    new Propagation(myID,
			    initiatorHID,
			    crtConsistency,
                            (Range[])ranges.clone());
	msg.allVariables=allVariables;
	msg.order=(int[])agentsOrder.clone();
	if(nogood) msg.consistencyNogood=true;
	return msg;
    }
    private boolean launchConsistency(){
	crtConsistency= crtConsistency+1;
        initiatorHID=myID;
	receivedCounters=new Hashtable();
	counters.reset();
	setModifiedDomainsToSend();//from solution
        Hashtable msgs=new Hashtable();
	for(int a=myID+1;a<agents.length;a++){
	    AgentID target=agents[agentsOrder[a]];
	    if(interestedAgent(target))
		msgs.put(target,getMsg(rangesIAllow));
	}
	Iterator it=(Iterator)msgs.keys();
	while(it.hasNext()){
	    AgentID target= (AgentID)it.next();
	    counters.incOut(getAID(target),1);
	    Propagation msg= (Propagation)msgs.get(target);
            msg.cost=(DCost)((DCost)Utils.agentCost).clone();

	    select.accept(0,_terminate);
	    select.call(1,genericAgent,genericAgent._sendCommand);
	    if(Synch_Wait()==0) return false;
	    this.agent.sendCommand(Commands.cPropagation,msg,target);
	}
	initModifiedDomainsToSend();
	for(;;){
	    if(countersReady())
		break;
	    select.accept(0,_terminate);
	    select.accept(1,_propagation);
	    if(Synch_Wait()==0) return false;
	    integratePropagate(rangesIAllow);
	}
	if(nogood){
	    nogood=false;
	    return false;
	}
        return true;
    }
    private void resetDomains(){
	rangesIAmAllowed=new Range[rangesIAmAllowed.length];
	updateAllowedAndDomainsFromInit();
    }
    private int getAID(AgentID aid){
	return ((IntObject)dSearch.agentOrder.get(aid)).i;
    }
    //send modifiedDomainsToSend and sets counters
    private boolean sendResultsSetCounters(Range[] ranges){
        Hashtable msgs=new Hashtable();
	for(int a=initiatorHID+1;a<agents.length;a++){
	    AgentID agent=agents[agentsOrder[a]];
	    if(agent.equals(myself)) continue;
            if(interestedAgent(agent))
	      msgs.put(agent,getMsg(ranges));
	}
	Iterator it=(Iterator)msgs.keys();
	while(it.hasNext()){
	    AgentID target= (AgentID)it.next();
	    counters.incOut(getAID(target),1);
	    Propagation msg= (Propagation)msgs.get(target);
            msg.cost=(DCost)((DCost)Utils.agentCost).clone();

	    select.accept(0,_terminate);
	    select.call(1,genericAgent,genericAgent._sendCommand);
	    if(Synch_Wait()==0) return false;
	    this.agent.sendCommand(Commands.cPropagation,msg,target);
	}
	initModifiedDomainsToSend();
        return true;
    }
    private void putCounters(Propagation msg){
	counters.ID++;
	receivedCounters.put(myself,counters.clone());
	msg.counters=receivedCounters;
	receivedCounters=new Hashtable();
    }
    final static int MAX_CNT=10;
    //send modifiedDomainsToSend,counters and sets counters
    private boolean sendResultsAndCounters(Range[] ranges){
        Hashtable msgs=new Hashtable();
	if(!nogood)
	    for(int a=initiatorHID+1;a<agents.length;a++){
		AgentID agent=agents[agentsOrder[a]];
		if(agent.equals(myself))
		    continue;
		if(interestedAgent(agent))
		    msgs.put(agent,getMsg(ranges));
	    }
	AgentID target;
	Iterator it=(Iterator)msgs.keys();
	while(it.hasNext()){
	    target= (AgentID)it.next();
	    counters.incOut(getAID(target),1);
	    Propagation msg= (Propagation)msgs.get(target);
            msg.cost=(DCost)((DCost)Utils.agentCost).clone();
	    if((!it.hasNext())&&(receivedCounters.size()<MAX_CNT)){
		putCounters(msg);
            }
	    select.accept(0,_terminate);
	    select.call(1,genericAgent,genericAgent._sendCommand);
	    if(Synch_Wait()==0)
		return false;
	    this.agent.sendCommand(Commands.cPropagation,msg,target);
	}
	if((msgs.size()==0)||(receivedCounters.size()>=MAX_CNT)){
	    target=agents[agentsOrder[initiatorHID]];
	    counters.incOut(getAID(target),1);
	    Propagation msg= getMsg(ranges);
	    putCounters(msg);
            msg.cost=(DCost)((DCost)Utils.agentCost).clone();
	    select.accept(0,_terminate);
	    select.call(1,genericAgent,genericAgent._sendCommand);
	    if(Synch_Wait()==0)
		return false;
	    this.agent.sendCommand(Commands.cPropagation,msg,target);
	}
	initModifiedDomainsToSend();
        return true;
    }
    synchronized public void getMessage(Message message){
	Message_Command mc=(Message_Command)message;
	Object param=(Object)mc.getArguments();
	String command=(String)mc.getCommand();
	MySystem.err.println("SMDC.got:"+command);
	if(command.equals(Commands.cStartParameters)){
	    myComputationNum=message.getComputationNum();
	    MySystem.err.println("SMDC.myComputationNum="+myComputationNum);
	    DStartLinks dsl=(DStartLinks)param;
	    MySystem.err.println("got="+dsl);
	    myID=dsl.position;
	    //dIncomingAgent=dsl.dIncomingAgent;
	    //dOutgoingAgent=dsl.dOutgoingAgent;
	    dSearch=dsl.dSearch;
            agents = new AgentID[dSearch.agentOrder.size()];
            Iterator it = (Iterator)dSearch.agentOrder.keys();
            while(it.hasNext()){
              AgentID agent = (AgentID)it.next();
              //IntObject pos=(IntObject)dSearch.agentOrder.get(agent);
              agents[getAID(agent)]=agent;
            }
	    //if(!registerInComing(dIncomingAgent.get()))endAgent=true;
	    //registerOutGoing(dOutgoingAgent.get());
	}
	if(command.equals(Commands.cOK)){
	    OrderMessage om=(OrderMessage)param;
	    ((DCost)Utils.agentCost).incrementMessages(om.cost);
	    agentsOrder=(int[])om.order.clone();
	    crtConsistency=om.crtConsistency;
            initiatorHID=myID=om.senderID+1;
	    nogood=false;
	    if(receivedCounters.size()>0)
		MySystem.exit(1);
            //counters=new Counters(agents.length);
	    rangesIAmAllowed=(Range[])om.domains.clone();
            updateDomainsFromAllowed();
	    engine.setCrtConstraint(0);
	}
	if(command.equals(Commands.cPropagation)){
	    this.message=(Propagation)param;
	    ((DCost)Utils.agentCost).incrementMessages(this.message.cost);
	}
	if(command.equals(Commands.cNogood)){
	    Nogood n=(Nogood)param;
            crtConsistency=n.crtConsistency;
	    ((DCost)Utils.agentCost).incrementMessages(n.cost);
	}
	if((((DCost)Utils.agentCost).getMessages()>Utils.MAX_SECV_MSG)&&(Utils.MAX_SECV_MSG>0)){
	    failure=true;;
	}
      Synch_Reply();
    }
}
