/*
This program was designed and implemented by Silaghi, Marius-Calin.
The package sJavap was obtained from sJava (developed by Prof. Petitpierre)
The package platform was initially the semester project of Michel Galley in 2000
Copyright (c) 1998, 1999, 2000, 2001, 2002, 2004
*/

package tester;
import java.util.ArrayList;
import java.util.Random;
import parameters.*;
import platform.*;
import utils.*;
import csp.*;
import java.io.*;

public class TestLeader implements TestLeaderI, BrokerOwner{
    AgentID[] agents;
    Platform platform;
    boolean solvingEnd=true;
    boolean searchSuccess=false;
    int lastcode=-1; //last result (-1:undef/0:nogood/1:sol)

    public static boolean repeat=false;
    int Failure_nrOfTrials=1;
    int Failure_start=2000;
    float Failure_increment=1.5f;

    boolean randomP=true;//false;
    boolean notPrespecified=true;
    boolean precolored=false; //random problems have solution
    boolean smallFirst=true;//false;
    int subscripted=0;
    int cleaned=0;
    int nogoodsNr=0;
    // size in nr of variables
    int size=0;
    Object solving=new Object();
    Object subscription=new Object();
    Object cleaning=new Object();
    Class protocols[];
    String fileNameBase = "tests/problem";
    String fileNameBaseSolution = "tests/Solution";

    int graph[][];
    int used[];
    int color[];
    boolean domain[][];
    int nr_var, nr_col, min_dens, tightness, nr_agents, avgNrOfReplicas;
    Random rgen= new Random();
    RandomAccessFile crtFile, solFile;
    boolean generate;

    public TestLeader(Platform _platform, boolean generate) {
	this.generate=generate;
	platform=_platform;
    }

    int nrOfTests = 100;
    public synchronized void test(int _size, int _nrOfTests, int _domain, int _tightness, float _density, int _agents,int _avgNrOfReplicas, int[] testedProtocols) {
	if(_size<=0) return;
	size=_size; nrOfTests=_nrOfTests;
	tightness=_tightness;
	nr_agents=_agents;
	avgNrOfReplicas=_avgNrOfReplicas;

	protocols=platform.getProtocols();
	if((protocols==null)||(protocols.length==0)){
	    MySystem.out.println("No protocols can be used");
	    return;
	}
// 	testedProtocols=new int[1];
// 	testedProtocols[0]=11;
	//testedProtocols[1]=8;//1;//6;
	//testedProtocols[2]=9;//1;//6;
	//testedProtocols[2]=7;//1;//6;
	//testedProtocols[2]=1;//0;//1;
	//testedProtocols[3]=0;
	//testedProtocols[4]=2;
	//int firsttested=0;
	//int lasttested=protocols.length;
	//firsttested=6;
	//lasttested=8;
	MySystem.out.println("Starting the tests");
	int k=0;
	for(int hh=0;hh<nrOfTests;hh++) {
	    if(!repeat) k=hh;
	    //MySystem.out.println("New test..");
	    //int GenerateProblem(int size, int colors, float dens, int minD, int densOfDomains, int setOfTests){
	    GenerateProblem(size,_domain,_density*(size-1),0,0,k);
	    //MySystem.out.println("Problem created");
	    openSolutionFile(k);
	    //MySystem.out.println("File Solution"+k+" created");
	    if(precolored) printSol("A solution:"+currentSolutionString());
	    lastcode=-1;
 	    for(int protocolID=0; protocolID<testedProtocols.length; protocolID++) {
		int Failures=Failure_start;
		for(int FT=0;FT<Failure_nrOfTrials;FT++,Failures*=Failure_increment){
                int last_ag_nr=-1;
		int prints=0;
		for(;;){
		    try{wait(1000);}catch(InterruptedException e){return;}
		    agents=platform.getAgentIDs();
		    if(nr_agents*(1+avgNrOfReplicas)==agents.length)
			break;
                    else{
                        if(agents.length!=last_ag_nr){
			  prints++;
			  if(prints<25)
			    MySystem.err.println("Nr of subscribed "+
						 agents.length+" of "+nr_agents);
                          last_ag_nr=agents.length;
                      }
		    }
		}
		//synchronized(subscription) {subscripted=0;}
		//synchronized(cleaning){cleaned=0;nogoodsNr=0;}
		// distribute problem(request remote subscription)
		platform.removeSubscriptions();
		for(int ag=0; ag<nr_agents*(1+avgNrOfReplicas); ag++) {
		    Problem problem = new Problem();
		    int ind =
			Integer.parseInt(agents[ag].getName().substring(5));
		    int pind = ind % nr_agents;
		    problem.loadFile(new File(getName(k,pind)));
		    if(ind<nr_agents*avgNrOfReplicas){
			problem.artificial=true;
			if(ind+1==nr_agents*avgNrOfReplicas)
			    problem.mLastArtificial=true;
			problem.mSplitter=true;
			try{
			    if(protocols[testedProtocols[protocolID]].newInstance()
			       instanceof dcsp.Cluster){
				problem.mSplitter=false;
				problem.mCoverSeedsNr=(ind/nr_agents)*3+2;
			    }
			}catch(Exception e){MySystem.exit("No class"+e);}
		    }
		    problem.workAmount=Failures;
		    platform.sendMessage("Load",
					 problem,
					 (AgentID)agents[ag]);
		}
		agents=platform.getAgentIDs();
		MySystem.err.println("LOADs sent. Nr of subscribed "+
				     agents.length+" of "+nr_agents);
 		prints=0;
                last_ag_nr=-1;
 		for(;;){
 		    try{wait(1000);}catch(InterruptedException e){return;}
 		    agents=platform.getAgentIDs();
 		    if(nr_agents*(1+avgNrOfReplicas)==agents.length)
			break;
                     else{
                       if(agents.length!=last_ag_nr){
 			  prints++;
 			  if(prints<4)
 			    MySystem.err.println("Nr of subscribed "+
 						 agents.length+" of "+nr_agents);
                          last_ag_nr=agents.length;
                      }
 		    }
 		}
		//BrokerServer.roundID.val=k*testedProtocols.length+protocolID;
		//MySystem.err.println("ID="+protocolID);
		platform.chooseProtocol(protocols[testedProtocols[protocolID]]);
		printSol("PROTOCOL "+protocols[testedProtocols[protocolID]]+"\n\n");
// 		synchronized(subscription) {
// 		    while(subscripted<size) {
// 			// wait 'size' subscriptions
// 			try{
// 			    subscription.wait();
// 			}catch(InterruptedException e){
// 			    e.printStackTrace();
// 			    MySystem.err.println("TestLeader:test");
// 			}
// 		    }
// 		}
//		MySystem.out.println("Subscription got");
		synchronized(solving) {
		    solvingEnd=false;
		    searchSuccess=false;
		    //MySystem.out.println("Subscription run");
		    //platform.startProtocol();
		    platform.startProtocol(this);
		    //timer set;
		    if(!solvingEnd)
			try{
			    solving.wait();
			}catch(InterruptedException e) {
			    e.printStackTrace();
			    MySystem.err.println("TestLeader:solving!!");
			};
		    //timer got;
		}
// 		synchronized(cleaning) {
// 		    while(cleaned<size) {
// 			// wait 'size' subscriptions
// 			try{
// 			    cleaning.wait();
// 			}catch(InterruptedException e){
// 			    e.printStackTrace();
// 			}
// 		    }
// 		}
// 		synchronized(solving) {
// 		    printSol("Nogoods number: "+nogoodsNr+"\n");
// 		}
		if(searchSuccess)break;
	    }
	    }
	    closeSolutionFile();
	}
    }

    void clean(int nogoods){
	synchronized(cleaning){
	    cleaned++;
	    nogoodsNr+=nogoods;
	    MySystem.out.println("got "+cleaned+" cleaned of "+nr_agents);
	    if(cleaned>=nr_agents)
		cleaning.notifyAll();
	}
    }

     public void answer(Object result){
 	synchronized(solving) {
 	    if(solvingEnd){
 		MySystem.out.println("Already End Solving");
 		return;
 	    }
            int code=((BrokerResult)result).code;
 	    printSol(((BrokerResult)result).result+"\n");
 	    MySystem.out.println("End Solving");
 	    solvingEnd=true;
 	    solving.notifyAll();
	    if(code==2){
		searchSuccess=false;
		return;
	    }
	    searchSuccess=true;
  	    if((lastcode>=0)&&(code!=lastcode))
  		MySystem.exit(0);
  	    lastcode=code;
 	}
     }

    void endSolving(String result,int code){
	synchronized(solving) {
	    if(solvingEnd){
		MySystem.out.println("Already End Solving");
		return;
	    }
	    printSol(result+"\n");
	    MySystem.out.println("End Solving");
	    solvingEnd=true;
	    solving.notifyAll();
	    if((lastcode>=0)&&(code!=lastcode))
		MySystem.exit(0);
	    lastcode=code;
	}
    }
    void subscribe(){
	synchronized(subscription){
	    subscripted++;
	    System.out.println("got "+subscripted+" subscriptions of "+nr_agents);
	    if(subscripted>=nr_agents)
		subscription.notifyAll();
	}
    }
    int aleat(int nr_up){
	int k=rgen.nextInt(nr_up);
	//MySystem.err.println("random to "+nr_up+":"+k);
	return k;
    }

    int linked(int n1, int n2){
	int v1,v2,tmp,j;
	if(used[n1]>used[n2]){
	    v2=n1; tmp=used[v1=n2];
	}else {
	    v2=n2; tmp=used[v1=n1];
	}
	for(j=0;j<tmp; j++)
	    if(graph[v1][j]==v2){
		//MySystem.err.println("Already linked "+n1+" "+n2);
		return 1;
	    }
	//MySystem.err.println("Not yet linked "+n1+" "+n2);
	return 0;
    }

    int link(int i, int j){
	if((used[i]>=nr_var-1)||(used[j]>=nr_var-1)){
	    //MySystem.err.println("Imposible to link "+i+" "+j);
	    return 0;
	}
	graph[i][used[i]++]=j;
	graph[j][used[j]++]=i;
	//MySystem.err.println("linked "+i+" "+j);
	return 1;
    }
    // try a color link
    int tryitlimited(int source, int start, int direction, int nr_var){
	int upaccepted;
	int src=source;
	int srcm1=src-1;
	if (srcm1<0)
	    srcm1= -srcm1;
	while (used[source]==nr_var-1){
	    if (source%nr_var==(srcm1)%nr_var){
		//MySystem.err.println("Sources exausted at:"+src+" while "+source%nr_var+" eq "+(srcm1)%nr_var);
		return 0;
	    }
	    //MySystem.err.println("Sources not exausted at:"+src+" while "+source%nr_var+" !eq "+(srcm1)%nr_var+" given:"+nr_var);
	    source++;
	    if (source>=nr_var)
		source=0;
	    //MySystem.err.println("Try new source:"+source+" of:"+src);
	}
	//MySystem.err.println("new source:"+source);
	upaccepted=min_dens;
	//if initially min_dens>nr_var
	if(upaccepted>=nr_var)
	    upaccepted=nr_var-1;
	for ( ;upaccepted<nr_var; upaccepted++)
	    if(upaccepted!=nr_var-1)
		upaccepted++;
	    for(int k=0; k<2; k++){
		if(direction!=0){
		    for(int j=start;j>=0;j--)
		      if(notPrespecified||(color[j]!=color[source]))
			if (j!=source)
			    if (used[j]<upaccepted)
				if (0==linked(j,source))
				    if (0!=link(j,source))
					return 1;
		}else
		    for(int j=start+1;j<nr_var;j++)
		      if(notPrespecified||(color[j]!=color[source]))
			if (j!=source)
			    if (used[j]<upaccepted)
				if (0==linked(j,source))
				    if (0!=link(j,source))
					return 1;
		direction= (direction==0)?1:0;
	    }
	return 0;
    }

    int tryit(int source, int start, int direction, int nr_var){
	int src=source;
	int srcm1=src-1;
	if (srcm1<0)
	    srcm1= -srcm1;
	while (used[source]==nr_var-1){
	    if (source%nr_var==(srcm1)%nr_var){
		//MySystem.err.println("Sources exausted at:"+src+" while "+source%nr_var+" eq "+(srcm1)%nr_var);
		return 0;
	    }
	    source++;
	    if (source>=nr_var)
		source=0;
	}
	for(int k=0; k<2; k++){
	    if(direction!=0){
		for(int j=start;j>=0;j--)
		  if (notPrespecified||(color[j]!=color[source]))
		    if (j!=source)
			if (0==linked(j,source))
			    if (0!=link(j,source))
				return 1;
	    }
	    else
		for(int j=start+1;j<nr_var;j++)
		  if (notPrespecified||(color[j]!=color[source]))
		    if (j!=source)
			if (0==linked(j,source))
			    if (0!=link(j,source))
				return 1;
	    direction= (direction==0)?1:0;
	}
	return 0;
    }

    int GenerateProblem(int size, int colors, float dens, int minD, int densOfDomains, int setOfTests){
	MySystem.err.println("Problem "+size+" "+colors+" "+dens+" "+minD);
	nr_var=size;
	nr_col=colors;
	float avg_dens=dens;
	min_dens=minD;

	graph= new int[nr_var][nr_var-1];
	used= new int[nr_var];
	color= new int[nr_var];
	domain= new boolean[nr_var][nr_col];

	for(int k=0; k<nr_var; k++) {
	    used[k]=0;
	    color[k]=aleat(nr_col);
	    //MySystem.err.println("domain of "+k);
	    for(int kk=0; kk<nr_col; kk++) {
		int prob=aleat(100);
		if(precolored&&(color[k]==kk))
		    domain[k][kk]=true;
		else domain[k][kk]=(prob>=densOfDomains);
		//MySystem.err.print((domain[k][kk]?1:0)+" ");
	    }
	    //MySystem.err.println("");
	    //MySystem.err.println("color for:"+k+"is"+color[k]);
	}

	int totalarcs=0;
	if(min_dens>0){
	    MySystem.err.println("Setting min density:"+min_dens);
	    for(int v=0; v<nr_var; v++) {
		int colorstoadd=min_dens-used[v];
		//MySystem.err.println(colorstoadd+" colors to add to "+v);
		for(int cols=0; cols<colorstoadd; cols++){
		    int target=aleat(nr_var);
		    int direction=aleat(2);
		    //MySystem.err.println("target "+target+" direction "+direction);
		    if(0!=tryitlimited(v,target,direction,nr_var)) {
			totalarcs++;
			//MySystem.out.println("arcs:"+totalarcs);
		    }
		    else
			break;
		}
	    }
	    MySystem.err.println("Setting totalarcs:"+totalarcs);
	}

	int esec=0;
	int restarcs=(int)(nr_var*avg_dens/2) -totalarcs;
        MySystem.err.println("Global min nr of constraints:"+totalarcs+" Rest arcs:"+restarcs);
	int j;
	for(j=0; j<restarcs;){
	    if (esec>10)
		break;
	    if(0!=tryit(aleat(nr_var), aleat(nr_var),aleat(2),nr_var)){
		j++;
		totalarcs++;
	    }
	    else
		esec++;
	}
	restarcs=j;

        MySystem.err.println("Global nr of constraints:"+totalarcs);
	int[][][] localGraph= new int[nr_agents][nr_var][nr_var];
	int[][] localUsed= new int[nr_agents][nr_var];
	for(int b1=0;b1<nr_agents;b1++)
          for(int b2=0;b2<nr_var;b2++)
            localUsed[b1][b2]=0;
	//result graph,in graph,nr of constraints to extract, failures accepted for clustering 2 variables,..for clustering 1 variable,percent of removed arcs on usage
	getLocalCSPs(localGraph,localUsed,graph,used,
		     totalarcs,(2*nr_var)/4,(4*nr_var)/4,100);
	//print(nr_col).print("\n");
	//print(nr_var).print("\n");
	// print each variable;
	for(int u=0; u<nr_agents; u++){
	    setOutput(setOfTests,(smallFirst?(nr_agents-1-u):u));
	    print("COLOR_V1").print("\n");
	    //print constraintsNr at u
	    int cNr=getConstraintsNr(localUsed[u]);
	    if(cNr==0) {
		print(1).print(" # constraints\n");
		printUConstraint(0);
	    }else{
		print(cNr).print(" # constraints\n");
		for(int s=0; s<nr_var; s++){
		    for(int v=0; v<localUsed[u][s]; v++){
			int varID=localGraph[u][s][v];
			if(varID<s){
			    // variables at u, v
			    int vNr=2;
			    print(vNr).print(" # variables\n");
			    print("v").print(s).print(" 0 ").print(domainSize(s)-1).print(" 1\n");
			    print("v").print(varID).print(" 0 ").print(domainSize(varID)-1).print(" -1\n");
			    printConstraint(s,varID);
			}
		    }
		}
	    }
	    closeOutput();
	}
	return 0;
    }

    void getLocalCSPs(int[][][]outGraph,int[][]outUsed,int[][]inGraph,int[]inUsed,
		     int count,int proc2,int proc1,int procRemoved){
	int start=0, end=0, p=0, k=0;
	while(k<count){
	    for(int a=0;a<nr_agents;a++){
		if(k==count)
		    return;
		//try in cluster
		for(p=0; p<proc2+1; p++){
		    start=aleat(nr_var);
		    while(inUsed[start]==0)
			start=(++start)%nr_var;
		    end=inGraph[start][aleat(inUsed[start])];
		    if((outUsed[a][start]>0)&&
		       (outUsed[a][end]>0))
			break;
		}
		//try simple extension
		for(p=0; p<proc1+1; p++){
		    if((outUsed[a][start]>0)||
		       (outUsed[a][end]>0))
			break;
		    start=aleat(nr_var);
		    while(inUsed[start]==0)
			start=(++start)%nr_var;
		    end=inGraph[start][aleat(inUsed[start])];
		}
		//avoid repeat
		boolean bla=false;
		for(int j=0; j<outUsed[a][start]; j++)
		    if(outGraph[a][start][j]==end){
			bla=true;
			break;
		    }
		if(bla){
		    //remove and go further
		    k++;
		    bla=false;
		    for(p=0;p<inUsed[start];p++)
			if(end==inGraph[start][p]){
			    inGraph[start][p]=
				inGraph[start][--inUsed[start]];
			    break;
			}
		    for(p=0;p<inUsed[end];p++)
			if(start==inGraph[end][p]){
			    inGraph[end][p]=
				inGraph[end][--inUsed[end]];
			    break;
			}
		    continue;
		}
		//set graph
		outGraph[a][start][outUsed[a][start]++]=end;
		outGraph[a][end][outUsed[a][end]++]=start;
		//if removing
		if(aleat(100)<procRemoved){
		    k++;
		    for(p=0;p<inUsed[start];p++)
			if(end==inGraph[start][p]){
			    inGraph[start][p]=
				inGraph[start][--inUsed[start]];
			    break;
			}
		    for(p=0;p<inUsed[end];p++)
			if(start==inGraph[end][p]){
			    inGraph[end][p]=
				inGraph[end][--inUsed[end]];
			    break;
			}
		}else{
                    MySystem.err.println("One replicated constraint");
                }
	    }
	}
    }

    int domainSize(int v){
	int k, size=0;
	for (k=0; k<nr_col; k++)
	    if(domain[v][k])
		size++;
	return size;
    }
    int getConstraintsNr(int v) {
	int cNr=0;
	for(int k=0; k<used[v]; k++)
	    if(graph[v][k]<v)
		cNr++;
	return cNr;
    }
    int getConstraintsNr(int[] v) {
	int cNr=0;
	for(int k=0; k<nr_var; k++)
	    cNr+=v[k];
	return cNr/2;
    }
    void printConstraint(int v, int u) {
	int i,j,ic,jc; //ic, vc counter to check the bug
	for(ic=i=0;i<nr_col;i++) {
	    if(!domain[v][i])
		continue;
	    ic++;
	    for(jc=j=0;j<nr_col;j++) {
		if(!domain[u][j])
		    continue;
		jc++;
		if(!randomP)
		    print((i!=j)?1:0).print(" ");
		else
		    if(precolored&&
			(color[v]==i)&&
			(color[u]==j))
			print(1).print(" ");
		    else
			print((aleat(100)<tightness)?1:0).print(" ");
		//print((aleat(nr_col)<nr_col-2)?1:0).print(" ");
	    }
	    if(jc!=domainSize(u)) {
		MySystem.err.println("printConstraint:EXIT-BOOM1");
		MySystem.exit(11);
	    }
	    print("\n");
	}
	if(ic!=domainSize(v)) {
	    MySystem.err.println("printConstraint:EXIT-BOOM2");
	    MySystem.exit(11);
	}
	print("\n");
    }
    void printUConstraint(int v) {
	// variables at u, v
	int vNr=1;
	print(vNr).print(" # variables\n");
	int maxVal=domainSize(v)-1;
	print("v").print(v).print(" 0 ").print(maxVal).print(" 1\n");
	for(int k=0;k<=maxVal; k++)
	    print("1 ");
	print("\n\n");
    }

    String currentSolutionString(){
	String s="";
	for (int k=0;k<nr_var;k++)
	    s=s+"v"+k+"="+color[k]+ " ";
	return s+"\n";
    }

    String getName(int set,int k){
	return fileNameBase+set+"p"+k;
    }

    void setOutput(int set,int k){
	String fname=getName(set,k);
	if(!generate){
	    fname="tmp";
	}
	try{
	    crtFile=new RandomAccessFile(fname,"rw");
	    crtFile.setLength(0);
	}catch(Exception e){
	    MySystem.err.println("error opening file "+set+" "+k);
	}
    }
    void openSolutionFile(int k){
	String fname=fileNameBaseSolution+k;
	try{
	    solFile=new RandomAccessFile(fname,"rw");
	    solFile.setLength(0);
	    solFile.writeBytes("Solution"+k+"\n");
	}catch(Exception e){
	    MySystem.err.println("error opening sol file "+fname);
	}
    }
    void closeSolutionFile(){
	try{
	    solFile.close();
	}catch(Exception e){
	    MySystem.err.println("error closing file");
	}
    }
    void closeOutput(){
	try{
	    crtFile.close();
	}catch(Exception e){
	    MySystem.err.println("error closing file");
	}
    }
    TestLeader print(Object o){
	try{
	    crtFile.writeBytes(o+"");
	}catch(Exception e){
	    MySystem.err.println("error writting to file");
	}
	//MySystem.out.print(o);
	return this;
    }
    TestLeader printSol(Object o){
	try{
	    solFile.writeBytes(o+"");
	}catch(Exception e){
	    MySystem.err.println("error writting to file");
	}
	MySystem.out.print(o);
	return this;
    }
    TestLeader print(int o){
	try{
	    crtFile.writeBytes(o+"");
	}catch(Exception e){
	    MySystem.err.println("error writting to file");
	}
	//MySystem.out.print(o);
	return this;
    }
}
